## Change Log
All notable changes to this project will be documented in this file.
This project adheres to [Semantic Versioning](http://semver.org/).

=======

### UNRELEASED -

#### Fixed
- Extra < in the locations detail custom layout
- Create button and others stopped working due to deprecated html syntax

### [3.5.4] - 2018-07-10 - Tony Partridge
- Fixed fatal error when selecting locations
- Fixed authorised user mode with location limits, JEvents defaults to 0 for unlimited
- Fixed http/https issue when the URL contains https. Refactored removing preg-replace and using str_replace

### 2018-07-10 Geraint Edwards
- added some intval() casts.

### [3.5.3] - 2018-07-06 - Carlos Cámara

#### Fixed

- Always sending location name to Google Maps Query when redirecting from Events view.
 
### [3.5.2] - 2018-06-28 - Carlos Cámara

#### Changed

- Empty value in Max Own Locations limit means unlimited now.

### Fixed

- Map in location Detail not adding query when linking to Google Maps

### [3.5.1] - 2018-06-20 - Carlos Cámara

#### Fixed
- Missing translation for max locations allowed reached
- Displaying error when location creator user is not found

### [3.5.0] - 2018-06-19 - Carlos Cámara

#### Added

- Allow Locations embed to be called globally
- Single Location Module
- Page title from menu settings to Manage Locations view
- Added missing columns in the list view
- Lookup Filter settings to show only locations with events
- Page title from menu settings to Manage Locations view
- Added missing columns in the list view
- Possibility to add Location Title to Breadcrumbs in the detail view
- Page title from menu settings to Manage Locations view and edit location
- Added missing columns in the list view
- New option to choose the content for Google Search Text box on Google Maps page after clicking location map


#### Fixed

- Locations module manifest warning on install
- Locations module showing previous location image if no image
- URLs in detail and list view now correctly understand https
- Image string properly formatted (at last!!)
- Loading Bootstrap libraries twice affecting display in Hathor template in backend
- Not honoring max number of own locations parameter
- When no open in popup it was not possible to redirect to Google Maps after clicking map
- Fixed pagination in location list views

#### Changed

- Reordered configuration options for easiness
- Refactored matching when importing events
- Improved JavaScript comments style

#### Removed

- Removed inline CSS for Locations embed and declared only 1 JFactory::getDocument; 

### [3.4.17] - 2017-05-17 - Carlos Cámara

#### Fixed

- J3.7 / 3.7.1 Save filtering Fix.
- Checking Facility now works correctly and as Joomla! Articles
- Workflow for Save, SaveCopy. Updated some tasks to Jinput. Save was duplicating location in J3.7. No longer does this happen.

### [3.4.16] - 2017-05-08 - Carlos Cámara

#### Fixed

- Workflow for Save, SaveCopy. Updated some tasks to Jinput. Save was duplicating location in J3.7. No longer does this happen.

#### Removed

- Removed old image.php and .htaccess in the assets folder.

### [3.4.15] - 2017-04-26 - Carlos Cámara

#### Fixed

- Removed call to missing filter for customfields
- Fixed show/hide link to calendar in latest events when using a custom layout

### [3.4.14] - 2017-04-26 - Carlos Cámara

#### Added

- Locations Creator filter for backend

#### Fixed

- Loading bootstrap twice in backend

### [3.4.13] - 2017-04-25 - Carlos Cámara

#### Fixed

- Error in PHP 7.1
- Compatibility with Joomla! 3.7.0
- Error in install script

### [3.4.11] - 2017-01-15

#### Fixed

- Fixing error when no CF in a location

### [3.4.10] - 2017-01-11

#### Fixed

- Fixing showing previous CF data when no CF data in location lists
- Showing unpublished locations in event edit when using JSON find

#### Changed

- Updated dates in manifests to 2017

### [3.4.9] - 2016-12-08

#### Added

- Terrain Type for Google Maps

#### Fixed

- Not using global Google API Key for static maps

### [3.4.8] - 2016-07-05

#### Added

- Messages and warnings for Google Maps API Keys usage.
- Fallback behaviour according to configured API Keys.

#### Changed

- Modified constructor class for filters for PHP7 compatibility

### [3.4.7] - 2016-06-08

#### Fixed

- Checking required fields for locations
- Bug in inline-buttons disappearing when no jsonfind

### [3.4.6] - 2016-05-31

#### Added

- JEVLOCATION_TITLE_LINK to allow offering a linked title in JEvents lists (and custom layouts in general)
- Option to open map links in a new window for lists and from Events views

#### Changed

- Set https as default protocol to call Google Maps API

#### Fixed

- Inline buttons appearing only when necessary

### [3.4.5] - 2016-05-13

#### Fixed

- Custom layout for blog items
- Click apply button was redirecting to list view
- Alias generation giving error due to deprecated method in use
- Adding parameters to filter alternative configuration
- Events CSV import failing due to not finding Address in Google Maps service
- Added proper language constant for search plugin

### [3.4.4] - 2016-04-04

#### Added

- Added City to Location inline matching

#### Changed

- Increased default Max Upload Size for location images

#### Fixed

- Category not found when in structured list
- Check Custom Fields plugin enable before using it
- Fix for Custom Fields Required fields checking
- Check locations filter is not blank before using it
- Location buttons can be clicked anywhere when editing an event
- Undefined variable loctheme

### [3.4.3] - 2016-03-07

#### Fixed

- Unclosed parenthesis in Static Maps javascript

### [3.4.2] - 2016-02-29

#### Changed

- Better description for Static Map options
- Sections for Google Maps tab in configuration
- New option for Static Maps API Key
- Only load static maps javascript if needed

#### Fixed

- Avoid loading Custom Fields when plugin is not enabled
- Added LOCATION info in the notification email

### [3.4.1] - 2016-02-22

#### Fixed

- Added back Categories filter

### [3.4.0] - 2016-02-17

#### Added

- Starts using new gwejson plugin for a faster json answer
- Using new Typeahead library for better interface
- New library architecture
- Instructions for Locations Embed content plugin
- Locations Custom Fields can be used now in JEvents layouts
- Added integration with JEvents Social Share plugin

#### Changed

- Mootools functions replaced with jQuery equivalents
- Moving CSS and JS files to media folder to allow easy overriding
- Replace extension internal images with icon fonts
- Improved styling for locations filter (Thanks Eugenio!!)
- Adding pagination prefix to avoid interferences

#### Fixed

- Separation between Events and Locations Custom Fields
- Location Modified format in custom layout
- SEF URLs also in the map
- Going back after clicking a location (on a list or map) Goes correctly to previous page
- Pagination not working when choosing "All"
- Not using target menu item param in global configuration
