<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod.defines.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;
use Joomla\CMS\Table\Table;
use Joomla\CMS\Language\Associations;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;
use Joomla\Utilities\ArrayHelper;
use Joomla\Component\Content\Site\Helper\RouteHelper;

jimport('joomla.plugin.plugin');

JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");
JLoader::register('JevJoomlaVersion', JPATH_ADMINISTRATOR . "/components/com_jevents/libraries/version.php");

class plgJEventsAgendaMinutes extends CMSPlugin
{

	var $_dbvalid = 0;

	function __construct(&$subject, $config)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		parent::__construct($subject, $config);
		$lang = Factory::getLanguage();
		$lang->load("plg_jevents_agendaminutes", JPATH_SITE);
		$lang->load("plg_jevents_agendaminutes", JPATH_ADMINISTRATOR);
		include_once(JPATH_SITE . "/components/com_jevents/jevents.defines.php");

	}

	function onJEventsPluginOutput()
	{
		$app    = Factory::getApplication();
		$input  = $app->input;
		$action = $input->getCmd('action', '');
		$task   = $input->getCmd('task', '');
		if ($task == "plugin.agendaminutes")
		{
			switch ($action)
			{
				case "selectcontent" :
					include_once('agendaminutes/selectcontent.php');
					break;
				case "selectsectioncategory" :
					include_once('agendaminutes/selectsectioncategory.php');
					break;
			}
		}
	}

	function onEditCustom(&$row, &$customfields)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		// article select only works in backend
		$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible
		$user      = Factory::getUser();

		// restrict usage to certain user types
		$userGroups = Factory::getUser()->getAuthorisedGroups();
		$editlevel  = $this->params->get('editlevel', array(8));
		// just in case params not configured and saved
		if (!is_array($editlevel) && intval($editlevel) > 0)
		{
			$editlevel = array(intval($editlevel));
		}
		if (!array_intersect($editlevel, array_values($userGroups)))
		{
			return "";
		}

		$jevuser = JEVHelper::getAuthorisedUser();


		$db = Factory::getDbo();

		// get the data from database and attach to row
		$detailid = intval($row->evdet_id());
		$sql      = "SELECT * FROM #__jev_agendaminutes as am WHERE evdet_id=" . $detailid;
		$db->setQuery($sql);
		$am = $db->loadObject();


		$script = <<<SCRIPT
		var targetarticle=false;
		function jevSelectArticle(id, title, object) {
			document.getElementById('custom_'+targetarticle).value =id;
			document.getElementById('custom_'+targetarticle + '_name').value = title;
			closeJevModalBySelector("#agendaminutes_selectmodal");
		}

		function jSelectSectionCategory(option, optionValue) {
			document.getElementById('new_article').value =  '0,'+option;
			document.getElementById('custom_agenda').value =  '0,'+option;
			document.getElementById('custom_agenda_name').value = 'New Article: '+optionValue;
			closeJevModalBySelector("#agendamodal_selectcategorymodal");
		}

SCRIPT;

		$document = Factory::getDocument();
		$document->addScriptDeclaration($script);

		if (is_null($am) || $am->agenda_id == 0)
		{
			$name = "";
			$id   = 0;
		}
		else
		{
			$content = Table::getInstance("content");
			$content->load($am->agenda_id);
			if ($content->id > 0)
			{
				$name = $content->title;
				$id   = $content->id;
			}
			else
			{
				$name = "";
				$id   = 0;
			}
		}


		JLoader::register('JevModal', JPATH_LIBRARIES . "/jevents/jevmodal/jevmodal.php");
		JevModal::framework();

		$selecttext  = Text::_("JEV_Select", true);
		$selecttext2 = Text::_("JEV_Select");

		$client           = $mainframe->isClient('administrator') ? "administrator" : "site";
		$agenda_directory = 'agendaminutes/';
		$link             = Route::_("index.php?option=com_jevents&task=plugin.agendaminutes&action=selectcontent&tmpl=component", false);

		$input         = <<<HTML
		<input type="hidden" name="custom_agenda" value="$id" id="custom_agenda" />
		<div style="float: left;"><input type="text" disabled="disabled" value="$name" id="custom_agenda_name" /></div>
		<div class="button2-left"  style="float: left;margin-left:5px;">
			<div class="blank">
				<button   
					class="gsl-button gsl-button-small gsl-button-primary agendamodal" 
					onclick="javascript:targetarticle='agenda';jevModalPopup('agendaminutes_selectmodal', '$link', '$selecttext');return false;">
					$selecttext2
				</button>
			</div>
		</div>

HTML;
		$plugin        = PluginHelper::getPlugin('jevents', 'agendaminutes');
		$params        = new Registry($plugin->params);
		$createarticle = $params->get("createarticle", 0);

		if ($createarticle)
		{
			//create new article
			$createtext  = Text::_("JEV_CREATE_ARTICLE", true);
			$createtext2 = Text::_("JEV_CREATE_ARTICLE");
			$link        = Route::_("index.php?option=com_jevents&task=plugin.agendaminutes&action=selectsectioncategory&tmpl=component", false);

			$input .= <<<HTML
		<input type="hidden" name="new_article" value="" id="new_article" />
		<div class="button2-left"  style="float: left;margin-left:5px;">
			<div class="blank">
				<button   
					class="gsl-button gsl-button-small gsl-button-primary agendamodal" 
					onclick="javascript:jevModalPopup('agendamodal_selectcategorymodal', '$link', '$createtext');return false;">
					$createtext2
				</button>
			</div>
		</div>


HTML;
		}

		//remove button
		if ($id > 0)
		{
			$removetext = Text::_("JEV_REMOVE");
			$input      .= <<<HTML
		<div class="button2-left"  style="float: left;margin-left:5px;">
			<div class="blank">
				<button   
					class="gsl-button gsl-button-small gsl-button-primary agendamodal" 
					onclick="javascript:document.getElementById('custom_agenda_name').value='';document.getElementById('custom_agenda').value='';return false;">
					$removetext
				</button>
			</div>
		</div>

HTML;
		}

		$label = Text::_("Select_Agenda");

		$customfield            = array("label" => $label, "input" => $input, "default_value" => "0", "id_to_check" => "custom_agenda");
		$customfields["agenda"] = $customfield;

		if (is_null($am) || $am->minutes_id == 0)
		{
			$name = "";
			$id   = 0;
		}
		else
		{
			$content = Table::getInstance("content");
			$content->load($am->minutes_id);
			if ($content->id > 0)
			{
				$name = $content->title;
				$id   = $content->id;
			}
			else
			{
				$name = "";
				$id   = 0;
			}
		}

		$client = $mainframe->isClient('administrator') ? "administrator" : "site";
		// RSH 11/09/11 - Use the content article view capability
		//$link = (version_compare(JVERSION, "1.6.0", 'ge')) ? 'index.php?option=com_content&amp;view=articles&amp;layout=modal&amp;tmpl=component&amp;function=jevSelectArticle' : JURI::root() . "plugins/jevents/agendaminutes/" . $agenda_directory . "selectcontent.php?&amp;object=id&amp;client=$client";
		//$link = JURI::root() . "plugins/jevents/agendaminutes/" . $agenda_directory . "selectcontent.php?&amp;object=id&amp;client=$client&amp;function=jevSelectArticle";
		$link  = Route::_("index.php?option=com_jevents&task=plugin.agendaminutes&action=selectcontent&tmpl=component", false);
		$input = <<<HTML
		<input type="hidden" name="custom_minutes" value="$id" id="custom_minutes" />
		<div style="float: left;"><input type="text" disabled="disabled" value="$name" id="custom_minutes_name" /></div>
			
		<div class="button2-left"  style="float: left;margin-left:5px;">
			<div class="blank">
				<button   
					class="gsl-button gsl-button-small gsl-button-primary agendamodal" 
					onclick="javascript:targetarticle='minutes';jevModalPopup('agendaminutes_selectmodal', '$link', '$selecttext');return false;">
					$selecttext2
				</button>
			</div>
		</div>

HTML;

		if ($id > 0)
		{
			$removetext  = Text::_("JEV_REMOVE", true);
			$removetext2 = Text::_("JEV_REMOVE");
			$input       .= <<<HTML
		<div class="button2-left"  style="float: left;margin-left:5px;">
			<div class="blank">
				<button   
					class="gsl-button gsl-button-small gsl-button-primary agendamodal" 
					onclick="javascript:document.getElementById('custom_minutes_name').value='';document.getElementById('custom_minutes').value='';return false;">
					$removetext
				</button>
			</div>
		</div>
HTML;
		}

		$label = Text::_("Select_Minutes");

		$customfield             = array("label" => $label, "input" => $input, "default_value" => "0", "id_to_check" => "custom_minutes");
		$customfields["minutes"] = $customfield;

		return true;

	}

	function onStoreCustomDetails($evdetail)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		$detailid = $evdetail->evdet_id;
		$minutes  = array_key_exists("minutes", $evdetail->_customFields) ? $evdetail->_customFields["minutes"] : "0";
		$agenda   = array_key_exists("agenda", $evdetail->_customFields) ? $evdetail->_customFields["agenda"] : "0";
		if ($agenda == "")
		{
			$agenda = 0;
		}
		if ($minutes == "")
		{
			$minutes = 0;
		}

		// Are we saving a repeat
		$task = Factory::getApplication()->input->getString("task", "");

		$eventLink = "";
		if ($task == "icalrepeat.save")
		{
			// if we are saving a repeat exception then we need to get the repeat id which we can put in the article text
			$repeat_id = Factory::getApplication()->input->getInt("rp_id", "0");
			$eventLink = "</br>{jevent=" . $repeat_id . "|_self|0}";
		}
		else if (($task == "icalevent.save" || $task == "icalevent.apply") && !is_numeric($agenda))
		{
			// we have no event id or repeat id at this stage so can't put it in the article text yet
			// but mark the detail as needing treatment
			$evdetail->addEventLinkToArticle = 1;
		}

		if ($agenda == "")
		{
			$db  = Factory::getDbo();
			$sql = "REPLACE INTO #__jev_agendaminutes SET agenda_id=0, evdet_id=" . $detailid . " ";
			$db->setQuery($sql);
			$success = $db->execute();

			return $success;
		}
		else if ($minutes == "")
		{
			$db  = Factory::getDbo();
			$sql = "REPLACE INTO #__jev_agendaminutes SET minutes_id=0, evdet_id=" . $detailid . " ";
			$db->setQuery($sql);
			$success = $db->execute();

			return $success;
		}
		else if (!is_numeric($agenda))
		{
			//put section and category into an array
			$sectionCategory = explode(',', $agenda);
			//prepare content
			$details          = array();
			$details["title"] = $evdetail->summary;
			// Add the date to the end of the title if creating an article for a repeating event
			if ($task == "icalrepeat.save" || $task == "icalrepeat.apply")
			{
				// get the repeat id
				$db  = Factory::getDbo();
				$sql = "SELECT * FROM #__jevents_repetition where eventdetail_id=" . $detailid;
				$db->setQuery($sql);
				$repeat = $db->loadObject();
				if ($repeat)
				{
					// get the data and query models
					$dataModel  = new JEventsDataModel();
					$queryModel = new JEventsDBModel($dataModel);
					// get the repeat (allowing for it to be unpublished)
					$theevent = $queryModel->listEventsById($repeat->rp_id);
					if ($theevent)
					{
						$date             = JEventsHTML::getDateFormat($theevent->yup(), $theevent->mup(), $theevent->dup(), 1);
						$details["title"] .= " [$date]";
					}

				}
			}
			$details["alias"]     = $evdetail->summary;
			$details["introtext"] = $evdetail->description . $eventLink;
			if ($details["introtext"] == "")
			{
				$details["introtext"] = $evdetail->summary;
			}
			$details["state"]        = 1;
			$details["sectionid"]    = $sectionCategory[0];
			$details["catid"]        = $sectionCategory[1];
			$details["publish_down"] = "never";

			$articleid = $this->createArticle($details);

			$db  = Factory::getDbo();
			$sql = "REPLACE INTO #__jev_agendaminutes SET agenda_id=" . ($articleid) . ",  minutes_id=" . intval($minutes) . ", evdet_id=" . $detailid . " ";
			$db->setQuery($sql);
			$success = $db->execute();

			return $success;
		}

		$db  = Factory::getDbo();
		$sql = "REPLACE INTO #__jev_agendaminutes SET agenda_id=" . intval($agenda) . ",  minutes_id=" . intval($minutes) . ", evdet_id=" . $detailid . " ";
		$db->setQuery($sql);
		$success = $db->execute();

		return $success;

	}

	//function onStoreCustomEvent($event)
	function onAfterSaveEvent($event, $dryrun = false)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		if ($dryrun)
			return true;

		$db = Factory::getDbo();
		// Are we saving a repeat
		$task     = Factory::getApplication()->input->getString("task", "");
		$evdetail = $event->_detail;
		$detailid = $evdetail->evdet_id;

		$sql = "SELECT * FROM #__jev_agendaminutes as am WHERE evdet_id=" . $detailid;
		$db->setQuery($sql);
		$am = $db->loadObject();

		if (!$am)
		{
			return;
		}
		if (intval($am->agenda_id) == 0)
			return;
		if (!isset($evdetail->addEventLinkToArticle))
			return;

		$content = Table::getInstance("content");
		$content->load($am->agenda_id);
		if ($content->id > 0)
		{
			$id = $content->id;

			$ev_id = $event->ev_id;

			// get the data and query models
			$dataModel  = new JEventsDataModel("JEventsAdminDBModel");
			$queryModel = new JEventsDBModel($dataModel);

			if ($this->params->get("createlinkinarticle", 0))
			{
				// get event by event id
				$jevent    = $queryModel->getEventById(intval($ev_id), 1, "icaldb");
				$repeat_id = $jevent->rp_id();

				if ($this->params->get("createlinkinarticle", 0) == 1 || $this->params->get("redirect", 0))
				{
					// update the article description with the repeat id now !
					$eventLink = "</br>{jevent=" . $repeat_id . "|_self|0}";
				}
				else
				{
					// auto redirect - must not be used if redirect mode is enabled too!
					$eventLink = "</br>{jevent=" . $repeat_id . "|_self|1}";
				}
			}
			else
			{
				$eventLink = "";
			}

			$details              = array();
			$details["id"]        = intval($id);
			$details["title"]     = $content->title;
			$details["alias"]     = $content->alias;
			$details["introtext"] = $content->introtext . $eventLink;
			$details["state"]     = 1;

			$details["publish_down"] = "never";

			if (!$this->createArticle($details))
			{
				return false;
			}

			return true;
		}


		return true;

	}

	/**
	 * Clean out custom details for deleted event details
	 *
	 * @param   comma separated list of event detail ids $idlist
	 */
	function onCleanCustomDetails($idlist)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		if (strlen(trim($idlist)) < 1)
			return false;

		$ids    = explode(",", $idlist);
		$ids    = ArrayHelper::toInteger($ids);
		$idlist = implode(",", $ids);

		$db    = Factory::getDbo();
		$query = "DELETE FROM #__jev_agendaminutes WHERE evdet_id IN(" . $idlist . ")";
		$db->setQuery($query);

		return $db->execute();

	}

	function onGetEventData(&$row)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}

		$db = Factory::getDbo();
		if (!$row)
			return;

		// Deal with agenda or minutes
		if (is_numeric($row->evdet_id()) && $row->evdet_id() > 0)
		{
			$sql = "SELECT am.* FROM #__jev_agendaminutes as am WHERE evdet_id=" . $row->evdet_id();
		}
		$db->setQuery($sql);
		$am = $db->loadObject();

		$row->agenda_id  = 0;
		$row->minutes_id = 0;

		if ($am && !is_null($am->agenda_id))
		{
			$row->agenda_id = $am->agenda_id;
		}

		if ($am && !is_null($am->minutes_id))
		{
			$row->minutes_id = $am->minutes_id;
		}

		return true;

	}

	// TODO Make this a config option
	function onListIcalEvents(&$extrafields, &$extratables, &$extrawhere, &$extrajoin, &$needsgroupdby = false)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		$mainframe = Factory::getApplication();
		if ($mainframe->isClient('administrator'))
		{
			return;
		}
		if (!$this->params->get("inlist", 0))
			return "";

		$extrafields   .= ", am.agenda_id, am.minutes_id ";
		$extrajoin[]   = " #__jev_agendaminutes as am ON am.evdet_id = det.evdet_id ";
		$needsgroupdby = true;

		return true;

	}

	private function getAssociatedLanguageContent($content)
	{
		$associated = $content->id;

		if (Associations::isEnabled())
		{
			if ($content->language != "" && $content->language != '*')
			{
				$associations = Associations::getAssociations('com_content', '#__content', 'com_content.item', $content->id);

				foreach ($associations as $tag => $association)
				{
					if (Factory::getLanguage()->getTag() == $tag)
					{
						$associated = $association->id;
					}
				}

				$content->load($associated);
			}
		}

		return $content;
	}

	function onDisplayCustomFields(&$row)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		$return = "";
		$user   = Factory::getUser();

		$db       = Factory::getDbo();
		$jnow     = Factory::getDate();
		$now      = $jnow->toSql();
		$nullDate = $db->getNullDate();
		$app      = Factory::getApplication();

		// option to display in lightbox
		if (isset($row->agenda_id) && $row->agenda_id > 0)
		{
			//echo "Has Agenda set<br>";
			$content = Table::getInstance("content");
			$content->load($row->agenda_id);

			$aid = JEVHelper::getAid($user, "array");
			if ($content->id > 0 && $content->state && in_array($content->access, $aid))
			{
				//echo "Has access<br>";
				$content = $this->getAssociatedLanguageContent($content);

				//echo "Agenda Pup = '" . $content->publish_up . "' Agenda Pdn = '" . $content->publish_down . "' Now = '$now' NullDate = '$nullDate'<br>";
				if (($content->publish_up == $nullDate || $content->publish_up == '' || $content->publish_up <= $now)
					&& ($content->publish_down == $nullDate ||  $content->publish_down == '' ||$content->publish_down >= $now)
				)
				{
					//echo "Match Publication criteria<br>";
					// show the article content ?
					if ($this->params->get("showarticle", 0))
					{
						//echo "Show Article<br>";
						if (StringHelper::strlen($content->fulltext) > 1)
						{
							$content->text = $content->introtext . "" . $content->fulltext;
						}
						else
						{
							$content->text = $content->introtext;
						}

						// Get the page/component configuration
						$content->params = ComponentHelper::getParams('com_content');

						// Merge article parameters into the page configuration
						$aparams = new Registry($content->attribs);
						$content->params->merge($aparams);

						// Process the content preparation plugins
						PluginHelper::importPlugin('content');
						$results = $app->triggerEvent('onContentPrepare', array('com_jevents', & $content, & $content->params, 0));
						$results = $app->triggerEvent('onContentBeforeDisplay', array('com_jevents', & $content, & $content->params, 0));

						$return .= "<div class='jevagenda'>";
						$return .= $content->text;
						$return .= "</div>";
					}
					else
					{
						//echo "Don't show Article<br>";
						$name = $content->title;
						$id   = $content->id;
						if (version_compare(JVERSION, "4.0.0", 'gt'))
						{
							$link = RouteHelper::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
						}
						else
						{
							JLoader::register('ContentHelperRoute', JPATH_SITE . '/components/com_content/helpers/route.php');
							$link = ContentHelperRoute::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
						}
						/*
						  if (strpos($link,"Itemid=")===false){
						  $Itemid = Factory::getApplication()->input->getInt("Itemid");
						  $link .= "&Itemid=$Itemid";
						  }
						 */
						$link   = Route::_($link);
						//echo "Article link = $link<br>";
						$return .= "<div class='jevagenda'>" . Text::_("Agenda") . "<a href='" . $link . "' title='" . $content->title . "'>" . $content->title . "</a></div>";

						// auto redirect ?
						if ($this->params->get("redirect", 0))
						{
							//echo "Autoredirect to $link<br>";
							$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible
							$mainframe->redirect($link);
						}
					}
				}
			}
		}
		$row->_agenda = $return;
		$return       = "";

		if (isset($row->minutes_id) && $row->minutes_id > 0)
		{
			$content = Table::getInstance("content");
			$content->load($row->minutes_id);
			$aid = JEVHelper::getAid($user, "array");
			if ($content->id > 0 && $content->state && in_array($content->access, $aid))
			{
				$content = $this->getAssociatedLanguageContent($content);

				if (
					($content->publish_up = $nullDate || $content->publish_up = '' || $content->publish_up <= $now)
					&& ($content->publish_down = $nullDate || $content->publish_down = '' || $content->publish_down >= $now)
				)
				{
					if ($now >= $row->_endrepeat)
					{
						$name   = $content->title;
						$id     = $content->id;
						if (version_compare(JVERSION, "4.0.0", 'gt'))
						{
							$link = RouteHelper::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
						}
						else
						{
							JLoader::register('ContentHelperRoute', JPATH_SITE . '/components/com_content/helpers/route.php');
							$link = ContentHelperRoute::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
						}

						$link   = Route::_($link);
						$return .= "<div class='jevminutes'>" . Text::_("Minutes") . "<a href='" . $link . "' title='" . $content->title . "'>" . $content->title . "</a></div>";
					}
				}
			}
		}
		$row->_minutes = $return;

		$return = $row->_agenda . $row->_minutes;

		$row->_agendaminutes = $return;

		return $return;

	}

	function onDisplayCustomFieldsMultiRow(&$rows)
	{
		if (defined("WPJEVENTS"))
		{
			return;
		}
		if ($this->params->get("inlist") == 0 || count($rows) == 0)
		{
			return true;
		}
		$user = Factory::getUser();

		$db       = Factory::getDbo();
		$jnow     = Factory::getDate();
		$now      = $jnow->toSql();
		$nullDate = $db->getNullDate();

		// get the data from database and attach to rows
		$detailids = array();
		foreach ($rows as & $row)
		{
			$return = "";
			// option to display in lightbox
			if (isset($row->_agenda_id) && $row->_agenda_id > 0)
			{
				$content = Table::getInstance("content");
				$content->load($row->_agenda_id);

				$aid = JEVHelper::getAid($user, "array");

				if ($content->id > 0 && $content->state && ((version_compare(JVERSION, "1.6.0", 'ge') && in_array($content->access, $aid)) || (!version_compare(JVERSION, "1.6.0", 'ge') && $user->aid >= $content->access)))
				{
					$content = $this->getAssociatedLanguageContent($content);

					if (($content->publish_up == $nullDate || $content->publish_up <= $now) && ($content->publish_down == $nullDate || $content->publish_down >= $now))
					{
						$name   = $content->title;
						$id     = $content->id;
						if (version_compare(JVERSION, "4.0.0", 'gt'))
						{
							$link = RouteHelper::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
						}
						else
						{
							JLoader::register('ContentHelperRoute', JPATH_SITE . '/components/com_content/helpers/route.php');
							$link = ContentHelperRoute::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
						}
						$link   = Route::_($link);
						$return .= "<div class='jevagenda'>" . Text::_("Agenda") . "<a href='" . $link . "' title='" . $content->title . "'>" . $content->title . "</a></div>";
					}
				}
			}
			$row->_agenda = $return;
			$return       = "";

			if (isset($row->_minutes_id) && $row->_minutes_id > 0)
			{
				$content = Table::getInstance("content");
				$content->load($row->_minutes_id);
				$aid = JEVHelper::getAid($user, "array");
				if ($content->id > 0 && $content->state && ((version_compare(JVERSION, "1.6.0", 'ge') && in_array($content->access, $aid)) || (!version_compare(JVERSION, "1.6.0", 'ge') && $user->aid >= $content->access)))
				{
					$content = $this->getAssociatedLanguageContent($content);

					if (($content->publish_up = $nullDate || $content->publish_up <= $now) && ($content->publish_down = $nullDate || $content->publish_down >= $now))
					{
						if ($now >= $row->_endrepeat)
						{
							$name   = $content->title;
							$id     = $content->id;
							if (version_compare(JVERSION, "4.0.0", 'gt'))
							{
								$link = RouteHelper::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
							}
							else
							{
								JLoader::register('ContentHelperRoute', JPATH_SITE . '/components/com_content/helpers/route.php');
								$link = ContentHelperRoute::getArticleRoute($content->id . ":" . $content->alias, $content->catid);
							}
							$link   = Route::_($link);
							$return .= "<div class='jevminutes'>" . Text::_("Minutes") . "<a href='" . $link . "' title='" . $content->title . "'>" . $content->title . "</a></div>";
						}
					}
				}
			}
			$row->_minutes = $return;

			$return = $row->_agenda . $row->_minutes;

			$row->_agendaminutes = $return;
			unset($row);
		}

	}

	static function fieldNameArray($layout = 'detail')
	{
		if (defined("WPJEVENTS"))
		{
			return array();
		}

		PluginHelper::importPlugin('jevents');
		$plugin = PluginHelper::getPlugin("jevents", "agendaminutes");
		$params = new Registry($plugin->params);

		if ($layout == "edit")
		{
			$return = array();
			$labels = array();
			$values = array();

			$return['group'] = Text::_("JEV_AGENDAMINUTES_ADDON", true);

			$labels[] = Text::_('JEV_AGENDA_LINK');
			$values[] = "agenda";

			$labels[] = Text::_('JEV_MINUTES_LINK');
			$values[] = "minutes";

			$return['values'] = $values;
			$return['labels'] = $labels;

			return $return;
		}

		// only offer in detail view
		if ($layout != "detail" && !$params->get("inlist", 0))
			return array();

		$labels   = array();
		$labels[] = Text::_("JEV_AGENDA_LINK", true);
		$labels[] = Text::_("JEV_MINUTES_LINK", true);
		$values   = array();
		$values[] = "JEV_AGENDA_LINK";
		$values[] = "JEV_MINUTES_LINK";

		$return           = array();
		$return['group']  = Text::_("JEV_AGENDAMINUTES_ADDON", true);
		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;

	}

	static function substitutefield($row, $code)
	{
		if (isset($row->hidedetail) && $row->hidedetail)
		{
			return "";
		}

		if ($code == "JEV_AGENDA_LINK")
		{
			if (isset($row->_agenda))
				return $row->_agenda;
		}
		if ($code == "JEV_MINUTES_LINK")
		{
			if (isset($row->_minutes))
				return $row->_minutes;
		}

		return "";

	}

	private function createArticle($details)
	{

		// Initialize variables
		$db   = Factory::getDbo();
		$user = Factory::getUser();
		if (version_compare(JVERSION, "1.6.0", 'ge'))
		{
			$userGroups = Factory::getUser()->getAuthorisedGroups();
			if (!array_intersect($this->params->get('editlevel', array(8)), array_values($userGroups)))
			{
				return;
			}
		}
		else
		{
			// make sure user is authorised to create and publish articles
			$groupID      = JEVHelper::getGid($user); // RSH Change to make J!1.6 Compatible - used to be: $user->get('gid');
			$minUserLevel = (version_compare(JVERSION, "1.6.0", 'ge')) ? 5 : 21;  // RSH 11/09/10 - in J!1.6 5 = Publisher, in J!1.5 21 = Publisher
			if ($groupID < $minUserLevel)
				return;
		}

		PluginHelper::importPlugin('content');

		$option   = Factory::getApplication()->input->getCmd('option');
		$task     = Factory::getApplication()->input->getCmd('task');
		$nullDate = $db->getNullDate();

		$row = Table::getInstance('content');
		if (!$row->bind($details))
		{
			//		throw Exception($db->getErrorMsg(), 500);

			return false;
		}


		// sanitise id field
		$row->id = (int) $row->id;

		$isNew = true;
		// Are we saving from an item edit?
		if ($row->id)
		{
			$isNew            = false;
			$datenow          = Factory::getDate();
			$row->modified    = $datenow->toSql();
			$row->modified_by = $user->get('id');
		}

		$row->created_by = $row->created_by ? $row->created_by : $user->get('id');

		if ($row->created && strlen(trim($row->created)) <= 10)
		{
			$row->created .= ' 00:00:00';
		}

		if (version_compare(JVERSION, "1.6.0", 'ge'))
		{
			$date = Factory::getDate();
		}
		else
		{
			$config   = Factory::getConfig();
			$tzoffset = $config->getValue('config.offset');
			$date     = Factory::getDate($row->created, $tzoffset);
		}
		$row->created = $date->toSql();

		// Lets set the language to all for now, maybe we will offer a config option in the future.
		$row->language = "*";

		// Append time if not added to publish date
		if (strlen(trim($row->publish_up)) <= 10)
		{
			$row->publish_up .= ' 00:00:00';
		}


		$date = Factory::getDate();

		$row->publish_up = $date->toSql();

		// Handle never unpublish date
		if (trim($row->publish_down) == Text::_('Never') || trim($row->publish_down) == 'never' || trim($row->publish_down) == '' || trim($row->publish_down) == '00:00:00')
		{
			$row->publish_down = $nullDate;
		}
		else
		{
			if (strlen(trim($row->publish_down)) <= 10)
			{
				$row->publish_down .= ' 00:00:00';
			}

			$date = Factory::getDate();

			$row->publish_down = $date->toSql();
		}


		//include_once(JPATH_BASE."/administrator/components/com_content/helper.php");
		// Prepare the content for saving to the database
		//ContentHelper::saveContentPrep( $row );
		// Make sure the data is valid
		if (!$row->check())
		{
			return false;
		}

		// Increment the content version number
		$row->version++;

		$result = Factory::getApplication()->triggerEvent('onBeforeContentSave', array(&$row, $isNew));
		if (in_array(false, $result, true))
		{
			throw new Exception($row->getError(), 500);

			return false;
		}

		// Store the content to the database
		if (!$row->store())
		{
			throw new Exception($row->getError(), 500);

			return false;
		}

		// Check the article and update item order
		$row->checkin();
		$row->reorder('catid = ' . (int) $row->catid . ' AND state >= 0');

		$cache = Factory::getCache('com_content');
		$cache->clean();

		Factory::getApplication()->triggerEvent('onAfterContentSave', array(&$row, $isNew));

		return $row->id;

	}

	/*
		public function onTranslateEvent(&$row, $language)
		{
			if (!isset($row->customfieldTranslations)) {
				$row->customfieldTranslations = array();
			}

			$field = array("name" => "agenda", "type" => "html", "label" => Text::_("Select_Agenda"));

			// get the data from database and attach to row
			$db = Factory::getDbo();
			$detailid = intval($row->evdet_id());
			$sql = "SELECT * FROM #__jev_agendaminutes as am WHERE evdet_id=" . $detailid;
			$db->setQuery($sql);
			$am = $db->loadObject();

			$content = Table::getInstance("content");
			$content->load($am->agenda_id);
			if ($content->id > 0)
			{
				$name = $content->title;
				$id = $content->id;
			}
			else
			{
				$name = "";
				$id = 0;
			}

			$id = "agendaminutes_" . $field["name"];
			$translation = new stdClass();
			$translation->label = "<strong>" . $field["label"] . "</strong>";
			$translation->original = $name;
			$translation->translation = 0;

			$fieldname = "translate_customfields[$id]";
			$translation->translation = "<input type='text' value='$translation->translation' name='$fieldname' />";

			$row->customfieldTranslations[$id] = $translation;

			$field = array("name" => "minutes", "type" => "html", "label" => Text::_("Select_Minutes"));

			return true;
		}
		*/
}
