<?php
defined('JPATH_BASE') or die();

use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

jimport( 'joomla.application.component.helper');
jimport( 'joomla.application.component.model');

// Based on joomla core model with added security filters on section, category and article access levels

/**
 * Content Component Article Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since		1.5
 */
class contentModelSectionCategory extends BaseDatabaseModel
{
	var $_data = null;


	/**
	 * Select item(s)
	 **/
	function getData()
	{
	
		// RSH 11/09/10 - Added logic to do different processing for J!1.6
		if (version_compare(JVERSION, "1.6.0", 'ge')) {  
			$sectCatList = HTMLHelper::_('select.genericlist', HTMLHelper::_('category.options', 'com_content'), 'sectcat', 'class="inputbox" style="cursor: pointer;" size="15" onchange="window.parent.jSelectSectionCategory(this[this.selectedIndex].value, this[this.selectedIndex].text);" ', 'value', 'text', NULL);
		} else {	
			$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible
			// Initialize variables
			$db			= Factory::getDbo();
			$user = Factory::getUser();
			$aid = $user->get('aid');

			## Section & Category query
			$query = 'SELECT CONCAT_WS(",",s.id,c.id) AS `value`, CONCAT_WS(" / ", s.title, c.title) AS `text`' .
					' FROM #__sections AS s' .
					' INNER JOIN #__categories AS c ON c.section = s.id' .
					' WHERE s.scope = "content"' .
					' AND s.access <= '.$aid .
					' AND c.access <= '.$aid .
					' ORDER BY s.title, c.title';
			$db->setQuery($query);

			// Add a row for uncategorized content
			$uncat	= JHTML::_('select.option', '0,0', Text::_('UNCATEGORIZED'));
			$rows	= $db->loadObjectList();
			array_unshift($rows, $uncat);

			$sectCatList = JHTML::_('select.genericlist', $rows, 'sectcat', 'class="inputbox" style="cursor: pointer;" size="15" onchange="window.parent.jSelectSectionCategory(this[this.selectedIndex].value, this[this.selectedIndex].text);" ', 'value', 'text', NULL);
		}
		
		$_data = $sectCatList;
		
		return $_data;
	}

}