<?php
/**
 * @version		$Id: view.php 11625 2009-02-15 15:32:42Z kdevine $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\String\StringHelper;
use Joomla\CMS\Router\Route;
jimport('joomla.application.component.view');
JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

// Based on joomla core view with added security filters on section, category and article access levels

/**
 * HTML Article Element View class for the Content component
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
include_once(JPATH_SITE . "/components/com_jevents/jevents.defines.php");

class ContentViewFrontelement extends HtmlView
{

	function display($tpl = NULL)
	{
		$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible
		// Initialize variables
		$db =  Factory::getDBO();
		$nullDate = $db->getNullDate();

		$limitstart = Factory::getApplication()->input->getInt('limitstart', '0');

		$lists = $this->_getLists();

		//Ordering allowed ?
		$ordering = ($lists['order'] == 'section_name' && $lists['order_Dir'] == 'ASC');

		$rows = $this->get('List');
		$page = $this->get('Pagination');
		HTMLHelper::_('bootstrap.tooltip');
		$client = Factory::getApplication()->isClient('administrator') ? "administrator" : "site";
		$link = Route::_("index.php?option=com_jevents&task=plugin.cck&action=selectcontent&tmpl=component&client=$client&type=$this->cck&object=id", false);
		?>
		<form action="<?php echo $link;?>" method="post" name="adminForm">

			<table>
				<tr>
					<td width="100%">
						<?php echo Text::_('Filter'); ?>:
						<input type="text" name="search" id="search" value="<?php echo $lists['search']; ?>" class="text_area" onchange="document.adminForm.submit();" />
						<button onclick="this.form.submit();"><?php echo Text::_('Go'); ?></button>
						<button onclick="document.getElementById('search').value = '';
								this.form.submit();"><?php echo Text::_('Reset'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php
						if (version_compare(JVERSION, "1.6.0", 'ge'))
						{
							echo $lists['categories'];  // RSH 11/09/10 - Added new list for J!1.6 Compatibility
						}
						else
						{
							echo $lists['sectionid'];
							echo $lists['catid'];
						}
						?>
					</td>
				</tr>
			</table>

			<table class="adminlist" cellspacing="1">
				<thead>
					<tr>
						<th width="5">
							<?php echo Text::_('Num'); ?>
						</th>
						<th class="title">
							<?php echo JHTML::_('grid.sort', 'Title', 'c.title', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
						<?php if (!version_compare(JVERSION, "1.6.0", 'ge'))
						{
							?>
							<th width="7%">
							<?php echo JHTML::_('grid.sort', 'Access', 'groupname', @$lists['order_Dir'], @$lists['order']); ?>
							</th>
							<?php } ?>
						<th width="2%" class="title">
						<?php echo JHTML::_('grid.sort', 'ID', 'c.id', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
						<?php if (!version_compare(JVERSION, "1.6.0", 'ge'))
						{
							?>
							<th class="title" width="15%" nowrap="nowrap">
							<?php echo JHTML::_('grid.sort', 'Section', 'section_name', @$lists['order_Dir'], @$lists['order']); ?>
							</th>
							<?php } ?>
						<th  class="title" width="15%" nowrap="nowrap">
							<?php echo JHTML::_('grid.sort', 'Category', 'cc.title', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
						<th align="center" width="10">
		<?php echo JHTML::_('grid.sort', 'Date', 'c.created', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="15">
		<?php echo $page->getListFooter(); ?>
						</td>
					</tr>
				</tfoot>
				<tbody>
					<?php
					$k = 0;
					for ($i = 0, $n = count($rows); $i < $n; $i++)
					{
						$row = &$rows[$i];

						$link = '';
						$date = JHTML::_('date', $row->created, Text::_('DATE_FORMAT_LC4'));
						?>
						<tr class="<?php echo "row$k"; ?>">
							<td>
			<?php echo $page->getRowOffset($i); ?>
							</td>
							<td>
								<span class="editlinktip hasTip" title="<?php echo Text::_('jev_Select_LISTING'); ?>::<?php echo $this->escape($row->title); ?>">
									<a href="javascript:void()" onclick="return window.parent.sortableCCK.selectThisCck(<?php echo $row->id; ?>, this);"><?php echo $this->escape($row->title); ?></a>
								</span>
							</td>
								<?php if (!version_compare(JVERSION, "1.6.0", 'ge'))
								{
									?>
								<td align="center">
									<?php echo $row->groupname; ?>
								</td>
							<?php } ?>
							<td>
							<?php echo $row->id; ?>
							</td>
								<?php if (!version_compare(JVERSION, "1.6.0", 'ge'))
								{
									?>
								<td>
									<?php echo $row->section_name; ?>
								</td>
								<?php } ?>
							<td>
			<?php echo $row->cctitle; ?>
							</td>
							<td nowrap="nowrap">
						<?php echo $date; ?>
							</td>
						</tr>
			<?php
			$k = 1 - $k;
		}
		?>
				</tbody>
			</table>
			<input type="hidden" name="type" value="content" />

			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="client" value="<?php echo Factory::getApplication()->input->getString("client", "site"); ?>" />
			<input type="hidden" name="filter_order" value="<?php echo $lists['order']; ?>" />
			<input type="hidden" name="filter_order_Dir" value="<?php echo $lists['order_Dir']; ?>" />
		</form>
		<?php

	}

	function _getLists()
	{
		$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible
		// Initialize variables
		$db =  Factory::getDBO();

		// Get some variables from the request
		$sectionid = Factory::getApplication()->input->getInt('sectionid', -1);
		$redirect = $sectionid;
		$option = Factory::getApplication()->input->getCmd('option');
		$filter_order = $mainframe->getUserStateFromRequest('articleelement.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir', 'filter_order_Dir', '', 'word');
		$filter_state = $mainframe->getUserStateFromRequest('articleelement.filter_state', 'filter_state', '', 'word');
		$catid = $mainframe->getUserStateFromRequest('articleelement.catid', 'catid', 0, 'int');
		$filter_authorid = $mainframe->getUserStateFromRequest('articleelement.filter_authorid', 'filter_authorid', 0, 'int');
		$filter_sectionid = $mainframe->getUserStateFromRequest('articleelement.filter_sectionid', 'filter_sectionid', -1, 'int');
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('articleelement.limitstart', 'limitstart', 0, 'int');
		$search = $mainframe->getUserStateFromRequest('articleelement.search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);


		// get list of sections for dropdown filter
		$javascript = 'onchange="document.adminForm.submit();"';

		// RSH 11/09/10 - Added logic to do different processing for J!1.6
		if (version_compare(JVERSION, "1.6.0", 'ge'))
		{
			$options = HTMLHelper::_('category.options', 'com_content');
			array_unshift($options, HTMLHelper::_('select.option', 0, Text::_("SELECT_CATEGORY")));
			$lists['categories'] = HTMLHelper::_('select.genericlist', $options, 'catid', 'class="inputbox" size="1" ' . $javascript, 'value', 'text', $catid);
		}
		else
		{
			// get list of categories for dropdown filter
			$filter = ($filter_sectionid >= 0) ? ' WHERE cc.section = ' . $db->Quote($filter_sectionid) : '';

			$user = Factory::getUser();
			$filter .= ($filter == "") ? " WHERE " : " AND ";
			$filter .= " cc.access" . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . JEVHelper::getAid($user) . ')' : ' <=  ' . JEVHelper::getAid($user)) .
					" AND s.access" . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . JEVHelper::getAid($user) . ')' : ' <=  ' . JEVHelper::getAid($user));

			// get list of categories for dropdown filter
			$query = 'SELECT cc.id AS value, cc.title AS text, section' .
					' FROM #__categories AS cc' .
					' INNER JOIN #__sections AS s ON s.id = cc.section' .
					$filter .
					' ORDER BY s.ordering, cc.ordering';

			$lists['catid'] = ContentHelper::filterCategory($query, $catid);

			$sections[] = JHTML::_('select.option', '-1', '- ' . Text::_('Select_Section') . ' -');
			$sections[] = JHTML::_('select.option', '0', Text::_('Uncategorized'));

			$query = 'SELECT id AS value, title AS text'
					. ' FROM #__sections'
					. ' WHERE published = 1' . " AND access" . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . JEVHelper::getAid($user) . ')' : ' <=  ' . JEVHelper::getAid($user))
					. ' ORDER BY ordering'
			;
			$db->setQuery($query);
			$sections = array_merge($sections, $db->loadObjectList());

			$lists['sectionid'] = JHTML::_('select.genericlist', $sections, 'filter_sectionid', 'class="inputbox" size="1" ' . $javascript, 'value', 'text', $filter_sectionid);
		}

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;

		return $lists;

	}

}
