<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod.defines.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;

class Jeveasyblog
{

	private
			$params;

	public
			function __construct($params)
	{
		$this->params = $params;
		$db =  Factory::getDbo();
                
                $db->setQuery("SELECT * FROM #__extensions where element='com_easyblog'");
                $easyblog = $db->loadObject();
                if (!$easyblog) {
                    $this->_list = array();
                    return $this->_list;
                }
                $easyblogData = new Registry($easyblog->manifest_cache);
                $this->easyblogVersion = $easyblogData->get("version","1.0.0");                
                
	}

	public
			function loadLanguages()
	{
		$lang = Factory::getLanguage();
		$lang->load("com_easyblog", JPATH_SITE);
		$lang->load("com_easyblog", JPATH_ADMINISTRATOR);

	}

	public
			function getcurrentListings($evdetid)
	{
		$db = Factory::getDBO();
		$sql = "SELECT  s2.id as cckid, s2.title as title FROM #__jev_cckeventsmap as jcckm
			LEFT JOIN #__easyblog_post as s2 ON s2.id = jcckm.cck_id
			WHERE jcckm.evdet_id =$evdetid";

		$db->setQuery($sql);
		$ret = @$db->loadObjectList('cckid');
		//echo $db->getErrorMsg();
		return $ret;

	}

	public
			function getcurrentMatched($invalue)
	{
		if (!is_array($invalue))
		{
			$invalue = array($invalue);
		}
		if (count($invalue) > 0)
		{
			$db = Factory::getDBO();
			$sql = "SELECT s2.id as cckid, s2.title FROM #__easyblog_post as s2
				WHERE s2.id IN(" . implode(",", $invalue) . ")";

			$db->setQuery($sql);
			return @$db->loadObjectList('cckid');
		}
		return array();

	}

	public
			function getPossible()
	{
		$allowall = $this->params->get('allowallselect', 0);
		if ($allowall == 0)
		{
			// All possible candidates
			$user  = Factory::getUser();
			$where = " WHERE s2.created_by=" . $user->id;
			// managers and above can pick ownerless entries too
			//if ($user->gid >= 20 and $user->gid != 29)
			if (version_compare(JVERSION, "1.6.0", 'ge') && Factory::getUser()->authorise('core.access'))
			{
				$where = "";
			}
			else if (!version_compare(JVERSION, "1.6.0", 'ge') && $user->gid >= 20 and $user->gid != 29)
			{
				$where = " WHERE s2.created_by IN (0," . $user->id . ") ";
			}
		} else {
			$where = '';
		}
		$sql = "SELECT s2.id as cckid, s2.title FROM #__easyblog_post as s2 $where order by title asc";
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$s2items = $db->loadObjectList();
		return $s2items;

	}

	public
			function getOption($possible, $invalue)
	{
		$title = $possible->title;
		$possible = $possible->cckid;
		$selected = in_array($possible, $invalue) ? "selected='selected'" : "";
		return "<option value='$possible' $selected>$title</option>";

	}

	public
			function getLi($possible)
	{
		$title = $possible->title;
		$pid = $possible->cckid;
		return "<li id='sortablecck$pid' >$title</li>";

	}

	public
			function getModel()
	{
		$model = BaseDatabaseModel::getInstance("frontelement", "easyblogModel");
		$model->setState('task', "element");
		return $model;

	}

	public
			function getLink($cckid, $Itemid, $tmpl)
	{
                if (version_compare($this->easyblogVersion, "5.0.0", "lt")){
                    include_once(JPATH_SITE . "/components/com_easyblog/helpers/router.php");
                    $link = EasyBlogRouter::_('index.php?option=com_easyblog&view=entry&id=' . $cckid);
                }
                else {
                    include_once(JPATH_ADMINISTRATOR . "/components/com_easyblog/includes/easyblog.php");
                    include_once(JPATH_ADMINISTRATOR . "/components/com_easyblog/includes/router.php");
                    $link = EBR::_('index.php?option=com_easyblog&view=entry&id=' . $cckid);
                }
		//$link = Route::_("index.php?option=com_easyblog&easyblogTask=easyblogDetails$tmpl&easyblogId=" . $cckid . "&Itemid=$Itemid");
		return $link;

	}

}

