<?php

defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Pagination\Pagination;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;

jimport('joomla.application.component.helper');
jimport('joomla.application.component.model');
jimport('joomla.html.parameter');

JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

// Based on joomla core model with added security filters on section, category and article access levels

/**
 * Content Component Article Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since		1.5
 */
class easyblogModelFrontelement extends BaseDatabaseModel
{

	/**
	 * Content data in category array
	 *
	 * @var array
	 */
	var
			$_list = null;
	var
			$_page = null;

	/**
	 * Method to get content article data for the frontpage
	 *
	 * @since 1.5
	 */
	function getList()
	{
		$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible

		$user = Factory::getUser();

		if (!empty($this->_list))
		{
			return $this->_list;
		}

		// Initialize variables
		$db =  $this->getDBO();
                
                $db->setQuery("SELECT * FROM #__extensions where element='com_easyblog'");
                $easyblog = $db->loadObject();
                if (!$easyblog) {
                    $this->_list = array();
                    return $this->_list;
                }
                $easyblogData = new Registry($easyblog->manifest_cache);
                $easyblogVersion = $easyblogData->get("version","1.0.0");                
                               
		$filter = null;

		// Get some variables from the request
		$sectionid = Factory::getApplication()->input->getInt('sectionid', -1);
		$redirect = $sectionid;
		$option = Factory::getApplication()->input->getCmd('option');
		$filter_order = $mainframe->getUserStateFromRequest('articleelement.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir', 'filter_order_Dir', '', 'word');
		$catid = $mainframe->getUserStateFromRequest('articleelement.catid', 'cc.id', 0, 'int');
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = Factory::getApplication()->input->getInt('limitstart', 0);
		$search = $mainframe->getUserStateFromRequest('articleelement.search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);

		// All possible candidates
		$user = Factory::getUser();
		// editors and above can pick any entries
		//if ($user->gid >= 20 and $user->gid != 29)
		if (Factory::getUser()->authorise('core.access'))
		{
			//$where[]  = " s2.created_by IN (0,".$user->id. ") ";
		}
		else
		{
			$where[] = " s2.created_by=" . $user->id;
		}

		if (!$filter_order)
		{
			$filter_order = 's2.title';
		}
		$order = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir;
		$all = 1;

		$section = new stdClass();
		$section->title = 'All Entries';
		$section->id = 0;

		// Category filter
		if ($catid > 0)
		{
			$where[] = 's2.category_id= ' . (int) $catid;
		}

		// Only published 
		$where[] = 's2.published = 1';

                if (version_compare($easyblogVersion, "5.0.0", "lt")){
                    // Only sitewide                
                    $where[] = 's2.issitewide= 1';
                }

		// Keyword filter
		if ($search)
		{
			$where[] = 'LOWER( s2.title ) LIKE ' . $db->Quote('%' . $db->escape($search, true) . '%', false);
		}

		// Build the where clause of the content record query
		$where = (count($where) ? ' WHERE ' . implode(' AND ', $where) : '');

		$sql = "SELECT s2.id as cckid, s2.title FROM #__easyblog_post as s2
		$where
		GROUP BY s2.id 
		$order";

		$db = Factory::getDBO();
		$db->setQuery($sql);
		$s2items = $db->loadObjectList();

		// Get the total number of records
		$query = "SELECT count(s2.id)  FROM #__easyblog_post as s2
		$where
		GROUP BY s2.id ";
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$this->_page = new Pagination($total, $limitstart, $limit);

		// Get the listings
		$query = "SELECT s2.id as id, s2.title, GROUP_CONCAT(cc.title SEPARATOR '<br/>') as catname FROM #__easyblog_post as s2
		LEFT JOIN #__easyblog_category as cc on cc.id =s2.category_id
		$where
		GROUP BY s2.id
		$order";
		$db->setQuery($query, $this->_page->limitstart, $this->_page->limit);
		$this->_list = $db->loadObjectList();

		// If there is a db query error, throw a HTTP 500 and exit
		if (false && $db->getErrorNum())
		{
			throw new Exception( $db->stderr(), 500);
			//	return false;
		}

		return $this->_list;

	}

	function getPagination()
	{
		if (is_null($this->_list) || is_null($this->_page))
		{
			$this->getList();
		}
		return $this->_page;

	}

}

