<?php

use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Date\Date;
use Joomla\CMS\Factory;

/**
 * @copyright	Copyright (C) 2013 GWE Systems Ltd. All rights reserved.
 *
 */
//ini_set("display_errors",0);
// make sure we have enough time to get all the data!
@ini_set("max_execution_time", 600);

//importing K2 events is ok
define("ENABLEIMPORT", 1);
// k2 events redirect from Jevents to K2 when viewed.
define("REDIRECTIMPORT", 1);

// Set flag that this is a parent file
define('_JEXEC', 1);
$x = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR);
if (!file_exists($x . DIRECTORY_SEPARATOR . "plugins"))
{
	$x = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR);
}
define('JPATH_BASE', $x);

// SETUP DATA AND INSTRUCTIONS
// use custom field name aliases
$startdate = "Article Date";
$enddate = "End Date";

// standard K2 fields
$title = "title";
$description = "introtext";
// END OF SETUP 
// 
// create the mainframe object
$_REQUEST['tmpl'] = 'component';

require_once JPATH_SITE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'defines.php';
require_once JPATH_SITE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'framework.php';
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");

global $mainframe;
$mainframe =  Factory::getApplication('site');
$mainframe->initialise();

if (!version_compare(JVERSION, "1.6.0", 'ge'))
{
	// load system plugin so that sef apps can change the router !
	PluginHelper::importPlugin('system');
	$mainframe->triggerEvent('onAfterInitialise');
}

if (!ENABLEIMPORT)
	die("No import  allowed");
$redirectimport = REDIRECTIMPORT;
;

$db = Factory::getDBO();

// get the custom fields id
$db->setQuery("SELECT * FROM #__k2_extra_fields as k2f  where name=" . $db->quote($startdate));
$startfield = $db->loadObject();
$startfieldalias = json_decode($startfield->value);
$startfieldalias = $startfieldalias[0]->alias;
$startfieldid = $startfield->id;

$db->setQuery("SELECT * FROM #__k2_extra_fields as k2f  where name=" . $db->quote($enddate));
$endfield = $db->loadObject();
$endfieldalias = json_decode($endfield->value);
$endfieldalias = $endfieldalias[0]->alias;
$endfieldid = $endfield->id;

// count all the events from K2  with a start date set
$db->setQuery("Select count(id) from #__k2_items as k2 where published=1 AND  extra_fields like '%\"id\":\"$startfieldid\"%' ");
$eventcount = $db->loadResult();

for ($loop = 0; $loop < $eventcount / 100 + 1; $loop++)
{
	$db->setQuery("Select * from #__k2_items as k2 where published=1 AND  extra_fields like '%\"id\":\"$startfieldid\"%' LIMIT  " . ($loop * 100) . ",  " . ($loop + 1) * 100);
	$events = $db->loadObjectList('id');
	foreach ($events as $id => $event)
	{
		$extrainfo = json_decode($event->extra_fields);
		$info = array();
		foreach ($extrainfo as $ei)
		{
			$info[$ei->id] = $ei->value;
		}

		$startdate = $info[$startfieldid];
		$enddate = isset($info[$endfieldid]) ? $info[$endfieldid] : $info[$startfieldid];
	}
}

jimport("joomla.utilities.date");
include_once (JPATH_SITE . "/components/com_k2/helpers/route.php");

header('Content-type: text/Calendar');
header('Content-Disposition: attachment; filename="calendar.ics"');
?>BEGIN:VCALENDAR
VERSION:2.0
<?php
for ($loop = 0; $loop < $eventcount / 100 + 1; $loop++)
{
	$db->setQuery("Select k2.*, u.username as creator from #__k2_items as k2 
			LEFT JOIN #__users as u ON u.id = k2.created_by
			where k2.published=1 AND  k2.extra_fields like '%\"id\":\"$startfieldid\"%' LIMIT  " . ($loop * 100) . ",  " . ($loop + 1) * 100);
	$events = $db->loadObjectList('id');
	foreach ($events as $id => $event)
	{
		$extrainfo = json_decode($event->extra_fields);

		$info = array();
		foreach ($extrainfo as $ei)
		{
			$info[$ei->id] = $ei->value;
		}

		$startdate = $info[$startfieldid];
		$enddate = isset($info[$endfieldid]) ? $info[$endfieldid] : $info[$startfieldid];

		$date = new Date($startdate);
		$dtstart = $date->toFormat('%Y%m%dT%H%M%SZ');

		$date = new Date($enddate);
		$dtend = $date->toFormat('%Y%m%dT%H%M%SZ');

		$url = Route::_(K2HelperRoute::getItemRoute($id, $event->catid));
		$url = str_replace("plugins/jevents/jevcck/", "", $url);
		$url = str_replace("plugins/jevents/jevcck/cck/", "", $url);
		?>
		BEGIN:VEVENT
		URL:<?php echo $url; ?>

		DTSTART:<?php echo $dtstart; ?>
		DTEND:<?php echo $dtend; ?>

		SUMMARY:<?php echo $event->$title; ?>

		DESCRIPTION:<?php echo $event->$description . "<Br/><a href='" . $url . "' >More Details</a>"; ?>

		UID:K2<?php echo $event->created_by . "xx" . $event->id;  // LOCATION:<?php echo $event->location; // ?>

		X-CREATEDBY:<?php echo $event->creator; ?>

		END:VEVENT
		<?php
	}
}
?>
END:VCALENDAR

