<?php

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;
use Joomla\CMS\Application\ApplicationHelper;

/**
 * @copyright	Copyright (C) 2011 GWE Systems Ltd. All rights reserved.
 *
 * Portions of this code :
 * @copyright Copyright (C) 2006 - 2011 Sigsiu.NET GmbH (http://www.sigsiu.net). All rights reserved.
 * @license see http://www.gnu.org/licenses/lgpl.html GNU/LGPL Version 3.
 */
//ini_set("display_errors",0);
// make sure we have enough time to get all the data!
@ini_set("max_execution_time", 600);

// Set flag that this is a parent file
define('_JEXEC', 1);
$x = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR );
if (!file_exists($x . DIRECTORY_SEPARATOR . "plugins"))
{
	$x = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR );
}
if (!file_exists($x . DIRECTORY_SEPARATOR . "plugins"))
{
	$x = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR);
}
if (!file_exists($x . DIRECTORY_SEPARATOR . "plugins") && isset($_SERVER["SCRIPT_FILENAME"]))
{
	$x = dirname(dirname(dirname(dirname(dirname($_SERVER["SCRIPT_FILENAME"])))));
}
define('JPATH_BASE', $x);

// SETUP DATA AND INSTRUCTIONS
// pass section id via url e.g. ?sid=1&menuid=331 for section 1 and menu id 331

$startdate = "field_start_date";
$enddate = "field_end_date";
$title = "field_name";
$description = "field_description";
$location = "field_gearbox";

// create the mainframe object
$_REQUEST['tmpl'] = 'component';

require_once JPATH_BASE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'defines.php';
require_once JPATH_BASE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'framework.php';
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");

global $mainframe;
$mainframe =  Factory::getApplication('site');

$mainframe->initialise();

$menuid = Factory::getApplication()->input->getInt("menuid", 966);

if (!version_compare(JVERSION, "1.6.0", 'ge'))
{
	// load system plugin so that sef apps can change the router !
	PluginHelper::importPlugin('system');
	$mainframe->triggerEvent('onAfterInitialise');
}

$lang = Factory::getLanguage();
$lang->load("plg_jevents_jevjsstream", JPATH_ADMINISTRATOR);


// Sobi Pro setup

define('SOBI_TESTS', false);

if (version_compare(JVERSION, '1.6.0', 'ge'))
{
	define('SOBI_CMS', 'joomla16');
}
else
{
	define('SOBI_CMS', 'joomla15');
}
define('SOBIPRO', true);
define('SOBI_TASK', 'task');
define('SOBI_DEFLANG', Factory::getConfig()->get('config.language'));
define('SOBI_ACL', 'front');
define('SOBI_ROOT', JPATH_ROOT);
define('SOBI_MEDIA', implode(DIRECTORY_SEPARATOR, array(JPATH_ROOT, 'media', 'sobipro')));
define('SOBI_MEDIA_LIVE', JURI::root() . '/media/sobipro');
define('SOBI_PATH', SOBI_ROOT . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_sobipro');
define('SOBI_LIVE_PATH', 'components/com_sobipro');
require_once ( SOBI_PATH . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR . 'base' . DIRECTORY_SEPARATOR . 'fs' . DIRECTORY_SEPARATOR . 'loader.php' );
SPLoader::loadController('interface');
SPLoader::loadClass('base.filter');
SPLoader::loadClass('base.request');

// Try to catch direct file calls. Like /directory/piwik.php
if (preg_match('/\.php$/', SPRequest::task()) || strlen(SPRequest::task()) > 50)
{
	throw new Exception( 'Unauthorized Access', 403);
}
$class = SPLoader::loadController('sobipro');
$sobi = new $class(SPRequest::task());

$ctrl = SPLoader::loadController('section');
$ctrl = new $ctrl();

$sid = SPRequest::int('sid');
$section =  SPFactory::object($sid);

$ctrl->setModel("SPSection");
$ctrl->extend($section);

// A list of SOBI2 entries
$entries = $ctrl->getEntries('createdTime', 0, 0, false, null, 1);

$class = SPLoader::loadView('section');

class MySPSectionView extends SPSectionView
{

	public
			function __construct($tTask = null)
	{
		return parent::__construct($tTask);

	}

	public
			function getEntry($entry, $manager, $noId = false)
	{
		return $this->entry($entry, $manager, $noId);

	}

}

//$view = new $class('view');
$view = new MySPSectionView('view');

/*
  foreach ($entries as $eid)
  {
  $en = $view->getEntry($eid, 1);
  if (isset($en["fields"]) && isset($en["fields"]["field_start_date"]))
  {
  if (isset($en["fields"]["field_start_date"]["_data"]["data"]["_attributes"]["timestamp"]))
  {
  echo ( $en["fields"]["field_start_date"]["_data"]["data"]["_attributes"]["timestamp"]) . "<br/>";
  $entry = SPFactory::Entry($eid);

  foreach ($entry->getFields() as $nid => $field)
  {
  echo $nid . " : " . $field->get('name') . " : " . $field->data() . "</br>";
  //$struct = $field->struct();
  //var_dump($struct);
  }
  }
  //print_r( $en["fields"]);
  }
  }
  exit();
 */

$db = Factory::getDBO();
jimport("joomla.utilities.date");

header('Content-type: text/Calendar');
header('Content-Disposition: attachment; filename="calendar.ics"');
?>BEGIN:VCALENDAR
VERSION:2.0
<?php
foreach ($entries as $eid)
{
	$entry = SPFactory::Entry($eid);
	$fields = $entry->getFields();
	if (!array_key_exists($startdate, $fields) || $fields[$startdate]->data() == "")
	{
		echo "Entry " . $fields[$title]->data() . " has no $startdate field value\n";
		continue;
	}

	$dtstart = strftime('%Y%m%dT%H%M%S', $fields[$startdate]->data());
	if (array_key_exists($enddate, $fields))
	{
		$dtend = strftime('%Y%m%dT%H%M%S', $fields[$enddate]->data());
	}
	else
	{
		$dtend = $dtstart;
	}

	$sid = Factory::getApplication()->input->getInt("sid", 0);
	$url = Route::_("index.php?option=com_sobipro&pid=$sid&sid=$eid:" . ApplicationHelper::stringURLSafe($fields[$title]->data()) . "&Itemid=$menuid");
	// reset the path for the URLs!
	$url = str_replace("plugins/jevents/jevcck/cck/", "", $url);	
        $url = str_replace("plugins/jevents/jevcck/", "", $url);
	?>
BEGIN:VEVENT

URL:<?php echo $url; ?>

DTSTART:<?php echo $dtstart; ?>

DTEND:<?php echo $dtend; ?>

SUMMARY:<?php echo wraplines($fields[$title]->data()); ?>

UID:SOBI<?php echo $eid; ?>

DESCRIPTION:<?php
	if (array_key_exists($description, $fields))
	{
		echo wraplines($fields[$description]->data() . "<br/>" . Text::sprintf("JEV_MORE_DETAILS", $url));
	}
	else
	{
		echo "No such field as description";
	}
	?>

LOCATION:<?php echo wraplines($fields[$location]->data()); ?>

END:VEVENT
<?php
}
?>
END:VCALENDAR
<?php

function wraplines($input, $line_max = 76, $quotedprintable = false)
{
	$hex = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
	$eol = "\r\n";

	$input = str_replace($eol, "", $input);

	// new version

	$output = '';
	while (StringHelper::strlen($input) >= $line_max)
	{
		$output .= StringHelper::substr($input, 0, $line_max - 1);
		$input = StringHelper::substr($input, $line_max - 1);
		if (strlen($input) > 0)
		{
			$output .= $eol . " ";
		}
	}
	if (strlen($input) > 0)
	{
		$output .= $input;
	}
	return $output;

	$escape = '=';
	$output = '';
	$outline = "";
	$newline = ' ';

	$linlen = StringHelper::strlen($input);


	for ($i = 0; $i < $linlen; $i++)
	{
		$c = StringHelper::substr($input, $i, 1);

		/*
		  $dec = ord($c);
		  if (!$quotedprintable) {
		  if (($dec == 32) && ($i == ($linlen - 1))) { // convert space at eol only
		  $c = '=20';
		  } elseif (($dec == 61) || ($dec < 32 ) || ($dec > 126)) { // always encode "\t", which is *not* required
		  $h2 = floor($dec / 16);
		  $h1 = floor($dec % 16);
		  $c = $escape . $hex["$h2"] . $hex["$h1"];
		  }
		  }
		 */
		if ((strlen($outline) + 1) >= $line_max)
		{ // CRLF is not counted
			$output .= $outline . $eol . $newline; // soft line break; "\r\n" is okay
			$outline = $c;
			//$newline .= " ";
		}
		else
		{
			$outline .= $c;
		}
	} // end of for
	$output .= $outline;

	return trim($output);

}
