<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod.defines.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;

class Jevk2
{

	private
			$params;

	public
			function __construct($params)
	{
		$this->params = $params;

	}

	public
			function loadLanguages()
	{
		$lang = Factory::getLanguage();
		$lang->load("com_k2", JPATH_SITE);
		$lang->load("com_k2", JPATH_ADMINISTRATOR);

	}

	public
			function getcurrentListings($evdetid)
	{
		$db = Factory::getDBO();
		$sql = "SELECT cck.id as cckid, cck.title as title FROM #__jev_cckeventsmap as jcckm
			LEFT JOIN #__k2_items as cck ON cck.id = jcckm.cck_id
			WHERE jcckm.evdet_id =$evdetid";

		$db->setQuery($sql);
		return @$db->loadObjectList('cckid');

	}

	public
			function getcurrentMatched($invalue)
	{
		if (!is_array($invalue))
		{
			$invalue = array($invalue);
		}
		if (count($invalue) > 0)
		{
			$db = Factory::getDBO();
			$sql = "SELECT cck.id as cckid, cck.title as title FROM #__k2_items as cck
				WHERE cck.id IN(" . implode(",", $invalue) . ")";

			$db->setQuery($sql);
			return @$db->loadObjectList('cckid');
		}
		return array();

	}

	public
			function getPossible()
	{
		$allowall = $this->params->get('allowallselect', 0);
		if ($allowall == 0)
		{
			// All possible candidates
			$user  = Factory::getUser();
			$where = " WHERE cck.created_by=" . $user->id;
			// managers and above can pick any entries
			//if ($user->gid >= 20 and $user->gid != 29)
			if (version_compare(JVERSION, "1.6.0", 'ge') && Factory::getUser()->authorise('core.access'))
			{
				$where = "";
			}
			else if (!version_compare(JVERSION, "1.6.0", 'ge') && $user->gid >= 20 and $user->gid != 29)
			{
				$where = "";
			}
		} else {
			$where = '';
		}

		$sql = "SELECT cck.id as cckid, cck.title FROM #__k2_items as cck $where order by title asc limit 10";
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$cckitems = $db->loadObjectList();
		return $cckitems;

	}

	public
			function getOption($possible, $invalue)
	{
		$title = $possible->title;
		$possible = $possible->cckid;
		$selected = in_array($possible, $invalue) ? "selected='selected'" : "";
		return "<option value='$possible' $selected>$title</option>";

	}

	public
			function getLi($possible)
	{
		$title = $possible->title;
		$pid = $possible->cckid;
		return "<li id='sortablecck$pid' >$title</li>";

	}

	public
			function getModel()
	{
		$model = BaseDatabaseModel::getInstance("frontelement", "k2Model");
		$model->setState('task', "element");
		return $model;

	}

	public
			function getLink($cckid, $Itemid, $tmpl)
	{
		
		$db = Factory::getDBO();
		$sql = "SELECT cck.id as cckid, cck.title as title, cck.alias as alias FROM #__k2_items as cck
		WHERE cck.id = " . intval($cckid);
		$db->setQuery($sql);
		$item = $db->loadObject();

		if ($item)
		{
			$link = Route::_("index.php?option=com_k2&view=item$tmpl&id=" . $cckid . ":" . $item->alias . "&Itemid=$Itemid");			
		}
		else {
			$link = Route::_("index.php?option=com_k2&view=item$tmpl&id=" . $cckid . "&Itemid=$Itemid");
		}
		return $link;

	}

}

