<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod.defines.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;

class Jevsobi2
{

	private
		$params;

	public
	function __construct($params)
	{
		$this->params = $params;

	}

	public
	function loadLanguages()
	{
		$lang = Factory::getLanguage();
		$lang->load("com_sobi2", JPATH_SITE);
		$lang->load("com_sobi2", JPATH_ADMINISTRATOR);

	}

	public
	function getcurrentListings($evdetid)
	{
		$db = Factory::getDBO();
		$sql = "SELECT cck.id as cckid, cck.title as title FROM #__jev_cckeventsmap as jcckm
			LEFT JOIN #__sobi2_item as s2 ON s2.itemid = jcckm.cck_id
			WHERE jcckm.evdet_id =$evdetid";

		try
		{
			$db->setQuery($sql);
			$listings = @$db->loadObjectList('cckid');
		}
		catch (Exception $e)
		{
			$listings = array();
		}
		return $listings;
	}

	public
	function getcurrentMatched($invalue)
	{
		if (!is_array($invalue))
		{
			$invalue = array($invalue);
		}
		$matched = array();
		if (count($invalue) > 0)
		{
			$db = Factory::getDBO();
			$sql = "SELECT s2.itemid as cckid, s2.title FROM #__sobi2_item as s2
				WHERE s2.itemid IN(" . implode(",", $invalue) . ")";

			try
			{
				$db->setQuery($sql);

				$matched = @$db->loadObjectList('cckid');
			}
			catch (Exception $e)
			{
				$matched = array();
			}
		}
		return $matched;

	}

	public
	function getPossible()
	{
		// All possible candidates
		$user = Factory::getUser();
		$where = " WHERE s2.owner=" . $user->id;
		// managers and above can pick ownerless entries too
		if (Factory::getUser()->authorise('core.access'))
		{
			//$where = " WHERE s2.owner IN (0," . $user->id . ") ";
			$where = " ";
		}
		$sql = "SELECT s2.itemid as cckid, s2.title FROM #__sobi2_item as s2 $where order by title asc";
		$db = Factory::getDBO();
		try
		{
			$db->setQuery($sql);
			$s2items = $db->loadObjectList();
		}
		catch (Exception $e)
		{
			$s2items = array();
		}

		return $s2items;

	}

	public
	function getOption($possible, $invalue)
	{
		$title = $possible->title;
		$possible = $possible->cckid;
		$selected = in_array($possible, $invalue) ? "selected='selected'" : "";
		return "<option value='$possible' $selected>$title</option>";

	}

	public
	function getLi($possible)
	{
		$title = $possible->title;
		$pid = $possible->cckid;
		return "<li id='sortablecck$pid' >$title</li>";

	}

	public
	function getModel()
	{
		$model = BaseDatabaseModel::getInstance("frontelement", "sobi2Model");
		$model->setState('task', "element");
		return $model;

	}

	public
	function getLink($cckid, $Itemid, $tmpl)
	{
		$link = Route::_("index.php?option=com_sobi2&sobi2Task=sobi2Details$tmpl&sobi2Id=" . $cckid . "&Itemid=$Itemid");
		return $link;

	}

}

