<?php

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Pagination\Pagination;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;

jimport('joomla.application.component.helper');
jimport('joomla.application.component.model');
jimport('joomla.html.parameter');

JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

// Based on joomla core model with added security filters on section, category and article access levels

/**
 * Content Component Article Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since		1.5
 */
class sobi2ModelFrontelement extends BaseDatabaseModel
{

	/**
	 * Content data in category array
	 *
	 * @var array
	 */
	var
			$_list = null;
	var
			$_page = null;

	/**
	 * Method to get content article data for the frontpage
	 *
	 * @since 1.5
	 */
	function getList()
	{
		$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible

		$user = Factory::getUser();

		if (!empty($this->_list))
		{
			return $this->_list;
		}

		// Initialize variables
		$db =  $this->getDBO();
		$filter = null;

		// Get some variables from the request
		$sectionid = Factory::getApplication()->input->getInt('sectionid', -1);
		$redirect = $sectionid;
		$option = Factory::getApplication()->input->getCmd('option');
		$filter_order = $mainframe->getUserStateFromRequest('articleelement.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir', 'filter_order_Dir', '', 'word');
		$catid = $mainframe->getUserStateFromRequest('articleelement.catid', 'catid', 0, 'int');
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = Factory::getApplication()->input->getInt('limitstart', 0);
		$search = $mainframe->getUserStateFromRequest('articleelement.search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);

		// All possible candidates
		$user = Factory::getUser();
		// editors and above can pick any entries
		//if ($user->gid >= 20 and $user->gid != 29)
		if (Factory::getUser()->authorise('core.access'))
		{
			//$where[]  = " s2.owner IN (0,".$user->id. ") ";
		}
		else
		{
			$where[] = " s2.owner=" . $user->id;
		}

		if (!$filter_order)
		{
			$filter_order = 's2.title';
		}
		$order = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir;
		$all = 1;

		$section = new stdClass();
		$section->title = 'All Entries';
		$section->id = 0;

		// Category filter
		if ($catid > 0)
		{
			$where[] = 'scr.catid = ' . (int) $catid;
		}

		// Only published 
		//$where[] = 's2.confirmed = 1';
		// Only approved
		$where[] = 's2.approved= 1';

		// Only entries
		$where[] = "s2.oType= 'entry'";

		// Keyword filter
		if ($search)
		{
			$where[] = 'LOWER( s2.title ) LIKE ' . $db->Quote('%' . $db->escape($search, true) . '%', false);
		}

		// Build the where clause of the content record query
		$where = (count($where) ? ' WHERE ' . implode(' AND ', $where) : '');

		$sql = "SELECT s2.itemid as cckid, s2.title FROM #__sobi2_item as s2
		LEFT JOIN #__sobi2_cat_items_relations as scr on scr.itemid=s2.itemid
		$where
		GROUP BY s2.itemid 
		$order";

		$db = Factory::getDBO();
		$db->setQuery($sql);
		$s2items = $db->loadObjectList();

		// Get the total number of records
		$query = "SELECT count(s2.itemid)  FROM #__sobi2_item as s2
		LEFT JOIN #__sobi2_cat_items_relations as scr on scr.itemid=s2.itemid
		$where
		GROUP BY s2.itemid ";
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$this->_page = new Pagination($total, $limitstart, $limit);

		// Get the listings
		$query = "SELECT s2.itemid as itemid, s2.title, GROUP_CONCAT(cc.name SEPARATOR '<br/>') as catname FROM #__sobi2_item as s2
		LEFT JOIN #__sobipro_relations as scr on scr.itemid=s2.itemid
		LEFT JOIN #__sobipro_category as cc on cc.catid =scr.catid
		$where
		GROUP BY s2.itemid
		$order";
		$db->setQuery($query, $this->_page->limitstart, $this->_page->limit);
		$this->_list = $db->loadObjectList();

		// If there is a db query error, throw a HTTP 500 and exit
		if (false && $db->getErrorNum())
		{
			throw new Exception($db->stderr(), 500);
			//	return false;
		}

		return $this->_list;

	}

	function getPagination()
	{
		if (is_null($this->_list) || is_null($this->_page))
		{
			$this->getList();
		}
		return $this->_page;

	}

}

