<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod.defines.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;

class Jevsobipro
{

	private
		$params;

	public
	function __construct($params)
	{
		$this->params = $params;

	}

	public
	function loadLanguages()
	{
		$lang = Factory::getLanguage();
		$lang->load("com_sobipro", JPATH_SITE);
		$lang->load("com_sobipro", JPATH_ADMINISTRATOR);

	}

	public
	function getcurrentListings($evdetid)
	{
		$db = Factory::getDBO();
		$sql = "SELECT cck.id as cckid, fd.baseData as title, cat.pid  FROM #__jev_cckeventsmap as jcckm
			LEFT JOIN #__sobipro_object as cck ON cck.id = jcckm.cck_id
			LEFT JOIN #__sobipro_field_data as fd ON fd.sid=cck.id 
			LEFT JOIN #__sobipro_field as fld ON fd.fid=fld.fid and fld.nid='field_name'
			LEFT JOIN #__sobipro_relations as cat ON cat.id=cck.id AND cat.oType='entry'
			WHERE jcckm.evdet_id =$evdetid  and fld.nid='field_name' 
			GROUP BY cck.id";

		$db->setQuery($sql);
		$data = @$db->loadObjectList('cckid');
		//echo $db->getErrorMsg();
		return $data;

	}

	public
	function getcurrentMatched($invalue)
	{
		if (!is_array($invalue))
		{
			$invalue = array($invalue);
		}
		if (count($invalue) > 0)
		{
			$db = Factory::getDBO();
			$sql = "SELECT s2.id as cckid, s2.name as title FROM #__sobipro_object as s2
				WHERE s2.id IN(" . implode(",", $invalue) . ")";

			$db->setQuery($sql);
			return @$db->loadObjectList('cckid');
		}
		return array();

	}

	public
	function getPossible()
	{
		$allowall = $this->params->get('allowallselect', 0);
		if ($allowall == 0)
		{
			// All possible candidates
			$user  = Factory::getUser();
			$where = " WHERE s2.owner=" . $user->id;
			// managers and above can pick any entries
			//if ($user->gid >= 20 and $user->gid != 29)
			if (Factory::getUser()->authorise('core.access'))
			{
				$where = " WHERE s2.owner IN (0," . $user->id . ") ";
			}
		} else {
			$where = '';
		}

		$sql = "SELECT s2.id as cckid, s2.nid as title FROM #__sobipro_object as s2 $where order by title asc limit 10";
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$s2items = $db->loadObjectList();
		return $s2items;

	}

	public
	function getOption($possible, $invalue)
	{
		$title = $possible->title;
		$possible = $possible->cckid;
		$selected = in_array($possible, $invalue) ? "selected='selected'" : "";
		return "<option value='$possible' $selected>$title</option>";

	}

	public
	function getLi($possible)
	{
		$title = $possible->title;
		$pid = $possible->cckid;
		return "<li id='sortablecck$pid' >$title</li>";

	}

	public
	function getModel()
	{
		$model = BaseDatabaseModel::getInstance("frontelement", "sobiproModel");
		$model->setState('task', "element");
		return $model;

	}

	public
	function getLink($cckid, $Itemid, $tmpl, $item = false)
	{
		//public function getLink( $cckid , $Itemid, $tmpl){
		$link = Route::_("index.php?option=com_sobipro&$tmpl&pid=$item->pid&sid=" . $cckid . "&Itemid=$Itemid");
		return $link;

	}

}

