<?php
/**
 * @version		$Id: view.php 11625 2009-02-15 15:32:42Z kdevine $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;
jimport('joomla.application.component.view');

// Based on joomla core view with added security filters on section, category and article access levels

/**
 * HTML Article Element View class for the Content component
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class ContentViewFrontelement extends HtmlView
{

	function display($tpl = NULL)
	{

		// Initialize variables
		$db =  Factory::getDBO();
		$nullDate = $db->getNullDate();

		$limitstart = Factory::getApplication()->input->getInt('limitstart', '0');

		$lists = $this->_getLists();

		//Ordering allowed ?
		$ordering = ($lists['order'] == 'section_name' && $lists['order_Dir'] == 'ASC');

		$rows = $this->get('List');
		$page = $this->get('Pagination');
		HTMLHelper::_('bootstrap.tooltip');
		$client = Factory::getApplication()->isClient('administrator') ? "administrator" : "site";
		$link = Route::_("index.php?option=com_jevents&task=plugin.cck&action=selectcontent&tmpl=component&client=$client&type=$this->cck&object=id", false);
		?>
		<form action="<?php echo $link;?>" method="post" name="adminForm">

			<table>
				<tr>
					<td width="100%">
						<?php echo Text::_('FILTER'); ?>:
						<input type="text" name="search" id="search" value="<?php echo $lists['search']; ?>" class="text_area" onchange="document.adminForm.submit();" />
						<button onclick="this.form.submit();"><?php echo Text::_('GO'); ?></button>
						<button onclick="document.getElementById('search').value = '';
								this.form.submit();"><?php echo Text::_('RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php
						echo $lists['catid'];
						?>
					</td>
				</tr>
			</table>

			<table class="adminlist" cellspacing="1">
				<thead>
					<tr>
						<th width="5">
							<?php echo Text::_('NUM'); ?>
						</th>
						<th class="title">
							<?php echo JHTML::_('grid.sort', 'Title', 's2.nid', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
						<th width="2%" class="title">
							<?php echo JHTML::_('grid.sort', 'ID', 's2.id', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
						<th  class="title" width="15%" nowrap="nowrap">
							<?php echo JHTML::_('grid.sort', 'Categories', 'cc.name', @$lists['order_Dir'], @$lists['order']); ?>
						</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="15">
							<?php echo $page->getListFooter(); ?>
						</td>
					</tr>
				</tfoot>
				<tbody>
					<?php
					$k = 0;
					for ($i = 0, $n = count($rows); $i < $n; $i++)
					{
						$row = &$rows[$i];

						$link = '';
						?>
						<tr class="<?php echo "row$k"; ?>">
							<td>
								<?php echo $page->getRowOffset($i); ?>
							</td>
							<td>
								<span class="editlinktip hasTip" title="<?php echo Text::_('jev_Select_LISTING'); ?>::<?php echo $this->escape($row->title); ?>">
									<a href="javascript:void()" onclick="return window.parent.sortableCCK.selectThisCck(<?php echo $row->id; ?>, this);"><?php echo $this->escape($row->title); ?></a>
								</span>
							</td>
							<td>
								<?php echo $row->id; ?>
							</td>
							<td>
								<?php echo $row->catname; ?>
							</td>
						</tr>
						<?php
						$k = 1 - $k;
					}
					?>
				</tbody>
			</table>

			<input type="hidden" name="type" value="sobipro" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="filter_order" value="<?php echo $lists['order']; ?>" />
			<input type="hidden" name="filter_order_Dir" value="<?php echo $lists['order_Dir']; ?>" />
			<input type="hidden" name="client" value="<?php echo Factory::getApplication()->getName(); ?>" />
		</form>
		<?php

	}

	function _getLists()
	{
		$mainframe = Factory::getApplication();  // RSH 11/09/10 - Make J!1.6 compatible
		// Initialize variables
		$db =  Factory::getDBO();

		// Get some variables from the request
		$option = Factory::getApplication()->input->getCmd('option');
		$filter_order = $mainframe->getUserStateFromRequest('articleelement.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir', 'filter_order_Dir', '', 'word');
		$filter_state = $mainframe->getUserStateFromRequest('articleelement.filter_state', 'filter_state', '', 'word');
		$catid = $mainframe->getUserStateFromRequest('articleelement.catid', 'catid', 0, 'int');
		$filter_authorid = $mainframe->getUserStateFromRequest('articleelement.filter_authorid', 'filter_authorid', 0, 'int');
		$filter_sectionid = $mainframe->getUserStateFromRequest('articleelement.filter_sectionid', 'filter_sectionid', -1, 'int');
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('articleelement.limitstart', 'limitstart', 0, 'int');
		$search = $mainframe->getUserStateFromRequest('articleelement.search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);


		$user = Factory::getUser();

		// get list of categories for dropdown filter
		$query = 'SELECT cc.id AS value, cc.name AS text' .
				' FROM #__sobipro_object AS cc' .
				" WHERE cout = 0 AND oType ='category' " .
				//" WHERE  cc.access". (version_compare(JVERSION, '1.6.0', '>=') ?  ' IN (' . JEVHelper::getAid($user) . ')'  :  ' <=  ' . JEVHelper::getAid($user)) .
				//' ORDER BY cc.ordering';
				"";

		$lists['catid'] = $this->filterCategory($query, $catid);

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;

		return $lists;

	}

	function filterCategory($query, $active = NULL)
	{
		// Initialize variables
		$db = Factory::getDBO();

		$categories[] = JHTML::_('select.option', '0', '- ' . Text::_('SELECT_CATEGORY') . ' -');
		$db->setQuery($query);
		$categories = array_merge($categories, $db->loadObjectList());
	//	echo $db->getErrorMsg();
		$category = JHTML::_('select.genericlist', $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $active);

		return $category;

	}

}
