<?php

defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Pagination\Pagination;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;

jimport('joomla.application.component.helper');
jimport('joomla.application.component.model');
jimport('joomla.html.parameter');

JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

// Based on joomla core model with added security filters on section, category and article access levels

/**
 * Content Component Article Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since		1.5
 */
class zooModelFrontelement extends BaseDatabaseModel
{

	/**
	 * Content data in category array
	 *
	 * @var array
	 */
	var $_list = null;
	var $_page = null;

	/**
 	 * @var $params
 	 */
	private $params;

	/**
	 * Method to get content article data for the frontpage
	 *
	 * @since 1.5
	 */
	function getList()
	{
		$plugin = PluginHelper::getPlugin('jevents', 'jevcck');
		$this->params = new Registry($plugin->params);

		$mainframe = Factory::getApplication();

		$user = Factory::getUser();

		if (!empty($this->_list))
		{
			return $this->_list;
		}

		// Initialize variables
		$db =  $this->getDBO();
		$filter = null;
		
		$allowedCategories = $this->params->get('zoo_category_id', array());
		$allowall = $this->params->get('allowallselect', 0);

		// Get some variables from the request
		$sectionid = Factory::getApplication()->input->getInt('sectionid', -1);
		$redirect = $sectionid;
		$option = Factory::getApplication()->input->getCmd('option');
		$filter_order = $mainframe->getUserStateFromRequest('articleelement.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir', 'filter_order_Dir', '', 'word');
		$catid = $mainframe->getUserStateFromRequest('articleelement.catid', 'catid', 0, 'int');
		$type = $this->params->get('zoo_app_id', $mainframe->getUserStateFromRequest('articleelement.app_id', 'app_id', 0, 'int'), 'int');
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = Factory::getApplication()->input->getInt('limitstart', 0);
		$search = $mainframe->getUserStateFromRequest('articleelement.search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);

		if (!in_array($catid, $allowedCategories))
		{
			$catid = 0;
		}

		// Set to show only items created by the user
		if ($allowall == 0)
		{
			$user = Factory::getUser();

			// Editors and above can pick any entries
			if (version_compare(JVERSION, "1.6.0", 'ge') &&  Factory::getUser()->authorise('core.manage'))
			{
			}
			else if (!version_compare(JVERSION, "1.6.0", 'ge') && $user->gid >= 20 and $user->gid != 29)
			{
			}
			else
			{
				$where[] = " cck.created_by =" . $user->id;
			}
		}

		if (!$filter_order)
		{
			$filter_order = 'cck.name';
		}

		$order = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir;
		$all = 1;

		$section = new stdClass();
		$section->title = 'All Entries';
		$section->id = 0;

		// Category filter
		if ($catid > 0)
		{
			$where[] = 'ccitem.category_id = ' . (int) $catid;
		}
		else if (!empty(array_filter($allowedCategories)))
		{
			$where[] = 'ccitem.category_id IN (' . implode(',', $allowedCategories) . ')';
		}

		// Application filter
		if ($type > 0)
		{
			$where[] = 'cck.application_id = ' . (int) $type;
		}

		// Only published
		$where[] = 'cck.state = 1';

		// Keyword filter
		if ($search)
		{
			$where[] = 'LOWER( cck.name) LIKE ' . $db->Quote('%' . $db->escape($search, true) . '%', false);
		}

		// Build the where clause of the content record query
		$where = (count($where) ? ' WHERE ' . implode(' AND ', $where) : '');

		$sql = "SELECT cck.id as cckid, cck.name as title FROM #__zoo_item as cck 
		LEFT JOIN #__zoo_category_item as ccitem on ccitem.item_id =cck.id
		$where
		GROUP BY cck.id 
		$order";

		$db = Factory::getDBO();
		$db->setQuery($sql);
		$cckitems = $db->loadObjectList();

		// Get the total number of records
		$query = "SELECT count(cck.id)  FROM #__zoo_item as cck
		LEFT JOIN #__zoo_category_item as ccitem on ccitem.item_id =cck.id
		$where
		GROUP BY cck.id ";
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$this->_page = new Pagination($total, $limitstart, $limit);

		// Get the listings
		//$query = "SELECT cck.id as id, cck.name as title,  tp.name as typename, CONCAT_WS(' : ',cc.name,  tp.name ) as catname FROM #__zoo_item as cck
		$query = "SELECT cck.id as id, cck.name as title,  tp.name as typename, GROUP_CONCAT(cc.name SEPARATOR '<br/>') as catname FROM #__zoo_item as cck
		LEFT JOIN #__zoo_category_item as ccitem on ccitem.item_id =cck.id
		LEFT JOIN #__zoo_category as cc on cc.id =ccitem.category_id
		LEFT JOIN #__zoo_application as tp on tp.id = cck.application_id
		$where
		GROUP BY cck.id
		$order";
		$db->setQuery($query, $this->_page->limitstart, $this->_page->limit);
		$this->_list = $db->loadObjectList();
	//	echo $db->getErrorMsg();
		
		// If there is a db query error, throw a HTTP 500 and exit
		if (false && $db->getErrorNum())
		{
			throw new Exception($db->stderr(), 500);
			//	return false;
		}

		return $this->_list;

	}

	function getPagination()
	{
		if (is_null($this->_list) || is_null($this->_page))
		{
			$this->getList();
		}
		return $this->_page;

	}

}

