<?php
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

JLoader::register('JevIsotope', JPATH_LIBRARIES . "/jevents/jevisotope/jevisotope.php");

$compcfg = ComponentHelper::getParams('com_jevents');
$jinput = Factory::getApplication()->input;
$isoParams = array('microdata' => 1);

$cfg = JEVConfig::getInstance();
$Itemid = JEVHelper::getItemid();

$compname = JEV_COM_COMPONENT;
$viewname = $this->getViewName();
$viewpath = JURI::root() . "components/$compname/views/" . $viewname . "/assets";
$viewimages = $viewpath . "/images";
$view = new FloatViewRange(array());

$numEvents = isset($this->eventdata['rows']) ? count($this->eventdata['rows']) : 0;

$data = $this->data;
$total = $this->total;
$start = $data['limitstart'];
$cd = $this->current_date;
$pd = $this->prev_date;
$nd = $this->next_date;

$menu = Factory::getApplication()->getMenu();

// Get Categories
$categories = JEV_CommonFunctions::getCategoryData();

// Filter out only Accessible categories for this user.
$accessiblecats = explode(",", $this->datamodel->accessibleCategoryList());

// Prefetch the first batch of data

require_once JPATH_SITE . '/components/com_jevents/views/float/helpers/gwejson_getfloatdata.php';

// Possibility to set order per view
// $order = "rpt.startrepeat asc, rpt.endrepeat ASC, det.summary ASC";

$order = $compcfg->get("dataorder", "rpt.startrepeat asc, rpt.endrepeat ASC, det.summary ASC");

$requestObject = new stdClass();
$requestObject->task = 'RangeData';
$requestObject->params = array($this->startdate, $this->enddate, $data['limit'], $data['limitstart'], $order);
$requestObject->Itemid = $jinput->getInt("Itemid", 0);

$returnData = new stdClass();

if (true || $jinput->getMethod == "POST"){
	$prefetchedData = "false";
}
else {
	$prefetchedData = json_encode(ProcessJsonRequest($requestObject, $returnData));
}

// Set out own output as this is a specialist view for the grid to work.
$width = $cfg->get('float_columns', 4);

$task = $jinput->getString('jevtask');

$Itemid = JEVHelper::getItemid();
if (isset($Itemid)) {
	$item= "&Itemid=$Itemid";
}
else
{
	$item = '';
}

// URL suffix to preserver catids!
$cat = $this->getCatidsOutLink();
$prev_sdate = $pd['sdate'];
$prev_edate = $pd['edate'];
$next_sdate = $nd['sdate'];
$next_edate = $nd['edate'];


$prev_link = Route::_("index.php?option=".JEV_COM_COMPONENT."&task=$task$item&startdate=$prev_sdate&enddate=$prev_edate".$cat);
$next_link = Route::_("index.php?option=".JEV_COM_COMPONENT."&task=$task$item&startdate=$next_sdate&enddate=$next_edate".$cat);
$month_link = (int) $compcfg->get('floatmonthlink', 0) === 1 ? $compcfg->get('floatmonthlinkmenu', '') : 0;

$jeventsUIkit = $compcfg->get("floatuikit", 1);
if ($jeventsUIkit && $compcfg->get("float_style" , 0 ) == 3)
{
	HTMLHelper::stylesheet('media/com_jevents/css/uikit.gsl.css', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => false));
	HTMLHelper::script('media/com_jevents/js/uikit.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => false), array('defer' => true));
	HTMLHelper::script('media/com_jevents/js/uikit-icons.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => false), array('defer' => true));
}

?>

<div id='jeviso_main' class='jeviso_day <?php echo $jeventsUIkit ? " gsl-scope " : "";?> <?php echo "jeviso_cols" . $cfg->get('float_columns', 4);?>'>
	<div class="jeviso_display_header <?php echo $compcfg->get('float_style', 1) == 3 ? "uk-grid" : "";?>">
		<div class="jeviso_view_switch <?php echo $compcfg->get('float_style', 1) == 3 ? "uk-width-1-1 uk-visible@m" : "";?>">
			<?php
			if ($compcfg->get('float_dyn_switch', 1) == 1):
				?>
				<a href="#" class="btn" onclick="jeviso_list();"><?php echo Text::_('JEV_FLOAT_LIST_VIEW');?> </a>
				<a href="#" class="btn" onclick="jeviso_grid();"><?php echo Text::_('JEV_FLOAT_GRID_VIEW');?> </a>
				<?php if ($month_link !== 0 && $compcfg->get('floatmonthlinkmenu', '') !== '') { ?>
				<a href="<?php echo Route::_($menu->getItem($month_link)->link . '&Itemid=' . $menu->getItem($month_link)->id); ?>" class="btn">
					<?php echo Text::_('JEV_FLOAT_CALENDAR_VIEW');?>
				</a>
			<?php } ?>
			<?php endif; ?>
		</div>
		<?php
		if ($compcfg->get('float_nav_range', 1) == 1 || $compcfg->get('float_nav_range', 1) == 3):
		?>

		<div class="date nv_links <?php echo $compcfg->get('float_style', 1) == 3 ? "uk-width-expand" : "";?>"" >
			<div class="jeviso_prev">
				<a href="<?php echo $prev_link; ?>" class="btn"> < </a>
			</div>
			<div class="jeviso_curr_range">
				<?php
				// We want to hide the year for the start if it's the same as the end, lets do some checking
				if ($cd['syear'] == $cd['eyear']) {
					$sd_format = 2;
					$ed_format = 1;
				} else {
					$sd_format = 1;
					$ed_format = 1;
				}
				echo JEventsHTML::getDateFormat($cd['syear'], $cd['smonth'], $cd['sday'], $sd_format); ?>

				<?php echo ' - ' . JEventsHTML::getDateFormat($cd['eyear'], $cd['emonth'], $cd['eday'], $ed_format); ?>
			</div>
			<div class="jeviso_next">
				<a href="<?php echo $next_link; ?>" class="btn"> > </a>
			</div>
		</div>
	<?php endif;?>
	</div>
<!-- We are events! we need markup! :-) -->
<?php
// still needs more work for YooTheme native!!
if (false && $compcfg->get('float_style', 1) == 3 && $compcfg->get('float_uikit_masonry', 1) == 1 ) {
?>
<div class="jeviso_container uk-child-width-1-2@s uk-child-width-1-<?php echo $cfg->get('float_columns', 4);?>@m" itemscope itemtype="http://schema.org/Event" uk-grid="masonry: true">
	<?php
	}
	else if ($compcfg->get('float_style', 1) == 3 && $compcfg->get('float_uikit_masonry', 1) == 1 ) {
	?>
	<div class="jeviso_container uikit_masonry" itemscope itemtype="http://schema.org/Event">
		<div class="jeviso_gutter"></div>
		<?php
		}
		else {
		?>
		<div class="jeviso_container" itemscope itemtype="http://schema.org/Event">
			<div class="jeviso_gutter"></div>
			<?php
			}
			?>
			<?php

			$results = $this->results;
			$floatStyle = $compcfg->get('float_style', 1);

			if ($floatStyle == 3 && !$jeventsUIkit)
			{
				$floatStyle .= "uikit";
			}

			if(isset($results->value) && $results->value > '') {
				$item_bodycore = $results->value;
				if ($floatStyle == 3)
				{
					if ($jeventsUIkit)
					{
						$item_bodycore = str_replace("uk-", "gsl-", $item_bodycore);
					}
					else
					{
						$item_bodycore = str_replace(".gsl-scope", "", $item_bodycore);
						$item_bodycore = str_replace("gsl-", "uk-", $item_bodycore);
					}
				}
			} else {

				$item_bodycore = file_get_contents(JEV_PATH . "/views/float/defaults/icalevent.list_block" . $floatStyle . ".html");
				if ($floatStyle == 3)
				{
					if ($jeventsUIkit)
					{
						$item_bodycore = str_replace("uk-", "gsl-", $item_bodycore);
					}
					else
					{
						$item_bodycore = str_replace(".gsl-scope", "", $item_bodycore);
						$item_bodycore = str_replace("gsl-", "uk-", $item_bodycore);
					}
				}

				$results = new stdClass();
				$templateparams = new stdClass();
				// is there custom css or js - if so push into the params
				if (strpos($item_bodycore, '{{CUSTOMJS}') !== false)
				{
					preg_match('|' . preg_quote('{{CUSTOMJS}}') . '(.+?)' . preg_quote('{{/CUSTOMJS}}') . '|s', $item_bodycore, $matches);

					if (count($matches) == 2)
					{
						$templateparams->customjs = $matches[1];
						$item_bodycore = str_replace($matches[0], "",	$item_bodycore);
					}
				}
				if (strpos($item_bodycore, '{{CUSTOMCSS}') !== false)
				{
					preg_match('|' . preg_quote('{{CUSTOMCSS}}') . '(.+?)' . preg_quote('{{/CUSTOMCSS}}') . '|s', $item_bodycore, $matches);

					if (count($matches) == 2)
					{
						$templateparams->customcss = $matches[1];
						$item_bodycore = str_replace($matches[0], "",	$item_bodycore);
					}
				}
				$results->params   = json_encode($templateparams);
			}

			// is there any custom css or javascript?
			if (isset($results->params) && !empty($results->params))
			{
				$tparams = @json_decode($results->params);
				if (isset($tparams->customcss) && !empty($tparams->customcss) )
				{
					Factory::getDocument()->addStyleDeclaration($tparams->customcss);
				}
				if (isset($tparams->customjs) && !empty($tparams->customjs) )
				{
					Factory::getDocument()->addScriptDeclaration($tparams->customjs);
				}
			}

			$html = '';
			$r = 0;

			if (false && $compcfg->get('float_style', 1) == 3 && $compcfg->get('float_uikit_masonry', 1) == 1)
			{
				foreach ($this->eventdata['rows'] as $row)
				{
					// special code to insert modules once every 5 cells e.g. for adverts

					if ($r > 0 && $r % 5 === 0)
					{

						$module = Jhtml::_('content.prepare', '{loadposition jevents_float_advert}');
						if ($module && $module !== '' && $module !== '{loadposition jevents_float_advert}')
						{
							$html .= '<div class="jeviso_item style' . $cfg->get('float_style', 1) . '">' . $module . '</div>';


						}
					}

					$item_body = '<div  id="jeviso_item' . $row->rp_id() . '" class="' . $row->catname() . ' style' . $cfg->get('float_style', 1) . '">';
					$item_body .= $item_bodycore;
					$item_body .= '</div>';
					$html      .= JevIsotope::itembody($row, $isoParams, '', $item_body, $view);
					$r++;
				}
			}
			else
			{
				foreach ($this->eventdata['rows'] as $row)
				{
					// special code to insert modules once every 5 cells e.g. for adverts

					if ($r > 0 && $r % 5 === 0)
					{

						$module = Jhtml::_('content.prepare', '{loadposition jevents_float_advert}');
						if ($module && $module !== '' && $module !== '{loadposition jevents_float_advert}') {
							$html .= '<div class="jeviso_item w' . $cfg->get('float_columns', 4) . ' style' . $cfg->get('float_style', 1) . '">' . $module . '</div>';


						}
					}

					$item_body = '<div  id="jeviso_item' . $row->rp_id() . '" class="jeviso_item w' . $cfg->get('float_columns', 4) . ' ' . $row->catname() . ' style' . $cfg->get('float_style', 1) . '">';
					$item_body .= $item_bodycore;
					$item_body .= '</div>';
					$html      .= JevIsotope::itembody($row, $isoParams, '', $item_body, $view);
					$r++;
				}
			}
			echo $html;  ?>
		</div>
		<?php
		$limit = (int) $compcfg->get('float_list_limit', 20);
		$limitStart = (int) $data['limitstart'];

		//$args = json_encode(array("task" => 'RangeData', "params" => array("startdate"=>$this->startdate, "enddate"=>$this->enddate, "listlimit"=>$compcfg->get('float_list_limit', 20), "liststart"=>$data['limitstart'], "order"=>$order), "Itemid" => Factory::getApplication()->input->getInt("Itemid", 0)));
		$args = json_encode(array("task" => 'RangeData', "params" => array($this->startdate, $this->enddate, $limit, $limitStart, $order), "Itemid" => $jinput->getInt("Itemid", 0)));

		$dataURL = Route::_("index.php?option=com_jevents&ttoption=com_jevents&typeaheadtask=gwejson&file=getfloatdata&path=site&folder=views%2Ffloat%2Fhelpers&token=" . Session::getFormToken() , false);

		$float_load_on_scroll = (int) $compcfg->get('float_load_on_scroll', 1);

		// Set Error messages for the JS
		$error_not_get_data = Text::_("JEV_COULD_NOT_GET_DATA");
		$error_not_process_handler = Text::_("JEV_COULD_NOT_PROCESS_EHANDLER");

		// Setup the JS/JSON
		$script = <<<SCRIPT
		var loadingEvents = false;
        var prefetchedData = $prefetchedData;
        var float_load_on_scroll = $float_load_on_scroll;
        var jevscriptsloaded = false;                
		var limit = $limit;
		var currentFloatArgs = $args;
		var container = '#jevents div.jeviso_container';
		
		function getMoreEvents(dataurl, filters) {
		
		    totalEvents = $total;
			current = jQuery('#jevents .jeviso_item').length;
			currenttest = current;
			limitstart = currentFloatArgs.params[3];

			currentFloatArgs.filters = filters;
			if (totalEvents < current) {
				alert('Too many events, something is not right ' + totalEvents + " vs " + current);
			}

            if (prefetchedData) {
                current = jQuery('.jeviso_item').length + prefetchedData.returned_count;
                limitstart +=  Math.max(currentFloatArgs.params[2], prefetchedData.returned_count);
                currentFloatArgs.params[3] = limitstart;

                var fe=prefetchedData.ev_pdata;
                jQuery("#jev_loadmore").removeClass("hide");
                jQuery("#jev_loadmore").removeClass("uk-hidden");
                 
                newItems = jQuery(fe).appendTo(container);
                jQuery(container).isotope('appended', newItems);

                /* layout Isotope after each image loads, otherwise we will get overlaps */
                jQuery(container).imagesLoaded().done( function() {
                    jQuery(container).isotope('layout');
                });
    
                /* clear out the prefretched data source */
                prefetchedData = false;
    
                if (totalEvents <= current && limitstart >= totalEvents || current < limit) {
                    jQuery( '.no_more' ).show(function(){
                        jQuery(this).fadeOut(4000);
                    });
                    jQuery("#jev_loadmore").removeClass("show");
                    jQuery("#jev_loadmore").addClass("hide");
                    jQuery("#jev_loadmore").addClass("uk-hidden");
                    jQuery("#jev_eventsloading").addClass("hide");
                    jQuery("#jev_eventsloading").addClass("uk-hidden");
                }
    
            }
            else {
                loadingEvents = true;
                jQuery("#jev_eventsloading").removeClass("hide");
                jQuery("#jev_eventsloading").removeClass("uk-hidden");
                var jSonRequest = jevjq.ajax({
                    type : 'POST',
                    dataType : 'json',
                    url : dataurl,
                    data : {'json':JSON.stringify(currentFloatArgs)},
                    contentType: "application/x-www-form-urlencoded; charset=utf-8",
                    scriptCharset: "utf-8"
                })
                .done(function(json){
                    if (!json){
                        alert('$error_not_get_data');
                    }
                    if (json.error){
                        try {
                                eval(json.error);
                        }
                        catch (e){
                                alert('$error_not_process_handler');
                        }
                    }
                    else 
                    {
                        /* get up to date total from filtered results */
                        totalEvents = json.ev_data.total;	
                        current = jQuery('.jeviso_item').length + json.returned_count;
                        limitstart +=  Math.max(currentFloatArgs.params[2], json.returned_count);
                        currentFloatArgs.params[3] = limitstart;

                        var fe=json.ev_pdata;
                        jQuery("#jev_eventsloading").addClass("hide");
                        jQuery("#jev_eventsloading").addClass("uk-hidden");
                        jQuery("#jev_loadmore").removeClass("hide");
                        jQuery("#jev_loadmore").removeClass("uk-hidden");
                        newItems = jQuery(fe).appendTo(container);
                        jQuery(container).isotope('appended', newItems);
        
                        /* layout Isotope after each image loads, otherwise we will get overlaps */
                        jQuery(container).imagesLoaded().done( function() {
                                jQuery(container).isotope('layout');
                        });

                        if (totalEvents <= current && limitstart >= totalEvents || current < limit) {
                            jQuery( '.no_more' ).show(function(){
                                    jQuery(this).fadeOut(4000);
                            });
                            jQuery("#jev_loadmore").removeClass("show");
                            jQuery("#jev_loadmore").addClass("hide");
                            jQuery("#jev_loadmore").addClass("uk-hidden");                            
                        }

                        /* Do we have any popups to process - check if setup script exists */
                        if (typeof setupEventPopups !== "undefined"){
                            setupEventPopups();
                        }

                        if (json.datatiming) {
                            alert(json.datatiming);
                        }

                        if (!jevscriptsloaded && json.headData && json.headData.scripts) {
                            /* alert(json.headData.scripts); */
                            var s = document.createElement('script');
                             s.type = 'text/javascript';
                             try {
                               s.appendChild(document.createTextNode(json.headData.scripts));
                               document.body.appendChild(s);
                             } catch (e) {
                               s.text = json.headData.scripts;
                               document.body.appendChild(s);
                             }
                            jevscriptsloaded = true;
                        }
                    }
                    loadingEvents = false;
                })
                .fail( function( jqxhr, textStatus, error){
                        /* loadingEvents = false; */
                        jQuery("#jev_eventsloading").addClass("hide");
                        jQuery("#jev_eventsloading").addClass("uk-hidden");
                        alert(textStatus + ", " + error);
                });
                /* Is the link still visible */
                /* if (!loadingEvents && isScrolledIntoView("#jev_loadmore")) { 
                      loadInEvents(); 
                 } */
 
            }
   			jQuery('#jevents div.jeviso_container').trigger('jevisomoreevents');
                                
		}

		function loadInEvents() {
			/* Event Filtering */
                
            /* are there any existing filters in action */
			/* Find the JEvents filter module (if present) */
			var filtermodule = jQuery('form.jevfiltermodule');
			
			if (filtermodule.length) {
                 getMoreEvents('$dataURL', filtermodule.formToJson());
                
				/* set the onsubmit method */
				filtermodule.off('submit');
				filtermodule.on('submit', function() {
					/* For events, from a usability point of view dynamically filtering this page is confusing, so lets wipe it */
                    jQuery(container).isotope('remove', jQuery('.jeviso_container .jeviso_item'));
                    
					/* Reset layout for new events */
					jQuery(container).isotope('layout');
					
                    /* Clear the load more link */
                    jQuery( '.no_more' ).show(function(){
                        jQuery(this).fadeOut(4000);
                    });
                    jQuery("#jev_loadmore").removeClass("show");
                    jQuery("#jev_loadmore").addClass("hide");
                    jQuery("#jev_loadmore").addClass("uk-hidden");    
                                
                    /* reset the limit start to zero! */
                    currentFloatArgs.params[3] = 0;
                    
					/* Now go fetch new events: */
					getMoreEvents('$dataURL', filtermodule.formToJson());
					return false;
				});                
            }
            else 
            {
                getMoreEvents('$dataURL', false);
            }
		}

		/* Lets do a function, we can expand it as needed then. */
		function jeviso_list() {
			jQuery('#jevents div.jeviso_container').trigger('jevisolist');
			
			jQuery('#jevents div.jeviso_container .jeviso_item').removeClass('w$width');
			jQuery('#jevents div.jeviso_container .jeviso_item').addClass('w1 listv');
			/* Reset layout for the changes to take effect */
			jQuery(container).isotope('layout');
		}

		/* Lets do a function, we can expand it as needed then. */
		function jeviso_grid() {
			jQuery('#jevents div.jeviso_container').trigger('jevisogrid');
			
			jQuery('#jevents div.jeviso_container .jeviso_item').addClass('w$width');
			jQuery('#jevents div.jeviso_container .jeviso_item').removeClass('w1');
			jQuery('#jevents div.jeviso_container .jeviso_item').removeClass('listv');
			/* Reset layout for the changes to take effect */
			jQuery(container).isotope('layout');
		}

		jQuery.fn.formToJson =  function(){
			var json = {};
			jevjq(this).find('input, textarea, select').each(function(index,el){
				var name = el.name;
				var value = el.value;
				if (value === false || !name || el.disabled) return;
				/* multi selects */
				if (name.indexOf('[]')>=0 && (el.tagName.toLowerCase() =='select' ) && el.multiple==true){
					name = name.substr(0,name.length-2);
					if (!json[name]) json[name] = [];
					jevjq(el).find('option').each(function(eldx, opt){
						if (opt.selected ==true) json[name].push(opt.value);
					});
				}
				else if (name.indexOf('[]')>=0 && (el.type=='radio' || el.type=='checkbox') ){
					if (!json[name]) json[name] = [];
					if (el.checked==true) json[name].push(value);
				}
				else if (el.type=='radio' || el.type=='checkbox'){
					if (el.checked==true) {
						json[name] = value;
					}
				}
				else json[name] = value;
			});
			return json;
		}

		jQuery(document).ready(function(){
			/* loadInEvents(); */
			if (float_load_on_scroll) {
				jQuery(window).on('scroll',  function() {
					if (!loadingEvents && isScrolledIntoView("#jev_loadmore")) {
						loadInEvents();
					}
				})
			}
			
		});

        function isScrolledIntoView(elem)
		{
			var jqelem = jQuery(elem);
			if (!jqelem.length){
				return false;
			}
			if (jqelem.hasClass('hide') || jqelem.hasClass('uk-hidden')) {
				return false;
			}
			var jqwindow = jQuery(window);

			var docViewTop = jqwindow.scrollTop();
			var docViewBottom = docViewTop + jqwindow.height();

			var elemTop = jqelem.offset().top;
			var elemBottom = elemTop + jqelem.height();

			return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop));
		}
SCRIPT;
		Factory::getDocument()->addScriptDeclaration($script);

		$isoParams = array("layoutMode" => "packery", "layoutOpts" => "percentPosition: true, packery: { gutter: '.jeviso_gutter' }, ", "itemSelector" => ".jeviso_item", "", "jevlayout" => "$viewname");
		//Load the Isotope Library
		JevIsotope::isotopep($data, $isoParams, $filters = null);
		?>
		<div class="no_more">
			<div>
				<?php echo Text::_("JEV_NO_MORE_EVENTS_TO_SHOW"); ?>
			</div>
		</div>
		<?php

		// Load more classing
		$lmClass = 'show';
		if ($numEvents < $limit ) {
			$lmClass = 'hide uk-hidden';
		}
		?>
		<div id="jev_loadmore" class="<?php echo $lmClass; ?>">
			<a class="jev_load_more" onclick="loadInEvents()"
			   href="javascript:void(0);"><?php echo Text::_("JEV_LOAD_MORE_EVENTS"); ?></a>
		</div>
		<div id="jev_eventsloading" class="hide uk-hidden">
			<?php echo Text::_("JEV_LOADING_EVENTS"); ?>
		</div>
		<div class="jeviso_footer">
			<?php
			if ($compcfg->get('float_nav_range', 1) == 2 || $compcfg->get('float_nav_range', 1) == 3):
				?>

				<div class="date nv_links">
					<div class="jeviso_prev">
						<a href="<?php echo $prev_link; ?>" class="btn"> < </a>
					</div>
					<div class="jeviso_curr_range">
						<?php

						// We want to hide the year for the start if it's the same as the end, lets do some checking
						if ($cd['syear'] == $cd['eyear']) {
							$sd_format = 2;
							$ed_format = 1;
						} else {
							$sd_format = 1;
							$ed_format = 1;
						}
						echo JEventsHTML::getDateFormat($cd['syear'], $cd['smonth'], $cd['sday'], $sd_format); ?>

						<?php echo ' - ' . JEventsHTML::getDateFormat($cd['eyear'], $cd['emonth'], $cd['eday'], $ed_format); ?>
					</div>
					<div class="jeviso_next">
						<a href="<?php echo $next_link; ?>" class="btn"> > </a>
					</div>
				</div>
			<?php endif;?>
		</div>
	</div>
