<?php
/**
 * JEvents Component for Joomla! 3.x
 *
 * @version     $Id: view.html.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-JEVENTS_COPYRIGHT GWESystems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;

/**
 * HTML View class for the component frontend
 *
 * @static
 */
class FloatViewRange extends JEventsFloatView
{

	function listevents($tpl = null)
	{
		JEVHelper::componentStylesheet($this);

		$params = ComponentHelper::getParams( JEV_COM_COMPONENT );

		list($startdate, $enddate) = $this->getStartEndDates();

		$jevStartDate = new JevDate($startdate);
		$jevEndDate = new JevDate($enddate);
		$interval = date_diff($jevStartDate, $jevEndDate);

		// Can't check using $interal->format('%s') since it returns zero even if whole number of days different
        if ($jevStartDate == $jevEndDate){
        	$interval = new DateInterval("P1D");
        }
		$this->current_date =  array(
			"sdate" => $jevStartDate->format('Y-m-d'),
			"syear"=>$jevStartDate->format('Y'),
			"smonth" => $jevStartDate->format('m'),
			"sday" => $jevStartDate->format('d'),
			"edate" => $jevEndDate->format('Y-m-d'),
			"eyear" => $jevEndDate->format('Y'),
			"emonth" => $jevEndDate->format('m'),
			"eday" => $jevEndDate->format('d'),
		);
		//echo "current dates ".$jevStartDate->format('Y-m-d H:i:s'). " - ".$jevEndDate->format('Y-m-d H:i:s')."<br/>";

		$jevNextStartDate = date_add($jevStartDate, $interval);
		$jevNextEndDate = date_add($jevEndDate, $interval);
		//echo "next dates ".$jevNextStartDate->format('Y-m-d H:i:s'). " - ".$jevNextEndDate->format('Y-m-d H:i:s')."<br/>";
		$this->next_date =  array(
			"sdate" => $jevNextStartDate->format('Y-m-d'),
			"syear"=>$jevNextStartDate->format('Y'),
			"smonth" => $jevNextStartDate->format('m'),
			"sday" => $jevNextStartDate->format('d'),
			"edate" => $jevNextEndDate->format('Y-m-d'),
			"eyear" => $jevNextEndDate->format('Y'),
			"emonth" => $jevNextEndDate->format('m'),
			"eday" => $jevNextEndDate->format('d'),
		);

		// NB date_add and date_sub changes the value of the first parameter so take care
		$jevStartDate = new JevDate($startdate);
		$jevEndDate = new JevDate($enddate);
		$jevPrevStartDate = date_sub($jevStartDate, $interval);
		$jevPrevEndDate = date_sub($jevEndDate, $interval);
		//echo "previous dates ".$jevPrevStartDate->format('Y-m-d H:i:s'). " - ".$jevPrevEndDate->format('Y-m-d H:i:s')."<br/>";
		$this->prev_date =  array(
			"sdate" => $jevPrevStartDate->format('Y-m-d'),
			"syear"=>$jevPrevStartDate->format('Y'),
			"smonth" => $jevPrevStartDate->format('m'),
			"sday" => $jevPrevStartDate->format('d'),
			"edate" => $jevPrevEndDate->format('Y-m-d'),
			"eyear" => $jevPrevEndDate->format('Y'),
			"emonth" => $jevPrevEndDate->format('m'),
			"eday" => $jevPrevEndDate->format('d'),
		);

		list($startyear,$startmonth,$startday)=explode("-",$startdate);
		list($startyear,$startmonth,$startday)=explode("-",$startdate);
		list($endyear,$endmonth,$endday)=explode("-",$enddate);

		$this->startdate = $startdate;
		$this->startyear = $startyear;
		$this->startmonth = $startmonth;
		$this->startday = $startday;
		$this->enddate = $enddate;
		$this->endyear = $endyear;
		$this->endmonth = $endmonth;
		$this->endday = $endday;

		$order = $params->get("dataorder", "rpt.startrepeat asc, rpt.endrepeat ASC, det.summary ASC");

		// Note that using a $limit value of -1 the limit is ignored in the query
		$cfg = JEVConfig::getInstance();

		$db = Factory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		//Block to load:
		$blocktl = "icalevent.list_block" . $cfg->get('float_style', 1);
		// Select all records from the user profile table where key begins with "custom.".
		// Order it by the ordering field.
		$query->select($db->quoteName(array('title', 'name', 'value', 'state', 'params')));
		$query->from($db->quoteName('#__jev_defaults'));
		$query->where($db->quoteName('name') . ' = '. $db->quote($blocktl) . ' AND ' . $db->quoteName('state') . ' = 1');

		$db->setQuery($query);

		$results = $db->loadObject();

		$this->results =  $results;
		$total = $this->datamodel->queryModel->countIcalEventsByRange( $startdate, $enddate,  $cfg->get('com_showrepeats'));
		$this->total = $total;

		$limit = $cfg->get('float_list_limit', 20);

		// Asign event data for pre-loading
		$this->eventdata =  $this->datamodel->getRangeData($startdate, $enddate, $limit, $this->limitstart, $order);

		if ($this->limitstart == 0) {
			$limitStart = $cfg->get('float_list_limit', 20);
		} else {
			$limitStart = $this->limitstart;
		}

		$this->data =  array("total"=>$total, "limit"=>$this->limit, "limitstart"=> $limitStart);

	}
}
