<?php

/**
 * thanks to Hi-Fi for the original version - rewritten to be in line with core Joomla JEvents Router
 *
 *  This is a jEvents sh404SEF native plugin file
 *
 */
defined('_JEXEC') or die('Direct Access to this location is not allowed.');

if (!defined("JEVTRANSLATETASK"))
{
	define("JEVTRANSLATETASK", 1);

	function jevTranslateTask($task)
	{
		$tasks = array(
			"year.listevents",
			"month.calendar",
			"week.listevents",
			"day.listevents",
			"range.listevents",
			"cat.listevents",
			"jevent.detail",
			"icalevent.detail",
			"icalrepeat.detail",
			"search.form",
			"search.results",
			"admin.listevents",
			"jevent.edit",
			"icalevent.edit",
			"icalevent.publish",
			"icalevent.unpublish",
			"icalevent.editcopy",
			"icalrepeat.edit",
			"jevent.delete",
			"icalevent.delete",
			"icalrepeat.delete",
			"icalrepeat.deletefuture",
			"modlatest.rss",
			"icalrepeat.vcal",
			"icalevent.vcal");

		if (!in_array($task, $tasks))
			return $task;
		// if not translated then just drop the . and use _ instead
		$task = str_replace(".", "_", $task);
		$transtask = JText::_("JEV_SEF_" . $task);
		$transtask = strpos($transtask, "JEV_SEF_") === 0 ? $task : $transtask;
		return $transtask;

	}

}

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG;
$sefConfig =  Sh404sefFactory::getConfig();
$shLangName = '';
$shLangIso = '';
$dosef = shInitializePlugin($lang, $shLangName, $shLangIso, $option);
if ($dosef == false)
	return;
// ------------------  standard plugin initialize function - don't change ---------------------------
// ------------------  load language file - adjust as needed ----------------------------------------
$lang = JFactory::getLanguage();
$lang->load("com_jevents", JPATH_SITE);
// ------------------  load language file - adjust as needed ----------------------------------------

JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

global $shGETVars;
if (isset($shGETVars['title']))
{
	$jevtitle = $shGETVars['title'];
}

if (isset($shGETVars['layout']) && isset($shGETVars['view']))
{
	if (!isset($task))
	{
		$task = $shGETVars['view'] . "." . $shGETVars['layout'];
	}
}

// remove common URL from GET vars list, so that they don't show up as query string in the URL
// We don't need the view - its only used to manipulate parameters
shRemoveFromGETVarsList('layout');
shRemoveFromGETVarsList('view');
shRemoveFromGETVarsList('task');
shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
shRemoveFromGETVarsList('Itemid');

// start by inserting the menu element title (just an idea, this is not required at all)
$task = isset($task) ? @$task : 'month.calendar';
$Itemid = isset($Itemid) ? @$Itemid : null;

$shEventsName = shGetComponentPrefix($option);
$shEventsName = empty($shEventsName) ?
		getMenuTitle($option, $task, $Itemid, null, $shLangName) : $shEventsName;
$shEventsName = (empty($shEventsName) || $shEventsName == '/') ? 'EventsCom' : $shEventsName;

$segments = array();
$segments[] = $shEventsName;
// $shGETVars is now empty then we are talking about a plain menu item so no need to do anything else!
if (count($shGETVars) > 0)
{

	// Translate the task name
	$transtask = jevTranslateTask($task); //$sh_LANG[$shLangIso]['_COM_SEF_SH_JEVENTS_DAY'] ;

	if ($task == "month.calendar")
	{
		$x = 1;
	}

	switch ($task) {
		case "year.listevents":
		case "month.calendar":
		case "week.listevents":
		case "day.listevents":
		case "cat.listevents":
		case "jevent.detail":
		case "icalevent.detail":
		case "icalrepeat.detail":
		case "search.form":
		case "search.results":
		case "admin.listevents": {
				if ($task != "icalrepeat.detail")
				{
					$segments[] = $transtask;
				}
				$config =  JFactory::getConfig();
				$t_datenow = JEVHelper::getNow();

				// if no date in the query then use TODAY not the calendar date
				$nowyear = "-"; //strftime('%Y', $t_datenow->toUnix(true));
				$nowmonth = "-"; //strftime('%m', $t_datenow->toUnix(true));
				$nowday = "-"; //strftime('%d', $t_datenow->toUnix(true));
				if (!isset($year))
				{
					$year = $nowyear;
				}
				if (!isset($month))
				{
					$month = $nowmonth;
				}
				if (!isset($day))
				{
					$day = $nowday;
				}
				// only include the year in the date and list views
				if (in_array($task, array("year.listevents", "month.calendar", "week.listevents", "day.listevents")))
				{
					$segments[] = $year;
				}

				// only include the month in the date and list views (excluding year)
				if (in_array($task, array("month.calendar", "week.listevents", "day.listevents")))
				{
					$segments[] = $month;
				}

				// only include the day in the week and day views (excluding year and month)
				if (in_array($task, array("week.listevents", "day.listevents")))
				{
					$segments[] = $day;
				}

				shRemoveFromGETVarsList('day');
				shRemoveFromGETVarsList('month');
				shRemoveFromGETVarsList('year');

				switch ($task) {
					case "icalrepeat.detail":
						if (isset($jevtitle))
						{
							$segments[] = substr(JFilterOutput::stringURLSafe($jevtitle), 0, 150);
						}
						break;
					default:
						break;
				}

				switch ($task) {
					case "jevent.detail":
					case "icalevent.detail":
					case "icalrepeat.detail":
						if (isset($evid))
						{
							$segments[] = $evid;
						}
						else
						{
							if ($task != "icalrepeat.detail")
							{
								$segments[] = "0";
							}
						}
						shRemoveFromGETVarsList('evid');
						break;
					default:
						break;
				}
				if ($task != "icalrepeat.detail")
				{
					if (isset($catids) && strlen($catids) > 0 && $catids != "0")
					{
						$segments[] = $catids;
					}
				}
				shRemoveFromGETVarsList('catids');
			}
			shRemoveFromGETVarsList('uid');
			shRemoveFromGETVarsList('title');
			break;
		case "jevent.edit":
		case "icalevent.edit":
		case "icalevent.publish":
		case "icalevent.unpublish":
		case "icalevent.editcopy":
		case "icalrepeat.edit":
		case "jevent.delete":
		case "icalevent.delete":
		case "icalrepeat.delete":
		case "icalrepeat.deletefuture":
			$segments[] = $transtask;
			if (isset($evid))
			{
				$segments[] = $evid;
			}
			else
				shRemoveFromGETVarsList('evid');
			break;
		case "modlatest.rss":
			$segments[] = $transtask;
			// assume implicit feed document
			//unset(format);
			// feed type
			if (isset($type))
			{
				$segments[] = $type;
			}
			else
			{
				$segments[] = 'rss';
			}
			//shRemoveFromGETVarsList('format');
			shRemoveFromGETVarsList('type');

			// modid
			if (isset($modid))
			{
				$segments[] = $modid;
			}
			else
			{
				$segments[] = "0";
			}
			shRemoveFromGETVarsList('modid');

			break;
		case "icalrepeat.vcal":
		case "icalevent.vcal":
			$segments[] = $transtask;
			if (isset($evid))
			{
				$segments[] = $evid;
			}
			else
			{
				$segments[] = "0";
			}
			shRemoveFromGETVarsList('evid');
			if (isset($catids))
			{
				$segments[] = $catids;
			}
			else
			{
				$segments[] = "0";
			}
			shRemoveFromGETVarsList('catids');

			break;

		default:
			$segments[] = $transtask;
			$segments[] = "-";
			break;
	}
}
$title = array();
foreach ($segments as $segment)
{
	$title[] = $segment;
	$title[] = "/";
}

//shRemoveFromGETVarsList('limit');
//shRemoveFromGETVarsList('limitstart'); // limitstart can be zero
shRemoveFromGETVarsList('rp_id');
shRemoveFromGETVarsList('jevtype');
shRemoveFromGETVarsList('type');


// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef)
{
	$shItemidString = '';
	$string = shFinalizePlugin($string, $title, $shAppendString, $shItemidString, (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null), (isset($shLangName) ? @$shLangName : null));
}

// ------------------  standard plugin finalize function - don't change ---------------------------

