<?php

/**
* @copyright	Copyright (C) 2008-2021 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
*/

defined('_JEXEC') or die('No Direct Access');
use Joomla\CMS\Filter\InputFilter;
use Joomla\CMS\Factory;

function ProcessJsonRequest(&$requestObject, $returnData){

	if (!isset($requestObject->rpid) || $requestObject->rpid==0){
		PlgSystemGwejson::throwerror("There was an error");
	}

	$user = Factory::getUser();
	if ($user->id==0 || $user->id!=$requestObject->userid){
		PlgSystemGwejson::throwerror("There was an error");
	}

	include_once(JPATH_SITE."/components/com_jevents/jevents.defines.php");

	$datamodel =new JEventsDataModel();
	$event = $datamodel->queryModel->listEventsById( $requestObject->rpid, 0,"icaldb");

	if (!$event || $event->rp_id()!= $requestObject->rpid)  PlgSystemGwejson::throwerror("There was an error");

	$safeHtmlFilter =  InputFilter::getInstance(array(), array(), 1, 1);
	$value = intval($requestObject->value);

	// If upgrading then add new columns - do all the tables at once
	$db = Factory::getDbo();
	$sql = "SHOW COLUMNS FROM `#__jev_customfields`";
	$db->setQuery($sql);
	$cols = $db->loadObjectList();
	$uptodate = false;
	foreach ($cols as $col)
	{
		if ($col->Field == "rp_id")
		{
			$uptodate = true;
			break;
		}
	}
	if (!$uptodate)
	{
		$sql = "ALTER TABLE #__jev_customfields ADD COLUMN user_id int(11) NOT NULL default 0";
		$db->setQuery($sql);
		@$db->execute();

		$sql = "ALTER TABLE `#__jev_customfields` ADD INDEX user_id (user_id)";
		$db->setQuery($sql);
		@$db->execute();

		$sql = "ALTER TABLE #__jev_customfields ADD COLUMN rp_id int(11) NOT NULL default 0";
		$db->setQuery($sql);
		@$db->execute();

		$sql = "ALTER TABLE `#__jev_customfields` ADD INDEX rp_id (rp_id)";
		$db->setQuery($sql);
		@$db->execute();

		$sql = "ALTER TABLE `#__jev_customfields` ADD INDEX detval (evdet_id, value(10) )";
		$db->setQuery($sql);
		@$db->execute();

	}

	// does the custom field exist already?
	$db = Factory::getDbo();
	if ($requestObject->separaterepeats) {
		$sql = "SELECT * FROM #__jev_customfields where name=".$db->Quote($requestObject->field)." and evdet_id=".$event->_detail_id ." and user_id=".$user->id. " and value=".$requestObject->rpid;
	}
	else {
		$sql = "SELECT * FROM #__jev_customfields where name=".$db->Quote($requestObject->field)." and evdet_id=".$event->_detail_id ." and user_id=".$user->id;
	}
	$db->setQuery($sql);
	try {
		$field = $db->loadObject();
	}
	catch (RuntimeException $e)
	{
		$error = $e->getMessage();
		$field = false;
	}

	if ($field){
		if ($requestObject->separaterepeats) {
			$sql = "DELETE FROM #__jev_customfields WHERE name=".$db->Quote($requestObject->field)." and evdet_id=".$event->_detail_id." and user_id=".$user->id. " and value=".$requestObject->rpid;
		}
		else {
			$sql = "DELETE FROM #__jev_customfields WHERE name=".$db->Quote($requestObject->field)." and evdet_id=".$event->_detail_id." and user_id=".$user->id;
		}
		$db->setQuery($sql);
		$success = $db->execute();
		$value = 0;
	}
	else {
		// THIS IS A GOOD IDEA TO MAKE IT REPEAT SPECIFIC
		if ($requestObject->separaterepeats) {
			$sql = "INSERT INTO  #__jev_customfields (user_id, value, evdet_id, name ) VALUES(".$user->id.",".$requestObject->rpid.", ".intval($event->_detail_id).", ".$db->Quote($requestObject->field).")";
		}
		else {
			$sql = "INSERT INTO  #__jev_customfields (user_id, value, evdet_id, name ) VALUES(".$user->id.",1, ".intval($event->_detail_id).", ".$db->Quote($requestObject->field).")";
		}
		$db->setQuery($sql);
		$success = $db->execute();
		$value = $user->id;
	}

	if (!$success) $returnData->error = 1;

	$returnData->result = $success;
	$returnData->newvalue = $value;

	return $returnData;
}

