<?php

/**
* @copyright	Copyright (C) 2008-2021 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
*/
defined('_JEXEC') or die('No Direct Access');
use Joomla\CMS\Filter\InputFilter;
use Joomla\CMS\Factory;

function ProcessJsonRequest(&$requestObject, $returnData){

	if (!isset($requestObject->rpid) || $requestObject->rpid==0){
		PlgSystemGwejson::throwerror("There was an error");
	}

	$user = Factory::getUser();
	if ($user->id==0 || $user->id!=$requestObject->userid){
		PlgSystemGwejson::throwerror("There was an error");
	}

	include_once(JPATH_SITE."/components/com_jevents/jevents.defines.php");

	$datamodel =new JEventsDataModel();
	$event = $datamodel->queryModel->listEventsById( $requestObject->rpid, 0,"icaldb");

	if (!$event || $event->rp_id()!= $requestObject->rpid)  PlgSystemGwejson::throwerror("There was an error");

	if (!JEVHelper::canEditEvent($event)){
	//	PlgSystemGwejson::throwerror("There was an error - not allowed");
	}

	$safeHtmlFilter =  InputFilter::getInstance(array(), array(), 1, 1);
	$value = $safeHtmlFilter->clean($requestObject->value);

	// does the custom field exist already?
	$db = Factory::getDbo();
	$sql = "SELECT * FROM #__jev_customfields where name=".$db->Quote($requestObject->field)." and evdet_id=".$event->_detail_id;
	$db->setQuery($sql);
	$field = $db->loadObject();

	if ($requestObject->append && $field){
		$value = $value."\n".$field->value;
	}

	$returnData->newvalue = nl2br($value);

	$value  = $db->Quote( $db->escape( $value, true ), false );

	if ($field){
		$sql = "UPDATE #__jev_customfields SET value=".$value. " WHERE name=".$db->Quote($requestObject->field)." and evdet_id=".$event->_detail_id;
		$db->setQuery($sql);
		$success = $db->execute();
	}
	else {
		$sql = "INSERT INTO  #__jev_customfields (value, evdet_id, name ) VALUES(".$value.", ".intval($event->_detail_id).", ".$db->Quote($requestObject->field).")";
		$db->setQuery($sql);
		$success = $db->execute();
	}

	if (!$success) $returnData->error = 1;

	$returnData->result = $success;

	return $returnData;
}

