<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\Folder;

include_once("JevcfFieldText.php");

class JFormFieldJevcfjoomla extends JevcfFieldText
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'jevcfjoomla';
	const name = 'jevcfjoomla';

	public static function loadScript($field=false){

		if ($field){
			$id = 'field'.$field->fieldname;
			$selectedField = $field->attribute('joomlacf');
		}
		else {
			$id = '###';
			$selectedField = '';
		}
		ob_start();
?>
<div class='jevcffieldinput gsl-hidden'>

	<?php
    CustomFieldsHelper::fieldtype($id, $field, self::name );
	CustomFieldsHelper::hidden($id,  $field, self::name);
	CustomFieldsHelper::label($id,  $field, self::name);
    CustomFieldsHelper::name($id, $field, self::name);
	CustomFieldsHelper::tooltip($id,  $field);

	?>
	<div class="jevcfnotranslate typeid tid<?php echo $id; ?>">
		<div class="jevcflabel ">
			<?php echo Text::_("JEVCF_JOOMLA_CUSTOM_FIELD");?>
			<?php CustomFieldsHelper::fieldTooltip(Text::_('JEVCF_JOOMLA_CUSTOM_FIELD_DESC'));?>
		</div>
		<div class="jevcfinputs ">
			<select name="joomlacf[<?php echo $id; ?>]" class="gsl-select gsl-form-width-large" id="joomlacf<?php echo $id; ?>"  >
				<?php
				$db = Factory::getDbo();
                if (version_compare(JVERSION, '4.0', 'ge')) {
                    $db->setQuery("SELECT id, title from #__fields where context='com_jevents.event' AND only_use_in_subform=0");
                }
                else {
                    $db->setQuery("SELECT id, title from #__fields where context='com_jevents.event' ");
                }
				$joomlafields = $db->loadObjectList();
                if (count($joomlafields) == 0)
                {
                    $html = ob_get_clean();
                    return false;
                }
				foreach ($joomlafields as $joomlafield)
				{
					$joomlafieldid = $joomlafield->id;
					$selected = "";
					if ($field && $selectedField == $joomlafieldid)
					{
						$selected = "selected='selected'";
					}

					?>
					<option value="<?php echo $joomlafield->id; ?>" <?php echo $selected; ?> ><?php echo $joomlafield->title ?></option>
					<?php
				}

				?>
			</select>
		</div>
	</div>

	<?php

	CustomFieldsHelper::required($id,  $field);
	CustomFieldsHelper::requiredMessage($id,  $field);
	CustomFieldsHelper::conditional($id,  $field);
	CustomFieldsHelper::allowoverride($id,  $field);
	CustomFieldsHelper::applicableCategories($id, $field) ;
	CustomFieldsHelper::accessOptions($id,  $field);
	CustomFieldsHelper::readaccessOptions($id,  $field);
    CustomFieldsHelper::fieldclass($id, $field);
    CustomFieldsHelper::universal($id, $field);
	?>


</div>
<div class='jevcffieldpreview'  id='<?php echo $id;?>preview'>
	<div class="previewlabel"><?php echo Text::_("JEVCF_PREVIEW");?></div>
	<div class="jevcflabel  jevcfpl" id='pl<?php echo $id;?>' ><?php echo $field?$field->attribute('label'):Text::_("JEVCF_FIELD_LABEL");?></div>
</div>

		<?php
		$html = ob_get_clean();

		return CustomFieldsHelper::setField($id,  $field, $html, self::name	);

	}

	function getInput()
	{

		$name = $this->name;
		$value = $this->value;

		if (strpos( $value, "json:") === 0)
		{
			$value = (array) json_decode(substr($value, 5));
		}
		JHTML::script('plugins/jevents/jevcustomfields/customfields/joomla.js');

		Factory::getLanguage()->load('plg_jevents_jevpeople', JPATH_ADMINISTRATOR);

		$db = Factory::getDbo();
		$fieldid = $this->attribute("joomlacf");

		if (empty($fieldid))
		{
			return "";
		}

		$input = Factory::getApplication()->input;
		$option = $input->getCmd('option', 'com_jevents');

		if ($option !== "com_jevents")
		{
			// disable for non-jevents for now
			//return "Joomla custom fields don't work in $option at present";
		}

		// Just in case plugin is not enabled
		JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
		$fields = FieldsHelper::getFields('com_jevents.event', null, true);

		$input = "";

		foreach ($fields as $field)
		{
			if ($field->id == $fieldid)
			{
				$data        = new stdClass();
				$data->catid = 0;

				if ($option == "com_jevents")
				{
					$data->id = isset($this->event) ? $this->event->ev_id() : '';
				}
				else if ($option == "com_jevlocations")
				{
					// Event field will acutally be a location!
					$data->id = isset($this->event) ? $this->event->loc_id : '';
				}
				else if ($option == "com_jevpeople")
				{
					// Event field will acutally be a location!
					$data->id = isset($this->event) ? $this->event->pers_id : '';
				}

				FieldsHelper::prepareForm('com_jevents.event', $this->form, $data);

				$joomlafield = $this->form->getField($field->name, 'com_fields');
				if (!empty($value))
				{
					$joomlafield->setValue($value);
				}
				// don't just assign as the name may be an array e.g. for checkboxes
				if ($joomlafield->type == "Subform")
				{
					// $joomlafield->fieldname is meaningless for subform fields!
					$joomlafield->name = preg_replace("#jform\[com_fields\]\[[-\w]*\]#", $name, $joomlafield->name);
				}
				// Joomla 4
				$joomlafield->name = str_replace("com_fields[" . $joomlafield->fieldname . "]", $name, $joomlafield->name);
				// Joomla 3
				$joomlafield->name = str_replace("jform[com_fields][" . $joomlafield->fieldname . "]", $name, $joomlafield->name);

				$input =  $joomlafield->getInput();
			}
		}

		return $input;

	}

	public function convertValue($value, $node)
	{

		if (empty($value))
		{
			return $value;
		}
		if (strpos( $value, "json:") === 0)
		{
			$value = (array) json_decode(substr($value, 5));
			$value = json_encode($value);
		}

		JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
		$fields = FieldsHelper::getFields('com_jevents.event', null, false);
		$fieldid = $this->attribute("joomlacf");

		foreach ($fields as $field)
		{
			if ($field->id == $fieldid)
			{

				$item = new stdClass();
				$field->value = $value;

				JPluginHelper::importPlugin('fields');
				Factory::getApplication()->triggerEvent('onCustomFieldsBeforePrepareField', array('com_jevents.event', $item, &$field));

				// Gathering the value for the field
				$fieldvalue = Factory::getApplication()->triggerEvent('onCustomFieldsPrepareField', array('com_jevents.event', $item, &$field));

				if (is_array($fieldvalue))
				{
					$layout = $field->params->get('layout', 'render');
					$content = FieldsHelper::render('com_jevents.event', 'field.' . $layout, array('field' => $field));

					return $content;
				}
/*
				// Get the path for the layout file
				$path = JPluginHelper::getLayoutPath('fields', $field->type, $field->type);

				if (file_exists($path))
				{
					// Render the layout
					$field->value = $value;

					ob_start();
					include $path;
					$output = ob_get_clean();
					return $output;
				}
*/
			}
		}

		return "Hello";

	}

	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value)
	{
		$this->value = $value;

	}

	public function bindField($fieldid)	{
		include_once("JevcfField.php");
		return JevcfField::bindFieldWithVarkeys($fieldid, get_object_vars($this));
	}

}
