<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: jevboolean.php 1569 2009-09-16 06:22:03Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();
use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;
use Joomla\Utilities\ArrayHelper;

jimport('joomla.form.formfield');
jimport('joomla.form.helper');
FormHelper::loadFieldClass('list');

class JFormFieldJevcfmultilistimage extends JFormFieldList
{

	public static function NotAvailableYetloadScript($field=false){
		HTMLHelper::script('plugins/jevents/jevcustomfields/customfields/js/jevcftext.js');

		if ($field){
			$id = 'field'.$field->fieldname;
		}
		else {
			$id = '###';
		}
		ob_start();
		?>
		<div class='jevcffieldinput gsl-hidden'>

			<?php
			CustomFieldsHelper::fieldtype($id, $field, self::name );
			CustomFieldsHelper::hidden($id,  $field, self::name);
			CustomFieldsHelper::label($id,  $field, self::name);
			CustomFieldsHelper::name($id, $field, self::name);
			CustomFieldsHelper::tooltip($id,  $field);
			?>

			<div class="jevcflabel ">
				<?php echo Text::_("JEVCF_DEFAULT_VALUE");?>
				<?php CustomFieldsHelper::fieldTooltip(Text::_('JEVCF_DEFAULT_VALUE_DESC'));?>
			</div>
			<div class="jevcfinputs ">
				<input type="text" name="dv[<?php echo $id;?>]" id="dv<?php echo $id;?>"
				       class="gsl-input gsl-form-width-large"
				       size="<?php echo $field?$field->attribute('size'):5;?>"  value="<?php echo $field?$field->attribute('default'):"";?>"  onchange="jevcftext.setvalue('<?php echo $id;?>');"  onkeyup="jevcftext.setvalue('<?php echo $id;?>');"/>
			</div>
			<!-- <div class="jevcfclear"></div> //-->

			<?php
			CustomFieldsHelper::required($id,  $field);
			CustomFieldsHelper::requiredMessage($id,  $field);
			CustomFieldsHelper::conditional($id,  $field);
			CustomFieldsHelper::allowoverride($id,  $field);
			CustomFieldsHelper::applicableCategories($id, $field) ;
			CustomFieldsHelper::accessOptions($id,  $field);
			CustomFieldsHelper::readaccessOptions($id,  $field);
			CustomFieldsHelper::fieldclass($id, $field);
			CustomFieldsHelper::universal($id, $field);
			?>

			<!-- <div class="jevcfclear"></div> //-->

		</div>
		<div class='jevcffieldpreview'  id='<?php echo $id;?>preview'>
			<div class="previewlabel"><?php echo Text::_("JEVCF_PREVIEW");?></div>
			<div class="jevcflabel  jevcfpl" id='pl<?php echo $id;?>' ><?php echo $field?$field->attribute('label'):Text::_("JEVCF_FIELD_LABEL");?></div>
			<input type="text" class="jevcfinputs" id="pdv<?php echo $id;?>" value="<?php echo $field?$field->attribute('default'):"";?>" size="<?php echo $field?$field->attribute('size'):5;?>"  />
		</div>
		<!-- <div class="jevcfclear"></div> //-->
		<?php
		$html = ob_get_clean();

		return CustomFieldsHelper::setField($id,  $field, $html, self::name	);

	}

	function getFilterInput($name, $value, &$node, $control_name)
	{
		if ($value != ""){
			$value = explode(",",$value);
		}
		else {
			$value = array();
		}
		$class = ( $this->element['class'] ? 'class="'.$this->element['class'].'"' : 'class="inputbox"' );
		$size =  ( $this->attribute('size') ? ' size="'.$this->attribute('size').'"' : '' );

		$multiple = ' multiple="multiple"';

		$options = array ();
		foreach ($this->element->children() as $option)
		{
			if ((int) $option['archive']) continue;
			$val	= (string) $option['value'];
			$text	= (string) $option;
			$options[] = JHTML::_('select.option', $val, Text::_($text));
		}

		return JHTML::_('select.genericlist',  $options, ''.$control_name.$name."[]", $class.$size.$multiple, 'value', 'text', $value, $control_name.$name);
	}

	function getInput(){
		return parent::getInput();
	}
	function fetchRequiredScript($name, &$node, $control_name)
	{
		return "JevStdRequiredFields.fields.push({'name':'".$control_name.$name."', 'default' :'".$this->attribute('default') ."' ,'reqmsg':'".trim(Text::_($this->attribute('requiredmessage'),true))."'}); ";
	}

	public function convertValue($value, $node){
		if ($value =="") return;
		return urldecode($value);
		$value = explode(",",$value);
		$value = ArrayHelper::toInteger($value);

		static $values;
		if (!isset($values)){
			$values =  array();
		}
		if (!isset($values[$this->attribute('name')])){
			$values[$this->attribute('name')]=array();
			foreach ($this->element->children() as $option)
			{
				$val	= (string) $option['value'];
				$text	= (string) $option;
				$values[$this->attribute('name')][$val] = $text;
			}
		}
		$output = array();
		foreach ($value as $v) {
			if (array_key_exists($v,$values[$this->attribute('name')])) $output[] = $values[$this->attribute('name')][$v];
		}

		return implode(", ",$output);
	}

	public function constructFilter($node){
		$this->node = $node;
		$specialCharacters = array(" ", "-" , ",", ".");
		$this->filterType = str_replace($specialCharacters,"",$this->attribute("name"));
		$this->filterLabel = JevcfField::varempty($this->attribute("filterlabel"))?$this->attribute("label"):$this->attribute("filterlabel");
		$this->filterNullValue = JevcfField::varempty($this->attribute("filterdefault"))?(JevcfField::varempty($this->attribute("default"))?"":$this->attribute("default")):$this->attribute("filterdefault");
		$this->filterNullValue = array($this->filterNullValue);
		$this->filter_value = $this->filterNullValue;
		$this->map = "csf".$this->filterType;

		$registry	= JevRegistry::getinstance("jevents");
		$this->indexedvisiblefilters = $registry->get("indexedvisiblefilters",false);
		if ($this->indexedvisiblefilters === false) return;

		// This is our best guess as to whether this filter is visible on this page.
		$this->visible = in_array("customfield",$this->indexedvisiblefilters);

		// If using caching should disable session filtering if not logged in
		$cfg	 = JEVConfig::getInstance();
		$useCache = (int) $cfg->get('com_cache', 0);
		$user = Factory::getUser();
		if ((int) Factory::getApplication()->input->getInt('filter_reset',0)){
			Factory::getApplication()->setUserState( $this->filterType.'_fv_ses', $this->filterNullValue );
			$this->filter_value = $this->filterNullValue;
		}
		// ALSO if this filter is not visible on the page then should not use filter value - does this supersede the previous condition ???
		else if (!$this->visible)
		{
			$this->filter_value = Factory::getApplication()->input->get($this->filterType . '_fv', $this->filterNullValue, 'array');
			ArrayHelper::toInteger($this->filter_value);
		}
		else {
			$this->filter_value =  Factory::getApplication()->getUserStateFromRequest( $this->filterType.'_fv_ses', $this->filterType.'_fv', $this->filterNullValue );
			ArrayHelper::toInteger($this->filter_value);
		}


	}

	public function createJoinFilter(){
		if ($this->filter_value==$this->filterNullValue) return "";
		if (count($this->filter_value)==0) return "";
		$join =  " #__jev_customfields AS $this->map ON det.evdet_id=$this->map.evdet_id";
		$db = Factory::getDbo();
		$filter =  "$this->map.name=".$db->Quote($this->attribute('name')). " AND ( ";
		$bits = array();
		foreach ($this->filter_value as $fv) {
			if (isset(plgJEventsJevcustomfields::$spencer) && plgJEventsJevcustomfields::$spencer == 0)
			{
				$bits[] = " $this->map.value RLIKE " . $db->Quote("\\b" . $fv . "\\b");
			}
			else
			{
				$bits[] = " $this->map.value RLIKE " . $db->Quote("[[:<:]]" . $fv . "[[:>:]]");
			}
		}
		$filter .= implode(" OR ",$bits);
		$filter .= ")";
		return $join . " AND ". $filter;
	}

	public function createFilter(){
		if ($this->filter_value==$this->filterNullValue) return "";
		if (count($this->filter_value)==0) return "";
		return "$this->map.id IS NOT NULL";
	}

	public function createFilterHTML(){
		$filterList=array();
		$filterList["title"]="<label class='evdate_label' for='".$this->filterType."_fv'>".Text::_($this->filterLabel)."</label>";
		$filterList["html"] =  $this->getFilterInput($this->filterType."_fv", implode(",",$this->filter_value), $this->node, "");

		$script = "try {JeventsFilters.filters.push({id:'".$this->filterType."_fv',value:".$this->filterNullValue[0] ."});} catch (e) {}";
		$document = Factory::getDocument();
		$document->addScriptDeclaration($script);

		return $filterList;
	}

	public function attribute($attr){
		$val = $this->element->attributes()->$attr;
		$val = !is_null($val)?(string)$val:null;
		return $val;
	}

	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value) {
		$this->value = $value;
	}

	public function bindField($fieldid)	{
		include_once("JevcfField.php");
		return JevcfField::bindFieldWithVarkeys($fieldid, get_object_vars($this));
	}

}
