<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: jevtext.php 1569 2009-09-16 06:22:03Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

jimport('joomla.form.formfield');
jimport('joomla.form.helper');
include_once('jevcfurl.php');

class JFormFieldJevcfonlineevent extends JFormFieldJevcfurl
{

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'Jevcfonlineevent';
	const name = 'jevcfonlineevent';

	public static function loadScript($field=false){

		HTMLHelper::script( 'plugins/jevents/jevcustomfields/customfields/js/jevcfurl.js' );

		if ($field){
			$id = 'field'.$field->fieldname;
		}
		else {
			$id = '###';
		}
		ob_start();
		?>
		<div class='jevcffieldinput gsl-hidden'>

			<?php
			CustomFieldsHelper::fieldtype($id, $field, self::name );
			CustomFieldsHelper::hidden($id,  $field, self::name);
			CustomFieldsHelper::label($id,  $field, self::name);
			CustomFieldsHelper::name($id, $field, self::name);
			CustomFieldsHelper::tooltip($id,  $field);
			?>

			<div class="jevcflabel "><?php echo Text::_("JEVCF_DEFAULT_VALUE");?></div>
			<div class="jevcfinputs ">
				<input type="text" name="dv[<?php echo $id;?>]" id="dv<?php echo $id;?>"
				       class="gsl-input gsl-form-width-large"
				       size="<?php echo $field?$field->attribute('size'):50;?>"  value="<?php echo $field?$field->attribute('default'):"http://www.jevents.net";?>"  onchange="jevcfurl.setvalue('<?php echo $id;?>');"  onkeyup="jevcfurl.setvalue('<?php echo $id;?>');"/>
			</div>
			<!-- <div class="jevcfclear"></div> //-->

			<?php
			CustomFieldsHelper::textField($id, $field, Text::_("JEVCF_PLACEHOLDER"), Text::_('JEVCF_PLACEHOLDER_DESC'), "placeholder", "placeholder","", ' onchange="jevcftext.setplaceholder(\''. $id .'\');"  onkeyup="jevcftext.setplaceholder(\''. $id .'\');"');
			CustomFieldsHelper::textField($id, $field, Text::_("JEVCF_LINKTEXT"), Text::_('JEVCF_LINKTEXT_DESC'), "linktext", "linktext");
			CustomFieldsHelper::textField($id, $field, Text::_("JEVCF_URL_TARGET"), Text::_('JEVCF_URL_TARGET_DESC'), "target", "target","_blank");
			CustomFieldsHelper::booleanField($field,"redirect[$id]", "redirect0$id", "redirect1$id", Text::_("JEVCF_URL_REDIRECT"), "redirect", Text::_("JEVCF_URL_REDIRECT_DESC"));
			CustomFieldsHelper::size($id,  $field, self::name);
			CustomFieldsHelper::maxlength($id,  $field, self::name);
			CustomFieldsHelper::required($id,  $field);
			CustomFieldsHelper::requiredMessage($id,  $field);
			CustomFieldsHelper::searchable($id,  $field);
			CustomFieldsHelper::fullsearch($id,  $field);
			CustomFieldsHelper::filterOptions($id, $field);
			CustomFieldsHelper::filtermenuOptions($id, $field);
			CustomFieldsHelper::filterDefault($id, $field);
			CustomFieldsHelper::allowoverride($id,  $field);
			CustomFieldsHelper::accessOptions($id,  $field);
			CustomFieldsHelper::readaccessOptions($id,  $field);
			CustomFieldsHelper::applicableCategories($id, $field) ;
			CustomFieldsHelper::fieldclass($id, $field);
			CustomFieldsHelper::universal($id, $field);
			?>

			<!-- <div class="jevcfclear"></div> //-->

		</div>
		<div class='jevcffieldpreview'  id='<?php echo $id;?>preview'>
			<div class="previewlabel"><?php echo Text::_("JEVCF_PREVIEW");?></div>
			<div class="jevcflabel  jevcfpl" id='pl<?php echo $id;?>'><?php echo $field?$field->attribute('label'):Text::_("JEVCF_FIELD_LABEL");?></div>
			<input type="text" class="jevcfinputs" id="pdv<?php echo $id;?>" value="<?php echo $field?$field->attribute('default'):"";?>" size="<?php echo $field?$field->attribute('size'):50;?>"  />
		</div>
		<!-- <div class="jevcfclear"></div> //-->
		<?php
		$html = ob_get_clean();

		return CustomFieldsHelper::setField($id,  $field, $html, self::name	);

	}

	function fetchRequiredScript($name, &$node, $control_name)
	{
		return "JevStdRequiredFields.fields.push({'name':'" . $control_name . $name . "', 'default' :'" . $this->attribute('default') . "' ,'reqmsg':'" . trim(Text::_($this->attribute('requiredmessage'), true)) . "'}); ";

	}

	public function convertValue($value, & $node)
	{
		$target = $this->attribute('target') ? " target='" . $this->attribute('target') . "' " : "";
		$linktext = $this->attribute('linktext') ? trim(Text::_($this->attribute('linktext'))) : $value;

		if ($value !== '')
		{
			$hv = $this->attribute("hiddenvalue");
			if (strpos($hv, "<a href=") !== 0 && strpos($hv, "http") === 0)
			{
				$node->element->attributes()->hiddenvalue = "<a href='$hv' $target >$hv</a>";
			}
			if (!is_string($value)){
				$x = 1;
			}
			if (strpos($value, "http://") === false && strpos($value, "https://") === false && strpos($value, "ftp://") === false && strpos($value, "mailto:") === false)
			{
				// convert email addresses to mailto links
				if (strpos($value, "@")>0 && strpos($value, "/")===false){
					$value = "mailto:" . $value;
				}
				else if (strpos($value, "/")!==0) {
					$value = "http://" . $value;
				}
			}

			// Redirect ONLY if viewing event detail
			if ($this->attribute("redirect")==1)
			{
				if (Factory::getApplication()->input->getString("jevtask") == "icalrepeat.detail" || Factory::getApplication()->input->getString("jevtask") == "icalevent.detail")
				{
					Factory::getApplication()->redirect($value);
				}
			}

			return "<a href='$value' $target>$linktext</a>";
		}

	}


	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value) {
		$this->value = $value;
	}

	public function bindField($fieldid)	{
		include_once("JevcfField.php");
		return JevcfField::bindFieldWithVarkeys($fieldid, get_object_vars($this));
	}

}