<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\Folder;

JLoader::register('JevModal',JPATH_LIBRARIES."/jevents/jevmodal/jevmodal.php");

include_once("JevcfField.php");
class JFormFieldJevcfperson extends JevcfField
{

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'Jevcfperson';
	const name = 'jevcfperson';

	function __construct()
	{
		parent::__construct();

	}

	public static function loadScript($field=false){

		// Make sure managed people is installed first (Basic check).
		if(!Folder::exists(JPATH_SITE . '/components/com_jevpeople/')) return;

		HTMLHelper::script('plugins/jevents/jevcustomfields/customfields/js/jevcfperson.js');

		if ($field){
			$id = 'field'.$field->fieldname;
			$selectedType = $field->attribute('perstype');
		}
		else {
			$id = '###';
			$selectedType = "";
		}
		ob_start();
		?>
		<div class='jevcffieldinput gsl-hidden'>

			<?php
			CustomFieldsHelper::fieldtype($id, $field, self::name );
			CustomFieldsHelper::hidden($id,  $field, self::name);
			CustomFieldsHelper::label($id,  $field, self::name);
			CustomFieldsHelper::name($id, $field, self::name);
			CustomFieldsHelper::tooltip($id,  $field);

			?>
			<div class="jevcfnotranslate typeid tid<?php echo $id; ?>">
				<div class="jevcflabel ">
					<?php echo Text::_("JEVCF_PERSON_RESOURCE_TYPE_ID");?>
					<?php CustomFieldsHelper::fieldTooltip(Text::_('JEVCF_PERSON_RESOURCE_TYPE_ID_DESC'));?>
				</div>
				<div class="jevcfinputs ">
					<select name="perstype[<?php echo $id; ?>]" id="perstype<?php echo $id; ?>"  onchange="jevcfperson.setvalue('<?php echo $id; ?>');">
						<?php
						$db = Factory::getDbo();
						$db->setQuery("SELECT type_id, title from #__jev_peopletypes");
						$types = $db->loadObjectList();
						foreach ($types as $type)
						{
							$typeid = $type->type_id;
							$selected = "";
							if ($field && $selectedType == $typeid)
							{
								$selected = "selected='selected'";
							}

							?>
							<option value="<?php echo $type->type_id; ?>" <?php echo $selected; ?> ><?php echo $type->title ?></option>
							<?php
						}

						?>
					</select>
				</div>
			</div>
			<!-- <div class="jevcfclear"></div> //-->

			<?php
			if ($field){
				?>
				<script type="text/javascript" >
                    document.addEventListener('DOMContentLoaded', function() {
                        jevcfforms.revealConditionalDisplayField('ct<?php echo $id;?>', 'pf<?php echo $id;?>' , 0);
                    })
				</script>
				<?php
			}

			CustomFieldsHelper::usergroups($id,  $field);

			CustomFieldsHelper::required($id,  $field);
			CustomFieldsHelper::requiredMessage($id,  $field);
			CustomFieldsHelper::conditional($id,  $field);
			CustomFieldsHelper::allowoverride($id,  $field);
			CustomFieldsHelper::applicableCategories($id, $field) ;
			CustomFieldsHelper::accessOptions($id,  $field);
			CustomFieldsHelper::readaccessOptions($id,  $field);
			CustomFieldsHelper::fieldclass($id, $field);
			CustomFieldsHelper::universal($id, $field);
			?>

			<!-- <div class="jevcfclear"></div> //-->

		</div>
		<div class='jevcffieldpreview'  id='<?php echo $id;?>preview'>
			<div class="previewlabel"><?php echo Text::_("JEVCF_PREVIEW");?></div>
			<div class="jevcflabel  jevcfpl" id='pl<?php echo $id;?>' ><?php echo $field?$field->attribute('label'):Text::_("JEVCF_FIELD_LABEL");?></div>
			<div class="jevcfinputs">
				<select name="pdv[<?php echo $id; ?>]" id="pdv<?php echo $id; ?>" >
					<option value="0" ><?php echo htmlspecialchars_decode(Text::_("JEVCF_SELECT_USER")); ?></option>
				</select>
			</div>
		</div>
		<!-- <div class="jevcfclear"></div> //-->
		<?php
		$html = ob_get_clean();

		return CustomFieldsHelper::setField($id,  $field, $html, self::name	);

	}



	function getInput()
	{

		$name = $this->name;
		$value = $this->value;

		if ($value == "")
		{
			$value = "-1";
		}
		$values = explode(",", $value);

		$plugin = PluginHelper::getPlugin('jevents', 'jevpeople');
		if (!$plugin)
		{
			return "<strong>" . Text::_("Please_install_the_JEV_People_Addon") . "</strong>";
		}

		JHTML::script('plugins/jevents/jevcustomfields/customfields/people.js');

		Factory::getLanguage()->load('plg_jevents_jevpeople', JPATH_ADMINISTRATOR);

		$this->params = new Registry($plugin->params);
		$compparams = ComponentHelper::getParams("com_jevpeople");

		$db = Factory::getDbo();
		$sql = "SELECT * from #__jev_peopletypes as jpt";
		$types = $this->attribute("typeid");
		if (!empty($types))
		{
			$sql .= " WHERE jpt.type_id IN ($types)";
		}
		$db->setQuery($sql);
		$types = @$db->loadObjectList('type_id');

		$sql = "SELECT jp.pers_id, jp.title, jpt.title as typename, jpt.type_id as type_id , jpt.categories ,jpt.calendars  FROM #__jev_people as jp
		LEFT JOIN #__jev_peopletypes as jpt ON jpt.type_id = jp.type_id
		WHERE jp.pers_id IN (" . $value . ")
		ORDER BY jp.type_id, jp.ordering,jp.title";

		$db->setQuery($sql);
		$jpmlist = $db->loadObjectList();
		if (!is_array($jpmlist))
		{
			$jpmlist = array();
		}

		$cleanname = $this->id;

		JevModal::framework();

		$link = Route::_("index.php?option=com_jevpeople&task=people.select&tmpl=component");
		// need catid element to stop js error message
		$input = "<div style='margin-bottom:5px;'><span id='catid' ></span><ul id='sortablePeople_$cleanname' style='margin:0px;cursor:move;'>";
		foreach ($jpmlist as $jpm)
		{
			$pname = $jpm->title;
			$pid = $jpm->pers_id;
			$type = $jpm->typename;
			$pname = $pname . " ($type)";
			$input .= "<li class='sortablepers$pid' >$pname</li>";
		}
		$input .= "</ul>";

		$input .= '<select multiple="multiple" name="' . $name . '[]" id="custom_person_' . $cleanname . '" size="4" style="display:none" >';
		foreach ($jpmlist as $jpm)
		{
			$pname = $jpm->title;
			$pid = $jpm->pers_id;
			$type = $jpm->typename;
			$pname = $pname . " ($type)";
			$input .= "<option value='$pid' selected='selected' id='sortablepers" . $pid . "option'>$pname</option>";
		}
		$input .= "</select>";
		$input .= "</div>";


		$firstpass = true;
		$style = "";
		$script = "";
		foreach ($types as $type)
		{
			$sp = "sp" . (int) $type->type_id;
			$script .= "var $sp= new sortablePeopleClass();\n";
		}
		$script .= "document.addEventListener('DOMContentLoaded', function (){";
		$firstscript = "";
		foreach ($types as $type)
		{
			$typelink = Route::_("index.php?option=com_jevpeople&task=people.select&tmpl=component&type_id=" . (int) $type->type_id);
			$sp = "sp" . (int) $type->type_id;
			$selectPerson = Text::sprintf("Select_by_type", $type->title);
			$selectPersonTip = Text::sprintf("Select_by_type_TIP", $type->title);
			$input .= '<div class="button2-left" style="cursor:move' . $style . '"><div class="blank"><a href="javascript:' . $sp . '.selectPerson(\'' . $typelink . '\');" title="' . $selectPerson . '::' . $selectPersonTip . '"  class="hasTip">' . $selectPerson . '</a></div></div>';

			$input .= "<img src='" . JURI::Root() . "components/com_jevpeople/assets/images/Trash.png' class='sortabletrash' id='trashimage' style='display:none;padding-right:2px;cursor:pointer;'/>";

			if ($firstpass)
			{
				$firstscript .= "
			peopleDeleteWarning='" . Text::_("JEV_REMOVE_PERSON_WARNING", true) . "';
			var jevpeople = {\n";
				$firstscript .= "duplicateWarning : '" . Text::_("Already_Selected", true) . "'\n";
				$firstscript .= "		}";

				$firstpass = false;
			}
			//Object.assign({}, obj);
			$script .= "		    
			$sp.setup('$cleanname');
			typenamemap['" . addslashes($type->title) . "'] = $sp;
			";
		}
		$script .= "});";

		$document = Factory::getDocument();
		$document->addScriptDeclaration($firstscript);

		if ($style != "")
		{
			$document->addStyleDeclaration($style);
			$this->setupCategorySpecificTypes($script);
		}
		else
		{
			$document->addScriptDeclaration($script);
		}

		return $input;

	}

	public function convertValue($value, $node)
	{
		if (empty($value))
		{
			return $value;
		}
		static $values;
		if (!isset($values))
		{
			$values = array();
		}
		static $typesdone;
		if (!isset($typesdone))
		{
			$typesdone = array();
		}
		$types = $this->attribute("typeid");
		if (!empty($types))
		{
			if (!isset($typesdone[$types]))
			{
				$typesdone[$types] = 1;
				$db = Factory::getDbo();
				$sql = "SELECT jp.pers_id, jp.title, jpt.title as typename, jpt.type_id as type_id , jpt.categories ,jpt.calendars  FROM #__jev_people as jp
						LEFT JOIN #__jev_peopletypes as jpt ON jpt.type_id = jp.type_id";
				$sql .= " WHERE jpt.type_id IN ($types)";

				$db->setQuery($sql);
				$values = $values + $db->loadObjectList('pers_id');
			}
		}
		else
		{
			static $alldone;
			if (!isset($alldone))
			{
				$alldone = 1;
				$db = Factory::getDbo();
				$sql = "SELECT jp.pers_id, jp.title, jpt.title as typename, jpt.type_id as type_id , jpt.categories ,jpt.calendars  FROM #__jev_people as jp
								LEFT JOIN #__jev_peopletypes as jpt ON jpt.type_id = jp.type_id";
				$db->setQuery($sql);
				$values = $db->loadObjectList('pers_id');
			}
		}
		$res = array();
		;
		foreach (explode(",", $value) as $val)
		{
			if (array_key_exists($val, $values))
			{
				$Itemid = Factory::getApplication()->input->getInt("Itemid");

				$link = Route::_("index.php?option=com_jevpeople&task=people.detail&se=1&pers_id=" . $values[$val]->pers_id . "&Itemid=$Itemid");
				$res[] = "<a href='$link'>" . $values[$val]->title . "</a>";
			}
		}
		return implode(", ", $res);

	}

	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value)
	{
		$this->value = $value;

	}

	public function bindField($fieldid)	{
		include_once("JevcfField.php");
		return JevcfField::bindFieldWithVarkeys($fieldid, get_object_vars($this));
	}

}
