<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: jevtextarea.php 1569 2009-09-16 06:22:03Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Filter\InputFilter;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Session\Session;


include_once("JevcfField.php");
class JFormFieldJevcfupdatable extends JevcfField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'Jevcfupdatable';
        const name = 'jevcfupdatable';
	var $_validuser = 0;

	public static function loadScript($field=false){
		HTMLHelper::script('plugins/jevents/jevcustomfields/customfields/js/jevcftextarea.js');

		if ($field){
			$id = 'field'.$field->fieldname;
		}
		else {
			$id = '###';
		}
		ob_start();
?>
<div class='jevcffieldinput gsl-hidden'>

	<?php
        CustomFieldsHelper::fieldtype($id, $field, self::name );
	CustomFieldsHelper::hidden($id,  $field, self::name);
	CustomFieldsHelper::label($id,  $field, self::name);
        CustomFieldsHelper::name($id, $field, self::name);
	CustomFieldsHelper::tooltip($id,  $field);

	?>
	<div class="jevcflabel "><?php echo Text::_("JEVCF_UPDATABLE_INITIAL_VALUE"); CustomFieldsHelper::fieldTooltip(Text::_("JEVCF_UPDATABLE_INITIAL_VALUE_DESC"));?></div>
	<div class="jevcfinputs ">
		<textarea name="dv[<?php echo $id;?>]" id="dv<?php echo $id;?>" onchange="jevcftextarea.setvalue('<?php echo $id;?>');" onkeyup="jevcftextarea.setvalue('<?php echo $id;?>');"
				rows="<?php echo $field?$field->attribute('rows'):5;?>" cols="<?php echo $field?$field->attribute('cols'):20;?>" ><?php echo $field?$field->attribute('default'):"";?></textarea>
	</div>
	<!-- <div class="jevcfclear"></div> //-->
	<?php

	CustomFieldsHelper::textField($id, $field, Text::_("JEVCF_UPDATEBUTTON_LABEL"), Text::_('JEVCF_UPDATEBUTTON_LABEL_DESC'), "buttonlabel", "buttonlabel");
        CustomFieldsHelper::textField($id, $field, Text::_("JEVCF_UPDATED_MESSAGE"), Text::_('JEVCF_UPDATED_MESSAGE_DESC'), "updatedmessage", "updatedmessage");

	CustomFieldsHelper::cols($id,  $field, self::name);
	CustomFieldsHelper::rows($id,  $field, self::name);

	CustomFieldsHelper::allowoverride($id,  $field);

        CustomFieldsHelper::applicableCategories($id, $field) ;
	CustomFieldsHelper::accessOptions($id,  $field);
	CustomFieldsHelper::readaccessOptions($id,  $field);
        CustomFieldsHelper::fieldclass($id, $field);
	CustomFieldsHelper::universal($id, $field);
	?>

	<!-- <div class="jevcfclear"></div> //-->

</div>
<div class='jevcffieldpreview'  id='<?php echo $id;?>preview'>
	<div class="previewlabel"><?php echo Text::_("JEVCF_PREVIEW");?></div>
	<div class="jevcflabel  jevcfpl" id='pl<?php echo $id;?>'><?php echo $field?$field->attribute('label'):Text::_("JEVCF_FIELD_LABEL");?></div>
	<textarea id="pdv<?php echo $id;?>" class="jevcfinputs"
				rows="<?php echo $field?$field->attribute('rows'):5;?>" cols="<?php echo $field?$field->attribute('cols'):20;?>" ><?php echo $field?$field->attribute('default'):"";?></textarea>
</div>
<!-- <div class="jevcfclear"></div> //-->
		<?php
		$html = ob_get_clean();

		return CustomFieldsHelper::setField($id,  $field, $html, self::name	);

	}


	function getInput()
	{

		$rows =$this->element['rows'];
		$cols = $this->element['cols'];
		$class = ( $this->element['class'] ? 'class="'.$this->element['class'].'"' : 'class="text_area"' );
		// convert <br /> tags so they are not visible when editing
		$this->value = str_replace(array("\\r\\n", "\\r", "\\n"), "\n",$this->value);
		$this->value = str_replace('<br />', "\n", $this->value);

		return '<textarea name="'.$this->name.'" cols="'.$cols.'" rows="'.$rows.'" '.$class.' id="'.$this->id.'" >'.$this->value.'</textarea>';
	}


	public function convertValue($value, &$node){
		// A hidden value is not relevant for this field type so set it to something silly!
		$this->addAttribute("hiddenvalue","sdronv03h54ng;sd f8ovb3n4likguns08r7bv89eurng08nfv087be345");

		$isEditor = JEVHelper::isEventEditor();

		// permissions handled by field access settings
		if (false && !$isEditor) {
			$node->element->attributes()->label = "";
			// set access to something impossible too!
			$node->element->attributes()->access = -999;
			return "";
		}

		// Manage event list outputs null here
		if (is_null($this->event) || !is_a($this->event, "jIcalEventRepeat" ) || is_null($this->event->rp_id()) ) return;

		static $scriptloaded;
		if (!isset($scriptloaded))
		{
			$debug = "";
			$scriptloaded = true;
			$url = Route::_("index.php?option=com_jevents&ttoption=com_jevents&typeaheadtask=gwejson&file=updatefield&path=plugin$debug&folder=jevents&plugin=jevcustomfields/customfields&token=" . Session::getFormToken() , false);
			//$url = JURI::root() . "plugins/jevents/jevcustomfields/customfields/updatefield.php";
			$updatedmessage = $this->attribute("updatedmessage");
			$doc            = Factory::getDocument();
			$rpid           = $this->event->rp_id();

			$script = <<<SCRIPT
function updateUpdatable(fieldname, userid, append){
	//alert($('jecfupdatable_'+fieldname).value);

	var requestObject = new Object();
	requestObject.error = false;
	requestObject.field = fieldname;
	requestObject.task = "updateUpdatable";
	requestObject.value = document.getElementById('jecfupdatable_'+fieldname).value;
	requestObject.userid = userid;
	requestObject.append = append;
	requestObject.rpid = $rpid;

    var jSonRequest = jQuery.ajax({
                type : 'GET',
                dataType : 'json',
                cache : false,                        
                url : '$url',
                data : {'json':JSON.stringify(requestObject)},
                contentType : "application/json; charset=utf-8",
                scriptCharset : "utf-8"
    })
    .done(function(json){
            if (!json){
                    alert('Update Failed');
            }
            if (json.error){
                    try {
                            eval(json.error);
                    }
                    catch (e){
                            alert('could not process error handler');
                    }
            }
            else {
				if (append){
					document.getElementById('jecfupdatable_'+fieldname).value = '';
					document.getElementById('jecfupdatablediv_'+fieldname).innerHTML = json.newvalue;
				}
				else {
					document.getElementById('jecfupdatable_'+fieldname).value = json.newvalue;
				}
				alert('$updatedmessage');
            }
    })
    .fail( function( jqxhr, textStatus, error){
		alert('Something went wrong... '+textStatus + ", " + error);
    });
}
SCRIPT;
			$doc->addScriptDeclaration($script);

}
		?>
		<?php
		$fieldname = $this->attribute("name");
		$rows = $this->element['rows'];
		$cols = $this->element['cols'];
		$class = ( $this->element['class'] ? 'class="'.$this->element['class'].'"' : 'class="text_area"' );
		$buttonlabel = $this->attribute("buttonlabel");
		$append = (int) $this->attribute("append");
		$append = 1;

		$user = Factory::getUser();

		if ($append){
			$html = '<textarea name="'.$fieldname.'" cols="'.$cols.'" rows="'.$rows.'" '.$class.' id="jecfupdatable_'.$fieldname.'"  style="display:block"></textarea>';
			$html .= '<div id="jecfupdatablediv_'.$fieldname.'" >'.str_replace(array("\\r\\n", "\\r", "\\n"), "<br />",$value);
			$html .= '</div><input type="button" class="gsl-button gsl-button-small gsl-button-default" onclick="updateUpdatable(\''.$fieldname.'\', '.$user->id.', '.$append.');return false;" value="'.Text::_($buttonlabel).'"/>';
		}
		else {
			$html = '<textarea name="'.$fieldname.'" cols="'.$cols.'" rows="'.$rows.'" '.$class.' id="jecfupdatable_'.$fieldname.'" >'.$value.'</textarea>';
			$html .= '<input type="button" class="gsl-button gsl-button-small gsl-button-default" onclick="updateUpdatable(\''.$fieldname.'\', '.$user->id.', '.$append.');return false;" value="'.Text::_($buttonlabel).'"/>';
		}
		$html = str_replace("\n","",$html);

		return $html;
	}

	function fetchRequiredScript($name, &$node, $control_name)
	{

		$user = Factory::getUser();
		if ($user->id != $this->_validuser) return "";

		return "JevStdRequiredFields.fields.push({'name':'".$control_name.$name."', 'default' :'".$this->attribute('default') ."' ,'reqmsg':'".trim(Text::_($this->attribute('requiredmessage'),true))."'}); ";
	}

	public function constructFilter($node){

		$user = Factory::getUser();
		if ($user->id != $this->_validuser) return "";

		$this->node = $node;
		$specialCharacters = array(" ", "-" , ",", ".");
		$this->filterType = str_replace($specialCharacters,"",$this->attribute("name"));
		$this->filterLabel = JevcfField::varempty($this->attribute("filterlabel"))?$this->attribute("label"):$this->attribute("filterlabel");
		//$this->filterNullValue = JevcfField::varempty($this->attribute("filterdefault"))?(JevcfField::varempty($this->attribute("default"))?"":$this->attribute("default")):$this->attribute("filterdefault");
                $this->filterNullValue = $this->attribute("filterdefault");
		$this->filter_value = $this->filterNullValue;
		$this->map = "csf".$this->filterType;

		$registry	= JevRegistry::getinstance("jevents");
		$this->indexedvisiblefilters = $registry->get("indexedvisiblefilters",false);
		if ($this->indexedvisiblefilters === false) return;

		// This is our best guess as to whether this filter is visible on this page.
		$this->visible = in_array("customfield",$this->indexedvisiblefilters);

		// If using caching should disable session filtering if not logged in
		$cfg	 = JEVConfig::getInstance();
		$useCache = (int) $cfg->get('com_cache', 0);
		$user = Factory::getUser();
		$mainframe = Factory::getApplication();
		if ((int) Factory::getApplication()->input->getInt('filter_reset',0)) {
			Factory::getApplication()->setUserState( $this->filterType.'_fv_ses', $this->filterNullValue );
			$this->filter_value = $this->filterNullValue;
		}
		// ALSO if this filter is not visible on the page then should not use filter value - does this supersede the previous condition ???
		else if (!$this->visible)
		{
			$this->filter_value =  Factory::getApplication()->input->getString($this->filterType.'_fv', $this->filterNullValue);
		}
		else {
			$this->filter_value = Factory::getApplication()->getUserStateFromRequest( $this->filterType.'_fv_ses', $this->filterType.'_fv', $this->filterNullValue , "string");
		}

	}

	public function createJoinFilter(){

		$user = Factory::getUser();
		if ($user->id != $this->_validuser) return "";

		if (trim($this->filter_value)==$this->filterNullValue) return "";
		$join =  " #__jev_customfields AS $this->map ON det.evdet_id=$this->map.evdet_id";
		$db = Factory::getDbo();
		$filter = "$this->map.name=".$db->Quote($this->attribute('name'))." AND $this->map.value LIKE (".$db->Quote($this->filter_value."%").")";
		return $join . " AND ". $filter;
	}

	public function createFilter(){

		$user = Factory::getUser();
		if ($user->id != $this->_validuser) return "";

		if (trim($this->filter_value)==$this->filterNullValue) return "";
		return "$this->map.id IS NOT NULL";
	}

	function getFilterInput($name, $value, &$node, $control_name)
	{

		$user = Factory::getUser();
		if ($user->id != $this->_validuser) return "";

		$size = ( $this->attribute('size') ? 'size="'.$this->attribute('size').'"' : '' );
		$class = ( $this->element['class'] ? 'class="'.$this->element['class'].'"' : 'class="text_area"' );
		/*
		* Required to avoid a cycle of encoding &
		* html_entity_decode was used in place of htmlspecialchars_decode because
		* htmlspecialchars_decode is not compatible with PHP 4
		*/
		$value = htmlspecialchars(html_entity_decode($value, ENT_QUOTES), ENT_QUOTES);

		return '<input type="text" name="'.$control_name.$name.'" id="'.$control_name.$name.'" value="'.$value.'" '.$class.' '.$size.' />';

	}


	public function createFilterHTML(){

		$user = Factory::getUser();
		if ($user->id != $this->_validuser) return "";

		$filterList=array();
		$filterList["title"]="<label class='evdate_label' for='".$this->filterType."_fv'>".Text::_($this->filterLabel)."</label>";
		if ($this->attribute("multifilter")==1){
			// allow multiple select!
			$filterList["html"] =  $this->getFilterInput($this->filterType."_fv", implode(",",$this->filter_value), $this->node, "", true);
			$script = "try {JeventsFilters.filters.push({id:'".$this->filterType."_fv',value:".$this->filterNullValue[0] ."});}";
		}
		else {
			$filterList["html"] =  $this->getFilterInput($this->filterType."_fv", $this->filter_value, $this->node, "");
			$script = "try {JeventsFilters.filters.push({id:'".$this->filterType."_fv',value:'".addslashes($this->filterNullValue)."'});} catch (e) {}";
		}

		$document = Factory::getDocument();
		$document->addScriptDeclaration($script);

		return $filterList;
	}

	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value) {
		$this->value = $value;
	}

	public function bindField($fieldid)	{
		include_once("JevcfField.php");
		$myXml  = JevcfField::bindFieldWithVarkeys($fieldid, get_object_vars($this));

                $input = Factory::getApplication()->input;
		$filter = InputFilter::getInstance();

		JevcfField::bindString($myXml, $fieldid, "buttonlabel");
		JevcfField::bindString($myXml, $fieldid, "updatedmessage");

                return $myXml;

	}

}
