var typenamemap = {};

(function sortablePeopleModule(factory) {
	"use strict";
	window["sortablePeopleClass"] = factory();

})
(function sortablePeopleFactory() {

	var cleanname = 'false';


	/**
	 * @class  sortablePeopleClass
	 * @param  {HTMLElement}  el
	 * @param  {Object}       [options]
	 */
	sortablePeopleClass = function () {
	}

	sortablePeopleClass.prototype = /** @lends Sortable.prototype */ {
		constructor: sortablePeopleClass,

		setup : function (cleanname) {
			this.cleanname = cleanname;
			this.ulname = 'sortablePeople_' + this.cleanname;
			this.cpname = "custom_person_" + this.cleanname;
			var sortable = document.getElementById(this.ulname);
			if (!sortable)
				return;
			sortable.setAttribute('data-sortable',
				Sortable.create(sortable, {
					//ghostClass: 'jev-sortable-highlight jev-people-sortable',
					//ghostClass: 'jev-sortable-highlight jev-people-sortable',
					onEnd: (evt) => {
						this.fieldsHaveReordered(evt.item, sortable)
					},
				})
			);

			//new Sortables(this.ulname,{"onComplete" = function(el) { this.fieldsHaveReordered(el, this)}.bind(this)});

			var uls = document.getElementById(this.ulname);
			var lis = uls.childNodes;
			lis.forEach(function (item, i) {
				this.copyTrash(item);
			}, this);
		},

		copyTrash : function (item) {
			var trashimage = document.getElementById('trashimage');
			var child = trashimage.cloneNode();
			child.style.display = "inline";
			child.style.marginLeft = "5px";
			child.style.lineHeight = item.style.lineHeight = "16px";
			item.style.backgroundImage = "none";
			item.style.listStyleType = "none";
			item.style.paddingLeft = "0px";
			item.insertBefore(child, item.firstChild);
			this.setupTrashImage(child);
		},

		fieldsHaveReordered : function (targetNode, sortable) {
			// Now rebuild the select list items
			var custom_person = document.getElementById(sortable.cpname);
			if (custom_person) {
				var options = custom_person.childNodes;

				// new dummy selectlist
				var selectList = document.createElement('select');

				options.forEach(function (item, i) {
					selectList.appendChild(item);
				});

				var uls = document.getElementById(sortable.ulname);
				var lis = uls.childNodes;
				lis.forEach(function (item, i) {
					selectList.childNodes.forEach(function (opt, j) {
						if (opt.id == item.className + "option") {
							custom_person.appendChild(opt);
							opt.selected = true;
						}
					});

				});
			}

		},

		setupTrashImage : function (item) {
			item.addEventListener('mousedown', function (event) {
				event.preventDefault();
				event.stopImmediatePropagation();

				if (!confirm(peopleDeleteWarning)) return;
				var id = event.target.parentNode.className;
				// remove the item from the li list
				event.target.parentNode.parentNode.removeChild(event.target.parentNode);
				// remove the item from the select list
				var option = document.getElementById(id + "option");
				if (option) option.parentNode.removeChild(option);

				var custom_person = document.getElementById(this.cpname);
				if (custom_person) {
					var options = custom_person.childNodes;
				}


			}.bind(this));
		},

		selectPerson : function (url) {
			jevModalNoTitle('jevPeopleModal', url);
			return;// SqueezeBox.call(SqueezeBox, true);
		},
	}
	function _extend(dst, src) {
		if (dst && src) {
			for (var key in src) {
				if (src.hasOwnProperty(key)) {
					dst[key] = src[key];
				}
			}
		}

		return dst;
	};

	function _clone(el) {
		return el.cloneNode(true);
	};



	// Export
	sortablePeopleClass.version = 'JEVENTS_VERSION';
	return sortablePeopleClass;
});

// Use ONLY part of this class from managed people - it should NOT be used for events!
var sortablePeople = {
	selectThisPerson:function (personid, elem, typename){
		var sp = typenamemap[typename];
		var duplicateTest = document.querySelector("#"+sp.ulname+" .sortablepers"+personid);
		if (duplicateTest) {
			alert(jevpeople.duplicateWarning);
			SqueezeBox.close();
			return false;
		}
		var title = elem.innerHTML;
		var custom_person = document.getElementById(sp.cpname);
		var opt = document.createElement('option');
		opt.value = personid;
		opt.id = "sortablepers"+personid+"option";
		if (custom_person){
			custom_person.appendChild(opt);
		}
		opt.text = title + " ("+typename+")";
		opt.selected = true;
		// No do the visible list item too
		var uls = document.getElementById(sp.ulname);
		var li = document.createElement('li');
		li.classList.add("sortablepers"+personid);
		li.innerText = opt.text;
		if (uls){
			uls.appendChild(li);
			sp.copyTrash(li);

			var sortable = uls;

			sortable.setAttribute('data-sortable',
				Sortable.create(uls, {
					//ghostClass: 'jev-sortable-highlight jev-people-sortable',
					//ghostClass: 'jev-sortable-highlight jev-people-sortable',
					onEnd: (evt) => {
						tsp.fieldsHaveReordered(evt.item, uls)
					}
				})
			);
		}

		// If actually selecting a person for a menu item we do something different:
		var menuperson = document.getElementById('menuperson');
		if (menuperson){
			menuperson.value += "jevp:"+personid+",";
		}

		closeJevModalBySelector('#jevPeopleModal')
		return false;
	}
};

