<?php

/**
 * JEvents Locations Component for Joomla 1.5.x
 *
 * @version     $Id: jevboolean.php 1331 2010-10-19 12:35:49Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2016 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
// Check to ensure this file is included in Joomla!

defined('JPATH_BASE') or die;

use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
FormHelper::loadFieldClass('spacer');


class JFormFieldJevchosenfix extends JFormFieldSpacer
{

	public function getinput()
	{
                $doc = Factory::getDocument();
                $js = <<<SCRIPT
                    jQuery(document).on('ready', function () {
                        jQuery(document).on('subform-row-add', function(event, row){
                            jQuery(row).find(".catselector").on('change', function(evt, params) {blockDuplicateCategories();});
                            blockDuplicateCategories();
                            setupHiddenPluginChosen();
                        })                                                
                        jQuery(".catselector").on('change', function(evt, params) {blockDuplicateCategories();});
                        jQuery(".whitelist").on('change', function(evt, params) {blockDuplicateCategories();});
                        //window.setTimeout(setupHiddenPluginChosen, 1000);
                        blockDuplicateCategories();
                        
                    })
                    function setupHiddenPluginChosen() {
                        jQuery('select.catselector, select.groupselector, select.whitelist').chosen();
                    }
                    function blockDuplicateCategories(){
                        var catlists = jQuery(".catselector");
                        var whitelist = jQuery(".whitelist");

                        catlists = jQuery.merge(whitelist, catlists);

                        // Make sure we don't select the same category more than once!
                        catlists.each(function(index,catlist) {
                            catlists.each(function(otherindex,othercatlist) {
                                // not jQuery so can use id directly
                                if (othercatlist.id == catlist.id ) {
                                    return;
                                }
                                selectedoptions = jQuery(catlist).find("option:selected");
                                otheroptions = jQuery(othercatlist).find("option");
                                otheroptions.each (function(idx, op) {
                                    \$op = jQuery(op);
                                    jQuery.each(selectedoptions , function (i,el){
                                        val = jQuery(el).val();
                                        if (\$op.val() == val){
                                            \$op.attr("disabled","disabled");
                                        }
                                    });
                                });
                            });
                        });
                        jQuery('select.catselector').trigger("liszt:updated");
                        jQuery('select.catselector').trigger("chosen:updated");
                        jQuery('select.whitelist').trigger("liszt:updated");
                        jQuery('select.whitelist').trigger("chosen:updated");
                    }
                        
SCRIPT;
                $doc->addScriptDeclaration($js);

                return "";
	}
        
        public function getLabel() {
            return "";
        }
        
}
