<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: Ccklookup.php 2175 2011-06-10 13:21:13Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
defined('_JEXEC') or die('No Direct Access');
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\Utilities\ArrayHelper;

// searches location of event
class jevCcklookupFilter extends jevFilter
{

	function __construct($tablename, $filterfield, $isstring = true)
	{
		$this->filterType = "cck";
		$this->filterLabel = Text::_("JEV_Search_By_Listing");
		$this->filterNullValue = 0;
		parent::__construct($tablename, $filterfield, true);

		// Should these be ignored?
		$reg =  Factory::getConfig();
		$modparams = $reg->get("jev.modparams", false);
		if ($modparams && $modparams->get("ignorefiltermodule", false))
		{
			$this->filter_value = $this->filterNullValue;
			return;
		}

		// Only have memory on page with the module visible for JEvents 1.5.4 onwards
		JLoader::register('JEventsVersion', JEV_ADMINPATH . "/libraries/version.php");
		$version = JEventsVersion::getInstance();
		$versionnumber = $version->RELEASE . "." . $version->DEV_LEVEL . "." . $version->PATCH_LEVEL;

		if (version_compare($versionnumber, "1.5.4", "<"))
		{
			$this->filter_value = Factory::getApplication()->input->getString($this->filterType . '_fv', $this->filterNullValue);
		}

	}

	function _createFilter($prefix = "")
	{
		if (!$this->filterField)
			return "";
		if (intval($this->filter_value) == $this->filterNullValue)
			return "";

		$db = Factory::getDBO();
		if (strpos($this->filter_value, ",") > 0)
		{
			$value = explode(",", $this->filter_value);
			$value = ArrayHelper::toInteger($value);
			$value[] = -1;
			$filter = "cckm.cck_id in (" . implode(",", $value) . ")";
			$this->needsgroupby = true;
		}
		else
		{
			$value = intval($this->filter_value);
			$filter = "cckm.cck_id = $value";
		}

		return $filter;

	}

	function _createJoinFilter($prefix = "")
	{
		if (!$this->filterField)
			return "";
		if (intval($this->filter_value) == $this->filterNullValue)
			return "";

		$filter = "#__jev_cckeventsmap as cckm ON cckm.evdet_id=det.evdet_id";
		return $filter;

	}

	// no need for lookup - its a hidden filter
	function _createfilterHTML()
	{
		return "";

	}

}