<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: Groupeventsearch.php 3954 2013-03-31 10:10:43Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
defined('_JEXEC') or die('No Direct Access');

// searches author of event
class jevGroupeventsearchFilter extends jevFilter
{

	private $params = null;
	private $userparams = false;

	function __construct($tablename, $filterfield, $isstring=true)
	{

		$this->filterType = "jevge";
		$this->filterNullValue = "";
		parent::__construct($tablename, $filterfield, true);

		// Should these be ignored?
		$reg =  JFactory::getConfig();
		$modparams = $reg->get("jev.modparams", false);
		if ($modparams && $modparams->get("ignorefiltermodule", false)) {
			$this->filter_value = $this->filterNullValue;
			return;
		}

		// Only have memory on page with the module visible or
		$this->filter_value = JRequest::getVar($this->filterType . '_fv', $this->filterNullValue);

		// get plugin params
		$plugin =  JPluginHelper::getPlugin('jevents', 'jevgroupevent');
		if (!$plugin) {
			return "";
		}

		$this->params = new JRegistry($plugin->params);

		$plugin =  JPluginHelper::getPlugin('jevents', 'jevusers');
		if (!$plugin) {
			return "";
		}
		$this->userparams = new JRegistry($plugin->params);

		/*
	if ($this->filterField &&  trim($this->filter_value) != $this->filterNullValue) {

	// Do we want the group attendance list too?
	$this->rawtemplate = $this->params->get("template",'');
	 if ($this->rawtemplate!=''){
		 $this->template =JPATH_SITE."/plugins/jevents/rsvppro/params/".$this->params->get("template",'');

		 if (file_exists($this->template)){
			 $xmlDoc = new DOMDocument();
			$xmlDoc->load($this->template);

			$elems = $xmlDoc->getElementsByTagName("param");
			foreach ($elems as $elem){
				if ($elem->getAttribute("type")=="jevrjsgroup"){
					$this->groupfield = $elem->getAttribute("name");

				}
			}
		 }
	 }
	}

	}
*/

	}

	function _createFilter($prefix="")
	{
		if (!$this->filterField) {
			return "";
		}

		if (trim($this->filter_value) == $this->filterNullValue) {
			return "";
		}

		$db = JFactory::getDbo();
		$this->filter_value = explode(",", $this->filter_value);
		JArrayHelper::toInteger($this->filter_value);
		if (count($this->filter_value) == 0) {
			return "";
		}
		$this->filter_value = implode(",", $this->filter_value);

		$filter = "gem.groupid IN (" . $this->filter_value . ")";

		$filter2 = "";

		if (isset($this->groupfield)){
			// Do this as a subquery not a join!!
			// it will not work with multiple groups!
			$db = JFactory::getDbo();
			$this->needsgroupby = true;

			$sql = "SELECT DISTINCT(gae.rp_id), gatd.id, gatd.ev_id, gatd.allrepeats FROM #__jev_attendees as gae";
			$sql .= " LEFT JOIN #__jev_attendance as gatd ON gatd.id=gae.at_id ";
			$sql .= " WHERE gatd.template=".$db->Quote($this->rawtemplate);
			$sql .= " AND gae.params LIKE (".$db->Quote("%".$this->groupfield."=".$this->filter_value."%").")";
			$sql .= " AND gae.attendstate=1";
			$sql .= " ORDER BY allrepeats, ev_id, rp_id";
			$db->setQuery($sql);
			$events =$db->loadObjectList();

			$rpids = array();
			$evids = array();
			foreach ($events as $event){
				if ($event->allrepeats ==0 && $event->rp_id>0 ){
					$rpids[]=$event->rp_id;
				}
				else if ($event->allrepeats==1 AND $event->rp_id==0){
					$evids[]=$event->ev_id;
				}
			}

			if (count($rpids)>0){
				$rpids = implode(",",$rpids);
				if (count($evids)>0){
					$evids = implode(",",$evids);
					$filter2 = " OR ((gatd.allrepeats=0 AND rpt.rp_id IN(".$rpids.")) OR (gatd.allrepeats=1 AND ev.ev_id IN (".$evids."))) ";
				}
				else {
					$filter2 = " OR (gatd.allrepeats=0 AND rpt.rp_id IN(".$rpids.")) ";
				}
			}
			else if (count($evids)>0){
				$evids = implode(",",$evids);
				$filter2 = " OR (gatd.allrepeats=1 AND ev.ev_id IN (".$evids.")) ";
			}

		}

		// if user specific events is enabled then add this in too.
		if ($this->userparams) {
			$user = JFactory::getUser();
			$filter = "(" . $filter . " OR ( jcgm2.groupid=jum2.groupid AND jcgm2.memberid=" . intval($user->id) . ") $filter2)";
		}
		else $filter =  "(" . $filter . " $filter2 )";


		return $filter;
	}

	function _createJoinFilter($prefix="")
	{
		if (trim($this->filter_value) == $this->filterNullValue) {
			return "";
		}
		$filter = "";

		$this->needsgroupby = true;
		$filter = " #__jev_groupeventsmap as gem ON det.evdet_id=gem.evdet_id";
		// if user specific events is enabled then add this is too.
		if ($this->userparams) {
			$filter .= " LEFT JOIN #__jev_usereventsmap as jum2 ON jum2.evdet_id=det.evdet_id";
			// JomSocial Groups
			$filter .= " LEFT JOIN #__community_groups_members as jcgm2 on jcgm2.groupid=jum2.groupid AND jcgm2.approved=1 ";
		}

		if (isset($this->groupfield)){
			$filter .= " LEFT JOIN #__jev_attendance as gatd ON gatd.ev_id=ev.ev_id ";
		}

		return $filter;
	}

	function _createfilterHTML()
	{

		return "";
	}

}