<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: Search.php 1410 2009-04-09 08:13:54Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

defined('_JEXEC') or die( 'No Direct Access' );
use Joomla\Utilities\ArrayHelper;
// Strips out non-featured events
class jevWeekdaysFilter extends jevFilter
{
	function __construct($tablename, $filterfield, $isstring=true){
		$this->filterType="jevwd";
		$this->filterNullValue="";
		parent::__construct($tablename,$filterfield, true);
	}

	function _createFilter($prefix=""){
		if (!$this->filterField ) return "";
		if ($this->filter_value == $this->filterNullValue) return "";
		$value = explode(",",$this->filter_value);
		$value = ArrayHelper::toInteger($value);
		if (in_array(-1, $value)) return "";
		$value[] = -1;
		$value = implode(",",$value);
		// If for specific repeats must specify them
		$filter = "WEEKDAY(rpt.startrepeat) IN ($value)";
		return $filter;
	}

}