<?php
/**
 * @copyright	Copyright (C) 2012-2021 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Factory;

function ProcessJsonRequest(&$requestObject, $returnData)
{

	ini_set("display_errors", 0);

	if (!isset($requestObject->modid) || $requestObject->modid == 0)
	{
		PlgSystemGwejson::throwerror("There was an error");
	}

	$user =  Factory::getUser();
	$db = Factory::getDbo();

	$query = 'SELECT id, title, module, position, content, showtitle,  params'
			. ' FROM #__modules AS m'
			//. ' LEFT JOIN #__modules_menu AS mm ON mm.moduleid = m.id'
			. ' WHERE m.published = 1'
			. ' AND m.access IN ('.implode(',', $user->getAuthorisedViewLevels()).')'
			. ' AND m.client_id = ' . (int) Factory::getApplication()->getClientId()
			. ' AND m.id = ' . (int) $requestObject->modid
			. ' ORDER BY position, ordering';

	$db->setQuery($query);
	$module = $db->loadObject();
	if (!$module)
	{
		//	PlgSystemGwejson::throwerror("There was an error - no module ".$db->getQuery()."\n".addslashes($db->getErrorMessage()));
		$returnData->result = 1;
		$returnData->modvalue = "" ;
		return $returnData;
	}

	Factory::getLanguage()->load('mod_tabbedmodules');

	include_once (JPATH_SITE."/modules/mod_tabbedmodules/helper.php");
	// Latest Events Title fix and pick up relevant parameters tweaks
	if ($module->module == "mod_jevents_latest")
	{
		modTabbedmodulesHelper::fixLatestEventsModule($module);
	}
	
	// commonly undeclared paths!
	jimport("joomla.filesystem.file");
	jimport("joomla.filesystem.folder");

	$document = Factory::getDocument();
	$renderer = $document->loadRenderer('module');
	$tempparams = array('style' => -2);
	$module->tabcontent = $renderer->render($module, $tempparams);
	$module->tabcontent = str_replace("/modules/mod_tabbedmodules","", $module->tabcontent );

	// wrap latest events module
	modTabbedmodulesHelper::wrapLatestEventsModule($module);
	
	$returnData->result = 1;
	$returnData->modvalue = $module->tabcontent ;

	$returnData->modvalue = str_replace(array("?tmpl=component", "&tmpl=component"), "", $returnData->modvalue);
	
	return $returnData;

}

