<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: helper.php 3937 2012-10-02 09:10:08Z geraintedwards $
 * @package     JEvents
 * @subpackage  Module JEvents Calendar
 * @copyright   Copyright (C) 2006-2008 JEvents Project Group
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://joomlacode.org/gf/project/jevents
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;

class modJeventsDynamicLegendHelper
{

	function __construct($params)
	{

		$this->params = $params;
		// setup for all required function and classes
		$file = JPATH_SITE . '/components/com_jevents/mod.defines.php';
		if (file_exists($file))
		{
			include_once($file);
		}
		else
		{
			die("JEvents Calendar\n<br />This module needs the JEvents component");
		}

	}

	function PrepareViewCatbar()
	{

		$db = Factory::getDbo();
		$aid = JEVHelper::getAid();
		$sectionname = "com_jevents";

		$lang = Factory::getLanguage();
		$curr_lang = $lang->get('tag');

		$allowedcatids = "";
		$cparams = ComponentHelper::getParams("com_jevents");
		$allowedcatids = $cparams->get("catidnew", array());
		if ($this->params->get("ignorecatconstraints", 0))
		{
			$allowedcatids = array();
		}
		$moduleCats = array();
		if ($this->params->get("catidnew", array()))
		{
			$moduleCats = $this->params->get("catidnew", array());
			if (count($allowedcatids) > 0)
			{
				$allowedcatids = array_intersect($allowedcatids, $moduleCats);
			}
			else
			{
				$allowedcatids = $moduleCats;
			}
		}
		if (is_array($allowedcatids) && count($allowedcatids) > 0)
		{
			$allowedcatids = "AND c.id in (" . implode(",", $allowedcatids) . ")";
		}
		else
		{
			$allowedcatids = "";
		}

		// Get all top level categories
		// GWE
		$query = "SELECT c.* , c.id FROM #__categories c JOIN #__categories  p ON c.lft BETWEEN p.lft 	AND p.rgt
			WHERE c.extension = '" . $sectionname . "' and c.parent_id = 1 
				AND c.language IN ('" . $curr_lang . "',  '*') 
				AND c.published = 1
				AND p.published = 1
				$allowedcatids
				 AND c.access " . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . $aid . ')' : ' <=  ' . $aid) . " ORDER BY c.lft";
		$db->setQuery($query);

		$topcatlist = $db->loadObjectList('id');
		//print_r($topcatlist);
		$fulltopcatlist = $topcatlist;

		// Get all sub level categories
		// GWE
		$query = "SELECT c.*, c.id FROM #__categories c JOIN #__categories  p ON c.lft BETWEEN p.lft 	AND p.rgt
			WHERE c.extension = '" . $sectionname . "' and c.parent_id > 1 
				AND c.language IN ('" . $curr_lang . "',  '*') 
				AND p.language IN ('" . $curr_lang . "',  '*') 
				AND c.published = 1
				AND p.published = 1
				$allowedcatids
				 AND c.access " . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . $aid . ')' : ' <=  ' . $aid) . " ORDER BY c.lft";
		$db->setQuery($query);
		//echo $query;
		$subcatlist = $db->loadObjectList('id');
		$fullsubcatlist = $subcatlist;


		if (!isset($this->catids))
		{
			$this->catids = Factory::getApplication()->input->getString('catids', "");
			$this->catids = explode("|", $this->catids);
			$this->catids = JEVHelper::forceIntegerArray($this->catids, false );
		}

		$catinfo = $this->getCategoryInfo($this->catids, $aid);
		$subcats = $this->getChildCategories($this->catids, 1, $aid);

		foreach ($subcatlist as &$subcat)
		{
			if (!isset($subcat->isSubActive))
			{
				$subcat->isSubActive = false;
			}
			if (!isset($subcat->isActive))
			{
				$subcat->isActive = false;
			}
			if (array_key_exists($subcat->id, $catinfo))
			{
				$subcat->isActive = true;
				$parent = & $subcatlist[$subcat->id];
				while (array_key_exists($parent->parent_id, $subcatlist))
				{
					$parent = & $subcatlist[$parent->parent_id];
					$parent->isSubActive = true;
				}
				if (array_key_exists($parent->parent_id, $topcatlist))
				{
					$parent = & $topcatlist[$parent->parent_id];
					$parent->isSubActive = true;
				}
			}
			else
			{
				$subcat->isActive = false;
			}


			unset($subcat);
		}

		foreach ($topcatlist as &$cat)
		{
			if (!isset($cat->isSubActive))
			{
				$cat->isSubActive = false;
			}
			if (array_key_exists($cat->id, $catinfo))
			{
				$cat->isActive = true;
			}
			else
			{
				$cat->isActive = false;
			}
			unset($cat);
		}

		$Itemid = JEVHelper::getItemid();
		if ($this->params->get("target_itemid", 0) > 0)
		{
			$Itemid = intval($this->params->get("target_itemid", 0));
		}

		$task = Factory::getApplication()->input->getCmd("jevtask", $this->params->get("jevview", "cat.listevents"));
		if (strpos($task, "detail") > 0)
		{
			$task = $this->params->get("jevview", "cat.listevents");
		}

		list($year, $month, $day) = JEVHelper::getYMD();

		return array($subcatlist, $topcatlist, $task, $Itemid, $year, $month, $day);
	}

	function CloseViewCatbar()
	{

		// record in the registry that the dynamic legend has displayed
		$registry = JevRegistry::getinstance("jevents");
		$registry->set("jevents.dynamiclegend", 1);

	}

	function DefaultViewCatbar()
	{

		$db = Factory::getDbo();
		$aid = JEVHelper::getAid();
		$sectionname = "com_jevents";

		$lang = Factory::getLanguage();
		$curr_lang = $lang->get('tag');

		$allowedcatids = "";
		$cparams = ComponentHelper::getParams("com_jevents");
		$allowedcatids = $cparams->get("catidnew", array());
		if ($this->params->get("ignorecatconstraints", 0))
		{
			$allowedcatids = array();
		}
		$moduleCats = array();
		if ($this->params->get("catidnew", array()))
		{
			$moduleCats = $this->params->get("catidnew", array());
			if (count($allowedcatids) > 0)
			{
				$allowedcatids = array_intersect($allowedcatids, $moduleCats);
			}
			else
			{
				$allowedcatids = $moduleCats;
			}
		}
		if (is_array($allowedcatids) && count($allowedcatids) > 0)
		{
			$allowedcatids = "AND c.id in (" . implode(",", $allowedcatids) . ")";
		}
		else
		{
			$allowedcatids = "";
		}

		// Get all top level categories
		// GWE
		$query = "SELECT c.* , c.id FROM #__categories c JOIN #__categories  p ON c.lft BETWEEN p.lft 	AND p.rgt
			WHERE c.extension = '" . $sectionname . "' and c.parent_id = 1 
				AND c.language IN ('" . $curr_lang . "',  '*') 
				AND c.published = 1
				AND p.published = 1
				$allowedcatids
				 AND c.access " . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . $aid . ')' : ' <=  ' . $aid) . " ORDER BY c.lft";
		$db->setQuery($query);

		$topcatlist = $db->loadObjectList('id');
		//print_r($topcatlist);
		$fulltopcatlist = $topcatlist;

		// Get all sub level categories
		// GWE
		$query = "SELECT c.*, c.id FROM #__categories c JOIN #__categories  p ON c.lft BETWEEN p.lft 	AND p.rgt
			WHERE c.extension = '" . $sectionname . "' and c.parent_id > 1 
				AND c.language IN ('" . $curr_lang . "',  '*') 
				AND p.language IN ('" . $curr_lang . "',  '*') 
				AND c.published = 1
				AND p.published = 1
				$allowedcatids
				 AND c.access " . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . $aid . ')' : ' <=  ' . $aid) . " ORDER BY c.lft";
		$db->setQuery($query);
		//echo $query;
		$subcatlist = $db->loadObjectList('id');
		$fullsubcatlist = $subcatlist;


		if (!isset($this->catids))
		{
			$this->catids = Factory::getApplication()->input->getString('catids', "");
			$this->catids = explode("|", $this->catids);
			$this->catids = JEVHelper::forceIntegerArray($this->catids, false );
		}

		$catinfo = $this->getCategoryInfo($this->catids, $aid);
		$subcats = $this->getChildCategories($this->catids, 1, $aid);

		foreach ($subcatlist as &$subcat)
		{
			if (!isset($subcat->isSubActive))
			{
				$subcat->isSubActive = false;
			}
			if (!isset($subcat->isActive))
			{
				$subcat->isActive = false;
			}
			if (array_key_exists($subcat->id, $catinfo))
			{
				$subcat->isActive = true;
				$parent = & $subcatlist[$subcat->id];
				while (array_key_exists($parent->parent_id, $subcatlist))
				{
					$parent = & $subcatlist[$parent->parent_id];
					$parent->isSubActive = true;
				}
				if (array_key_exists($parent->parent_id, $topcatlist))
				{
					$parent = & $topcatlist[$parent->parent_id];
					$parent->isSubActive = true;
				}
			}
			else
			{
				$subcat->isActive = false;
			}


			unset($subcat);
		}

		foreach ($topcatlist as &$cat)
		{
			if (!isset($cat->isSubActive))
			{
				$cat->isSubActive = false;
			}
			if (array_key_exists($cat->id, $catinfo))
			{
				$cat->isActive = true;
			}
			else
			{
				$cat->isActive = false;
			}
			unset($cat);
		}

		$Itemid = JEVHelper::getItemid();
		if ($this->params->get("target_itemid", 0) > 0)
		{
			$Itemid = intval($this->params->get("target_itemid", 0));
		}

		list($year, $month, $day) = JEVHelper::getYMD();

		$task = Factory::getApplication()->input->getCmd("jevtask", $this->params->get("jevview", "cat.listevents"));
		if (strpos($task, "detail") > 0)
		{
			$task = $this->params->get("jevview", "cat.listevents");
		}
		?>
		<div id="jevcatbar">
			<ul class="catmenu">
					<?php
					if ($this->params->get("positionall", 0) == 1)
					{
						?>
					<li class="level1">
						<?php
						$all = Text::_("JEV_DYNAMIC_ALL");
						if ($all == "JEV_DYNAMIC_ALL")
						{
							$all = "All";
						}
						$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=0&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
						echo "<a class='level1' href='$link' title='All'><span style='border-width:0px;border-color:transparent'>" . $all . "</span></a>";
						?>
					</li>
					<?php
				}

				$zindex = count($topcatlist) + 7;
				foreach ($topcatlist as $cat)
				{
					$zindex--;
					$this->DefaultViewCatbarGetColour($cat);
					?>
					<li class="level1 <?php echo $cat->isActive ? 'active' : ($cat->isSubActive ? 'subactive' : ''); ?>" style="z-index:<?php echo $zindex; ?>">
						<?php
						$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $cat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
						// should we convert this link into a span
						$disableparent = false;
						if ($this->params->get("disableparent", 0))
						{
							foreach ($subcatlist as $subcat)
							{
								if ($subcat->parent_id == $cat->id)
								{
									$disableparent = true;
									break;
								}
							}
						}
						if (!$disableparent)
						{
							echo "<a class='level1 " . ($cat->isActive ? 'active' : ($cat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($cat->title) . "'><span style= 'border-color:" . $cat->color . "'>" . $cat->title . "</span></a>";
						}
						else
						{
							// the next line disables the top level selections
							echo "<span class='spanfolder level1 " . ($cat->isActive ? 'active' : ($cat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($cat->title) . "'><span style= 'border-color:" . $cat->color . "'>" . $cat->title . "</span></span>";
							$tempcat = clone $cat;
							$tempcat->parent_id = $tempcat->id;
							$tempcat->skipkids = true;
							array_unshift($subcatlist, $tempcat);
						}

						$opensubcat = false;
						foreach ($subcatlist as $subcat)
						{
							if ($subcat->parent_id == $cat->id)
							{
								$this->DefaultViewCatbarGetColour($subcat);

								if (!$opensubcat)
								{
									echo "<ul class='level2'>\n";
									$opensubcat = true;
								}
								echo "<li class='level2  " . ($subcat->isActive ? 'active' : ($subcat->isSubActive ? 'subactive' : '')) . "'>\n";
								$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
								// should we convert this link into a span
								$disableparent = false;
								if ($this->params->get("disableparent", 0))
								{
									foreach ($subcatlist as $subsubcat)
									{
										if ($subsubcat->parent_id == $subcat->id && !isset($subcat->skipkids))
										{
											$disableparent = true;
											break;
										}
									}
								}
								if (!$disableparent)
								{
									echo "<a  class='level2  " . ($subcat->isActive ? 'active' : ($subcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subcat->title) . "'><span style='border-color:" . $subcat->color . "'>" . $subcat->title . "</span></a>";
								}
								else
								{
									// the next line disables the top level selections
									echo "<span  class='spanfolder level2  " . ($subcat->isActive ? 'active' : ($subcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subcat->title) . "'><span style='border-color:" . $subcat->color . "'>" . $subcat->title . "</span></span>";
									$tempcat = clone $subcat;
									$tempcat->parent_id = $tempcat->id;
									$tempcat->skipkids = true;
									array_unshift($subcatlist, $tempcat);
								}

								$opensubsubcat = false;
								foreach ($subcatlist as $subsubcat)
								{
									// if this is a dummy entry to replace the parent's link then skips its kids here
									if (isset($subcat->skipkids))
									{
										continue;
									}
									if ($subsubcat->parent_id == $subcat->id)
									{
										$this->DefaultViewCatbarGetColour($subsubcat);

										if (!$opensubsubcat)
										{
											echo "<ul class='level3 '>\n";
											$opensubsubcat = true;
										}
										echo "<li class='level3 " . ($subsubcat->isActive ? 'active' : ($subsubcat->isSubActive ? 'subactive' : '')) . "'>\n";
										$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
										// should we convert this link into a span
										$disableparent = false;
										if ($this->params->get("disableparent", 0))
										{
											foreach ($subcatlist as $subsubsubcat)
											{
												if ($subsubsubcat->parent_id == $subsubcat->id && !isset($subsubcat->skipkids))
												{
													$disableparent = true;
													break;
												}
											}
										}
										if (!$disableparent)
										{
											echo "<a  class='level3 " . ($subsubcat->isActive ? 'active' : ($subsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubcat->title) . "'><span style='border-color:" . $subsubcat->color . "'>" . $subsubcat->title . "</span></a>";
										}
										else
										{
											// the next line disables the top level selections
											echo "<span  class='spanfolder level3 " . ($subsubcat->isActive ? 'active' : ($subsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubcat->title) . "'><span style='border-color:" . $subsubcat->color . "'>" . $subsubcat->title . "</span></span>";
											$tempcat = clone $subsubcat;
											$tempcat->parent_id = $tempcat->id;
											$tempcat->skipkids = true;
											array_unshift($subcatlist, $tempcat);
										}

										$opensubsubsubcat = false;
										foreach ($subcatlist as $subsubsubcat)
										{
											// if this is a dummy entry to replace the parent's link then skips its kids here
											if (isset($subsubcat->skipkids))
											{
												continue;
											}

											if ($subsubsubcat->parent_id == $subsubcat->id)
											{
												$this->DefaultViewCatbarGetColour($subsubsubcat);

												if (!$opensubsubsubcat)
												{
													echo "<ul class='level4 '>\n";
													$opensubsubsubcat = true;
												}
												echo "<li class='level4 " . ($subsubsubcat->isActive ? 'active' : ($subsubsubcat->isSubActive ? 'subactive' : '')) . "'>\n";
												$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
												// should we convert this link into a span
												$disableparent = false;
												if ($this->params->get("disableparent", 0))
												{
													foreach ($subcatlist as $subsubsubsubcat)
													{
														if ($subsubsubsubcat->parent_id == $subsubsubcat->id && !isset($subsubsubcat->skipkids))
														{
															$disableparent = true;
															break;
														}
													}
												}
												if (!$disableparent)
												{
													echo "<a  class='level4 " . ($subsubsubcat->isActive ? 'active' : ($subsubsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubsubcat->title) . "'><span style='border-color:" . $subsubsubcat->color . "'>" . $subsubsubcat->title . "</span></a>";
												}
												else
												{
													// the next line disables the top level selections
													echo "<span  class='spanfolder level4 " . ($subsubsubcat->isActive ? 'active' : ($subsubsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubsubcat->title) . "'><span style='border-color:" . $subsubsubcat->color . "'>" . $subsubsubcat->title . "</span></span>";
													$tempcat = clone $subsubsubcat;
													$tempcat->parent_id = $tempcat->id;
													$tempcat->skipkids = true;
													array_unshift($subcatlist, $tempcat);
												}

												$opensubsubsubsubcat = false;
												foreach ($subcatlist as $subsubsubsubcat)
												{
													// if this is a dummy entry to replace the parent's link then skips its kids here
													if (isset($subsubsubcat->skipkids))
													{
														continue;
													}

													if ($subsubsubsubcat->parent_id == $subsubsubcat->id)
													{
														$this->DefaultViewCatbarGetColour($subsubsubsubcat);

														if (!$opensubsubsubsubcat)
														{
															echo "<ul class='level5 '>\n";
															$opensubsubsubsubcat = true;
														}
														echo "<li class='level5 " . ($subsubsubsubcat->isActive ? 'active' : ($subsubsubsubcat->isSubActive ? 'subactive' : '')) . "'>\n";
														$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubsubsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
														// should we convert this link into a span
														$disableparent = false;
														if ($this->params->get("disableparent", 0))
														{
															foreach ($subcatlist as $subsubsubsubsubcat)
															{
																if ($subsubsubsubsubcat->parent_id == $subsubsubsubcat->id && !isset($subsubsubsubcat->skipkids))
																{
																	$disableparent = true;
																	break;
																}
															}
														}
														if (!$disableparent)
														{
															echo "<a  class='level5" . ($subsubsubsubcat->isActive ? 'active' : ($subsubsubsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubsubsubcat->title) . "'><span style='border-color:" . $subsubsubsubcat->color . "'>" . $subsubsubsubcat->title . "</span></a>";
														}
														else
														{
															// the next line disables the top level selections
															echo "<span  class='spanfolder level5" . ($subsubsubsubcat->isActive ? 'active' : ($subsubsubsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubsubsubcat->title) . "'><span style='border-color:" . $subsubsubsubcat->color . "'>" . $subsubsubsubcat->title . "</span></span>";
															$tempcat = clone $subsubsubsubcat;
															$tempcat->parent_id = $tempcat->id;
															$tempcat->skipkids = true;
															array_unshift($subcatlist, $tempcat);
														}

														$opensubsubsubsubsubcat = false;
														foreach ($subcatlist as $subsubsubsubsubcat)
														{
															// if this is a dummy entry to replace the parent's link then skips its kids here
															if (isset($subsubsubsubcat->skipkids))
															{
																continue;
															}
															if ($subsubsubsubsubcat->parent_id == $subsubsubsubcat->id)
															{
																$this->DefaultViewCatbarGetColour($subsubsubsubsubcat);

																if (!$opensubsubsubsubsubcat)
																{
																	echo "<ul class='level6 '>\n";
																	$opensubsubsubsubsubcat = true;
																}
																echo "<li class='level6 " . ($subsubsubsubsubcat->isActive ? 'active' : ($subsubsubsubsubcat->isSubActive ? 'subactive' : '')) . "'>\n";
																$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubsubsubsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
																echo "<a  class='level6" . ($subsubsubsubsubcat->isActive ? 'active' : ($subsubsubsubsubcat->isSubActive ? 'subactive' : '')) . "' href='$link' title='" . htmlspecialchars($subsubsubsubsubcat->title) . "'><span style='border-color:" . $subsubsubsubsubcat->color . "'>" . $subsubsubsubsubcat->title . "</span></a>";
																echo "</li>\n";
															}
														}
														if ($opensubsubsubsubsubcat)
														{
															echo "</ul>\n";
														}

														echo "</li>\n";
													}
												}
												if ($opensubsubsubsubcat)
												{
													echo "</ul>\n";
												}

												echo "</li>\n";
											}
										}
										if ($opensubsubsubcat)
										{
											echo "</ul>\n";
										}

										echo "</li>\n";
									}
								}
								if ($opensubsubcat)
								{
									echo "</ul>\n";
								}
								echo "</li>\n";
							}
						}
						if ($opensubcat)
						{
							echo "</ul>\n";
						}
						?>
					</li>
						<?php
					}
					if ($this->params->get("positionall", 0) == 0)
					{
						?>
					<li class="level1">
						<?php
						$all = Text::_("JEV_DYNAMIC_ALL");
						if ($all == "JEV_DYNAMIC_ALL")
						{
							$all = "All";
						}
						$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=0&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
						echo "<a class='level1' href='$link' title='All'><span style='border-width:0px;border-color:transparent'>" . $all . "</span></a>";
						?>
					</li>
		<?php } ?>
			</ul>
		</div>
		<?php
		// remove all the cloned items from the subcatlist and re-index!
		$newsubcatlist = array();
		foreach ($subcatlist as $subcat)
		{
			if (!isset($subcat->skipkids))
			{
				$newsubcatlist[$subcat->id] = $subcat;
			}
		}
		$subcatlist = $newsubcatlist;

		$html = array();
		unset($subcat);
		foreach ($subcatlist as $subcat)
		{
			if (isset($subcat->isActive) && $subcat->isActive)
			{
				if ($this->params->get("breadcrumblinks", 1) == 1)
				{
					$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
					$html [] = "<a  href='$link' title='" . htmlspecialchars($subcat->title) . "'>" . $subcat->title . "</a>";
				}
				else
				{
					$html [] = $subcat->title;
				}

				while (array_key_exists($subcat->parent_id, $subcatlist))
				{
					$subcat = $subcatlist[$subcat->parent_id];
					if ($this->params->get("breadcrumblinks", 1) == 1)
					{
						$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
						$html [] = "<a  href='$link' title='" . htmlspecialchars($subcat->title) . "'>" . $subcat->title . "</a>";
					}
					else
					{
						$html [] = $subcat->title;
					}
				}
				while (array_key_exists($subcat->parent_id, $topcatlist))
				{
					$subcat = $topcatlist[$subcat->parent_id];
					if ($this->params->get("breadcrumblinks", 1) == 1)
					{
						$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
						$html [] = "<a  href='$link' title='" . htmlspecialchars($subcat->title) . "'>" . $subcat->title . "</a>";
					}
					else
					{
						$html [] = $subcat->title;
					}
				}

				break;
			}
		}

		if (count($html) == 0)
		{
			foreach ($topcatlist as $topcat)
			{
				if (isset($topcat->isActive) && $topcat->isActive)
				{
					if ($this->params->get("breadcrumblinks", 1) == 1)
					{
						$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $topcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
						$html [] = "<a  href='$link' title='" . htmlspecialchars($topcat->title) . "'>" . $topcat->title . "</a>";
					}
					else
					{
						$html [] = $topcat->title;
					}
				}
			}
		}

		$html = implode(" -> ", array_reverse($html));
		if ($html != "" && count($this->catids) == 1 && $this->catids[0] != 0)
		{
			if ($this->params->get("breadcrumblinks", 1) == 1)
			{
				$all = Text::_("JEV_DYNAMIC_ALL");
				if ($all == "JEV_DYNAMIC_ALL")
				{
					$all = "All";
				}
				$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=0&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
				$html = "<a  href='$link' title='All'>" . $all . "</a> -> " . $html;
			}
			else
			{
				$html = Text::_("ALL") . " -> " . $html;
			}

			$eventsInCat = Text::sprintf("JEV_DYNAMICLEG_EVENTS_IN_CATEGORY", $html);
			if ($eventsInCat == "JEV_DYNAMICLEG_EVENTS_IN_CATEGORY")
			{
				$eventsInCat = "Events in the Category : " . $html;
			}
			if ($this->params->get("show_breadcrumbs", 1) == 1)
			{
				$html = "<div class='dynamicleg_breadcrumb' style='margin:5px 0px;color:gray'>" . $eventsInCat . "</div>";
				echo $html;
			}
			else
				echo "<br style='clear:left' />";
		}
		else
			echo "<br style='clear:left' />";

		// record in the registry that the dynamic legend has displayed
		$registry = JevRegistry::getinstance("jevents");
		$registry->set("jevents.dynamiclegend", 1);

	}

	function DefaultViewCatbarGetColour(& $cat)
	{
		// GWE
		if (version_compare(JVERSION, "1.6.0", 'ge'))
		{
			if ($cat->params != "")
			{
				$params = json_decode($cat->params);
				$cat->color = isset($params->catcolour) ? $params->catcolour : (isset($params->colour) ? $params->colour : "#123456");
			}
			else
			{
				$cat->color = "#fff";
			}
		}

	}

	private
			function getCategoryInfo($catids = null, $aid = null)
	{

		$db = Factory::getDbo();

		$catidList = implode(",", $catids);

		$cfg = JEVConfig::getInstance();
		$sectionname = JEV_COM_COMPONENT;

		static $instances;

		if (!$instances)
		{
			$instances = array();
		}

		// calculate unique index identifier
		$index = $aid . '+' . $catidList;
		$where = null;

		if (!array_key_exists($index, $instances))
		{
			if (count($catids) > 0 && $catidList != "0" && strlen($catidList) != "")
			{
				$where = ' AND c.id IN (' . $catidList . ') ';
			}

			$q_published = Factory::getApplication()->isClient('administrator') ? "\n AND c.published >= 0" : "\n AND c.published = 1";
			$query = "SELECT c.*"
					. "\n FROM #__categories AS c"
					. "\n WHERE c.access IN (" . $aid . ") "
					. $q_published
					. ' AND c.extension = ' . $db->Quote($sectionname)
					. "\n " . $where;
			;

			$db->setQuery($query);
			$catlist = $db->loadObjectList('id');
			if (!$catlist || !is_array($catlist))
			{
				$catlist = array();
			}
			$instances[$index] = $catlist;
		}
		return $instances[$index];

	}

	private
			function getChildCategories($catids = null, $levels = 1, $aid = null)
	{

		$db = Factory::getDbo();

		$catidList = implode(",", $catids);

		$cfg = JEVConfig::getInstance();
		$sectionname = JEV_COM_COMPONENT;

		static $instances;

		if (!$instances)
		{
			$instances = array();
		}

		// calculate unique index identifier
		$index = $aid . '+' . $catidList;
		$where = null;

		if (!array_key_exists($index, $instances))
		{
			if (count($catids) > 0 && $catidList != "0" && strlen($catidList) != "")
			{
				$where = ' AND (p.id IN (' . $catidList . ') ' . ($levels > 1 ? ' OR gp.id IN (' . $catidList . ')' : '') . ($levels > 2 ? ' OR ggp.id IN (' . $catidList . ')' : '') . ')';
			}
			// TODO check if this should also check abncestry based on $levels
			$where .= ' AND p.id IS NOT NULL ';

			$q_published = Factory::getApplication()->isClient('administrator') ? "\n AND c.published >= 0" : "\n AND c.published = 1";
			$query = "SELECT c.*"
					. "\n FROM #__categories AS c"
					. ' LEFT JOIN #__categories AS p ON p.id=c.parent_id'
					. ($levels > 1 ? ' LEFT JOIN #__categories AS gp ON gp.id=p.parent_id ' : '')
					. ($levels > 2 ? ' LEFT JOIN #__categories AS ggp ON ggp.id=gp.parent_id ' : '')
					. "\n WHERE c.access " . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . $aid . ')' : ' <=  ' . $aid)
					. $q_published
					. ' AND c.extension ' . ' = ' . $db->Quote($sectionname)
					. "\n " . $where;
			;


			$db->setQuery($query);
			$catlist = $db->loadObjectList('id');
			if (!$catlist || !is_array($catlist))
			{
				$catlist = array();
			}
			$instances[$index] = $catlist;
		}
		return $instances[$index];

	}

}
