<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @subpackage  Module JEvents Calendar
 * @copyright   Copyright (C) 2006-2008 JEvents Project Group
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://joomlacode.org/gf/project/jevents
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

class modJeventsNotifyHelper
{

	function __construct($params)
	{
		// setup for all required function and classes
		$file = JPATH_SITE . '/components/com_jevents/mod.defines.php';
		if (file_exists($file))
		{
			include_once($file);
			include_once(JEV_LIBS . "/modfunctions.php");
		}
		else
		{
			die("JEvents Calendar\n<br />This module needs the JEvents component");
		}

		// load language constants
		JEVHelper::loadLanguage('modcal');

		$this->params = $params;

	}

	public function categoriesTree($size=15, $order="parent, ordering")
	{

		$values = "0";

		$db = Factory::getDbo();
		$user = Factory::getUser();
		$db->setQuery("SELECT cat_id FROM #__jev_notification_map WHERE user_id=$user->id");
		$cats = $db->loadColumn();
		if ($cats && count($cats) > 0)
		{
			$values = implode("|", $cats);
		}

		$reveal = $this->params->get("enlarge", "[+]");
		$hide = $this->params->get("reduce", "[-]");

		static $script;
		if (!isset($script))
		{
			$root = JURI::root();
			$token = Session::getFormToken();
			$success = Text::_("JEV_NOTIFY_SUCCESS", true);
			$failure = Text::_("JEV_NOTIFY_FAILURE", false);
			$script = <<<SCRIPT
function resetNotificationOptions(elem){
	var select = elem;
	select.querySelectorAll('option').forEach(
		function(item,index){
			if (item.selected) {
				// if select none - reset everything else
				if (item.value=="0") {
					select.selectedIndex=0;
					return;
				}
				else {
					select.options[0].selected = false;
				}
			}
		}
	);
	try {
		jQuery(elem).trigger("chosen:updated");
		jQuery(elem).trigger("liszt:updated");
	}
	catch (e){
	}
}

var jsontoken = '$token';
function updateNotifications(url){
	var requestObject = new Object();
	requestObject.error = false;
	requestObject.token = jsontoken;
	requestObject.task = "updateNotifications";
	var elem = document.getElementById('notificationcategories');
	var selected = new Array();
	for (var i = 0; i < elem.options.length; i++) if (elem.options[ i ].selected) selected.push(elem.options[ i ].value);
	requestObject.cats = selected;

	rsvpjsonactive = true;
	const xhr = new XMLHttpRequest();
	xhr.open("POST", url);

	xhr.onload = function () {
		try {
			if (xhr.status != 200) {
				alert('error ' + xhr.statusText);
				return;
			}
			let json = JSON.parse(xhr.responseText);
			if (json.error){
				try {
					eval(json.error);
				}
				catch (e){
					alert("$failure");
				}
			}
			else {
				alert("$success");
			}
		} catch (e) {
			alert('bad response = ' + e + " : " + xhr.responseText );
		}
	};
	xhr.onerror = function () {
		alert('error ' + xhr.statusText);

	}

	let fd = new FormData()
	fd.append('json', JSON.stringify(requestObject));

	xhr.send(fd);	
}
SCRIPT;
			$document = Factory::getDocument();

			$document->addScriptDeclaration($script);
		}

			$db = Factory::getDbo();
			$query = $db->getQuery(true);

			$query->select('a.id, a.title, a.level, a.parent_id');
			$query->from('#__categories AS a');
			$query->where('a.parent_id > 0');

			// Filter on extension.
			$query->where('extension = ' . $db->quote(JEV_COM_COMPONENT));

			// Filter on the published state
			$query->where('a.published = 1');

			// filter on access
			$user = Factory::getUser();
			$aids = JEVHelper::getAid($user);

			$query->where('a.access IN (' . $aids . ')');

			$query->order('a.lft');

			$db->setQuery($query);
			$items = $db->loadObjectList();

			$mitems = array();
			$mitems[] = JHTML::_('select.option', 0, Text::_("JEV_NO_NOTIFICATIONS"));
			foreach ($items as $item)
			{
				$repeat = ( $item->level - 1 >= 0 ) ? $item->level - 1 : 0;
				$item->title = "--".str_repeat('- ', $repeat) . $item->title;
				$mitems[] = HTMLHelper::_('select.option', $item->id, $item->title);
			}

		$onchange = " onchange='resetNotificationOptions(this);' ";
		if (intval($size) > 0)
		{
			return JHTML::_('select.genericlist', $mitems, 'notificationcategories[]', 'multiple="multiple" size="' . $size . '"' . $onchange, 'value', 'text', explode("|", $values));
		}
		else
		{
			return JHTML::_('select.genericlist', $mitems, 'notificationcategories[]', 'multiple="multiple" ' . $onchange, 'value', 'text', explode("|", $values));
		}

	}

}
