<?php

/**
 * copyright (C) 2012 GWE Systems Ltd - All rights reserved
 * @license GNU/GPLv3 www.gnu.org/licenses/gpl-3.0.html
 * */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class plgjeventsjevjsstreamInstallerScript
{
	//
	// Joomla installer functions
	//
	public function preflight($type, $parent) {

		if (version_compare(PHP_VERSION, "7.0", "<")){
			\Joomla\CMS\Factory::getApplication()->enqueueMessage('JEvents and its addons require PHP version 7 at least to run - please upgrade your server from version ' . PHP_VERSION, 'warning');
		}

		// Joomla! broke the update call, so we have to create a workaround check.
		$db = \Joomla\CMS\Factory::getDbo();
		$db->setQuery ( "SELECT * FROM #__extensions WHERE element = 'com_jevents' AND type='component' " );
		$jevents = $db->loadObject();

		if (is_null($jevents))
		{
			\Joomla\CMS\Factory::getApplication()->enqueueMessage('JEvents Must be installed first to use this addon.', 'warning');
			return false;
		}

		if ((int) $jevents->enabled !== 1)
		{
			\Joomla\CMS\Factory::getApplication()->enqueueMessage('JEvents has been disabled, please enable it first.', 'warning');
			return false;
		}

		$manifestcache = @json_decode($jevents->manifest_cache, true);
		if (!$manifestcache)
		{
			\Joomla\CMS\Factory::getApplication()->enqueueMessage('Invalid JEvents Manifest Cache entry please download a freshcopy of JEvents and reinstall ', 'warning');
			return false;
		}

		if (version_compare($manifestcache["version"], "3.6.0", "lt"))
		{
			\Joomla\CMS\Factory::getApplication()->enqueueMessage('A minimum of JEvents V3.6.0 is required for this addon. <br/>Please update JEvents first. Current version is ' . $manifestcache["version"], 'warning');
			return false;
		}

	}

	function install($parent)
	{

		$this->createTables();

		//Whoops! must disable auto enable for now. We need to update the database default params at the same time, or add more fallbacks in code.

		// New install, lets enable the plugin!
		//$db = JFactory::getDbo();

		//$sql = "UPDATE #__extensions SET enabled=1 WHERE element='agendaminutes'";
		//$db->setQuery($sql);
		//$db->execute();
		//echo $db->getErrorMsg();

		return true;

	}

	function uninstall($parent)
	{
		// No nothing for now, we want to keep the tables just incase they remove the plugin by accident.
	}

	function update($parent)
	{
		// Nothing to do for now, tables should be created on install.
	}

	function createTables() {
		// Nothing to do for now, tables should be created on install.
	}
	function postflight($type, $parent)
    {
		// $parent is the class calling this method
		// $type is the type of change (install, update or discover_install)
	    $jversion = new \Joomla\CMS\Version;
	    if ($jversion->isCompatible('4.0'))
	    {
		    $version =  $parent->manifest->version;
	    }
	    else
	    {
		    $version =  $parent->get('manifest')->version ;
	    }
	    echo '<h2>' . JText::_('JEV_JOMSSTREAM_PLUGIN') . ' ' . $version . ' </h2>';

		echo '<strong>';

		if ($type == "update") {
			echo JText::_('JEV_JOMSSTREAM_INSTALL_SUCCESS_1') . '<br/>';
			echo JText::_('JEV_JOMSSTREAM_PLUGIN_DESC');
		} else {
			echo JText::_('JEV_JOMSSTREAM_INSTALL_SUCCESS_2') . '<br/>';
			echo JText::_('JEV_JOMSSTREAM_PLUGIN_DESC');
		}
		echo '</strong><br/><br/>';
	}
}
