<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Factory;
use Joomla\Utilities\ArrayHelper;
jimport( 'joomla.plugin.plugin' );
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");

class plgJEventsJevcalendar extends CMSPlugin
{
	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);

		$lang 		= Factory::getLanguage();
		$lang->load("plg_jevents_jevcalendar", JPATH_ADMINISTRATOR);
	}

	/**
	 * When editing a JEvents menu item can add additional menu constraints dynamically
	 *
	 */
	function onEditMenuItem(&$menudata, $value,$control_name,$name, $id, $param)
	{
		// already done this param
		if (isset($menudata[$id])) return;

		static $matchingextra = null;
		// find the parameter that matches jevc: (if any)
		if (!isset($matchingextra)){
			if (version_compare(JVERSION, '1.6.0', '>=') ){
				$params = $param->getGroup('params');
				foreach ($params as $key => $element){
					$val = $element->value;
					if (strpos($key,"jform_params_extras")===0 ){
						if (strpos($val,"jevc:")===0){
							$matchingextra = $key;
							break;
						}
					}
				}
			}
			else {
				$keyvals = $param->toArray();
				foreach ($keyvals as $key=>$val) {
					if (strpos($key,"extras")===0 && strpos($val,"jevc:")===0){
						$matchingextra = str_replace("extras","",$key);
						break;
					}
				}
			}
			if (!isset($matchingextra)){
				$matchingextra = false;
			}
		}

		// either we found matching extra and this is the correct id or we didn't find matching extra and the value is blank
		if ((($matchingextra==$id || $matchingextra=="jform_params_extras".$id) && strpos($value,"jevc:")===0) || (($value==""||$value=="0") && $matchingextra===false)){
			$matchingextra = $id;
			$invalue = str_replace("jevc:","",$value);
			$invalue = str_replace(" ","",$invalue);
			if (strlen($invalue)>0){
				$invalue = explode(",",$invalue);
				$invalue =ArrayHelper::toInteger($invalue);
			}
			else {
				$invalue = array();
			}

			$db = Factory::getDBO();
			$sql = "SELECT * FROM #__jevents_icsfile as isc";
			$db->setQuery($sql);
			$calendars = @$db->loadObjectList('ics_id');

			$input = "<div style='align-text:left;'>";
			$input .= "<select multiple='multiple' id='jevcals' onchange='updateJevCalendar();'>";
			$selected = (count($invalue)==0)?"selected='selected'":"";
			if (!version_compare(JVERSION, "3.0.0", 'ge')){
				$input .= "<option value='' $selected>---</option>";
			}
			foreach ($calendars as $calendar) {
				$title=$calendar->label;
				$icsid=$calendar->ics_id;
				$selected = in_array($calendar->ics_id,$invalue)?"selected='selected'":"";
				$input .= "<option value='$icsid' $selected>$title</option>";
			}
			$input .= "</select>";
			$input .= '<input type="hidden"  name="'.$name.'"  id="jevcalendar" value="'.$value.'" />';
			// for CB plugins !!!
			$input .= '<input type="hidden"  name="'.$control_name.'['.$name.']"   id="compat_jevcalendar"  value="'.$value.'" />';

			$input .= "</div>";

			$script = '
			function updateJevCalendar(){
				var input = document.getElementById("jevcalendar");
				var cbinput = document.getElementById("compat_jevcalendar");
				input.value="";
				if (cbinput) cbinput.value="";
				// jquery array
				jQuery("select#jevcals option:selected").each(function(index, item){
					// if select none - reset everything else
					if (item.value=="") {
						select.selectedIndex=0;
						return;
					}
					if (input.value!="") input.value+=",";
					input.value+="jevc:"+item.value;
					if (cbinput) {
						if (cbinput.value!="") cbinput.value+=",";
						cbinput.value+="jevc:"+item.value;
					}
				});
			}
			';
			$document = Factory::getDocument();
			$document->addScriptDeclaration($script);

			$data = new stdClass();
			$data->name = "calendars";
			$data->html = $input;
			$data->label = Text::_("JEV_SPECIFIED_CALENDARS");
			$data->description = Text::_("JEV_SPECIFIED_CALENDARS_DESC");
			$data->options = array();
			$menudata[$id] = $data;
		}
	}

	function onSelectIcals( &$query){
		if(Factory::getApplication()->isClient('administrator')) {
			return;
		}

		// Have we specified specific people for the menu item
		$compparams = ComponentHelper::getParams("com_jevents");

		// If loading from a module then get the modules params from the registry
		$reg = Factory::getConfig();
		$modparams = $reg->get("jev.modparams",false);
		if ($modparams){
			$compparams = $modparams;
		}

		for ($extra = 0;$extra<20;$extra++){
			$extraval = $compparams->get("extras".$extra, false);
			if (strpos($extraval,"jevc:")===0){
				break;
			}
		}
		if (!$extraval) return true;

		$invalue = str_replace("jevc:","",$extraval);
		$invalue = str_replace(" ","",$invalue);
		if (strlen($invalue)>0){
			$invalue = explode(",",$invalue);
			$invalue =ArrayHelper::toInteger($invalue);
		}
		else {
			return true;
		}

                if (strpos($query, "ORDER BY")>0){
                    $query = str_replace("ORDER BY", " AND ical.ics_id IN (".implode(",",$invalue).") ORDER BY" , $query);
                }
                else {
                    $query .= " AND ical.ics_id IN (".implode(",",$invalue).")";
                }
	}


	function onListIcalEvents( & $extrafields, & $extratables, & $extrawhere, & $extrajoin, & $needsgroupdby=false)
	{
		if(Factory::getApplication()->isClient('administrator')) {
			return;
		}

		// Have we specified specific people for the menu item
		$compparams = ComponentHelper::getParams("com_jevents");

		// If loading from a module then get the modules params from the registry
		$reg = Factory::getConfig();
		$modparams = $reg->get("jev.modparams",false);
		if ($modparams){
			$compparams = $modparams;
		}

		// if its called from a module then we don't need the taglookup filter if we are ignoring the filter module
		if (!$modparams || ! $modparams->get("ignorefiltermodule", false)){
			if (version_compare(JVERSION, '1.6.0', '>=') ){
				$pluginsDir = JPATH_ROOT."/".'plugins'."/".'jevents'."/".'jevcalendar';
			}
			else {
				$pluginsDir = JPATH_ROOT."/".'plugins'."/".'jevents';
			}
			$filters = jevFilterProcessing::getInstance(array("calendar","multicalendar"),$pluginsDir."/"."filters"."/");
			$filters->setWhereJoin($extrawhere,$extrajoin);
		}

		for ($extra = 0;$extra<20;$extra++){
			$extraval = $compparams->get("extras".$extra, false);
			if (strpos($extraval,"jevc:")===0){
				break;
			}
		}
		if (!$extraval) return true;

		$invalue = str_replace("jevc:","",$extraval);
		$invalue = str_replace(" ","",$invalue);
		if (strlen($invalue)>0){
			$invalue = explode(",",$invalue);
			$invalue = ArrayHelper::toInteger($invalue);
		}
		else {
			return true;
		}

		$extrawhere[]  = "icsf.ics_id IN (".implode(",",$invalue).")";
		return true;
	}

	function onListEventsById( & $extrafields, & $extratables, & $extrawhere, & $extrajoin)
	{
		if(Factory::getApplication()->isClient('administrator')) {
			return;
		}

		if (version_compare(JVERSION, '1.6.0', '>=') ){
			$pluginsDir = JPATH_ROOT."/".'plugins'."/".'jevents'."/".'jevcalendar';
		}
		else {
			$pluginsDir = JPATH_ROOT."/".'plugins'."/".'jevents';
		}
		$filters = jevFilterProcessing::getInstance(array("calendar","multicalendar"),$pluginsDir."/"."filters"."/");
		$filters->setWhereJoin($extrawhere,$extrajoin);

		// Have we specified specific people for the menu item
		$compparams = ComponentHelper::getParams("com_jevents");

		// If loading from a module then get the modules params from the registry
		$reg = Factory::getConfig();
		$modparams = $reg->get("jev.modparams",false);
		if ($modparams){
			$compparams = $modparams;
		}

		for ($extra = 0;$extra<20;$extra++){
			$extraval = $compparams->get("extras".$extra, false);
			if (strpos($extraval,"jevc:")===0){
				break;
			}
		}
		if (!$extraval) return true;

		$invalue = str_replace("jevc:","",$extraval);
		$invalue = str_replace(" ","",$invalue);
		if (strlen($invalue)>0){
			$invalue = explode(",",$invalue);
			$invalue = ArrayHelper::toInteger($invalue);
		}
		else {
			return true;
		}

		$extrawhere[]  = "ev.icsid IN (".implode(",",$invalue).")";
		return true;
	}


}
