<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: jevcck.php 3952 2013-03-05 11:05:41Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\File;
use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;

jimport('joomla.plugin.plugin');
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");
JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");
JLoader::register('JevModal', JPATH_LIBRARIES . "/jevents/jevmodal/jevmodal.php");

class plgJEventsJevcck extends CMSPlugin
{

	private
		$cck;
	private
		$cckhelper;

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$lang = Factory::getLanguage();
		$lang->load("plg_jevents_jevcck", JPATH_ADMINISTRATOR);

		if (version_compare(JVERSION, "1.6.0", 'ge'))
		{
			$this->pluginpath = "plugins/jevents/jevcck/";
		}
		else
		{
			$this->pluginpath = "plugins/jevents/";
		}
		jimport("joomla.utilities.file");
		jimport("joomla.filesystem.file");
		$this->cck = $l = $cck = $this->params->get("ccktype", 'sobi2');
		if (File::exists(JPATH_SITE . DIRECTORY_SEPARATOR . $this->pluginpath . "cck/$cck.php"))
		{
			include_once(JPATH_SITE . DIRECTORY_SEPARATOR . $this->pluginpath . "cck/$cck.php");
			$cck = "Jev$cck";
			$this->cckhelper = new $cck($this->params);
		}
		else
		{
			$this->cckhelper = false;
			throw new Exception( "Invalid CCK Type", 403);
		}
		if ($this->cckhelper)
		{
			$this->cckhelper->loadLanguages();
		}

	}

	function onEditMenuItem(&$menudata, $value, $control_name, $name, $id, $param)
	{
		static $matchingextra = null;
		// find the parameter that matches jevcck: (if any)
		if (!isset($matchingextra))
		{
			$paramsgroup = $param->getGroup('params');
			foreach ($paramsgroup as $key => $element)
			{
				$val = $element->value;
				if (strpos($key, "jform_params_extras") === 0)
				{
					if (strpos($val, "jevcck:") === 0)
					{
						$matchingextra = str_replace("jform_extras", "", $key);
						break;
					}
				}
			}

			if (!isset($matchingextra))
			{
				$matchingextra = false;
			}
		}

		// already done this param
		if (isset($menudata[$id]))
			return;

		// either we found matching extra and this is the correct id or we didn't find matching extra and the value is blank
		if (($matchingextra == $id && strpos($value, "jevcck:") === 0) || (($value == "" || $value == "0") && $matchingextra === false))
		{
			$matchingextra = $id;
			$invalue = str_replace("jevcck:", "", $value);
			$invalue = str_replace(" ", "", $invalue);
			if (strlen($invalue) > 0)
			{
				$invalue = explode(",", $invalue);
				$invalue = ArrayHelper::toInteger($invalue);
				$invalue = array_unique($invalue);
			}
			else
			{
				$invalue = array();
			}

			JevModal::modal("a.jevmodal");

			HTMLHelper::script('media/com_jevents/js/Sortable.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => false));
			HTMLHelper::script($this->pluginpath . 'cck/jevcck.js');
			$current = $this->cckhelper->getcurrentMatched($invalue);

			$client = Factory::getApplication()->isClient('administrator') ? "administrator" : "site";

			$link = Route::_("index.php?option=com_jevents&task=plugin.cck&action=selectcontent&tmpl=component&client=$client&type=$this->cck", false);

			$input = "<div style='display:inline-block;align-text:left;'>
				<ul id='sortableCCK' style='margin:0px;padding:5px;cursor:move;'>";
			$validvals = array();
			foreach ($invalue as $cckid)
			{
				if (!array_key_exists($cckid, $current))
					continue;
				$validvals[] = $cckid;
				$input .= $this->cckhelper->getLi($current[$cckid]);
			}
			$value = count($validvals) > 0 ? "jevcck:" . implode(",jevcck:", $validvals) . "," : "";

			$input .= "</ul>";
			$input .= '<input type="hidden"  name="' . $name . '"  id="menucck" value="' . $value . '" />';
			// for CB plugins !!!
			$input .= '<input type="hidden"  name="' . $control_name . '[' . $name . ']"   id="compat_menucck"  value="' . $value . '" />';
			$input .= '<div style="clear:left"></div>';

			$input .= "</div>";
			$input .= "<img src='" . JURI::Root() . $this->pluginpath . "cck/Trash.png' class='sortabletrash' id='ccktrashimage' style='display:none;padding-right:2px;cursor:pointer;' title='" . Text::_("JEV_REMOVE_CCK_LISTING", true) . "'/>";
			$input .= "<script type='text/javascript'>
			peopleDeleteWarning='" . Text::_("JEV_REMOVE_CCKLISTING_WARNING", true) . "';
			document.addEventListener('DOMContentLoaded', function() {
				sortableCCK.setup();
			});
			var jevcck = {\n";
			$input .= "duplicateWarning : '" . Text::_("JEV_ALREADY_SELECTED", true) . "'\n";
			$input .= "		}
			</script>";
			Text::script("JEV_SELECT_LISTING",true);

			$input.='<button class="btn btn-primary gsl-button gsl-button-small gsl-button-primary" id="jevselectlisting" onclick="sortableCCK.selectCck(\'' . $link . '\');return false;"   >' . Text::_('JEV_SELECT_LISTING') . '</button>';

			$data = new stdClass();
			$data->name = "jevcck";
			$data->html = $input;
			$data->label = "JEV_SPECIFY_LISTINGS";
			$data->description = "JEV_SPECIFY_LISTINGS_TIP";
			$data->options = array();
			$menudata[$id] = $data;
		}

		// Now the filter for CCK detail page based modules - only in K2 at present
		if ($this->params->get("ccktype", 'sobi2')!="k2"){
			return;
		}

		static $matchingextra2 = null;
		// find the parameter that matches jevcck: (if any)
		if (!isset($matchingextra2))
		{
			$paramsgroup = $param->getGroup('params');
			foreach ($paramsgroup as $key => $element)
			{
				$val = $element->value;
				if (strpos($key, "jform_params_extras") === 0)
				{
					if (strpos($val, "jevcck2:") === 0)
					{
						$matchingextra2 = str_replace("jform_extras", "", $key);
						break;
					}
				}
			}

			if (!isset($matchingextra2))
			{
				$matchingextra2 = false;
			}
		}

		// already done this param
		if (isset($menudata[$id]))
			return;

		// either we found matching extra and this is the correct id or we didn't find matching extra and the value is blank
		if (($matchingextra2 == $id && strpos($value, "jevcck2:") === 0) || (($value == "" || $value == "0") && $matchingextra2 === false))
		{
			$matchingextra2 = $id;
			$invalue = str_replace("jevcck2:", "", $value);
			if (strlen($invalue) > 0)
			{
				$invalue = intval($invalue);
			}
			else
			{
				$invalue = 0;
			}

			$input = "<div style='display:inline-block;text-align:left;'>";
			$input .= "<select  id='jevk2filter'  name='" . $name . "'  >";
			$selected = ($invalue==0) ? "selected='selected'" : "";
			$input .= "<option value='jevcck2:0' $selected>".Text::_("JNO")."</option>";
			$selected = ($invalue!==0) ? "selected='selected'" : "";
			$input .= "<option value='jevcck2:1' $selected>".Text::_("JYES")."</option>";
			$input .= "</select>";
			$input .= "</div>";
			$input .= '<div style="clear:left"></div>';

			$data = new stdClass();
			$data->name = "jevcck2";
			$data->html = $input;
			$data->label = "JEV_FILTER_MODULE_ON_K2_DETAIL_PAGE";
			$data->description = "JEV_FILTER_MODULE_ON_K2_DETAIL_PAGE_TIP";
			$data->options = array();
			$menudata[$id] = $data;
		}

	}

	function onEditCustom(&$row, &$customfields)
	{

		$db = Factory::getDBO();
		$charset = ($db->hasUTFSupport()) ? 'DEFAULT CHARACTER SET `utf8`' : '';

		$sql = <<<SQL
CREATE TABLE IF NOT EXISTS #__jev_cckeventsmap(
	cck_id int(12) NOT NULL  default 0,
	evdet_id int(12) NOT NULL  default 0,

	PRIMARY KEY (evdet_id,cck_id),
	INDEX  (evdet_id),
	INDEX  (cck_id)
)  $charset;
SQL;
		$db->setQuery($sql);
		if (!$db->execute())
		{
			//	echo $db->getErrorMsg();
			return false;
		}

		// get the data from database and attach to row
		$detailid = intval($row->evdet_id());

		// Fetch the current match - changed for yoursites
		if ($detailid)
		{
			$current = $this->cckhelper->getcurrentListings($detailid);
		}
		else
		{
			// When creating direct we the custom fields data here - coujd also use $row->_customFields but this works ok
			$app    = Factory::getApplication();
			$input = $app->input;

			$invalue = $input->getString('custom_cck', '');

			$invalue = str_replace(array("jevcck:", ""), "", $invalue);
			if (strlen($invalue) > 0)
			{
				$invalue = explode(",", $invalue);
				$invalue = ArrayHelper::toInteger($invalue);
				$invalue = array_unique($invalue);
			}
			else
			{
				$invalue = array();
			}

			$current = $this->cckhelper->getcurrentMatched($invalue);
		}


		// All possible candidates
		$possibleItems = $this->cckhelper->getPossible();

		if (!$possibleItems || count($possibleItems) == 0)
			return;

		JevModal::modal("a.jevmodal");

		HTMLHelper::script($this->pluginpath . 'cck/jevcck.js');
		$client = Factory::getApplication()->isClient('administrator') ? "administrator" : "site";
		$link = Route::_("index.php?option=com_jevents&task=plugin.cck&action=selectcontent&tmpl=component&client=$client&type=$this->cck", false);

		$input = "<div class='gsl-margin-right' style='align-text:left;'>
				<ul id='sortableCCK' class='gsl-list' style='cursor:move;'>";
		$validvals = array();
		foreach ($current as $cck)
		{
			// skip missmatches
			if (!$cck->cckid)
				continue;
			$validvals[] = $cck->cckid;
			$input .= $this->cckhelper->getLi($cck);
		}
		$value = count($validvals) > 0 ? "jevcck:" . implode(",jevcck:", $validvals) . "," : "";

		$input .= "</ul>";
		$input .= '<input type="hidden"  name="custom_cck"  id="menucck" value="' . $value . '" />';
		$input .= "</div>";
		$input .= "<img src='" . JURI::Root() . $this->pluginpath . "cck/Trash.png' class='sortabletrash' id='ccktrashimage' style='display:none;padding-right:2px;cursor:pointer;' title='" . Text::_("JEV_REMOVE_CCK_LISTING", true) . "'/>";
		$input .= "<script type='text/javascript'>
			peopleDeleteWarning='" . Text::_("JEV_REMOVE_CCKLISTING_WARNING", true) . "';
			document.addEventListener('DOMContentLoaded', function() {
				sortableCCK.maxlistings = " . $this->params->get('maxlistings', 9999) . ";
				sortableCCK.setup();
			});
			var jevcck = {\n";
		$input .= "duplicateWarning : '" . Text::_("JEV_ALREADY_SELECTED", true) . "'\n";
		$input .= "		}
			</script>";
		Text::script("JEV_SELECT_LISTING",true);
		$input.='<button class="gsl-button gsl-button-small gsl-button-primary" id="jevselectlisting" onclick="sortableCCK.selectCck(\'' . $link . '\');return false;"   >' . Text::_('JEV_SELECT_LISTING') . '</button>';

		/*
		  if (count($possibleItems) > 1)
		  {
		  array_unshift($possibleItems, HTMLHelper::_('select.option', 0, Text::_("JEV_SELECT"), 'cckid', 'title'));
		  }
		  $input = JHTML::_('select.genericlist', $possibleItems, 'custom_cck', '', 'cckid', 'title', $value, 'custom_cck');
		 */

		HTMLHelper::_('bootstrap.tooltip');
		$customfield = array("label" => Text::_("JEV_SELECT_LISTING"), "input" => $input,"default_value"=>"","id_to_check"=>"menucck");
		$customfields["cck"] = $customfield;

		return true;

	}

	/**
	 * Clean out custom fields for event details not matching global event detail
	 *
	 * @param unknown_type $idlist
	 */
	function onCleanCustomDetails($idlist)
	{
		// TODO
		return true;

	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	function onStoreCustomDetails($evdetail)
	{
		$detailid = intval($evdetail->evdet_id);
		$ccks = array_key_exists("cck", $evdetail->_customFields) ? $evdetail->_customFields["cck"] : "0";
		$ccks = str_replace("jevcck:", "", $ccks);
		$ccks = explode(",", $ccks);
		$ccks = ArrayHelper::toInteger($ccks);

		$db = Factory::getDBO();

		// first of all remove all the old mappings
		$sql = "DELETE FROM #__jev_cckeventsmap WHERE evdet_id=" . $detailid;
		$db->setQuery($sql);
		$success = $db->execute();

		if (count($ccks))
		{
			foreach ($ccks as $cck)
			{
				if ($cck > 0)
				{
					$sql = "INSERT INTO #__jev_cckeventsmap SET cck_id=" . intval($cck) . ",  evdet_id=" . $detailid;
					$db->setQuery($sql);
					$success = $db->execute();
				}
			}
		}
		return $success;

	}

	/**
	 * Clean out custom details for deleted event details
	 *
	 * @param comma separated list of event detail ids $idlist
	 */
	function onDeleteEventDetails($idlist)
	{
		return true;

	}

	function onListIcalEvents(& $extrafields, & $extratables, & $extrawhere, & $extrajoin, & $needsgroupdby = false)
	{
		if (Factory::getApplication()->isClient('administrator'))
		{
			return;
		}

		// Have we specified specific cck for the menu item
		$compparams = ComponentHelper::getParams("com_jevents");

		// If loading from a module then get the modules params from the registry
		$reg =  Factory::getConfig();
		$modparams = $reg->get("jev.modparams", false);
		if ($modparams)
		{
			$compparams = $modparams;
		}

		for ($extra = 0; $extra < 20; $extra++)
		{
			$extraval = $compparams->get("extras" . $extra, false);
			if (strpos($extraval, "jevcck:") === 0 || strpos($extraval, "jevcck2:") === 0)
			{
				break;
			}
		}

		$invar = Factory::getApplication()->input->getString("cck_fv", "");

		if (!$extraval && $invar == "")
			return true;

		JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");
		// find what is running - used by the filters
		$registry = JevRegistry::getinstance("jevents");
		$moduleid = $registry->get("jevents.moduleid", 0);

		if (strpos($extraval, "jevcck:") === 0 ){
			$invalue = str_replace("jevcck:", "", $extraval);
			$invalue = str_replace(" ", "", $invalue);
			if (substr($invalue, strlen($invalue) - 1) == ",")
			{
				$invalue = substr($invalue, 0, strlen($invalue) - 1);
			}
			$invalue = explode(",", $invalue);
			$invalue = ArrayHelper::toInteger($invalue);

			$invars = explode(",", $invar);
			if (count($invars) > 0)
			{
				$invars = ArrayHelper::toInteger($invars);
				$invalue = array_merge($invars, $invalue);
			}
			Factory::getApplication()->input->set("cck_fv", implode(",", $invalue));
			JevHelper::setMenuFilter("cck_fv",  implode(",", $invalue));

			$filters = jevFilterProcessing::getInstance(array("ccklookup"), JPATH_SITE . "/plugins/jevents/filters/", false, $moduleid);
			$filters->setWhereJoin($extrawhere, $extrajoin);
			if (!$needsgroupdby)
				$needsgroupdby = $filters->needsGroupBy();

			Factory::getApplication()->input->set("cck_fv", $invar);
			JevHelper::clearMenuFilter("cck_fv");
		}
		if (strpos($extraval, "jevcck2:") === 0 && str_replace("jevcck2:","" ,$extraval)==1){
			if (Factory::getApplication()->input->getCmd("option")=="com_k2" && Factory::getApplication()->input->getCmd("view")=="item" && Factory::getApplication()->input->getCmd("layout")=="item" && Factory::getApplication()->input->getInt("id")>0){
				$registry = JevRegistry::getinstance("jevents");
				$moduleid = $registry->get("jevents.moduleid", 0);

				$id = Factory::getApplication()->input->getInt("id");
				Factory::getApplication()->input->set("cck_fv", $id);
				JevHelper::setMenuFilter("cck_fv",  implode(",", $id));

				$filters = jevFilterProcessing::getInstance(array("ccklookup"), JPATH_SITE . "/plugins/jevents/filters/", false, $moduleid);
				$filters->setWhereJoin($extrawhere, $extrajoin);
				if (!$needsgroupdby)
					$needsgroupdby = $filters->needsGroupBy();

				Factory::getApplication()->input->set("cck_fv", $invar);
				JevHelper::clearMenuFilter("cck_fv");
			}
			else {
				$extrawhere[] = "ev.created_by = -1"
				;			}
		}

		if (!isset($filters)) {
			$filters = jevFilterProcessing::getInstance(array("ccklookup"), JPATH_SITE . "/plugins/jevents/filters/", false, $moduleid);
			$filters->setWhereJoin($extrawhere, $extrajoin);
			if (!$needsgroupdby)
				$needsgroupdby = $filters->needsGroupBy();
		}

		return true;

	}

	function onListEventsById(& $extrafields, & $extratables, & $extrawhere, & $extrajoin)
	{
		return true;

	}

	function onDisplayCustomFields(&$row)
	{

		if (isset($row->hidedetail) && $row->hidedetail){
			return "";
		}

		$db = Factory::getDBO();

		// get the data from database and attach to row
		$detailid = intval($row->evdet_id());

		$jcckmlist = $this->cckhelper->getcurrentListings($detailid);

		$presentation = 1;

		$text = "";
		$rel = "";
		$tmpl = "";
		$Itemid = $this->params->get("targetmenu", Factory::getApplication()->input->getInt("Itemid"));
		if (count($jcckmlist) > 0)
		{
			// Do not use ul/li if there is only one item
			if (count($jcckmlist)==1){
				$presentation = 1;
			}

			$ptype = false;
			$persopen = false;
			$ulopen = false;
			$divopen = false;
			$needsseparator = false;
			$text .= "<div class='jevcck'>\n";
			if ($presentation == 0 || $presentation == 1)
			{
				$text .= "<ul class='jevcck_entries'>\n";
			}
			if ($presentation == 2)
			{
				$text .= "<div class='jevcck_entries'>\n";
				$divopen = true;
			}
			foreach ($jcckmlist as $jp)
			{

				$needsseparator = false;

				// don't use popup URL when redirecting ;)
				if ($this->params->get("cckpopup", 1) && !$this->params->get("redirect", 0))
				{
					JevModal::modal('.jevmodal');

					$tmpl = "&tmpl=component";
				}

				$link = $this->cckhelper->getLink($jp->cckid, $Itemid, $tmpl, $jp);

				// auto redirect to first listing?
				if ($this->params->get("redirect", 0))
				{
					Factory::getApplication()->redirect($link);
				}

				if ($presentation == 2)
				{
					if ($needsseparator)
					{
						$text .= ", ";
					}
					$text .= "<span>";
					$needsseparator = true;
				}
				if ($presentation == 0 || $presentation == 1)
				{
					$text .= "<li>\n";
				}

				$attr = "";

				// don't use popup URL when redirecting ;)
				if ($this->params->get("cckpopup", 1) && !$this->params->get("redirect", 0))
				{
					JevModal::modal('.jevmodal');

					$tmpl = "&tmpl=component";
					$data = new stdClass();
					$data->width  = 200;
					$data->height = 400;
					$data->size = 'modal-lg';
					$data->title  = $jp->title;
					$attr = " class='gsl-button jevmodal' data-jevmodal='" . json_encode($data) ."' ";
				}

				$text .= "<a href=\"$link\" $attr>" . $jp->title . "</a>\n";
				if ($presentation == 0 || $presentation == 1)
				{
					$text .= "</li>\n";
				}
				if ($presentation == 2)
				{
					$text .= "</span>\n";
				}
			}
			if ($presentation == 1)
			{
				$text .= "</ul>\n";
			}
			if ($presentation == 2)
			{
				$text .= "</div>\n";
			}
			$text .= "</div>\n";
		}

		// Add reference to cck info in the $event
		$row->_jevcck = $jcckmlist;
		$row->_jevccktext = $text;

		return $text;

	}


	function onDisplayCustomFieldsMultiRow(&$rows)
	{

		if (!$this->params->get("inlists", 0))
			return;

		if (count($rows) == 0)
			return;

		foreach ($rows as $key=>$val)
		{
			$this->onDisplayCustomFields($rows[$key]);
		}
	}

	static
	function fieldNameArray($layout = 'detail')
	{
		if ($layout == "edit")
		{
			$return = array();
			$labels = array();
			$values = array();

			$return['group'] = Text::_("JEV_LISTING_ADDON", true);

			$labels[] = Text::_('JEV_SELECT_LISTING');
			$values[] = "cck";

			$return['values'] = $values;
			$return['labels'] = $labels;

			return $return;
		}

		static $pluginparams;
		if (!isset($pluginparams))
		{
			$plugin = PluginHelper::getPlugin("jevents", "jevcck");
			$pluginparams = new Registry($plugin ? $plugin->params : null);
		}

		// only offer in detail view
		if ($layout != "detail"  && !$pluginparams->get("inlists", 0))
			return array();

		$lang = Factory::getLanguage();
		$lang->load("plg_jevents_jevcck", JPATH_ADMINISTRATOR);

		$labels = array();
		$labels[] = Text::_("JEV_LISTING_SUMMARY", true);
		$values = array();
		$values[] = "JEV_CCK_SUMMARY";

		$cck = $pluginparams->get("ccktype", 'sobi2');
		if (false && $cck == "sobipro"){
			$labels[] = Text::_("JEV_SOBIPRO_FIELD", true);
			$values[] = "CCK_SOBIPRO_field_company_logo ;";

		}

		$return = array();
		$return['group'] = Text::_("JEV_LISTING_ADDON", true);
		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;

	}

	static
	function substitutefield($row, $code)
	{
		if (isset($row->hidedetail) && $row->hidedetail){
			return "";
		}

		if ($code == "JEV_CCK_SUMMARY")
		{
			if (isset($row->_jevccktext))
				return $row->_jevccktext;
		}
		if (strpos($code, "CCK_SOBIPRO_")===0){
			return "has field";
		}
		return "";

	}

	function onJEventsPluginOutput()
	{
		$app = Factory::getApplication();
		$input = $app->input;
		$action = $input->getCmd('action', '');
		$task = $input->getCmd('task', '');
		if ($task == "plugin.cck")
		{
			switch ($action)
			{
				case "selectcontent" :
					include_once('cck/selectcontent.php');
					break;
			}
		}
	}

}

