    <?php
/**
* @copyright Copyright (C) 2008 GWE Systemts Ltd. All rights reserved.
* @license By negotiation
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;

jimport('joomla.plugin.plugin');

class plgContentJevcreator extends CMSPlugin {

	function __construct( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	// Joomla 1.6!!
	public function onContentPrepare($context, &$article, &$params, $page = 0) {
		return $this->onPrepareContent($article, $params, 0);
	}
	
	function onPrepareContent( &$article, &$params, $limitstart )
	{
		// only process events
		$option = Factory::getApplication()->input->getCmd("option");
		if (!isset($option) || !($option=="com_content"  || $option=="com_jevents" || $option=="com_frontpage" || $option == "com_k2" || $option == "com_sobi2" )) return true;

		// do not process the same article more than once (i.e. avoid recursion!)
		if (isset($article->jevu_processed)){
			return true;
		}
		$article->jevu_processed = true;
		
		// simple performance check to determine whether bot should process further
		if ( strpos( $article->text, '{jevu' ) === false ) {
			return true;
		}

		// define the regular expression for the bot
		$regex = "#{jevu}(.*?){/jevu}#s";

		preg_match($regex, $article->text, $matches);
		if (count($matches)!=2) return true;

                if (intval($matches[1])>0){
                    $creator = intval($matches[1]);
                }
                else if (isset($article->created_by) && intval($article->created_by)>0){
                    $creator = intval($article->created_by);
                }
                else {
                    return true;
                }
                
                Factory::getApplication()->input->set("jevu_fv",$creator);
		
		// record what is running - used by the filters
		Factory::getApplication()->input->set("jevents.activeprocess","mod_jevents_latest");
		Factory::getApplication()->input->set("jevents.moduleid", "jevcreator");
		Factory::getApplication()->input->set("jevents.moduleparams", $this->params);
		
		require_once (JPATH_SITE."/modules/mod_jevents_latest/helper.php");

		$jevhelper = new modJeventsLatestHelper();
		$theme = $this->params->get("com_calViewName", JEV_CommonFunctions::getJEventsViewName());

		PluginHelper::importPlugin("jevents");

		$viewclass = $jevhelper->getViewClass($theme, 'mod_jevents_latest',$theme."/latest", $this->params);

		$modview = new $viewclass($this->params, 0);
		$return = $modview->displayLatestEvents();

		$return = preg_replace('#<div class="mod_events_latest_callink">.*</div>#U','', $return);
		
		$return .="<br style='clear:both'/>";

		$menuitem = intval($this->params->get("target_itemid",0));
		$link = Route::_("index.php?option=com_jevents&jevu_fv=".$creator."&Itemid=".$menuitem);
		$link ="<strong>".Text::sprintf("JEV_ALL_EVENTS",$link)."</strong>";

		if ($this->params->get('modlatest_LinkToCal', 0) == 1) $return = $link . $return;
		if ($this->params->get('modlatest_LinkToCal', 0) == 2)  $return .= $link;


		// must remove the filter from the memory cache
		Factory::getApplication()->input->set("jevu_fv","");

		$article->text = preg_replace( $regex, $return, $article->text );


		Factory::getApplication()->triggerEvent( 'onJEventsLatestFooter');

		return true;
	}
}

