<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version $Id: jevtextarea.php 1569 2009-09-16 06:22:03Z geraint $
 * @package JEvents
 * @copyright Copyright (C) 2008-2009 GWE Systems Ltd
 * @license GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link http://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

define("MULTIFILTER", JRequest::getInt("mf", 1));

class JElementJevcfupdatablenf extends JElement
{

	/**
	 * Element name
	 *
	 * @access protected
	 * @var string
	 */
	var $_name = 'Jevcfupdatablenf';

	public function getInput($name, $value, &$node, $control_name)
	{
		$rows = $node->attributes()->rows;
		$cols = $node->attributes()->cols;
		$class = ( $this->element['class'] ? 'class="' . $this->element['class'] . '"' : 'class="text_area"' );
// convert <br /> tags so they are not visible when editing
		$value = str_replace('<br />', "\n", $value);

// reset the filter
		JRequest::setVar($name . "_fv", -1);
		return '<strong>This can be altered in the view event screen</strong><textarea style="display:none" name="' . $control_name . $name . '" cols="' . $cols . '" rows="' . $rows . '" ' . $class . ' id="' . $control_name . $name . '" >' . $value . '</textarea>';

	}

	public function convertValue($value, &$node)
	{
		$isEditor = JEVHelper::isEventEditor();

		if (!$isEditor)
		{
			$node->element->attributes()->label = "";
			// set access to something impossible too!
			$node->element->attributes()->access = -999;
			return "";
		}

		if (is_null($this->event) || !isset($this->event->_detail_id))
			return;

		$lines = explode("##@@^^", $value);
		$retvalues = array();
		$currentvalue = "";
		foreach ($lines as $line)
		{
			$parts = explode("#&^", $line);
			if (count($parts) == 4)
			{
				if ($currentvalue == "")
				{
					$currentvalue = $parts[3];
				}
				$cuser = JEVHelper::getUser($parts[1]);
				foreach ($node->children() as $option)
				{
					$val = (int) $option->attributes('value');
					if ($val == $parts[3])
					{
						$parts[3] = $option->data();
						break;
					}
				}

				$retvalues[] = "<div class='nfcomment'><span class='nfstate' style='margin-right:10px;'>" . $parts[3] . " :</span>" . $parts[0] . " (" . $cuser->username . " @ " . $parts[2] . ") </div>";
			}
			else if (count($parts) == 3)
			{
				$cuser = JEVHelper::getUser($parts[1]);
				$retvalues[] = "<div class='nfcomment'>" . $parts[0] . " (" . $cuser->username . " @ " . $parts[2] . ") </div>";
			}
			else if (count($parts) == 2)
			{
				$cuser = JEVHelper::getUser($parts[1]);
				$retvalues[] = "<div class='nfcomment'>" . $parts[0] . " (" . $cuser->username . ")</div>";
			}
			else
				$retvalues[] = "<div class='nfcomment'>" . $line . "</div>";
		}
		$value = nl2br(implode("", $retvalues));

		static $scriptloaded;
		if (!isset($scriptloaded))
		{
			$scriptloaded = 1;
			$url = JURI::root() . "plugins/jevents/customfields/updatefieldnf.php";
			$updatedmessage = $node->attributes()->updatedmessage;
			$doc = JFactory::getDocument();
			$rpid = $this->event->rp_id();
			$script = <<<SCRIPT
function updateupdatablenf(fieldname, userid, username, append){
//alert($('jecfupdatablenf_'+fieldname).value);

var requestObject = new Object();
requestObject.error = false;
requestObject.field = fieldname;
requestObject.task = "updateupdatablenf";
requestObject.value = $('jecfupdatablenf_'+fieldname).value;
requestObject.newstate = $('jecfupdatablenf_'+fieldname+"_state").value;
requestObject.userid = userid;
requestObject.username = username;
requestObject.append = append;
requestObject.rpid = $rpid;

var jSonRequest = new Json.Remote('$url', {
method:'get',
onComplete: function(json){
if (json.error){
alert('Update Failed');
}
else {
if (append){
$('jecfupdatablenf_'+fieldname).value = '';
$('jecfupdatablenfdiv_'+fieldname).innerHTML = json.newvalue;
}
else {
$('jecfupdatablenf_'+fieldname).value = json.newvalue;
}
alert('$updatedmessage');
}
},
onFailure: function(){
alert('Something went wrong...')
}
}).send(requestObject);

}
SCRIPT;
			$doc->addScriptDeclaration($script);
		}
?>
		<?php

		$fieldname = $node->attributes()->name;
		$rows = $node->attributes()->rows;
		$cols = $node->attributes()->cols;
		$class = ( $this->element['class'] ? 'class="' . $this->element['class'] . '"' : 'class="text_area"' );
		$buttonlabel = $node->attributes()->buttonlabel;
		$append = (int) $node->attributes()->append;

		$user = JFactory::getUser();

// handle current state
		$db = JFactory::getDBO();

		$sql = "SELECT * FROM #__jev_customfields where name=" . $db->Quote($fieldname . "_state") . " and evdet_id=" . $this->event->_detail_id;
		$db->setQuery($sql);
		$field = $db->loadObject();
		if ($field)
			$newstate = (int) $field->value;
// fields are deleted when you save them so we must lock in the value here!
		else if ($currentvalue != "")
		{
			$newstate = $currentvalue;
			$sql = "insert into #__jev_customfields set value=" . (int) $currentvalue . " , name=" . $db->Quote($fieldname . "_state") . " , evdet_id=" . $this->event->_detail_id;
			$db->setQuery($sql);
			$db->query();
		}
		else
			$newstate = -1;

		$options = array();
		foreach ($node->children() as $option)
		{
			if ($option->attributes('archive'))
				continue;
			$val = (int) $option->attributes('value');
			$text = $option->data();
			$options[] = JHTML::_('select.option', $val, JText::_($text));
		}

		$control_name = "custom_";

		$html = JHTML::_('select.genericlist', $options, 'jecfupdatablenf_' . $fieldname . "_state", $class . ' style="float:left;margin-right:10px;"', 'value', 'text', $newstate, 'jecfupdatablenf_' . $fieldname . "_state");

		if ($append)
		{
			$html .= '<textarea name="' . $fieldname . '" cols="' . $cols . '" rows="' . $rows . '" ' . $class . ' id="jecfupdatablenf_' . $fieldname . '" style="float:left"></textarea>';
			$html .= '<div style="float:left;margin-left:10px;">';
			$html .= '<input type="button" onclick="updateupdatablenf(\'' . $fieldname . '\', ' . $user->id . ', \'' . $user->username . '\', ' . $append . ');return false;" value="' . JText::_($buttonlabel) . '"/>';
			$html .= '</div>';
			$html .= '<div id="jecfupdatablenfdiv_' . $fieldname . '" style="clear:both">' . nl2br($value) . '</div>';
		}
		else
		{
			$html .= '<textarea name="' . $fieldname . '" cols="' . $cols . '" rows="' . $rows . '" ' . $class . ' id="jecfupdatablenf_' . $fieldname . '" >' . $value . '</textarea>';
			$html .= '<input type="button" onclick="updateupdatablenf(\'' . $fieldname . '\', ' . $user->id . ', \'' . $user->username . '\', ' . $append . ');return false;" value="' . JText::_($buttonlabel) . '"/>';
		}
		$html = str_replace("\n", "", $html);

		return $html;

	}

	public function fetchRequiredScript($name, &$node, $control_name)
	{

		return "JevStdRequiredFields.fields.push({'name':'" . $control_name . $name . "', 'default' :'" . $node->attributes()->default . "' ,'reqmsg':'" . trim(JText::_($node->attributes()->requiredmessage, true)) . "'}); ";

	}

	public function constructFilter($node)
	{

		$this->node = $node;
		$this->filterType = str_replace(" ", "", $this->node->attributes()->name);
		$this->filterLabel = JevcfField::varempty($this->attribute("filterlabel"))?$this->attribute("label"):$this->attribute("filterlabel");
		$this->filterNullValue = -1;
		$this->filter_value = $this->filterNullValue;
		$this->map = "csf" . $this->filterType;

		$registry = JRegistry::getInstance("jevents");
		$this->indexedvisiblefilters = $registry->get("indexedvisiblefilters", false);
		if ($this->indexedvisiblefilters === false)
			return;

// This is our best guess as to whether this filter is visible on this page.
		$this->visible = in_array("customfield", $this->indexedvisiblefilters);

// If using caching should disable session filtering if not logged in
		$cfg = JEVConfig::getInstance();
		$useCache = (int) $cfg->get('com_cache', 0);
		$user = JFactory::getUser();
		global $mainframe;
		if (MULTIFILTER && $this->node->attributes()->multifilter == 1)
		{
			$this->filterNullValue = array($this->node->attributes()->default);
			if ((int) JRequest::getVar('filter_reset', 0))
			{
				JFactory::getApplication()->setUserState( $this->filterType.'_fv_ses', $this->filterNullValue ); 			
				$this->filter_value = $this->filterNullValue;
			}
// if not logged in and using cache then do not use session data
// ALSO if this filter is not visible on the page then should not use filter value - does this supersede the previous condition ???
			else if (($user->get('id') == 0 && $useCache) || !$this->visible)
			{
				$this->filter_value = JRequest::getVar($this->filterType . '_fv', $this->filterNullValue, "request", "array");
				JArrayHelper::toInteger($this->filter_value);
			}
			else
			{
				$this->filter_value = JFactory::getApplication()->getUserStateFromRequest($this->filterType . '_fv_ses', $this->filterType . '_fv', $this->filterNullValue);
				JArrayHelper::toInteger($this->filter_value);
			}
		}
		else
		{
			if ((int) JRequest::getVar('filter_reset', 0))
			{
				JFactory::getApplication()->setUserState( $this->filterType.'_fv_ses', $this->filterNullValue ); 			
				$this->filter_value = $this->filterNullValue;
			}
// if not logged in and using cache then do not use session data
// ALSO if this filter is not visible on the page then should not use filter value - does this supersede the previous condition ???
			else if (($user->get('id') == 0 && $useCache) || !$this->visible)
			{
				$this->filter_value = JRequest::getVar($this->filterType . '_fv', $this->filterNullValue, "request", "string");
			}
			else
			{
				$this->filter_value = JFactory::getApplication()->getUserStateFromRequest($this->filterType . '_fv_ses', $this->filterType . '_fv', $this->filterNullValue, "string");
			}
		}

	}

	public function createJoinFilter()
	{
		if (MULTIFILTER && $this->node->attributes()->multifilter == 1)
		{
			if ($this->filter_value == $this->filterNullValue)
				return "";
			if (count($this->filter_value) == 0)
				return "";
		}
		else
		{
			if (trim($this->filter_value) == $this->filterNullValue)
				return ""; {
				
			}
		}

		$join = " #__jev_customfields AS $this->map ON det.evdet_id=$this->map.evdet_id";

		$db = JFactory::getDbo();
		if (MULTIFILTER && $this->node->attributes()->multifilter == 1)
		{
			$filter = "$this->map.name=" . $db->Quote($this->filterType) . " AND ( ";
			$bits = array();
			foreach ($this->filter_value as $fv)
			{
				$bits[] = " $this->map.value RLIKE " . $db->Quote(",*" . $fv . ",*");
			}
			$filter .= implode(" OR ", $bits);
			$filter .= ")";
		}
		else
		{
			$filter = "$this->map.name=" . $db->Quote($this->filterType) . " AND $this->map.value=" . $db->Quote($this->filter_value);
		}
		return $join . " AND " . $filter;

	}

	public function createFilter()
	{
		if (MULTIFILTER && $this->node->attributes()->multifilter == 1)
		{
			if ($this->filter_value == $this->filterNullValue)
				return "";
			if (count($this->filter_value) == 0)
				return "";
		}
		else
		{
			if (isset($this->filter_value) && trim($this->filter_value) == $this->filterNullValue)
				return "";
		}
		return "$this->map.id IS NOT NULL";

	}

	public function getFilterInput($name, $value, &$node, $control_name)
	{

		$size = ( $node->attributes()->size ? 'size="' . $node->attributes()->size . '"' : '' );
		$class = ( $this->element['class'] ? 'class="' . $this->element['class'] . '"' : 'class="text_area"' );
		/*
		 * Required to avoid a cycle of encoding &
		 * html_entity_decode was used in place of htmlspecialchars_decode because
		 * htmlspecialchars_decode is not compatible with PHP 4
		 */
		$value = htmlspecialchars(html_entity_decode($value, ENT_QUOTES), ENT_QUOTES);

		foreach ($node->children() as $option)
		{
			if ($option->attributes('archive'))
				continue;
			$val = (int) $option->attributes('value');
			$text = $option->data();
			$options[] = JHTML::_('select.option', $val, JText::_($text));
		}

		
		if (MULTIFILTER && $node->attributes()->multifilter==1){
			if ($value != ""){
				$value = explode(",",$value);
				JArrayHelper::toInteger($value);
			}
			else {
				$value = array();
			}

			$size =  ( $node->attributes()->filtersize ? ' size="'.$node->attributes()->filtersize.'"' : '' );
			$multiple = ' multiple="multiple"';
			return JHTML::_('select.genericlist',  $options, ''.$control_name.$name."[]", $class.$size.$multiple, 'value', 'text', $value, $control_name.$name);
		}
		else {
			return JHTML::_('select.genericlist',  $options, ''.$control_name.$name, $class, 'value', 'text', $value, $control_name.$name);
		}
		
	}

	public function createFilterHTML()
	{

		$filterList = array();
		$filterList["title"] = "<label class='evdate_label' for='" . $this->filterType . "_fv'>" . $this->filterLabel . "</label>";
		if (MULTIFILTER && $this->node->attributes()->multifilter == 1)
		{
// allow multiple select!
			$filterList["html"] = $this->getFilterInput($this->filterType . "_fv", implode(",", $this->filter_value), $this->node, "", true);
			$filterList["html"] .= "<input type='hidden' name='mf' value='1' />"; 
			//$script = "try {JeventsFilters.filters.push({id:'" . $this->filterType . "_fv',value:'" . addslashes($this->filterNullValue[0]) . "'});} catch (e) {}";
			
			$script = "function reset".$this->filterType."_fvs(){
				//document.getElements('option',\$('".$this->filterType."_fv')).each(function(item){
					\$('".$this->filterType."_fv').getElements('option').each(function(item){
					item.selected=(item.value==".$this->filterNullValue[0].")?true:false;
					var x = item.selected;
					})
				};\n";
			$script .= "try {
				JeventsFilters.filters.push({action:'reset".$this->filterType."_fvs()',id:'".$this->filterType."_fv',value:".$this->filterNullValue."});
				} 
				catch (e) {
					alert('failed to reset');
				}\n";
			
		}
		else
		{
			$filterList["html"] = $this->getFilterInput($this->filterType . "_fv", $this->filter_value, $this->node, "");
			$script = "try {JeventsFilters.filters.push({id:'" . $this->filterType . "_fv',value:'" . addslashes($this->filterNullValue) . "'});} catch (e) {}";
		}

		$document = JFactory::getDocument();
		$document->addScriptDeclaration($script);

		return $filterList;

	}

	public function attribute($attr){
		$val = $this->element->attributes()->$attr;
		$val = !is_null($val)?(string)$val:null;
		return $val;
	}

	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value) {
		$this->value = $value;
	}

}