<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: jevtext.php 1569 2009-09-16 06:22:03Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

class JElementJevcfwurl extends JElement
{

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'Jevcfwurl';

	function getFilterInput($name, $value, &$node, $control_name)
	{
		$rows = $node->attributes()->rows;
		$cols = $node->attributes()->cols;
		$class = ( $this->element['class'] ? 'class="' . $this->element['class'] . '"' : 'class="text_area"' );
// convert <br /> tags so they are not visible when editing
		$value = str_replace('<br />', "\n", $value);

// reset the filter
		JRequest::setVar($name . "_fv", -1);

		$fieldname = $node->attributes()->name;
		$size = $node->attributes()->size;
		$maxlength = $node->attributes()->maxlength;

		$class = ( $this->element['class'] ? 'class="' . $this->element['class'] . '"' : 'class="text_area"' );
		$buttonlabel = $node->attributes()->buttonlabel;

		$user = JFactory::getUser();
		$value = htmlspecialchars($value, ENT_NOQUOTES);

		$html =  '<input type="text" name="'.$control_name.$name.'" id="'.$control_name.$name.'" value="'.$value.'"   '.$size.' '.$maxlength.'/>';
		if ($value != "")
		{
			$linkvalue = $this->generateLink($value, $node);
			$html .= '<div class="webmeetlink" id="jecfwurl_link_' . $fieldname . '">' . $linkvalue . '</div>';
		}
		else {
			$linkvalue = "Please enter meeting name and passwords and save the event to generate the meeting link";
			$html .= '<div class="webmeetlink" id="jecfwurl_link_' . $fieldname . '">' . $linkvalue . '</div>';			
		}

		return $html;

	}

	public function convertValue($value, &$node)
	{
		$fieldname = $node->attributes()->name;
		$linkvalue = $this->generateLink($value, $node);
		$html = '<div class="webmeetlink" id="jecfwurl_link_' . $fieldname . '">' . $linkvalue . '</div>';
		return $html;

	}

	function generateLink($value, $node)
	{
		if(!$this->event) return "";
		
		$params = $this->_parent;

		$db = JFactory::getDBO();
		$sql = "SELECT * FROM #__jev_customfields where evdet_id=" . $this->event->_detail_id;
		$db->setQuery($sql);
		$fields = $db->loadObjectList('name');

		if (!isset($fields["wname"]) || !isset($fields["wpassword"]))
		{
			return "Please save the event to generate the link";
		}

		$meetingname= $fields["wname"]->value;
		$meetingpassword=$fields["wpassword"]->value;
		$meetingpassword=$value;
		
		return "Combination of $meetingname $meetingpassword and $meetingpassword";
		//return '<a href="http://www.website.meeting/WITHCODE" title="Click to join meeting">Click to join meeting</a>';

	}
	

	public function attribute($attr){
		$val = $this->element->attributes()->$attr;
		$val = !is_null($val)?(string)$val:null;
		return $val;
	}

	/**
	 * Magic setter; allows us to set protected values
	 * @param string $name
	 * @return nothing
	 */
	public function setValue($value) {
		$this->value = $value;
	}

}