<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// no direct access
defined( 'JPATH_BASE' ) or die( 'Direct Access to this location is not allowed.' );

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;
use Joomla\CMS\Object\CMSObject;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * Editor Jevents buton
 *
 * @package		Joomla.Plugin
 * @subpackage	Editors-xtd.jevents
 * @since 1.5
 */
class plgButtonJEvents extends CMSPlugin
{
	/**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}


	/**
	 * Display the button
	 */
	function onDisplay($name)
	{
		/*
		 * Javascript to insert the link
		 * View element calls jSelectEvent when an event is clicked
		 * jSelectEvent creates the link tag, sends it to the editor,
		 * and closes the select frame.
		 */

		Factory::getDocument()->addScriptOptions('xtd-jevents', array('editor' => $name));

		$target = $this->params->get("target_itemid",1);
		$js = "
		function jSelectEvent(link, title, Itemid, evid, rpid, editor) {
			if (Itemid>0){
				link = link.replace(/Itemid=1/, 'Itemid='+Itemid);
			}
			else {
				link = link.replace(/Itemid=1/, 'Itemid=$target');
			}
			var tag = '<a href=\"' + link + '\">' + title + '</a>';
			
			/** Use the API, if editor supports it **/
			if (window.parent.Joomla && window.parent.Joomla.editors && window.parent.Joomla.editors.instances && window.parent.Joomla.editors.instances.hasOwnProperty(editor)) {
				window.parent.Joomla.editors.instances[editor].replaceSelection(tag)
			} else {
				window.parent.jInsertEditorText(tag, editor);
			}
			if (window.parent.Joomla.Modal) {
				window.parent.Joomla.Modal.getCurrent().close();
			}
			else {
				window.parent.jModalClose();
			}

			return false;
		}";

		$doc = Factory::getDocument();
		$doc->addScriptDeclaration($js);

//		JLoader::register('JevModal', JPATH_LIBRARIES . "/jevents/jevmodal/jevmodal.php");
//		JevModal::bootstrapModal("a.jevmodal");

		$link = 'index.php?option=com_jevents&amp;task=icalevent.select&amp;tmpl=component&amp;'.Session::getFormToken().'=1&editor=' . $name;

		$button = new CMSObject();
		$button->set('modal', true);				
		$button->set('link', $link);
		$button->set('text', Text::_('PLG_EVENT_BUTTON_EVENT'));
		// use article name to pickup article icon!
		$button->set('class','gsl-button jevmodal');
		$button->set('name','calendar');
		$button->set('options', "{handler: 'iframe', size: {x: 770, y: 600}}");

		//$attr = " class='gsl-button jevmodal' data-jevmodal='" . json_encode($data) ."' ";

		return $button;
	}
}
