<?php

defined('_JEXEC') or die('Restricted access');

/**
 * @copyright (C) 2009 GWE Systems Ltd
 * @license		GNU/GPL, see LICENSE.php
 */
require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");

if(!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

if (!class_exists('plgCommunityJevents'))
{

	class plgCommunityJevents extends CApplications
	{

		var $name = "JEvents";
		var $_name = 'jevents';
		var $_jevpath = '';
		var $_user = '';
		var $_me = '';
		protected $queryModel = null;
		protected $dataModel = null;

		function __construct(& $subject, $config)
		{
			$this->_jevpath = JPATH_SITE . '/' . 'components' . '/' . 'com_jevents';
			$this->_user = CFactory::getActiveProfile();
			$this->_me = CFactory::getUser();

			parent::__construct($subject, $config);

			// Load language
			JFactory::getLanguage()->load('plg_community_jevents', JPATH_ADMINISTRATOR);

			include_once(JPATH_SITE . "/components/com_jevents/jevents.defines.php");
			$this->dataModel = new JEventsDataModel("JEventsAdminDBModel");
			$this->queryModel = new JEventsDBModel($this->dataModel);

		}

		function onSystemStart()
		{
// Add the tab
			$toolbar =  CFactory::getToolbar();

			include_once(JPATH_SITE . '/components/com_jevents/mod.defines.php');
// Must load site language files
			$lang = JFactory::getLanguage();
			$lang->load("com_jevents", JPATH_SITE);

			$menuitemId = intval($this->params->get("target_itemid", 0));

			if (!$this->params->get('jevtab', 1))
			{
// we choose not to show the tab!
				return;
			}

			list ($y, $m, $d) = JEVHelper::getYMD();
			if ($this->params->get('managedpeople', 0))
			{
				$this->_linkedperson = false;
// If using managed people link then find the associated managed person
				$this->_user = CFactory::getActiveProfile();
				if ($this->_user->id == 0)
					return;
				$db = JFactory::getDbo();
				$db->setQuery("SELECT * FROM #__jev_people WHERE linktouser=" . intval($this->_user->id));
// just the first
				$linkedusers = $db->loadObjectList();
				$this->_linkedpersons = $linkedusers;
				if (count($this->_linkedpersons) > 0)
				{
					$this->_linkedperson = $linkedusers[0];
// In JomSocial 2.2.1 routing is done again in toolbar and can be wrong
					$toolbar->addGroup('JEVENTS', JText::_('JEVENTS_TAB'), 'index.php?option=com_community&view=profile&task=app&app=jevents&mpid=' . $linkedusers[0]->pers_id . '&userid=' . $this->_user->id);
				}
				return;
			}

			$option = JRequest::getCmd("option");
			if (JRequest::getString("task", "") == "viewgroup" || ($option == "com_jevents" && intval(JFactory::getApplication()->getUserStateFromRequest('jevge_fv_ses', 'jevge_fv', 0)) > 0))
			{
				if ($this->params->get("showgroup", 0) == 0)
					return;

				$link = $this->getGroupCalendarLink();
				$toolbar->addGroup('JEVENTS', JText::_('JEV_GROUP_EVENTS'), $link);
				JRequest::setVar("jevu_fv", "");
			}
			else
			{
				$link = $this->getCalendarLink(false);
				$toolbar->addGroup('JEVENTS', JText::_('JEVENTS_TAB'), $link);
				JRequest::setVar("jevge_fv", "");
			}

// This should not be private I should be able to set it!
			$toolbar->_toolbar["JEVENTS"]->view = array("JEVENTS_TAB");
			if ($option == JEV_COM_COMPONENT)
				JRequest::setVar("view", "JEVENTS");

			$user = JFactory::getUser();
			if ($user->id > 0 && JEVHelper::isEventCreator())
			{
//$editLink = JRoute::_('index.php?option=' . JEV_COM_COMPONENT	. '&task=icalevent.edit' . '&year=' . $y . '&month=' . $m . '&day=' . $d . '&Itemid=' . $this->myItemid, true);
				$editLink = 'index.php?option=' . JEV_COM_COMPONENT . '&task=icalevent.edit' . '&year=' . $y . '&month=' . $m . '&day=' . $d . '&Itemid=' . $this->myItemid;
				$popup = false;
				$params = JComponentHelper::getParams(JEV_COM_COMPONENT);
				if ($params->get("editpopup", 0))
				{
					JHtml::_('behavior.modal');
					JHtml::script('components/' . JEV_COM_COMPONENT . '/assets/js/editpopup.js');
					$popup = true;
					$popupw = $params->get("popupw", 800);
					$popuph = $params->get("popuph", 600);
				}
				$eventlinkadd = $popup ? "javascript:jevEditPopup('" . $editLink . "',$popupw, $popuph);" : $editLink;
				$toolbar->addItem('JEVENTS', 'JEVENTS_ITEM_ADDEVENT', JText::_('ADD_AN_EVENT'), $eventlinkadd, 'append');
			}
			if ($user->id > 0 && JRequest::getCmd("jevtask") == "icalrepeat.detail" && JRequest::getInt("evid") > 0)
			{
				$datamodel = new JEventsDataModel();
				$row = $datamodel->queryModel->listEventsById(JRequest::getInt("evid"), 0, "icaldb");

				if ($row && JEVHelper::canEditEvent($row))
				{
					$ev_id = $row->ev_id();
					$rp_id = $row->rp_id();
					$editLink = 'index.php?option=' . JEV_COM_COMPONENT . '&task=icalevent.edit' . '&evid=' . $ev_id . '&rp_id=' . $rp_id . '&year=' . $y . '&month=' . $m . '&day=' . $d . '&Itemid=' . $this->myItemid;
					$popup = false;
					$params = JComponentHelper::getParams(JEV_COM_COMPONENT);
					if ($params->get("editpopup", 0))
					{
						JHtml::_('behavior.modal');
						JHtml::script('components/' . JEV_COM_COMPONENT . '/assets/js/editpopup.js');
						$popup = true;
						$popupw = $params->get("popupw", 800);
						$popuph = $params->get("popuph", 600);
					}
					$eventlinkadd = $popup ? "javascript:jevEditPopup('" . $editLink . "',$popupw, $popuph);" : $editLink;
					$toolbar->addItem('JEVENTS', 'JEVENTS_ITEM_EDITEVENT', JText::_('JEV_EDIT_EVENT'), $eventlinkadd, 'append');
				}
			}

//$searchlink=JRoute::_( 'index.php?option=' . JEV_COM_COMPONENT .  '&task=search.form&'. '&year=' . $y . '&month=' . $m . '&day=' . $d . '&Itemid=' . $this->myItemid);
			$searchlink = 'index.php?option=' . JEV_COM_COMPONENT . '&task=search.form&' . '&year=' . $y . '&month=' . $m . '&day=' . $d . '&Itemid=' . $this->myItemid;
			$toolbar->addItem('JEVENTS', 'JEVENTS_ITEM_SEARCH', JText::_("JEV_SEARCH_TITLE"), $searchlink, 'append');

		}

		function onProfileDisplay()
		{
// Load language
			JFactory::getLanguage()->load('plg_community_jevents', JPATH_ADMINISTRATOR);
// Must load site language files
			$lang = JFactory::getLanguage();
			$lang->load("com_jevents", JPATH_SITE);

			if (!file_exists($this->_jevpath .'/jevents.php'))
			{
				$content = "<div class=\"icon-nopost\"><img src='" . JURI::base() . "components/com_community/assets/error.gif' alt=\"\" /></div>";
				$content .= "<div class=\"content-nopost\">" . JText::_('JEV_JEVENTS_NOT_INSTALLED') . "</div>";
			}
			else
			{
				$this->_user = CFactory::getActiveProfile();
				$userName = $this->_user->getDisplayName();
				$userId = $this->_user->id;

				if ((!$userId && JRequest::getVar('userid', 0, 'REQUEST')) || ($userId && $userId != JRequest::getVar('userid', 0, 'REQUEST'))){
								$this->_user = CFactory::getUser(JRequest::getVar('userid', 0, 'REQUEST'));

								$userName = $this->_user->getDisplayName();
								$userId = $this->_user->id;
				}

				$caching = $this->params->get('cache', 1);
				if ($caching)
				{
					$caching = JFactory::getApplication()->getCfg('caching');
				}

				$cache =  JFactory::getCache('plgCommunityJevents');
				$cache->setCaching($caching);
				$callback = array($this, '_getLatestEvents');

// is showing only managed people then disable this
				if ($this->params->get('managedpeople', 0) == 1)
				{
					$content = "";
				}
				else
				{
					$content = $cache->call($callback, $userName, $userId);
				}

				if (!$this->params->get('showempty', 1) && strpos($content, "mod_events_latest_noevents") > 0)
				{
					$content = "";
				}

				if ($this->params->get('managedpeople', 0))
				{
					$callback = array($this, '_getLatestEvents');
// Must get a unique filter ID
//$this->params->set("ignorefiltermodule",false);
					$this->params->set('tabMessage', $this->params->get("mptabMessage", JText::_('JEV_PEOPLE_TAB_TEXT_DEFAULT')));
					$content .= $cache->call($callback, $userName, $userId, true);
				}
			}
			return $content;

		}

		function onAppDisplay()
		{
// Load language
			JFactory::getLanguage()->load('plg_community_jevents', JPATH_ADMINISTRATOR);
// Must load site language files
			$lang = JFactory::getLanguage();
			$lang->load("com_jevents", JPATH_SITE);

			if (!file_exists($this->_jevpath . DS . 'jevents.php'))
			{
				$content = "<div class=\"icon-nopost\"><img src='" . JURI::base() . "components/com_community/assets/error.gif' alt=\"\" /></div>";
				$content .= "<div class=\"content-nopost\">" . JText::_('JEV_JEVENTS_NOT_INSTALLED') . "</div>";
			}
			else
			{
				$link = $this->getCalendarLink();
				JFactory::getApplication()->redirect($link);
			}
			return $content;

		}

			public function onCommunityStreamRender($act)
			{
				$user	= CFactory::getUser($act->actor);
				$config	= CFactory::getConfig();

				// Load params
				$param = new JRegistry($act->params);
				$action = $param->get('action');
				$actors = $param->get('actors');
				$this->set('actors', $actors);

				// Handle 'single' view exclusively
				$act->title = preg_replace('/\{multiple\}(.*)\{\/multiple\}/i', '', $act->title);
				$search = array('{single}', '{/single}');
				$act->title = CString::str_ireplace($search, '', $act->title);
				$actorLink = '<a class="cStream-Author" href="' .CUrlHelper::userLink($user->id).'">'.$user->getDisplayName().'</a>';
				$title = CString::str_ireplace('{actor}', $actorLink, $act->title);

				$stream = new stdClass();
				$stream->actor = $user;
				$stream->target = null;
				$stream->headline = $title;
				$stream->message = $act->content;
				$stream->group = "";
				$stream->attachments = array();

				$attachment = new stdClass();
				$attachment->type = 'quote';
				$attachment->message = '';
				$stream->attachments[] = $attachment;

				return $stream;
			}

		public function onEventCreate($event)
		{
			if (!$this->params->get("syncwithjevents") || !$this->params->get("calendar"))
			{
				return;
			}
			$this->saveEvent($event, true);

		}

		public function onEventUpdate($event)
		{
			if (!$this->params->get("syncwithjevents") || !$this->params->get("calendar"))
			{
				return;
			}
			$this->saveEvent($event, false);

		}

		public function onBeforeEventDelete($event)
		{
			if (!$this->params->get("syncwithjevents") || !$this->params->get("calendar"))
			{
				return;
			}
			$x = 1;

		}

		public function onAfterEventDelete($event)
		{
			if ($this->params->get("syncwithjevents") && $this->params->get("calendar"))
			{
				$jseventid = $event->id;
				$parent = $event->parent;
				
				// Find the JEvents event first so we hav the event id for later
				$db = JFactory::getDbo();
				$db->setQuery("SELECT ev_id  from #__jev_jomsocial_repeats_map WHERE js_id=$event->id	");
				$veventidstring = $db->loadResult();
				if (!$veventidstring ){
					return;
				}
				//$db->setQuery("INSERT INTO #__jev_jomsocial_repeats_map  (rp_id,  ev_id,  js_id,  js_parent) VALUES " . implode(",", $maps));				
				
				// delete the repeats which are deleted in JomSocial (note that means published state = 3)
				$db->setQuery("SELECT map.rp_id  from #__jev_jomsocial_repeats_map as map 
						LEFT JOIN #__community_events as jsev ON jsev.id=map.js_id
						WHERE map.js_parent=$event->parent
						AND (jsev.published=3 OR jsev.published IS NULL)
						");
				$repeats = $db->loadColumn();
				if (!$repeats || !is_array($repeats)){
					return;
				}
				$rpidstring = implode(",",$repeats);
				
				$query = "SELECT DISTINCT (eventdetail_id) FROM #__jevents_repetition WHERE rp_id IN ($rpidstring)";
				$db->setQuery($query);
				$detailids = $db->loadColumn();
				$detailidstring = implode(",", $detailids);
				
				$query = "DELETE FROM #__jevents_repetition WHERE rp_id IN ($rpidstring)";
				$db->setQuery($query);
				$db->execute();

				// create exception based on deleted repetition
				foreach ($repeats as $rp_id){
					$exception = iCalException::loadByRepeatId($rp_id);
					if (!$exception)
					{
						$exception = new iCalException($db);
						$exception->bind(get_object_vars($data));
					}
					$exception->exception_type = 0; // deleted
					$exception->store();
				}
				
				$query = "DELETE FROM #__jev_jomsocial_repeats_map WHERE rp_id IN ($rpidstring)";
				$db->setQuery($query);
				$db->execute();

				$query = "SELECT * FROM #__jevents_repetition WHERE rp_id=rp_id IN ($rpidstring)";
				$db->setQuery($query);
				$data = null;
				$data = $db->loadObject();

				$query = "SELECT detail_id FROM #__jevents_vevent WHERE ev_id=$data->eventid";
				$db->setQuery($query);
				$eventdetailid = $db->loadResult();

				// only remove the detail id if its different for this repetition i.e. not the global one!
				if ($eventdetailid != $data->eventdetail_id)
				{
					$query = "SELECT DISTINCT (eventdetail_id) FROM #__jevents_repetition WHERE rp_id IN ($rpidstring)";
					$db->setQuery($query);
					$detailids = $db->loadColumn();
					$detailidstring = implode(",", $detailids);
					
					
					$query = "DELETE FROM #__jevents_vevdetail WHERE evdet_id IN ($detailidstring)";
					$db->setQuery($query);
					$db->execute();

					// I also need to clean out associated custom data
					// just incase we don't have jevents plugins registered yet
					JPluginHelper::importPlugin("jevents");
					$res = JFactory::getApplication()->triggerEvent('onDeleteEventDetails', array($detailidstring));
				}
				
				
				// Are there any left
				$query = "SELECT rp_id  FROM #__jevents_repetition WHERE eventid IN ($veventidstring)";
				$db->setQuery($query);
				$repeats = $db->loadColumn();
				
				// if not then remove the parent event!
				if (!$repeats)
				{
					// clean out the cache
					$cache = JFactory::getCache('com_jevents');
					$cache->clean(JEV_COM_COMPONENT);

					$veventidstring = implode(",", $cid);

					// This would fail if all recurrances have been 'adjusted'
					$query = "SELECT DISTINCT (eventdetail_id) FROM #__jevents_repetition WHERE eventid IN ($veventidstring)";
					$db->setQuery($query);
					$detailids = $db->loadColumn();
					$detailidstring = implode(",", $detailids);

					$query = "DELETE FROM #__jevents_rrule WHERE eventid IN ($veventidstring)";
					$db->setQuery($query);
					$db->execute();

					$query = "DELETE FROM #__jevents_repetition WHERE eventid IN ($veventidstring)";
					$db->setQuery($query);
					$db->execute();

					$query = "DELETE FROM #__jevents_exception WHERE eventid IN ($veventidstring)";
					$db->setQuery($query);
					$db->execute();

					$query = "DELETE FROM #__jevents_catmap WHERE evid IN ($veventidstring)";
					$db->setQuery($query);
					$db->execute();

					$query = "DELETE FROM #__jevents_vevent WHERE ev_id IN ($veventidstring)";
					$db->setQuery($query);
					$db->execute();

					// I also need to delete custom data
					// just incase we don't have jevents plugins registered yet
					JPluginHelper::importPlugin("jevents");
					$res = JFactory::getApplication()->triggerEvent('onDeleteCustomEvent', array(&$veventidstring));

					return;
				}
			}
			$x = 1;

		}

// this could be used for RSVP Pro and custom fields down the line
		/*
		  public function onFormDisplay($action ){
		  $results = array();

		  $position = "before";
		  $results[$position] = new CFormElement();
		  $results[$position]->position = $position;
		  $results[$position]->label = "JEvents Before";
		  $results[$position]->html = "JEvents Before HTML";

		  $position = "after";
		  $results[$position] = new CFormElement();
		  $results[$position]->position = $position;
		  $results[$position]->label = "JEvents After";
		  $results[$position]->html = "JEvents After HTML";

		  return $results;
		  }
		 */

		private function saveEvent($event, $newevent = true)
		{
			require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
			require_once( COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'apps.php' );
			CFactory::load('helpers', 'event');
			$temp = JTable::getInstance('Event', 'CTable');
			$handler = CEventHelper::getHandler($temp);

			$array = array();
			/*
			 *  default values are ok for these fields
			 * 
			 * priority, access, extra_info, color, lockevent
			 * 
			 * handle these later
			 * 
			 * location, contact_info (use the JomSocial Profile), multiday, noendtime
			 *
			 * TODO - sort out publishing permissions
			 *  
			 */

			if ($newevent)
			{
				$array["evid"] = 0;
			}
			else
			{
				// find it !!
				$db = JFactory::getDbo();

				// a non-repeating event
				if ($event->parent == 0)
				{
					$db->setQuery("SELECT * FROM #__jevents_vevent WHERE uid=" . $db->quote("JOMSOCIAL" . $event->creator . "xx" . $event->id));
					$jev = $db->loadObject();
					if (!$jev)
					{
						// we cannot modify historic events 
						return;
					}
					$array["evid"] = $jev ? $jev->ev_id : 0;
					$array["rp_id"] = 0;
				}
				else
				{
					$db->setQuery("SELECT * from #__jev_jomsocial_repeats_map WHERE js_id=$event->id");
					$jsevent = $db->loadObject();
					if (!$jsevent)
					{
						// we cannot modify historic events 
						return;
					}
					$array["evid"] = $jsevent ? $jsevent->ev_id : 0;
					$array["rp_id"] = $jsevent ? $jsevent->rp_id : 0;
				}
			}

			// FIND  and create category
			$db = JFactory::getDbo();
			static $categories;
			if (is_null($categories))
			{
				$sql = "SELECT * FROM #__categories WHERE extension='com_jevents'";
				$db->setQuery($sql);
				$categories = $db->loadObjectList('title');
			}

			$sql = "SELECT name FROM #__community_events_category WHERE id=" . $event->catid;
			$db->setQuery($sql);
			$jscat = $db->loadResult();

			// if no such category then create it/them		
			if (!array_key_exists($jscat, $categories))
			{
				JLoader::register('JEventsCategory', JEV_ADMINPATH . "/libraries/categoryClass.php");
				$cat = new JEventsCategory($db);
				$cat->bind(array("title" => trim($jscat)));
				$cat->published = 1;
				$cat->check();
				$cat->store();

				$sql = "SELECT * FROM #__categories WHERE extension='com_jevents'";
				$db->setQuery($sql);
				$categories = $db->loadObjectList('title');
			}

			$catid = array_key_exists($jscat, $categories) ? $categories[$jscat]->id : 0;
			$jevparams = JComponentHelper::getParams(JEV_COM_COMPONENT);
			if ($jevparams->get("multicategory", 0))
			{
				$array["catid"] = array($catid);
			}
			else
			{
				$array["catid"] = $catid;
			}

			$array["access"] = 1;
			$array["title"] = $event->title;
			$array["uid"] = "JOMSOCIAL" . $event->creator . "xx" . $event->id;

			$url = $handler->getFormattedLink('index.php?option=com_community&view=events&task=viewevent&eventid=' . $event->id, false, true);
			// reset the path for the URLs!
			$url = str_replace("plugins/jevents/jomsocial/", "", $url);
			$url = str_replace("plugins/jevents/jevjsstream/jomsocial/", "", $url);
			$array["url"] = $url;
			$array["jevcontent"] = $event->description;
			$array["extra_info"] = $event->summary;

			// a non-repeating event to insert the redirect/detail link directly
			if ($event->parent == 0)
			{
				if ($this->params->get("redirectimport"))
				{
					$array["jevcontent"] .="<br/>" . 'JSE:' . $url;
				}
				else
				{
					$array["jevcontent"] .="<br/>" . JText::sprintf("JEV_MORE_DETAILS", $url);
				}
			}
			else
			{
				// repeating event - we will need to create exceptions !
				if ($this->params->get("redirectimport"))
				{
					$array["jevcontent"] .="<br/>" . 'JSE:' . $url;
				}
				else
				{
					$array["jevcontent"] .="<br/>" . JText::sprintf("JEV_MORE_DETAILS", $url);
				}
				//$array["jevcontent"] = "Special text to be replaced with a link #@~~@#";
			}
			$array["state"] = 1;
			$array["ics_id"] = $this->params->get("calendar");
			$array["allDayEvent"] = $event->allday ? "on" : "off";
			$array["jev_creatorid"] = $event->creator;

			// See http://www.php.net/manual/en/timezones.php
			$jevparams = JComponentHelper::getParams("com_jevents");
			$jevtz = $jevparams->get("icaltimezonelive", "");
			$jevents_timezone = false;
			if ($jevtz != "" && is_callable("date_default_timezone_set"))
			{
				$jevents_timezone = date_default_timezone_get();
				date_default_timezone_set($jevtz);
				$registry = JRegistry::getInstance("jevents");
				$registry->set("jevents.timezone", $jevents_timezone);
			}

			// convert JomSocial Timezones back to true timezones!
			$jstimezones = CTimeHelper::getTimezoneList();

			$jstz = isset($jstimezones[$event->offset]) ? $jstimezones[$event->offset] : null;
                        $tz = null;
			if ($jstz)
			{
				$tz = new DateTimeZone($jstz);
			}

			$date = new JevDate($event->startdate, $tz);
			$startdate = "icaldate = " . $event->startdate . " imported date=" . $date->toSql() . "<br/>";
			$startunix = $date->toUnix();
			list($array["publish_up"], $array["start_time"] ) = explode("#", date("Y-m-d#H:i", $startunix));

			$date = new JevDate($event->enddate, $tz);
			$enddate = "icaldate = " . $event->enddate . " imported date=" . $date->toSql() . "<br/>";
			$endunix = $date->toUnix();
			list($array["publish_down"], $array["end_time"] ) = explode("#", date("Y-m-d#H:i", $endunix));

			// if editing a repeat only
			if (!$newevent && $event->parent > 0)
			{
				// TODO find the specific repeat!
				$repeataction = JRequest::getCmd("repeataction", "current");
				$event->repeat = false;
			}
			else
			{
				// otherwise just continue as normal
				$repeataction = JRequest::getCmd("repeataction", "current");
			}

			if (isset($event->repeat) && $event->repeat != "")
			{
				$rrule = array();
				$rrule["FREQ"] = strtoupper($event->repeat);
				$rrule["INTERVAL"] = 1;
				$rrule["UNTIL"] = JevDate::strtotime($event->repeatend . " 00:00:00");
				;
			}
			else
			{
				$rrule = array();
				$rrule["FREQ"] = "NONE";
				$rrule["INTERVAL"] = 1;
				$rrule["COUNT"] = 1;
			}
			$vevent = SaveIcalEvent::save($array, $this->queryModel, $rrule, false);

			// create mapping table as needed
			$db = JFactory::getDbo();
			$charset = ($db->hasUTFSupport()) ? 'DEFAULT CHARACTER SET `utf8`' : '';
			$sql = <<<SQL
CREATE TABLE IF NOT EXISTS #__jev_jomsocial_repeats_map(
	rp_id int(12) NOT NULL  default 0,				
	ev_id int(12) NOT NULL  default 0,
	js_id int(12) NOT NULL  default 0,
	js_parent int(12) NOT NULL  default 0,

	PRIMARY KEY (rp_id),
	INDEX (ev_id),
	INDEX (js_id),
	INDEX (js_parent)
)  $charset;
SQL;
			$db->setQuery($sql);
			if (!$db->execute())
			{
				echo $db->getErrorMsg();
				exit();
			}

			// Create mapping of repeats
			if ($array["evid"] == 0 && $vevent)
			{
				if ($vevent->_repetitions && count($vevent->_repetitions) > 0)
				{
					// find JomSocial repeats
					$db->setQuery("SELECT * from #__community_events where parent = $event->parent ORDER BY startdate asc");
					$jsrepeats = $db->loadObjectList();
					// find Jevents repeats
					$db->setQuery("SELECT * from #__jevents_repetition WHERE eventid = $vevent->ev_id ORDER BY startrepeat asc");
					$jevrepeats = $db->loadObjectList();

					$countrepeats = min(count($jsrepeats), count($jevrepeats));

					// ideally  (count($jsrepeats) == count($jevrepeats))

					$maps = array();
					for ($r = 0; $r < $countrepeats; $r++)
					{
						$maps[] = "(" . $jevrepeats[$r]->rp_id . "," . $vevent->ev_id . "," . $jsrepeats[$r]->id . "," . $jsrepeats[$r]->parent . ")";
					}
					if (count($maps) > 0)
					{
						$db->setQuery("INSERT INTO #__jev_jomsocial_repeats_map  (rp_id,  ev_id,  js_id,  js_parent) VALUES " . implode(",", $maps));
						if (!$db->execute())
						{
							echo $db->getErrorMsg();
							exit();
						}
					}
				}
			}
			else if ($array["evid"] != 0 && $vevent)
			{
				// now create the repeat exceptions and details
				for ($r = 0; $r < $countrepeats; $r++)
				{
					// TODO THIS
					echo "a real error to spot this";
					exit();
					//$db->setQuery("INSERT INTO #__jev_jomsocial_repeats_map  (rp_id,  ev_id,  js_id,  js_parent) VALUES " . implode(",", $maps));
				}
			}


			if ($jevents_timezone && is_callable("date_default_timezone_set"))
			{
				date_default_timezone_set($jevents_timezone);
			}

		}

		function _getLatestEvents($userName, $userId, $managedpeople = false)
		{

// get plugin params
			$plugin =  JPluginHelper::getPlugin('jevents', 'jevusers');
			if (!$plugin)
				return "";
			$jevusers_params = new JRegistry($plugin->params);

			if ($jevusers_params->get("showattending", 1))
			{
				$tab_intro = $this->params->get('tabMessage', JText::_("JEVENTS TAB TEXT DEFAULT 2"));
			}
			else
			{
				$tab_intro = $this->params->get('tabMessage', JText::_('JEVENTS_TAB_TEXT_DEFAULT'));
			}

			$return = "<div class='jevtabintro'>\n"
					. "<p>"
					. htmlspecialchars($tab_intro) // make all other output html-safe
					. "</p>"
					. "</div>\n";

			// record what is running - used by the filters
			$registry = JRegistry::getInstance("jevents");
			$registry->set("jevents.activeprocess", "mod_jevents_latest");
			$registry->set("jevents.moduleparams", $this->params);

			$jevu_fv = JRequest::getInt("jevu_fv", "");
			$peoplelkup_fv = JRequest::getInt("peoplelkup_fv", "");
			if ($managedpeople && isset($this->_linkedpersons))
			{
				$registry->set("jevents.moduleid", "jomsocial_mp");
				$ids = array();
				foreach ($this->_linkedpersons as $linkedperson)
				{
					$ids[] = $linkedperson->pers_id;
				}
				JRequest::setVar("peoplelkup_fv", implode(",", $ids));
				JRequest::setVar("jevu_fv", "");
				JRequest::setVar("jevge_fv", "");
			}
			else if ($managedpeople && !$this->_linkedperson)
			{
				return "";
			}
			else
			{
				$registry->set("jevents.moduleid", "jomsocial");
				JRequest::setVar("jevu_fv", $userId);
				JRequest::setVar("jevge_fv", "");
				JRequest::setVar("filter_reset", 0);
			}
			require_once (JPATH_SITE . "/modules/mod_jevents_latest/helper.php");

			$jevhelper = new modJeventsLatestHelper();
			$theme = JEV_CommonFunctions::getJEventsViewName();

			// Make sure using correct JEvents layout
			if ($this->params->get("com_calViewName", "") && $this->params->get("com_calViewName", "")!="global"){
				$theme = $this->params->get("com_calViewName", "");
			}

			JPluginHelper::importPlugin("jevents");

			$viewclass = $jevhelper->getViewClass($theme, 'mod_jevents_latest', $theme . DS . "latest", $this->params);


			$modview = new $viewclass($this->params, 0);
			$return .= $modview->displayLatestEvents();

			$return .="<br style='clear:both'/>";

			$menuitemId = intval($this->params->get("target_itemid", 0));

			$menu =  JFactory::getApplication()->getMenu('site');
			$menuItem = $menu->getItem($menuitemId);
			if ($menuItem && $menuItem->component == JEV_COM_COMPONENT)
			{
				if (isset($menuItem->query["task"]))
				{
					$task = $menuItem->query["task"];
				}
				else
				{
					$task = $menuItem->query["view"] . "." . $menuItem->query["layout"];
				}
			}
			else
			{
				$task = "month.calendar";
			}

			if ($managedpeople && $this->_linkedperson)
			{
				$link = JRoute::_("index.php?option=com_jevents&jevge_fv=&jevu_fv=&peoplelkup_fv=" . $this->_linkedperson->pers_id . "&task=" . $task . "&Itemid=" . $menuitemId);
				$return .="<strong>" . JText::sprintf("JEV_ALL_EVENTS", $link) . "</strong>";
			}
			else if ($managedpeople && !$this->_linkedperson)
			{
				
			}
			else
			{
				$link = JRoute::_("index.php?option=com_jevents&jevge_fv=&jevu_fv=" . $userId . "&task=" . $task . "&Itemid=" . $menuitemId);
				$return .="<strong>" . JText::sprintf("JEV_ALL_EVENTS", $link) . "</strong>";
			}

// MUST RESET THE FILTERS
			JRequest::setVar("peoplelkup_fv", $peoplelkup_fv > 0 ? $peoplelkup_fv : "");
			JRequest::setVar("jevu_fv", $jevu_fv > 0 ? $jevu_fv : "");

			return $return;

		}

		protected function getCalendarLink($sef = true)
		{

			require_once (JPATH_SITE . "/modules/mod_jevents_latest/helper.php");
// this loads the required classes
			$jevhelper = new modJeventsLatestHelper();

			$this->datamodel = new JEventsDataModel();
// find appropriate Itemid and setup catids for datamodel
			$this->catidsOut = "";
			$this->catids = null;
			$this->catidList = null;
			$this->moduleAllCats = false;

			$menuitem = findAppropriateMenuID($this->catidsOut, $this->catids, $this->catidList, $this->params->toObject(), $this->moduleAllCats);
//$menuitem = $this->datamodel->setupModuleCatids($this->params);
			if ($menuitem)
			{
				$this->myItemid = $menuitem;
			}
			else
			{
				$this->myItemid = $this->params->get("target_itemid");
			}

			$menu =  JFactory::getApplication()->getMenu('site');
			$menuItem = $menu->getItem($menuitem);
			if ($menuItem->component == JEV_COM_COMPONENT)
			{
				if (isset($menuItem->query["task"]))
				{
					$task = $menuItem->query["task"];
				}
				else
				{
					$task = $menuItem->query["view"] . "." . $menuItem->query["layout"];
				}
			}
			else
			{
				$task = "month.calendar";
			}

			$user = CFactory::getActiveProfile();

			$catids = "";
			if ($this->catidsOut != "")
			{
				$catids = "&catids=" . $this->catidsOut;
			}
// in JomSocial 2.2 it does its own sef and adds ANOTHER itemid which is the WRONG one
			if (JRequest::getInt("mpid", 0) > 0)
			{
//$link  =  JRoute::_("index.php?option=".JEV_COM_COMPONENT .  "&Itemid=". $this->myItemid ."&task=".$task. $catids."&peoplelkup_fv=".JRequest::getInt("mpid",0), true);
				$link = "index.php?option=" . JEV_COM_COMPONENT . "&Itemid=" . $this->myItemid . "&task=" . $task . $catids . "&peoplelkup_fv=" . JRequest::getInt("mpid", 0);
			}
			else
			{
//$link =  JRoute::_("index.php?option=".JEV_COM_COMPONENT .  "&Itemid=". $this->myItemid ."&task=".$task. $catids."&jevge_fv=&jevu_fv=".$user->id, true);
				$link = "index.php?option=" . JEV_COM_COMPONENT . "&Itemid=" . $this->myItemid . "&task=" . $task . $catids . "&jevge_fv=&jevu_fv=" . $user->id;
			}
			if ($sef)
			{
				$link = JRoute::_($link);
			}
			return $link;

		}

		protected function getGroupCalendarLink()
		{

			require_once (JPATH_SITE . "/modules/mod_jevents_latest/helper.php");
// this loads the required classes
			$jevhelper = new modJeventsLatestHelper();

			$this->datamodel = new JEventsDataModel();
// find appropriate Itemid and setup catids for datamodel
			$this->catidsOut = "";
			$this->catids = null;
			$this->catidList = null;
			$this->moduleAllCats = false;

			$menuitem = findAppropriateMenuID($this->catidsOut, $this->catids, $this->catidList, $this->params->toObject(), $this->moduleAllCats);
//$menuitem = $this->datamodel->setupModuleCatids($this->params);
			if ($menuitem)
			{
				$this->myItemid = $menuitem;
			}
			else
			{
				$this->myItemid = $this->params->get("target_itemid");
			}

			$menu =  JFactory::getApplication()->getMenu('site');
			$menuItem = $menu->getItem($menuitem);
			if ($menuItem->component == JEV_COM_COMPONENT)
			{
				if (isset($menuItem->query["task"]))
				{
					$task = $menuItem->query["task"];
				}
				else
				{
					$task = $menuItem->query["view"] . "." . $menuItem->query["layout"];
				}
			}
			else
			{
				$task = "month.calendar";
			}

			$groupid = JRequest::getInt("groupid", 0);

			$catids = "";
			if ($this->catidsOut != "")
			{
				$catids = "&catids=" . $this->catidsOut;
			}

// in JomSocial 2.2 it does its own sef and adds ANOTHER itemid which is the WRONG one
//$link =  JRoute::_("index.php?option=".JEV_COM_COMPONENT .  "&Itemid=". $this->myItemid ."&task=".$task. $catids."&jevu_fv=&jevge_fv=".$groupid, true);
			$link = "index.php?option=" . JEV_COM_COMPONENT . "&Itemid=" . $this->myItemid . "&task=" . $task . $catids . "&jevu_fv=&jevge_fv=" . $groupid;
			return $link;

		}

	}

}
