<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: Search.php 1410 2009-04-09 08:13:54Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

defined('_JEXEC') or die( 'No Direct Access' );

use Joomla\CMS\Factory;

// Strips out non-featured events
class jevFeaturedFilter extends jevFilter
{
	function __construct($tablename, $filterfield, $isstring=true){
		$this->filterType="jevfeatured";
		$this->filterNullValue="";
		parent::__construct($tablename,$filterfield, true);
	}

	function _createFilter($prefix=""){
		if (!$this->filterField ) return "";
		
		$user = Factory::getUser();
		
		
		// If for specific repeats must specify them
		$filter = "(atd.featured IS NULL 
					OR ev.created_by=$user->id
					OR atd.featured=0 
					OR atd.invites=0 
					OR (atd.invites=1 AND atd.featured=1 AND inv.user_id=$user->id  AND ((atd.allinvites=1 AND inv.rp_id=0) OR (atd.allinvites=0 AND inv.rp_id=rpt.rp_id))))";
		return $filter;
	}

}