<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Filter\InputFilter;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Factory;
use Joomla\CMS\Image\Image;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\Utilities\ArrayHelper;
use Joomla\String\StringHelper;

jimport('joomla.plugin.plugin');
JLoader::register('JevJoomlaVersion', JPATH_ADMINISTRATOR . '/components/com_jevents/libraries/version.php');
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

class plgJEventsjevfiles extends CMSPlugin
{

	private
		$_dbvalid = 0;
	private
		$form = false;
	private
		$anonupload = false;

	public function onContentPrepareForm($form, $data)
	{
		if (!($form instanceof Form))
		{
			$this->_subject->setError('JERROR_NOT_A_FORM');
			return false;
		}

		$input = Factory::getApplication()->input;
		if (!($input->getCmd("option") == "com_jevents" && ($input->getString("task") == "icalevent.edit" || $input->getString("task") == "icalrepeat.edit" || $input->getString("jevtask") == "icalevent.edit" || $input->getString("jevtask") == "icalrepeat.edit")))
		{
			return true;
		}

		// Check we are manipulating a valid form.
		$name = $form->getName();
		if (in_array($name, array('jevents.edit.icalevent')))
		{
			Form::addFormPath(JPATH_SITE . "/plugins/jevents/jevfiles/");
			$form->loadFile('media', false);
		}

		// Store a reference to the form to use on the event edit page
		$this->form = $form;
	}

	public function onJeventsGetter(&$row, $name, &$available)
	{
		$value = $this->substitutefield($row, $name);
		if ($value !== "")
		{
			$available = true;
			echo $value;
		}
	}

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);

		Factory::getLanguage()->load('plg_jevents_jevfiles', JPATH_ADMINISTRATOR);

		jimport('joomla.application.component.view');

		if (version_compare(JVERSION, '1.6.0', 'ge'))
		{
			$this->_basepath = JPATH_SITE . '/plugins/jevents/jevfiles/';
		}
		else
		{
			$this->_basepath = JPATH_SITE . '/plugins/jevents/';
		}
		//$this->view = new JView(array('base_path' => $this->_basepath, "template_path" => $this->_basepath . "tmpl", "name" => 'jevfiles'));
		//$this->view->addTemplatePath(JPATH_SITE . / . 'templates' . / . Factory::getApplication ()->getTemplate() . / . 'html' . / . "plg_jevfiles" );
	}

	function onEditCustom(&$row, &$customfields)
	{
		if (!extension_loaded('gd') || !function_exists('gd_info'))
		{
			echo '<strong>' . Text::_("JEV_GD_LIBRARY_MISSING") . '</strong>';
			return;
		}

		if (!$this->authorised(false))
		{
			return;
		}

		$app	   = Factory::getApplication();
		$files     = $app->input->files;
		$filecount = $files->count();

		// intercept this to save the file
		if ($filecount > 0)
		{
			$filedata = $files->getArray();
			$hasfile = false;
			$uploadfile = '';
			foreach ($filedata as $key => $val)
			{
				// Joomla 3.6 is too strict on file uploads and considered zip files to be unsafe!
				$val = $files->get($key, $val, 'raw');

				if ((strpos($key, 'upload_image') === 0 || strpos($key, 'upload_file') === 0) && ($val['size'] > 0 || ($val['error'] > 0 && $val['error'] !== UPLOAD_ERR_NO_FILE)))
				{
					$hasfile = true;
					$uploadfile = $key;
					break;
				}

			}

			if ($hasfile)
				return $this->processUpload($uploadfile);
		}

		// Only setup when editing an event (not a repeat)  - unless editing a repeat and it is allowed!
		if (!$this->params->get('allowoverrides', 0))
		{
			if ($app->input->getString('jevtask', '') != 'icalevent.edit' && $app->input->getString('jevtask', '') != 'icalevent.editcopy')
			{
				return;
			}
		}

		// Useful query form which I considered but was slower than the single combined row
		/*
		 * Using #__jev_files instead and
		 * CASE WHEN jfc.file_num=1 then jfc.filename else null end as filename1,
		 * CASE WHEN jfc.file_num=2 then jfc.filename else ull end as filename2,
		 * CASE WHEN jfc.file_num=3 then jfc.filename else null end as filename3
		 */
		// Do we offer migration?  Remove this code after October 2017
		if ($this->params->get('offermigration', 1) && Factory::getUser()->authorise('core.admin'))
		{
			$sql = "SELECT count(jf.file_num) FROM #__jev_files as jf
LEFT JOIN #__jev_files_combined as jfc on jf.ev_id = jfc.ev_id AND jf.evdet_id = jfc.evdet_id
where jfc.file_id is null";
			$db = Factory::getDbo();
			$db->setQuery($sql);
			$migrationcount = (int) $db->loadResult();
			if ($migrationcount > 0 && $this->params->get('offermigration', 1) == 1)
			{
				$app->enqueueMessage(Text::_("JEV_IMAGES_MIGRATION"), "warning");
			}
			else if ($migrationcount > 0 && $this->params->get('offermigration', 1) == 2)
			{

				// do migration using PHP - too many sites have issues with stored procedures :(

				$sql = "DELETE  FROM #__jev_files where filename=''";
				$db->setQuery($sql);
				$db->execute();

				// Initial import of reference data - no image or files yet
				$sql = "INSERT IGNORE INTO #__jev_files_combined ( ev_id, evdet_id) 
                SELECT  ev_id, evdet_id FROM #__jev_files 
                WHERE filetype='image' OR filetype='file' AND ev_id IS NOT NULL 
                GROUP BY ev_id, evdet_id;";
				$db->setQuery($sql);
				$db->execute();

				// Now loop over the images/files
				for ($cnt = 1; $cnt <= 30; $cnt++)
				{
					$sql = "UPDATE #__jev_files_combined AS jfc
    LEFT JOIN #__jev_files AS jf ON jfc.evdet_id=jf.evdet_id AND jfc.ev_id=jf.ev_id 
    SET jfc.imagetitle$cnt = jf.filetitle ,
    jfc.imagename$cnt = jf.filename,
    jfc.imagecomment$cnt = jf.filecomment
    WHERE jf.filetype='image' AND jf.file_num=$cnt ";
					$db->setQuery($sql);
					$db->execute();

					$sql = "UPDATE #__jev_files_combined AS jfc
    LEFT JOIN #__jev_files AS jf ON jfc.evdet_id=jf.evdet_id AND jfc.ev_id=jf.ev_id 
    SET jfc.filetitle$cnt = jf.filetitle ,
    jfc.filename$cnt = jf.filename,
    jfc.filecomment$cnt = jf.filecomment
    WHERE jf.filetype='file' AND jf.file_num=$cnt ";
					$db->setQuery($sql);
					$db->execute();

					$app->enqueueMessage(Text::_("JEV_IMAGES_MIGRATED"), "warning");
				}
			}
		}
		$jevuser = JEVHelper::getAuthorisedUser();

		// Get the media component configuration settings
		$mediaParams = ComponentHelper::getParams('com_media');
		// Set the path definitions
		if (!defined('JEVP_MEDIA_BASE'))
		{
			define('JEVP_MEDIA_BASE', JPATH_ROOT . '/' . $mediaParams->get('image_path', 'images/stories'));
			define('JEVP_MEDIA_BASEURL', JURI::root(true) . '/' . $mediaParams->get('image_path', 'images/stories'));
		}

		// folder relative to media folder
		$folder = $this->params->get("folder", "");
		if ($folder == "")
		{
			echo Text::_("JEV_SAVE_PLUGIN_PARAMETERS");
			return;
		}

		$mediafolder = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder);
		$mediafolderURL = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASEURL . "/" . $folder);

		// ensure folder exists
		jimport('joomla.filesystem.folder');
		if (!Folder::exists($mediafolder))
		{
			Folder::create($mediafolder);
		}

		// get the data from database and attach to row
		$db = Factory::getDbo();
		$filemappings = new stdClass();
		if ($this->params->get("allowoverrides", 0) && $row->evdet_id() > 0)
		{
			$detid = intval($row->evdet_id());
			$sql = "SELECT * FROM #__jev_files_combined WHERE evdet_id=" . $detid;
			$db->setQuery($sql);
			$filemappings = $db->loadObject();
		}
		else if ($row->ev_id() > 0)
		{
			$evid = intval($row->ev_id());
			$sql = "SELECT * FROM #__jev_files_combined WHERE ev_id=" . $evid;
			$db->setQuery($sql);
			$filemappings = $db->loadObject();
		}

		// need session id to ensure login is maintained
		$session = Factory::getSession();
		$mainframe = $app;
		if ($mainframe->isClient('administrator'))
		{
			//$targetURL = JURI::root(true) . '/administrator/index.php?tmpl=component&folder=' . $folder . '&' . $session->getName() . '=' . $session->getId() . '&' . Session::getFormToken() . '=1';
			$targetURL = JURI::root(true) . '/administrator/index.php?tmpl=component&folder=' . $folder;
		}
		else
		{
			//$targetURL = JURI::root(true) . '/index.php?tmpl=component&folder=' . $folder . '&' . $session->getName() . '=' . $session->getId() . '&' . Session::getFormToken() . '=1';
			$targetURL = JURI::root(true) . '/index.php?tmpl=component&folder=' . $folder;
		}

		$uploaderInit = "
		var oldAction = '';
		var oldTarget = '';
		var oldTask = '';
		var oldOption = '';
		function resetUploadFile(field){

			document.getElementById(field).value = '';
			
			var elemname =  field.substr(0,field.length-5);
			
			var loading = document.getElementById(elemname+'_loading');
			loading.setAttribute('hidden', true);
			var loaded = document.getElementById(elemname+'_loaded');
			loaded.setAttribute('hidden', true);

			if (document.getElementById(field).parentNode.classList.contains('gsl-form-custom'))
			{
				document.getElementById(field).parentNode.querySelector('.gsl-input').value = '';
			}

		}
		function uploadFileType(field){
			form = document.adminForm;
			oldAction = form.action;
			oldTarget = form.target;
			oldTask = form.task.value;
			oldOption = form.option.value;
			form.action = '" . $targetURL . "&jEV=default&field='+field;

			form.target = 'uploadtarget';";
		if ($mainframe->isClient('administrator'))
		{
			// if we allow overrides then no need to change the task!
			if (!$this->params->get("allowoverrides", 0))
			{
				$uploaderInit .= "form.task.value = 'icalevent.edit';";
			}
		}
		else
		{
			$uploaderInit .= "form.task.value = 'day.listevents';";
		}
		$uploaderInit .= "form.option.value = 'com_jevents';
			form.submit();
			form.action = oldAction ;
			form.target = oldTarget ;
			form.task.value = oldTask ;
			form.option.value = oldOption;

			var loading = document.getElementById(field+'_loading');
			loading.removeAttribute('hidden');
			var loaded = document.getElementById(field+'_loaded');
			loaded.setAttribute('hidden');
		}
		
		function setImageFileName(fname, filename,oname){
			if(!fname) return;

			var elemname =  fname.substr(0,fname.length-5);
			var titleelem = document.getElementById('custom_' + elemname + '_title');
			var settitle = false;
			if (titleelem && titleelem.value=='')  settitle = true;

			// msie fix - it doens't clear the upload fieldfile  after upload
			var elem = document.getElementById(fname);
			if (msieversion()){
				elem.parentNode.innerHTML = elem.parentNode.innerHTML;
			}

			// contorted because of Msie fix!
			if (settitle) {
				titleelem = document.getElementById('custom_' + elemname + '_title');
				titleelem.value = oname;
				//titleelem.value = document.getElementById('title').value;
			}

			elem = document.getElementById('custom_' + elemname);
			if (elem) elem.value = filename;
			elem = document.getElementById(fname);
			if (elem) elem.value = '';
			img = document.getElementById(elemname+'_img');
			img.src = '" . $mediafolderURL . "/thumbnails/thumb_'+filename;
			img.removeAttribute('hidden');
			img.classList.add('gsl-margin-right');

			var loading = document.getElementById(elemname+'_loading');
			loading.setAttribute('hidden', true);
			var loaded = document.getElementById(elemname+'_loaded');
			loaded.removeAttribute('hidden');

			button = document.querySelector('.clear_' + elemname);
			button.removeAttribute('hidden');

		}
		
		function clearImageFile(elemname){
			button = document.querySelector('.clear_' + elemname);
			button.setAttribute('hidden', true);
			
			img = document.getElementById(elemname+'_img');
			img.src = ''
			img.setAttribute('hidden', true);
			img.style.marginRight='0px';
			elem = document.getElementById('custom_' + elemname);
			if (elem) elem.value = '';
			elem = document.getElementById('custom_' + elemname+'_title');
			if (elem) elem.value = '';
			elem = document.getElementById('custom_' + elemname+'comment');
			if (elem) elem.value = '';

			var loaded = document.getElementById(elemname+'_loaded');
			loaded.setAttribute('hidden', true);			
		}

		function clearFile(elemname){
			button = document.querySelector('.clear_' + elemname);
			button.setAttribute('hidden', true);;

			img = document.getElementById(elemname+'_link');
			img.href = ''
			img.innerHTML='';
			img.setAttribute('hidden', true);;
			elem = document.getElementById('custom_'+elemname);
			if (elem) elem.value = '';
			elem = document.getElementById('custom_' + elemname+'_title');
			if (elem) elem.value = '';
			
			var loaded = document.getElementById(elemname+'_loaded');
			loaded.removeAttribute('hidden');;			
		}

		function msieversion() {
			var ua = window.navigator.userAgent;
			var msie = ua.indexOf(\"MSIE \");

			if (msie > 0) // If Internet Explorer, return version number
			{
				return true;
			}

			return false;
		}

		function setLinkFileHref(fname, filename, oname){
			if(!fname) return;

			// msie fix - it doens't clear the upload fieldfile  after upload
			elem = document.getElementById(fname);
			if (msieversion()) {
				elem.parentNode.innerHTML = elem.parentNode.innerHTML;
			}

			elemname = fname.substr(0,fname.length-5);
			elem = document.getElementById('custom_' + elemname);
			if (elem) elem.value = filename;

			var titleelem = document.getElementById('custom_' + elemname + '_title');
			var settitle = false;
			if (titleelem && (titleelem.value=='' || titleelem != titleelem.value))  settitle = true;

			if (settitle) {
				titleelem.value = oname;
			}

			elem = document.getElementById(fname);
			if (elem) elem.value = '';
			mylink = document.getElementById(elemname+'_link');
			mylink.href = '" . $mediafolderURL . "/'+filename;
			mylink.innerHTML = oname;

			var loading = document.getElementById(elemname+'_loading');
			loading.style.display='none';
			var loaded = document.getElementById(elemname+'_loaded');
			loaded.style.display='block';
			
			button = document.querySelector('.clear_' + elemname);
			button.removeAttribute('hidden');;			
		}

		";
		$document = Factory::getDocument();
		$document->addScriptDeclaration($uploaderInit);

		$result = '<iframe src="about:blank" style="display:none" name="uploadtarget" id="uploadtarget"></iframe>';
		$result .= '<input type="hidden" name="' . $session->getName() . '" id="sessions" value="' . $session->getId() . '" />';
		$result .= '<input type="hidden" name="' . Session::getFormToken() . '" id="token" value="1" />';

		$imagenos = intval($this->params->get("imnum", 1));
		$filenos = intval($this->params->get("filnum", 1));

		// index from 1 !!!
		for ($i = 1; $i <= $imagenos; $i++)
		{

			$namefield = "imagename" . $i;
			$titlefield = "imagetitle" . $i;
			$commentfield = "imagecomment" . $i;
			$filename = isset($filemappings->$namefield) && $filemappings->$namefield != "" ? $filemappings->$namefield : "";
			$filetitle = isset($filemappings->$namefield) && $filemappings->$titlefield != "" ? $filemappings->$titlefield : "";
			$filecomment = isset($filemappings->$commentfield) && $filemappings->$commentfield != "" ? $filemappings->$commentfield : "";

			if ($filename)
			{
				// non-joomla images
				if ($this->params->get("allowmedia", 0) && !File::exists(JPATH_ROOT . "/$filename"))
				{
					$filename = plgJEventsjevfiles::canonicalize($mediaParams->get('image_path', 'images/stories') . "/$folder/$filename");
				}
				if (strpos($filename, "/") !== false)
				{
					$src = JURI::root(true) . '/' . $filename;
				}
				else
				{
					$src = JEVP_MEDIA_BASEURL . "/$folder/thumbnails/thumb_$filename";
				}
				$visibility = "gsl-margin-right";
				$hidden = "";
			}
			else
			{
				$src = "about:blank";
				$visibility = "";
				$hidden = "hidden";
			}

			$fieldname = "upload_image" . $i;
			$id_to_check = "custom_" . $fieldname;

			//$result .= "<div data-gsl-lightbox class='gsl-inline-block'><a href='$src'>";
			$result .= '<img id="' . $fieldname . '_img" class="gsl-inline-block  ' . $visibility . '" ' . $hidden. ' alt="' . JEventsHTML::special($filetitle) . '" src="' . $src . '" style="max-width:400px!important;"/>';
			//$result .= '</a></div>';
			$result .= JHTML::_('form.token');


			if ($this->params->get("imagetitle", 1))
			{
				$result .= '<div  class="gsl-inline-block gsl-margin-right gsl-text-top" >';
				$result .= '<label for="custom_' . $fieldname . '_file" >' . Text::_("JEV_UPLOAD_IMAGE_TITLE") . '</label>';
				$result .= '<input type="text" name="custom_' . $fieldname . '_title" id="custom_' . $fieldname . '_title" value="' . $filetitle . '" size="50"/>';
				if ($this->params->get("imagecomment", 0))
				{
					$result .= '<label for="custom_' . $fieldname . '_file">' . Text::_("JEV_UPLOAD_IMAGE_COMMENT") . '</label>';
					$result .= '<textarea name="custom_' . $fieldname . '_comment" id="custom_' . $fieldname . '_comment" rows="5" columns="40">' . $filecomment . '</textarea>';
				}
				$result .= '</div>';
			}
			else
			{
				$result .= '<input type="hidden" name="custom_' . $fieldname . '_title" id="custom_' . $fieldname . '_title" value="' . $filetitle . '" size="50"/>';
			}
			if (!$this->params->get("imagecomment", 0))
			{
				$result .= '<input type="hidden" name="custom_' . $fieldname . '_comment" id="custom_' . $fieldname . '_comment" value="' . $filecomment . '" size="50"/>';
			}

			if ($this->params->get("allowmedia", 0) && $this->form)
			{
				$result .= '<div  class="gsl-inline-block gsl-margin-right  gsl-text-top" >';
				$result .= '<label for="' . $fieldname . '_file">' . Text::_("JEV_SELECT_IMAGE") . '</label>';
				$this->form->setValue("custom_upload_image$i", null, $filename);
				$imageField = $this->form->getField("custom_upload_image$i");

				if (version_compare(JVERSION, "4.0.0", "ge"))
				{
					$imageField->directory = $folder;
				}
				$imageinput = $imageField->input;
				//$imageinput = $this->form->getInput("custom_upload_image$i");

				// workaround for CMS routing problem with frontend media manager
				//$result .= str_replace("&amp;asset=com_jevents&", "&amp;asset=com_jevents&amp;task=display&", $imageinput );
				if($app->isClient('site')) {
					$imageinput = str_replace("index.php", Uri::base() . "index.php", $imageinput);
				}
				// tell it NOT to use MooTools
				// $imageinput = str_replace("com_media&amp;", "com_media&amp;ismoo=0&amp;", $imageinput);

				// remove input-prepend class since it make the font size zero here!!
				$imageinput = str_replace(array("input-prepend",'input-append'), "", $imageinput);

				// Joomla media manager layout can add a stray carriage return in the href which the browser missinterprets!
				$imageinput = str_replace('href="' . "\n", 'href="', $imageinput);

				$result .= str_replace("/" . Uri::base(), Uri::base(), $imageinput);

				// Clear the preview image when clicking remove image icon
				//$result .= '<script>jQuery("#custom_upload_image'.$i.'").parent().find("a.icon-remove").on("mousedown",function(){jQuery("#upload_image'.$i.'_img").attr("src","about:blank").css("display","none");return true;});</script>';
				$result .= '<script>jQuery("#custom_upload_image' . $i . '").on("change",function(){if(jQuery("#custom_upload_image' . $i . '").val()=="") {jQuery("#upload_image' . $i . '_img").attr("src","about:blank").css("display","none");}});</script>';
				if (version_compare(JVERSION, "4.0.0", "lt"))
				{
					Factory::getDocument()->addStyleDeclaration("#jevents #imageModal_custom_upload_image$i {margin-left: -40%;}");
				}
				$result .= '</div>';
			}
			else
			{
				$result .= '<div  class="gsl-inline-block gsl-margin-right  gsl-text-top" >';
                $maxsize = $this->imageSpecificParameter("maxupload", 1000000, $i);

				$result .= '<input type="hidden" name="custom_' . $fieldname . '" id="custom_' . $fieldname . '" value="' . $filename . '" size="50"/>';
				$result .= '<label for="' . $fieldname . '_file">' . Text::sprintf("JEV_UPLOAD_IMAGE", number_format($maxsize / 1000000, 2)) . '</label>';
				if ($this->params->get("autoupload", 1))
				{
					$result .= '<div data-gsl-form-custom="target:true">';
					$result .= '<input type="file" name="' . $fieldname . '_file" id="' . $fieldname . '_file" size="50" onchange="uploadFileType(\'' . $fieldname . '\')">';
					//$result .= '<input class="gsl-input gsl-form-small gsl-form-width-medium" type="text" placeholder="' . Text::_("JEV_SELECT_IMAGE", true) . '" disabled>';
					$result .= '<button class="gsl-button gsl-button-small gsl-button-primary">' . Text::_("JEV_SELECT_IMAGE", true) . '</button>';
					$result .= '</div>'; // custom form
				}
				else
				{
					$result .= '<div data-gsl-form-custom="target:true">';
					$result .= '<input type="file" name="' . $fieldname . '_file" id="' . $fieldname . '_file" size="50" >';
					$result .= '<input class="gsl-input gsl-form-width-medium" type="text" placeholder="' . Text::_("JEV_SELECT_IMAGE", true) . '" disabled>';
					//$result .= '<button class="gsl-button gsl-button-small gsl-button-primary">' . Text::_("JEV_SELECT_IMAGE", true) . '</button>';
					$result .= '</div>'; // custom form
					$result .= '<input type="button" onclick="uploadFileType(\'' . $fieldname . '\')" value="' . Text::_("jev_upload") . '" class="gsl-button gsl-button-small gsl-button-primary" /> ';
				}
				$result .= '<div id="' . $fieldname . '_loading" class="loading " hidden>' . Text::_("JEV_UPLOADING_WAIT") . '</div>';
				$result .= '<div id="' . $fieldname . '_loaded" class="loaded " hidden>' . Text::_("JEV_UPLOAD_COMPLETE") . '</div>';
				$result .= '</div>';

				$result .= '<div  class="gsl-inline-block gsl-margin-right  gsl-text-top clear_' . $fieldname . '" ' . ($src === "about:blank" ? " hidden" : ""). '>';
				$result .= '<label>&nbsp;</label><input type="button" onclick="clearImageFile(\'' . $fieldname . '\')" value="' . Text::_("jev_Delete") . '"  class="gsl-button gsl-button-small gsl-button-danger"/>';
				$result .= '</div>';
			}

			$label = Text::_("JEV_STANDARD_IMAGE_" . $i);
			if ($label == "JEV_STANDARD_IMAGE_" . $i)
				$label = Text::_("JEV_STANDARD_IMAGE");

			$user = Factory::getUser();
			$jevparams = ComponentHelper::getParams('com_jevents');
			if (($jevparams->get("authorisedonly", 0) && $jevuser && $jevuser->canuploadimages) || $this->anonupload)
			{
				$customfield = array("label" => $label, "input" => $result, "default_value" => "", "id_to_check" => $id_to_check);
				$customfields["image$i"] = $customfield;
			}
			else if (!$jevparams->get("authorisedonly", 0))
			{
				$userGroups = Factory::getUser()->getAuthorisedGroups();
				if (!array_intersect($this->params->get('upimageslevel', array(8)), array_values($userGroups)))
				{
					return;
				}
				$customfield = array("label" => $label, "input" => $result, "default_value" => "", "id_to_check" => $id_to_check);
				$customfields["image$i"] = $customfield;
			}

			$result = "";
		}

		// if there are no images then we need to setup the hidden iframe etc.
		if ($imagenos == 0)
		{
			$result = '<iframe src="about:blank" style="display:none" name="uploadtarget" id="uploadtarget"></iframe>';
			$result .= '<input type="hidden" name="' . $session->getName() . '" id="sessions" value="' . $session->getId() . '" />';
			$result .= '<input type="hidden" name="' . Session::getFormToken() . '" id="token" value="1" />';
		}

		// index from 1 !!!
		for ($i = 1; $i <= $filenos; $i++)
		{

			$namefield = "filename" . $i;
			$titlefield = "filetitle" . $i;
			$filename = isset($filemappings->$namefield) && $filemappings->$namefield != "" ? $filemappings->$namefield : "";
			$filetitle = isset($filemappings->$namefield) && $filemappings->$titlefield != "" ? $filemappings->$titlefield : "";

			if ($filename)
			{
				$href = $mediafolderURL . "/$filename";
			}
			else
			{
				$href = "about:blank";
			}
			$fieldname = "upload_file" . $i;
			$id_to_check = "custom_" . $fieldname;
			$result .= '<a id="' . $fieldname . '_link" href="' . $href . '" class="gsl-inline-block gsl-margin-right"  target="_blank">' . ($filename ? $filetitle : "") . "</a>";
			$result .= JHTML::_('form.token');
			$result .= '<input type="hidden" name="' . $id_to_check . '" id="custom_' . $fieldname . '" value="' . $filename . '" size="50"/>';

			if ($this->params->get("filetitle", 1))
			{
				$result .= '<div  class="gsl-inline-block gsl-margin-right" >';
				$result .= '<label for="custom_' . $fieldname . '_file">' . Text::_("JEV_UPLOAD_FILE_TITLE") . '</label>';
				$result .= '<input type="text" name="custom_' . $fieldname . '_title" id="custom_' . $fieldname . '_title" value="' . $filetitle . '" size="50"/>';
				$result .= '</div>';
			}
			else
			{
				$result .= '<input type="hidden" name="custom_' . $fieldname . '_title" id="custom_' . $fieldname . '_title" value="' . $filetitle . '" size="50"/>';
			}

			$result .= '<div  class="gsl-inline-block gsl-margin-right" >';
			$result .= '<label for="' . $fieldname . '_file">' . Text::sprintf("JEV_UPLOAD_FILE", number_format($this->params->get("maxupload", 1000000) / 1000000, 2)) . '</label>';
			$result .= '<div data-gsl-form-custom="target:true">';
			$result .= '<input type="file" name="' . $fieldname . '_file" id="' . $fieldname . '_file" >';
			$result .= '<input class="gsl-input gsl-form-small gsl-form-width-medium" type="text" placeholder="' . Text::_("JEV_SELECT_FILE", true) . '" disabled>';
			//$result .= '<button class="gsl-button gsl-button-small gsl-button-primary">' . Text::_("JEV_SELECT_FILE", true) . '</button>';
			$result .= '</div>'; // custom form
			$result .= '<input type="button" onclick="uploadFileType(\'' . $fieldname . '\')" value="' . Text::_("jev_upload") . '" class="gsl-button gsl-button-small gsl-button-primary"/>';
			$result .= '<div id="' . $fieldname . '_loading" class="loading  " hidden>' . Text::_("JEV_UPLOADING_WAIT") . '</div>';
			$result .= '<div id="' . $fieldname . '_loaded" class="loaded " hidden>' . Text::_("JEV_UPLOAD_COMPLETE") . '</div>';
			$result .= '</div>';

			$result .= '<div  class="gsl-inline-block gsl-margin-right  gsl-text-top clear_' . $fieldname . '" ' . ($src === "about:blank" ? " hidden" : ""). '>';
			$result .= '<label>&nbsp;</label><input type="button" onclick="clearFile(\'' . $fieldname . '\')" value="' . Text::_("jev_Delete") . '" class="gsl-button gsl-button-small gsl-button-danger"/>';
			$result .= '</div>';

			$label = Text::_("JEV_STANDARD_FILE_" . $i);
			if ($label == "JEV_STANDARD_FILE_" . $i)
				$label = Text::_("JEV_STANDARD_FILE");

			$user = Factory::getUser();
			$jevparams = ComponentHelper::getParams('com_jevents');
			if (($jevparams->get("authorisedonly", 0) && $jevuser && $jevuser->canuploadmovies) || $this->anonupload)
			{
				$customfield = array("label" => $label, "input" => $result, "default_value" => "", "id_to_check" => $id_to_check);
				$customfields["file$i"] = $customfield;
			}
			else if (!$jevparams->get("authorisedonly", 0))
			{
				if (!(JEVHelper::isAdminUser($user)))
				{
					// restrict usage to certain user types
					$userGroups = Factory::getUser()->getAuthorisedGroups();
					if (!array_intersect($this->params->get('upfileslevel', array(8)), array_values($userGroups)))
					{
						return;
					}
				}
				$customfield = array("label" => $label, "input" => $result, "default_value" => "", "id_to_check" => $id_to_check);
				$customfields["file$i"] = $customfield;
			}


			$result = "";
		}

		return true;
	}

	/**
	 * Clean out custom fields for event details not matching global event detail
	 *
	 * @param unknown_type $idlist
	 */
	function onDeleteEventDetails($idlist)
	{
		return true;
	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	function onStoreCustomDetails($evdetail)
	{
		// are we importing events with image details contained within them
		if (isset($evdetail->_customFields) && strpos(Factory::getApplication()->input->getCmd("task"), "icals") !== false)
		{
			foreach ($evdetail->_customFields as $key => $val)
			{
				if (strpos($key, "IMPORT_IMAGE_") === 0)
				{
					$x = 1;
				}
			}
		}
	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	// TODO update reminder timestamps when event times have changed
	function onStoreCustomEvent($event)
	{
		if (!$this->authorised(false))
			return;

		$success = true;
		$evdetail = $event->_detail;

		$eventid = $event->ev_id;
		$detailid = $event->detail_id;

		$db = Factory::getDbo();
		$sql = "SELECT * FROM #__jev_files_combined WHERE evdet_id=" . $detailid;
		$db->setQuery($sql);
		$filedata = $db->loadObject();

		$imagenos = intval($this->params->get("imnum", 1));
		$rowcreated = false;
		$hasimages = false;
		// index from 1 !!!
		for ($i = 1; $i <= $imagenos; $i++)
		{
			$filename = "upload_image" . $i;

			if (!isset($evdetail->_customFields) || !array_key_exists($filename, $evdetail->_customFields) || $evdetail->_customFields[$filename] == "")
			{
				if ($filedata && $filedata->evdet_id > 0)
				{
					plgJEventsjevfiles::cleanUpImageData($i, $filedata->evdet_id);
				}
				continue;
			}

			if ($evdetail->_customFields[$filename] == "")
			{
				// if there is no filedata when the custom field data is empty we can skip this
				if (!($filedata && $filedata->evdet_id > 0))
				{
					continue;
				}
				// otherwise set the entry to blank below!
			}

			$hasimages = true;

			$noHtmlFilter = InputFilter::getInstance(/* $tags, $attr, $tag_method, $attr_method, $xss_auto */);
			$image = $noHtmlFilter->clean($evdetail->_customFields[$filename]);
			$imagetitle = $noHtmlFilter->clean($evdetail->_customFields[$filename . "_title"]);

			$safeHtmlFilter = InputFilter::getInstance(array(), array(), 1, 1);
			$imagecomment = $safeHtmlFilter->clean($evdetail->_customFields[$filename . "_comment"], 'html');

			if (empty($image))
			{
				if ($filedata && $filedata->evdet_id > 0)
				{
					plgJEventsjevfiles::cleanUpImageData($i, $filedata->evdet_id);
				}

				continue;
			}

			// Joomla media manager in Joomla 4 uses lazy image loading which can mess up the URL/filename here so strip out that stuff
			if ($this->params->get("allowmedia", 0) && version_compare(JVERSION, "4.0.0", "ge") && strpos($image, "#") > 0)
			{
				$image = substr($image, 0, strpos($image, "#"));
			}
			if (($filedata && $filedata->evdet_id > 0) || $rowcreated)
			{

				$sql = "UPDATE #__jev_files_combined "
					. " SET imagename$i=" . $db->Quote($image)
					. ", imagetitle$i=" . $db->Quote($imagetitle)
					. ", imagecomment$i=" . $db->Quote($imagecomment)
					. " WHERE evdet_id=" . intval($detailid);
			}
			else
			{
				$sql = "INSERT INTO #__jev_files_combined "
					. " SET imagename$i=" . $db->Quote($image)
					. ", imagetitle$i=" . $db->Quote($imagetitle)
					. ", imagecomment$i=" . $db->Quote($imagecomment)
					. ", ev_id=" . intval($eventid)
					. ", evdet_id=" . intval($detailid);
				$rowcreated = true;
			}
			$db->setQuery($sql);
			$success = $db->execute();
		}

		$filenos = intval($this->params->get("filnum", 1));
		// index from 1 !!!
		for ($i = 1; $i <= $filenos; $i++)
		{
			$filename = "upload_file" . $i;

			if (!isset($evdetail->_customFields) || !array_key_exists($filename, $evdetail->_customFields) || $evdetail->_customFields[$filename] == "")
			{
				if ($filedata && $filedata->evdet_id > 0)
				{
					plgJEventsjevfiles::cleanUpFileData($i, $filedata->evdet_id);
				}
				continue;
			}

			$noHtmlFilter = InputFilter::getInstance(/* $tags, $attr, $tag_method, $attr_method, $xss_auto */);
			$file = $noHtmlFilter->clean($evdetail->_customFields[$filename]);
			$fileTitle = $noHtmlFilter->clean($evdetail->_customFields[$filename . "_title"]);

			if (empty($file))
			{
				if ($filedata && $filedata->evdet_id > 0)
				{
					plgJEventsjevfiles::cleanUpFileData($i, $filedata->evdet_id);
				}

				continue;
			}

			if (($filedata && $filedata->evdet_id > 0) || $rowcreated)
			{

				$sql = "UPDATE #__jev_files_combined "
					. " SET filename$i=" . $db->Quote($file)
					. ", filetitle$i=" . $db->Quote($fileTitle)
					. " WHERE evdet_id=" . intval($detailid);
			}
			else
			{
				$sql = "INSERT INTO #__jev_files_combined "
					. " SET filename$i=" . $db->Quote($file)
					. ", filetitle$i=" . $db->Quote($fileTitle)
					. ", ev_id=" . intval($eventid)
					. ", evdet_id=" . intval($detailid);
				$rowcreated = true;
			}
			$db->setQuery($sql);
			$success = $db->execute();
		}

		return $success;
	}

	public static function cleanUpImageData($i, $detailid)
	{
		$db = Factory::getDbo();
		$sql = "UPDATE #__jev_files_combined "
			. " SET imagename$i=''"
			. ", imagetitle$i=''"
			. ", imagecomment$i=''"
			. " WHERE evdet_id=" . intval($detailid);
		$db->setQuery($sql);
		$success = $db->execute();
	}

	public static function cleanUpFileData($i, $detailid)
	{
		$db = Factory::getDbo();
		$sql = "UPDATE #__jev_files_combined "
			. " SET filename$i=''"
			. ", filetitle$i=''"
			. " WHERE evdet_id=" . intval($detailid);
		$db->setQuery($sql);
		$success = $db->execute();
	}

	function onStoreCustomRepeat($event)
	{
		$event->_detail = new stdClass();
		$data = Factory::getApplication()->input->getArray();
		foreach ($data as $key => $value)
		{
			if (strpos($key, "custom_") === 0)
			{
				$field = StringHelper::substr($key, 7);
				$event->_detail->_customFields[$field] = $value;
			}
		}

		$event->ev_id = $event->eventid;
		$event->detail_id = $event->eventdetail_id;

		return $this->onStoreCustomEvent($event);
	}

	/**
	 * Clean out custom details for deleted event details
	 *
	 * @param comma separated list of event detail ids $idlist
	 */
	function onDeleteCustomEvent($idlist)
	{

		$ids = explode(",", $idlist);
		ArrayHelper::toInteger($ids);
		$idlist = implode(",", $ids);

		// Find the referenced files
		$db = Factory::getDbo();
		$sql = "SELECT * FROM #__jev_files_combined WHERE ev_id IN (" . $idlist . ")";
		$db->setQuery($sql);
		$eventfilesrows = $db->loadAssocList();
		$eventfiles = array();
		foreach ($eventfilesrows as $row)
		{
			foreach ($row as $fieldname => $fieldvalue)
			{
				if ((strpos($fieldname, "imagename") === 0 || strpos($fieldname, "filename") === 0) && $fieldvalue != "")
				{
					$eventfiles[$fieldname] = $fieldvalue;
				}
			}
		}

		// Get the media component configuration settings
		$mediaParams = ComponentHelper::getParams('com_media');
		$path = JPATH_ROOT . "/" . $mediaParams->get('image_path', 'images/stories');
		$folder = $this->params->get("folder", "jevents");

		// Set the path definitions
		if (!defined('JEVP_MEDIA_BASE'))
		{
			define('JEVP_MEDIA_BASE', JPATH_ROOT . "/" . $mediaParams->get('image_path', 'images/stories'));
			define('JEVP_MEDIA_BASEURL', JURI::root(true) . '/' . $mediaParams->get('image_path', 'images/stories'));
		}

		jimport('joomla.filesystem.file');
		foreach ($eventfiles as $fieldname => $file)
		{
			if (trim($file) == "")
				continue;

			// make sure not used in a copied event
			$sql = "SELECT count(ev_id) FROM #__jev_files_combined WHERE $fieldname = " . $db->quote($file);
			$db->setQuery($sql);
			$count = $db->loadResult();
			if ($count > 1)
				continue;


			$files = Folder::files(plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder), $file, true, true);
			foreach ($files as $file2)
			{
				File::delete($file2);
			}
			if (File::exists(plgJEventsjevfiles::canonicalize($path . "/" . $folder) . "/" . 'thumbnails' . "/" . 'thumb_' . $file))
			{
				File::delete(plgJEventsjevfiles::canonicalize($path . "/" . $folder) . "/" . 'thumbnails' . "/" . 'thumb_' . $file);
			}
		}

		// delete the metatags too
		$sql = "DELETE FROM #__jev_files_combined WHERE ev_id IN (" . $idlist . ")";
		$db->setQuery($sql);
		$db->execute();

		return;
	}

	function onDisplayCustomFields(&$row)
	{
		if (isset($row->hidedetail) && $row->hidedetail)
		{
			return "";
		}

		$db = Factory::getDbo();
		if ($this->params->get("allowoverrides", 0))
		{
			$detid = intval($row->evdet_id());
			$sql = "SELECT * FROM #__jev_files_combined WHERE evdet_id=" . $detid;
		}
		else
		{
			$evid = intval($row->ev_id());
			$sql = "SELECT * FROM #__jev_files_combined WHERE ev_id=" . $evid;
		}

		$db->setQuery($sql);
		$row->filedata = $db->loadObject();

		$row->_image = "";

		// Get the media component configuration settings
		$mediaParams = ComponentHelper::getParams('com_media');
		// Set the path definitions
		if (!defined('JEVP_MEDIA_BASE'))
		{
			define('JEVP_MEDIA_BASE', JPATH_ROOT . "/" . $mediaParams->get('image_path', 'images/stories'));
			define('JEVP_MEDIA_BASEURL', JURI::root(true) . '/' . $mediaParams->get('image_path', 'images/stories'));
		}

		$result = "";
		// folder relative to media folder
		$folder = $this->params->get("folder", "jevents");

		$imagenos = intval($this->params->get("imnum", 1));
		// index from 1 !!!
		for ($i = 1; $i <= $imagenos; $i++)
		{
			$imageurlfield = "_imageurl$i";
			$imagetitlefield = "_imagetitle$i";
			$imagecommentfield = "_imagecomment$i";
			$imagenamesql = "imagename$i";
			$imagetitlesql = "imagetitle$i";
			$imagecommentsql = "imagecomment$i";

			if (!isset($row->filedata->$imagenamesql) || $row->filedata->$imagenamesql == "")
			{
				$row->$imageurlfield = "";
				$row->$imagetitlefield = "";
				continue;
			}
			$row->$imageurlfield = $row->filedata->$imagenamesql; // ? Replaced by below ?
			// put original full sized image in the _imageurl'n' field since its used by other plguins e.g. autotweet and facebook social
			$row->$imageurlfield = plgJEventsjevfiles::getSizedImageUrl($row, "_imageurl$i", "0x0", $this->params);

			$filetitle = $row->filedata->$imagetitlesql;
			$row->$imagetitlefield = $filetitle;

			$filecomment = $row->filedata->$imagecommentsql;
			$row->$imagecommentfield = $filecomment;

			$result .= ($result != "") ? "<br/>" : "";
			$name = "_image$i";

			// this is all that matters any more!
			// TODO remove the redundant field setting
			$img = plgJEventsjevfiles::getSizedImageUrl($row, "_imageurl" . $i, $this->imageSpecificParameter("imagew", 300, $i) . "x" . $this->imageSpecificParameter("imageh", 225, $i), $this->params);
			$row->$name = '<img  src="' . $img . '" alt="' . JEventsHTML::special($filetitle) . '"  class="jev_image jev_image' . $i . '"/>';
			$result .= $row->$name;
		}

		$filnos = intval($this->params->get("filnum", 1));
		// index from 1 !!!
		for ($i = 1; $i <= $filnos; $i++)
		{

			$filtitle = "filetitle" . $i;
			$filname = "filename" . $i;
			if (!isset($row->filedata->$filtitle) || $row->filedata->$filtitle == "")
			{
				$name = "_file$i";
				$row->$name = "";
				$name = "_filetitle$i";
				$row->$name = "";
				continue;
			}
			$filename = $row->filedata->$filname;
			$filetitle = $row->filedata->$filtitle;

			if ($filename == "")
			{
				$name = "_file$i";
				$row->$name = "";
				$name = "_filetitle$i";
				$row->$name = "";
				continue;
			}

			$href = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASEURL . "/$folder/$filename");
			$name = "_filetitle$i";
			$row->$name = $filetitle;
			$name = "_file$i";
			$row->$name = $filename;

			if (strpos($filename, '.pdf'))
			{
				$ispdf = "target='_blank'";
			}
			else
			{
				$ispdf = "";
			}

			$link = "<a href='$href' title='" . JEventsHTML::special($filetitle) . "' " . $ispdf . " class='jev_file jev_file1'>" . $filetitle . "</a>";
			$name = "_filelink$i";
			$row->$name = $link;
			$name = "_filehref$i";
			$row->$name = $href;

			$result .= ($result != "") ? "<br/>" : "";
			$result .= $link;
		}

		return $result;
	}

	function onListIcalEvents(& $extrafields, & $extratables, & $extrawhere, & $extrajoin, & $needsgroupdby = false)
	{

		$files = Factory::getApplication()->input->files;
		$filecount = $files->count();

		// intercept this to save the file
		if ($filecount > 0)
		{
			$filedata = $files->getArray();
			$hasfile = false;
			$uploadfile = "";
			foreach ($filedata as $key => $val)
			{
				// Joomla 3.6 is too strict on file uploads and considered zip files to be unsafe!
				$val = $files->get($key, $val, "raw");

				if ((strpos($key, "upload_image") === 0 || strpos($key, "upload_file") === 0) && $val["size"] > 0)
				{
					$hasfile = true;
					$uploadfile = $key;
					break;
				}
			}

			if ($hasfile)
				return $this->processUpload($uploadfile);
		}

		if (!$this->params->get("inlist", 1))
			return "";


		$mediaParams = ComponentHelper::getParams('com_media');
		$mediabase = JURI::root(true) . '/' . $mediaParams->get('image_path', 'images/stories');
		// folder relative to media folder
		$folder = $this->params->get("folder", "jevents");

		$mediabasefolder = plgJEventsjevfiles::canonicalize("$mediabase/$folder");

		$imagenos = intval($this->params->get("imnum", 1));

		// if loading multiple images then needs group by!!
		//if ($imagenos > 1)
		//	{
		//	$needsgroupdby = true;
		//	}

		if ($this->params->get("allowoverrides", 0))
		{
			$extrajoin[] = " #__jev_files_combined as jfc ON jfc.evdet_id = det.evdet_id";
		}
		else
		{
			$extrajoin[] = " #__jev_files_combined as jfc ON jfc.ev_id = ev.ev_id";
		}

		// index from 1 !!!
		for ($i = 1; $i <= $imagenos; $i++)
		{
			// are we using Joomla media manager - if so mustn't repeat the path
			$extrafields .= <<<SQL
                , jfc.imagename$i AS imageurl$i, jfc.imagetitle$i AS imagetitle$i, jfc.imagecomment$i AS imagecomment$i
SQL;
		}

		$filenos = (int) $this->params->get("filnum", 1);
		for ($i = 1; $i <= $filenos; $i++)
		{
			$extrafields .= <<<SQL
                , CASE WHEN (jfc.filename$i='') THEN '' ELSE CONCAT('$mediabasefolder/',jfc.filename$i) END as filehref$i
                , jfc.filetitle$i as filetitle$i
                , CASE WHEN (jfc.filename$i='') THEN '' ELSE CONCAT('<a href="$mediabasefolder/',jfc.filename$i,'" />',jfc.filetitle$i,'</a>') END as filelink$i
SQL;
		}


		// default is to only show all events
		// If loading from a module then get the modules params from the registry
		$reg = Factory::getConfig();
		$compparams = clone ComponentHelper::getParams(Factory::getApplication()->input->getCmd("option", "com_jevents"));
		$modparams = $reg->get("jev.modparams", false);

		if ($modparams)
		{
			$compparams = $modparams;
		}

		$extraval = "";
		for ($extra = 0; $extra < 20; $extra++)
		{
			$extraval = $compparams->get("extras" . $extra, false);
			if (strpos($extraval, "jevhi:") === 0)
			{
				break;
			}
		}

		if ($extraval && strpos($extraval, "jevhi:") === 0)
		{

			$invalue = str_replace("jevhi:", "", $extraval);
			$invalue = intval(str_replace(" ", "", $invalue));

			if ($invalue == 1)
			{
				$extrawhere[] = " jfc.imagename1 is not NULL AND jfc.imagename1 <> '' ";
			}
			else if ($invalue == 0)
			{
				$extrawhere[] = " (jfc.imagename1 is NULL OR jfc.imagename1 = '') ";
			}
		}
	}

	private
	function processUpload($uploadfile)
	{

		// Check for request forgeries
		Session::checkToken() or jexit('Invalid Token');

		$this->authorised(true);

		// Get the media component configuration settings
		$mediaParams = ComponentHelper::getParams('com_media');
		// Set the path definitions
		if (!defined('JEVP_MEDIA_BASE'))
		{
			define('JEVP_MEDIA_BASE', JPATH_ROOT . "/" . $mediaParams->get('image_path', 'images/stories'));
			define('JEVP_MEDIA_BASEURL', JURI::root(true) . '/' . $mediaParams->get('image_path', 'images/stories'));
		}

		include_once(dirname(__FILE__) . "/files/uploadhelper.php");
		$uploadhelper = new JevUploadHelper($this->params);
		$filename = $uploadfile;

		$files = Factory::getApplication()->input->files;
		$filedata = $files->getArray();

		@header("Content-Type: text/html; charset=utf-8");

		foreach ($filedata as $fname => $file)
		{
			if (strpos($fname, $filename) === 0)
			{
				// Joomla 3.6 is too strict on file uploads and considered zip files to be unsafe!
				$file = $files->get($fname, $file, "raw");

				if (strpos($uploadfile, "upload_image") === 0)
				{
					$filename = $uploadhelper->processImageUpload($fname);
					$filetype = "image";
				}
				else
				{
					$filename = $uploadhelper->processFileUpload($fname, ".xml", explode(",", $this->params->get("allowedfiles", "csv,xml,pdf,doc,xls")));
					$filetype = "file";
				}
				$oname = $file['name'];
				?>
				<script  data-cfasync="false" type="text/javascript">
                    var oname = "<?php echo $oname; ?>";
                    var fname = "<?php echo $fname; ?>";
                    var filename = "<?php echo $filename; ?>";
                    var filetype = "<?php echo $filetype; ?>";
					<?php
					if ($filetype == "image")
					{
					?>
                    window.parent.setImageFileName(fname, filename, oname);
					<?php
					}
					else
					{
					?>
                    window.parent.setLinkFileHref(fname, filename, oname);
					<?php } ?>
				</script>
				<?php
			}
		}
		exit();
		return;
	}

	private
	function erroralert($msg)
	{
		@header("Content-Type: text/html; charset=utf-8");
		?>
		<html>
		<head>
			<script  data-cfasync="false" type="text/javascript">
                alert("<?php echo $msg; ?>");
			</script>
		</head>
		<body>
		</body>
		</html>
		<?php
		exit();
	}

	private
	function authorised($kill = false)
	{
		$jevuser = JEVHelper::getAuthorisedUser();
		$params = ComponentHelper::getParams(JEV_COM_COMPONENT);
		$authorisedonly = $params->get("authorisedonly", 0);
		$user = Factory::getUser();

		if ($user->id == 0 && $this->params->get("anonupload", 0))
		{
			$plugin = PluginHelper::getPlugin('jevents', 'jevanonuser');
			$pluginparams = new Registry($plugin->params);
			if ($pluginparams->get("recaptchapublic", false))
			{
				$this->anonupload = true;
				return true;
			}
		}

		if ($authorisedonly)
		{
			if (is_null($jevuser))
			{
				// Set the layout
				if ($kill)
					$this->erroralert(Text::_("JEV_Not_authorised", true));
				return false;
			}
			else if (!$jevuser->canuploadimages && !$jevuser->canuploadmovies)
			{
				// Set the layout
				if ($kill)
					$this->erroralert(Text::_("JEV_Not_authorised", true));
				return false;
			}
		}
		else
		{
			$userGroups = Factory::getUser()->getAuthorisedGroups();
			if (!is_array($userGroups) || !is_array($this->params->get('upimageslevel', array(8))) || !is_array($this->params->get('upfileslevel', array(8))))
			{
				if ($kill)
					$this->erroralert(Text::_("JEV_YOU_MUST_SET_PERMISSIONS_IN_JEVFILES_PLUGIN", true));
				return false;
			}
			if (!array_intersect($this->params->get('upimageslevel', array(8)), array_values($userGroups)) && !array_intersect($this->params->get('upfileslevel', array(8)), array_values($userGroups)))
			{
				if ($kill)
					$this->erroralert(Text::_("JEV_Not_authorised", true));
				return false;
			}
		}
		return true;
	}

	static
	function fieldNameArray($layout = 'detail')
	{
		$return = array();
		$return['group'] = Text::_("JEV_STANDARD_IMAGES_FILES", true);

		$labels = array();
		$values = array();

		PluginHelper::importPlugin('jevents');
		$plugin = PluginHelper::getPlugin("jevents", "jevfiles");
		$params = new Registry($plugin->params);
		$imagenos = (int) $params->get("imnum", 1);
		$filenos = (int) $params->get("filnum", 1);

		if ($layout == "edit")
		{
			if ($imagenos > 0 || $filenos > 0)
			{
				// index from 1 !!!
				for ($i = 1; $i <= $imagenos; $i++)
				{
					$label = Text::_("JEV_STANDARD_IMAGE_EDIT_" . $i);
					if ($label == "JEV_STANDARD_IMAGE_EDIT_" . $i)
						$label = Text::_("JEV_STANDARD_IMAGE_" . $i);
					if ($label == "JEV_STANDARD_IMAGE_" . $i)
						$label = Text::_("JEV_STANDARD_IMAGE_");
					$labels[] = $label;
					$values[] = "image$i";
				}

				for ($i = 1; $i <= $filenos; $i++)
				{
					$label = Text::_("JEV_STANDARD_FILE_EDIT_" . $i);
					if ($label == "JEV_STANDARD_FILE_EDIT_" . $i)
						$label = Text::_("JEV_STANDARD_FILE_" . $i);
					if ($label == "JEV_STANDARD_FILE_" . $i)
						$label = Text::_("JEV_STANDARD_FILE");
					$labels[] = $label;
					$values[] = "file$i";
				}
			}

			$return['values'] = $values;
			$return['labels'] = $labels;
			return $return;
		}

		if ($imagenos > 0 || $filenos > 0)
		{
			if ($layout == "detail")
			{
				// index from 1 !!!
				for ($i = 1; $i <= $imagenos; $i++)
				{
					$labels[] = Text::_("JEV_STANDARD_IMAGE", true) . " " . $i;
					$labels[] = Text::_("JEV_IMAGE_LINK", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_THUMBNAIL", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_POPUP", true) . " " . $i;
					$labels[] = Text::_("JEV_IMAGE_TITLE", true) . " " . $i;
					$labels[] = Text::_("JEV_IMAGE_COMMENT", true) . " " . $i;
					$values[] = "JEV_STANDARD_IMAGE_$i";
					$values[] = "JEV_IMAGE_LINK_$i";
					$values[] = "JEV_STANDARD_THUMBNAIL_$i";
					$values[] = "JEV_STANDARD_POPUP_$i";
					$values[] = "JEV_IMAGE_TITLE_$i";
					$values[] = "JEV_IMAGE_COMMENT_$i";
				}
				for ($i = 1; $i <= $filenos; $i++)
				{
					$labels[] = Text::_("JEV_STANDARD_FILE_TITLE", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_FILE_LINK", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_FILE_HREF", true) . " " . $i;

					$values[] = "JEV_FILE_TITLE_$i";
					$values[] = "JEV_FILE_LINK_$i";
					$values[] = "JEV_FILE_HREF_$i";
				}
				$labels[] = Text::_("JEV_PINTEREST", true);
				$values[] = "PINTEREST";
			}
			else if ($layout == "list")
			{
				// index from 1 !!!
				for ($i = 1; $i <= $imagenos; $i++)
				{
					$labels[] = Text::_("JEV_STANDARD_IMAGE", true) . " " . $i;
					$labels[] = Text::_("JEV_IMAGE_LINK", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_THUMBNAIL", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_POPUP", true) . " " . $i;
					$labels[] = Text::_("JEV_THUMBNAIL_LINK", true) . " " . $i;
					$labels[] = Text::_("JEV_IMAGE_TITLE", true) . " " . $i;
					$labels[] = Text::_("JEV_IMAGE_COMMENT", true) . " " . $i;

					$values[] = "JEV_LIST_IMAGE_$i";
					$values[] = "JEV_IMAGE_LINK_$i";
					$values[] = "JEV_LIST_THUMBNAIL_$i";
					$values[] = "JEV_LIST_POPUP_$i";
					$values[] = "JEV_THUMBLINK_$i";
					$values[] = "JEV_IMAGE_TITLE_$i";
					$values[] = "JEV_IMAGE_COMMENT_$i";
				}

				for ($i = 1; $i <= $filenos; $i++)
				{
					$labels[] = Text::_("JEV_STANDARD_FILE_TITLE", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_FILE_LINK", true) . " " . $i;
					$labels[] = Text::_("JEV_STANDARD_FILE_HREF", true) . " " . $i;

					$values[] = "JEV_FILE_TITLE_$i";
					$values[] = "JEV_FILE_LINK_$i";
					$values[] = "JEV_FILE_HREF_$i";
				}
			}
			// index from 1 !!!
			for ($i = 1; $i <= $imagenos; $i++)
			{
				$labels[] = Text::_("JEV_IMAGE_URL", true) . " " . $i;
				$labels[] = Text::_("JEV_THUMBNAIL_URL", true) . " " . $i;

				$values[] = "JEV_IMAGEURL_$i";
				$values[] = "JEV_THUMBURL_$i";
			}
			for ($i = 1; $i <= $imagenos; $i++)
			{
				$labels[] = Text::_("JEV_SIZED_IMAGE", true) . " " . $i;

				$values[] = "JEV_SIZEDIMAGE_$i;400x300";
			}
			for ($i = 1; $i <= $imagenos; $i++)
			{
				$labels[] = Text::sprintf("JEV_SIZED_IMAGE_URL", $i, array('jsSafe' => true));

				$values[] = "JEV_SIZEDIMAGE_URL_$i;400x300";
			}
		}

		// if called from a module then we must support old style codes
		$callers = array(debug_backtrace()[1]['function'], debug_backtrace()[2]['function'], debug_backtrace()[3]['function']);

		if (in_array("processMatch", $callers))
		{
			for ($i = 1; $i <= $imagenos; $i++)
			{
				$labels[] = "";
				$values[] = "imageimg$i";
				$labels[] = "";
				$values[] = "thumbimg$i";
				$labels[] = "";
				$values[] = "imagethumb$i";
			}
			$labels[] = "";
			$values[] = "imageimg";
			$labels[] = "";
			$values[] = "thumbimg";
			$labels[] = "";
			$values[] = "imagethumb";
		}

		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;
	}

	// Special method called when plugins are saved
	// Have the image sizes changed ??
	/*
	  static function onPluginBeforeSave($context, $article, $isNew)
	  {
	  if (!$isNew){
	  $plugin = PluginHelper::getPlugin("jevents", "jevfiles");
	  if ($plugin)
	  {
	  $params = new Registry($plugin->params);
	  }
	  }
	  $x = 1;
	  }
	 */

	// TODO move ALL of this over to scaled image code - also simplify queries and make sure I handle latest events module !
	static
	function substitutefield($row, $code)
	{

		if (isset($row->hidedetail) && $row->hidedetail)
		{
			return "";
		}

		// Old style codes
		$code = str_replace(array("imageimg", "thumbimg", "imagethumb"), array("JEV_STANDARD_IMAGE_", "JEV_LIST_THUMBNAIL_", "JEV_THUMBURL_"), $code);

		if (substr($code, strlen($code) - 1) == "_")
		{
			$code .= "1";
		}
		$plugin = PluginHelper::getPlugin("jevents", "jevfiles");
		$params = new Registry($plugin->params);

		if (strpos($code, "JEV_STANDARD_IMAGE_") === 0 || strpos($code, "JEV_IMAGEURL_") === 0 || strpos($code, "JEV_LIST_IMAGE_") === 0)
		{

			$i = str_replace(array("JEV_STANDARD_IMAGE_", "JEV_LIST_IMAGE_", "JEV_IMAGEURL_"), "", $code);

			$name = "_imageurl" . $i;

			$img = plgJEventsjevfiles::getSizedImageUrl($row, $name, plgJEventsjevfiles::imageSpecificParameterStatic($params, "imagew", 300, $i) . "x" . plgJEventsjevfiles::imageSpecificParameterStatic($params, "imageh", 225, $i), $params);

			if (!$img)
			{
				return "";
			}
			if (strpos($code, "JEV_STANDARD_IMAGE_") === 0 || strpos($code, "JEV_LIST_IMAGE_") === 0)
			{
				$fname = "_imagetitle$i";
				if (!empty($row->$fname))
					$filetitle = $row->$fname;
				else
					$filetitle = "";

				return "<img src='" . $img . "' class='jev_image" . $i . "'  alt='" . JEventsHTML::special($filetitle) . "' />";
			} else
			{
				return $img;
			}
		}
		if (strpos($code, "JEV_SIZEDIMAGE_") === 0 || strpos($code, "JEV_SIZEDIMAGE_URL_") === 0)
		{
			if (strpos($code, ";") === false || strpos($code, "x") === false)
			{
				return "";
			}

			list($code, $dimensions) = explode(";", $code);
			$i = str_replace(array("JEV_SIZEDIMAGE_URL_", "JEV_SIZEDIMAGE_"), "", $code);

			$name = "_imageurl" . $i;

			$img = plgJEventsjevfiles::getSizedImageUrl($row, $name, $dimensions, $params);

			if (!$img)
			{
				return "";
			}

			$fname = "_imagetitle$i";
			if (!empty($row->$fname))
				$filetitle = $row->$fname;
			else
				$filetitle = $row->title();
			if (strpos($code, "JEV_SIZEDIMAGE_URL_") === 0)
			{
				return $img;
			}
			else
			{
				return "<img alt='" . JEventsHTML::special($filetitle) . "' src='" . $img . "' class='jev_image" . $i . "' />";
			}
		}
		if (strpos($code, "JEV_IMAGE_LINK_") === 0 || strpos($code, "JEV_THUMBLINK_") === 0)
		{
			$i = str_replace(array("JEV_IMAGE_LINK_", "JEV_THUMBLINK_"), "", $code);
			$name = "_imageurl" . $i;
			if (strpos($code, "JEV_IMAGE_LINK_") === 0)
			{
				$img = plgJEventsjevfiles::getSizedImageUrl($row, $name, plgJEventsjevfiles::imageSpecificParameterStatic($params, "imagew", 300, $i) . "x" . plgJEventsjevfiles::imageSpecificParameterStatic($params, "imageh", 225, $i), $params);
			}
			else
			{
				$img = plgJEventsjevfiles::getSizedImageUrl($row, $name, plgJEventsjevfiles::imageSpecificParameterStatic($params, "thumbw", 120, $i) . "x" . plgJEventsjevfiles::imageSpecificParameterStatic($params, "thumbh", 90, $i), $params);
			}

			if (!$img)
			{
				return "";
			}

			$fname = "_imagetitle$i";
			if (!empty($row->$fname))
				$filetitle = $row->$fname;
			else
				$filetitle = "";

			if (strpos($code, "JEV_IMAGE_LINK_") === 0)
			{
				$img = "<img src='" . $img . "' class='jev_image" . $i . "'  alt='" . JEventsHTML::special($filetitle) . "' />";
			}
			else
			{
				$img = "<img src='" . $img . "' class='jev_imagethumb" . $i . "'  alt='" . JEventsHTML::special($filetitle) . "' />";
			}

			// Title link
			$reg = JevRegistry::getInstanceWithReferences("jevents");
			static $datamodel;
			if (!isset($datamodel))
			{
				$datamodel = $reg->getReference("jevents.datamodel", false);
				if (!$datamodel)
				{
					$datamodel = new JEventsDataModel();
				}
			}

			$rowlink = $row->viewDetailLink($row->yup(), $row->mup(), $row->dup(), false);
			$rowlink = Route::_($rowlink . $datamodel->getCatidsOutLink());
			ob_start();
			?>
			<a class="ev_link_row" href="<?php echo $rowlink; ?>" style="font-weight:bold;" title="<?php echo JEventsHTML::special($row->title()); ?>">
				<?php echo $img; ?>
			</a>
			<?php
			$link = ob_get_clean();

			return $link;
		}
		if (strpos($code, "JEV_STANDARD_THUMBNAIL_") === 0 || strpos($code, "JEV_THUMBURL_") === 0 || strpos($code, "JEV_LIST_THUMBNAIL_") === 0)
		{
			$i = str_replace(array("JEV_STANDARD_THUMBNAIL_", "JEV_THUMBURL_", "JEV_LIST_THUMBNAIL_"), "", $code);
			$name = "_imageurl" . $i;

			$img = plgJEventsjevfiles::getSizedImageUrl($row, $name, plgJEventsjevfiles::imageSpecificParameterStatic($params, "thumbw", 120, $i) . "x" . plgJEventsjevfiles::imageSpecificParameterStatic($params, "thumbh", 90, $i), $params);

			if (!$img)
			{
				return "";
			}
			if (strpos($code, "JEV_STANDARD_THUMBNAIL_") === 0 || strpos($code, "JEV_LIST_THUMBNAIL_") === 0)
			{
				$fname = "_imagetitle$i";
				if (!empty($row->$fname))
				{
					$filetitle = $row->$fname;
				}
				else
				{
					$filetitle = $row->_title;
				}
				return "<img src='" . $img . "' class='jev_imagethumb" . $i . "'  alt='" . JEventsHTML::special($filetitle) . "' />";
			}
			else
			{
				return $img;
			}
		}

		if (strpos($code, "JEV_STANDARD_POPUP") === 0 || strpos($code, "JEV_LIST_POPUP") === 0)
		{
			$i = str_replace(array("JEV_LIST_POPUP_", "JEV_STANDARD_POPUP_"), "", $code);
			$name = "_imageurl" . $i;

			$thumb = plgJEventsjevfiles::getSizedImageUrl($row, $name, plgJEventsjevfiles::imageSpecificParameterStatic($params, "thumbw", 120, $i) . "x" . plgJEventsjevfiles::imageSpecificParameterStatic($params, "thumbh", 90, $i), $params);
			$img = plgJEventsjevfiles::getSizedImageUrl($row, $name, plgJEventsjevfiles::imageSpecificParameterStatic($params, "imagew", 300, $i) . "x" . plgJEventsjevfiles::imageSpecificParameterStatic($params, "imageh", 225, $i), $params);
			if (!$img || !$thumb)
			{
				return "";
			}

			$fname = "_imagetitle$i";
			if (!empty($row->$fname))
				$filetitle = $row->$fname;
			else
				$filetitle = "";

			JHTML::_('behavior.modal');
			static $cssdone = false;
			if (!$cssdone)
			{
				Factory::getDocument()->addStyleDeclaration("#jevents_body .modal {  display: inherit;  position: relative;}");
				$cssdone = true;
			}
			$src = "<a class='modal' rel='{handler: \"image\",}' href='" . $img . "' ><img src='" . $thumb . "' class='jev_imagethumb" . $i . "' alt='" . JEventsHTML::special($filetitle) . "' /></a>";
			return $src;
		}

		if (strpos($code, "JEV_IMAGE_TITLE_") === 0)
		{
			$i = str_replace("JEV_IMAGE_TITLE_", "", $code);
			$name = "_imagetitle" . $i;
			if (isset($row->$name))
				return $row->$name;
		}

		if (strpos($code, "JEV_IMAGE_COMMENT_") === 0)
		{
			$i = str_replace("JEV_IMAGE_COMMENT_", "", $code);
			$name = "_imagecomment" . $i;
			if (isset($row->$name))
				return $row->$name;
		}

		if (strpos($code, "JEV_FILE_TITLE_") === 0)
		{
			$i = str_replace("JEV_FILE_TITLE_", "", $code);
			$name = "_filetitle" . $i;
			if (isset($row->$name))
				return $row->$name;
		}
		if (strpos($code, "JEV_FILE_LINK_") === 0)
		{
			$i = str_replace("JEV_FILE_LINK_", "", $code);
			$name = "_filelink" . $i;
			if (isset($row->$name))
				return $row->$name;
		}
		if (strpos($code, "JEV_FILE_HREF_") === 0)
		{
			$i = str_replace("JEV_FILE_HREF_", "", $code);
			$name = "_filehref" . $i;
			if (isset($row->$name))
				return $row->$name;
		}
		if ($code == "PINTEREST")
		{
			$name = "_imageurl1";
			if (!isset($row->$name) || $row->$name == "")
			{
				return "";
			}
			$reg = JevRegistry::getInstanceWithReferences("jevents");
			static $datamodel2;
			if (!isset($datamodel2))
			{
				$datamodel2 = $reg->getReference("jevents.datamodel", false);
				if (!$datamodel2)
				{
					$datamodel2 = new JEventsDataModel();
				}
			}

			$rowlink = $row->viewDetailLink($row->yup(), $row->mup(), $row->dup(), false);
			$rowlink = Route::_($rowlink . $datamodel2->getCatidsOutLink());

			$url = urlencode(substr(Uri::base(), 0, -1) . $rowlink);
			$image = "&media=" . urlencode(substr(Uri::base(), 0, -1) . $row->$name);
			$title = urlencode($row->title());
			return '<div style="margin:5px 0px" class="jevpinterest"><a href="http://pinterest.com/pin/create/button/?url=' . $url . '&description=' . $title . $image . '" class="pin-it-button" count-layout="horizontal">Pin It</a>
<script  data-cfasync="false" type="text/javascript" src="http://assets.pinterest.com/js/pinit.js"></script></div>';
		}

		return "";
	}

	static public function getCategoryImageUrl($row)
	{
		$data = $row->getCategoryData();
		if (is_array($data))
		{
			$data = $data[0];
		}
		if ($data)
		{
			$params = json_decode($data->params);
			if (isset($params->image) && $params->image != "")
			{
				return JURI::root() . $params->image;
			}
		}
	}

	/**
	 * When editing a JEvents menu item/module can add additional menu constraints dynamically
	 *
	 */
	function onEditMenuItem(&$menudata, $value, $control_name, $name, $id, $param)
	{
		// already done this param
		if (isset($menudata[$id]))
			return;

		static $matchingextra = null;
		// find the parameter that matches jevtl: (if any)
		if (!isset($matchingextra))
		{
			$params = $param->getGroup('params');
			foreach ($params as $key => $element)
			{
				$val = $element->value;
				if (strpos($key, "jform_params_extras") === 0)
				{
					if (strpos($val, "jevhi:") === 0)
					{
						$matchingextra = $key;
						break;
					}
				}
			}
			if (!isset($matchingextra))
			{
				$matchingextra = false;
			}
		}

		// either we found matching extra and this is the correct id or we didn't find matching extra and the value is blank
		if (strpos($value, "jevhi:") === 0 || (($value == "" || $value == "0") && $matchingextra === false))
		{
			$matchingextra = true;
			$invalue = str_replace(" ", "", $value);
			if ($invalue == "")
				$invalue = 'jevwd:-1';

			$options = array();
			$options[] = JHTML::_('select.option', 'jevhi:-1', Text::_('JEV_ANY_EVENTS'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevhi:0', Text::_('JEV_WITH_NO_IMAGE'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevhi:1', Text::_('JEV_WITH_IMAGE'), 'id', 'title');

			$input = JHTML::_('select.genericlist', $options, $name, '', 'id', 'title', $invalue, $name);

			$data = new stdClass();
			$data->name = "jevwithimage";
			$data->html = $input;
			$data->label = "JEVF_EVENTS_HAVE_IMAGE";
			$data->description = "JEVF_EVENTS_HAVE_IMAGE_DESC";
			$data->options = array();
			$menudata[$id] = $data;
		}
	}

	public static function getSizedImageUrl($row, $name, $dimensions, $params)
	{

		list($width, $height) = explode("x", $dimensions);

		$base = Uri::base();
		$basepath = Uri::base(true);
		$baseExAdmin = str_replace("/administrator", "", $base);
		$basepathExAdmin = str_replace("/administrator", "", $basepath);

		$nosmallupscale = plgJEventsjevfiles::imageSpecificParameterStatic($params, "nosmallupscale", 0, intval(str_replace('_imageurl','', $name)));

		$img = false;
		if (!isset($row->$name) || $row->$name == "")
		{
			$defimage = plgJEventsjevfiles::imageSpecificParameterStatic($params, "defaultimage", false, intval(str_replace('_imageurl','', $name)));

			if ($params->get("defaultonlyforfirst", 0) && $name !== "_imageurl1")
			{
				$defimage = false;
			}

			if ($defimage)
			{
				$img = $defimage;
			}
			else
			{
				$catimage = $row->getCategoryImageUrl();
				if ($catimage)
				{
					$img = $catimage;
				}
			}
			if (!$img)
				return false;
		}
		else
		{
			$img = $row->$name;
		}

		$imgfile = str_replace($base, "", $img);
		$imgfile = str_replace($basepath, "", $imgfile);
		$imgfile = str_replace($baseExAdmin, "", $imgfile);
		$imgfile = str_replace($basepathExAdmin, "", $imgfile);
		if (strpos($imgfile, "/") === 0)
		{
			$imgfile = substr($imgfile, 1);
		}

		// Get the media component configuration settings
		$mediaparams = ComponentHelper::getParams('com_media');
		// Set the path definitions
		if (!defined('JEVP_MEDIA_BASE'))
		{
			define('JEVP_MEDIA_BASE', JPATH_ROOT . '/' . $mediaparams->get('image_path', 'images/stories'));
			define('JEVP_MEDIA_BASEURL', JURI::root(true) . '/' . $mediaparams->get('image_path', 'images/stories'));
		}
		// folder relative to media folder
		$folder = $params->get("folder", "");
		if ($folder == "")
		{
			echo Text::_("JEV_SAVE_PLUGIN_PARAMETERS");
			return false;
		}

		jimport('joomla.filesystem.folder');

		//Check if we are scaling?
		if ((int) $width === 0 && (int) $height === 0)
		{
			// We shouldn't be scaling 0 = no scaling.
			$src = JPATH_SITE . "/" . $imgfile;

			if (!File::exists($src))
			{
				jimport("joomla.image.image");
				if (File::exists(plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/originals/" . basename($imgfile)))
				{
					$src = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/originals/" . basename($imgfile);
					$img = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASEURL . "/" . $folder) . "/originals/" . basename($imgfile);
				}
				else if (File::exists(plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/originals/orig_" . basename($imgfile)))
				{
					$src = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/originals/orig_" . basename($imgfile);
					$img = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASEURL . "/" . $folder) . "/originals/orig_" . basename($imgfile);
				}
				else
				{
					$src = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/" . basename($imgfile);
					$img = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASEURL . "/" . $folder) . "/" . basename($imgfile);
				}

				if (!File::exists($src))
				{
					return false;
				}
				return $img;
			}
			else
			{
				$img = JURI::root(true) . "/" . $imgfile;
				return $img;
			}
		}

		// ensure folder exists
		$imgfile = str_replace($mediaparams->get('image_path', 'images/stories') . "/" . $folder . "/", "", $imgfile);
		if (!Folder::exists(plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/" . $dimensions))
		{
			Folder::create(plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/" . $dimensions);
		}

		// use basename($imgfile) in case default image is not in the main path!
		$targetfile = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/" . $dimensions . "/" . basename($imgfile);
		if (!File::exists($targetfile))
		{
			$src = File::exists(plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASE . "/" . $folder) . "/originals/" . basename($imgfile)) ? JEVP_MEDIA_BASE . "/" . $folder . "/originals/" . basename($imgfile) : JEVP_MEDIA_BASE . "/" . $folder . "/" . basename($imgfile);

			if (!File::exists($src) && File::exists(JPATH_SITE . "/" . $imgfile))
			{
				$src = JPATH_SITE . "/" . $imgfile;
			}
			else if (!File::exists($src))
			{
				return false;
			}

			// scale the image
			jimport("joomla.image.image");

			// Image uses isTransparent method which fails on alpha transparent PNG images :(
			try
			{
				$imageproperties = Image::getImageFileProperties($src);
			}
			catch (Exception $e)
			{
				return false;
			}

			$origw = $imageproperties->width;
			$origh = $imageproperties->height;

			try {
				$src_img = new Image($src);
			}
			catch (Exception $e){
				return false;
			}

			if (!$src_img)
			{
				return false;
			}

			if(function_exists("exif_read_data")){
				$exif = @exif_read_data($src);
				if(isset($exif['Orientation']) && !empty($exif['Orientation'])) {
					switch($exif['Orientation']) {
						case 8:
							$src_img->rotate(90, -1, false);
							break;
						case 3:
							$src_img->rotate(180, -1, false);
							break;
						case 6:
							$src_img->rotate(-90, -1, false);
							break;
					}
				}
			}

			// fetch origw and origh AFTER rotation!
			$origw = $src_img->getWidth();
			$origh = $src_img->getHeight();

			// TODO thumbnail size in config
			// don't make thumbnail bigger than original!!
			if ($origw <= $width && $origh <= $height)
			{
				$thumbWidth = $origw;
				$thumbHeight = $origh;
			}
			else
			{
				$thumbWidth = $width;
				$thumbHeight = intval($origh * $thumbWidth / $origw);
				if ($thumbHeight > $height)
				{
					$thumbHeight = $height;
					$thumbWidth = intval($origw * $thumbHeight / $origh);
				}
			}

			$thumbdir = dirname($targetfile);
			include_once(dirname(__FILE__) . "/files/uploadhelper.php");
			$uploadhelper = new JevUploadHelper($params);

			$uploadhelper->ensureDirExists($thumbdir);

			if ($thumbWidth == $origw && $thumbHeight == $origh) {
				$dst_img = $src_img;
			}
			else {
				$dst_img = $src_img->cropResize($thumbWidth, $thumbHeight, true);
			}

			if (!$dst_img)
			{
				return false;
			}

			$quality = $params->get("imagequality", 90);

			if ($nosmallupscale && ($imageproperties->height < $height || $imageproperties->width < $width))
			{
				$height = $imageproperties->height;
				$width = $imageproperties->width;
			}

			if ($imageproperties->type == IMAGETYPE_PNG && $quality >= 10) {
				// PNG quality is up to 10
				$quality = intval($quality/10);
				$quality = $quality>9?9:$quality;
			}

			if (!$dst_img->toFile($targetfile, $imageproperties->type, array("quality"=>$quality)))
			{
				return false;
			}
			// Joomla image scaling doesn't work for alpha transparent PNG images ??
				/*
			if ($imageproperties->type == IMAGETYPE_PNG)
			{
				if ($quality >= 10)
				{
					// PNG quality is up to 10
					$quality = intval($quality / 10);
					$quality = $quality > 9 ? 9 : $quality;
				}

				$img = @imagecreatefrompng($src);
				$old_x = imageSX($img); // width
				$old_y = imageSY($img); // height
				// preserve aspect ratio
				$thumbWidth = $width;
				$thumbHeight = intval($old_y * $thumbWidth / $old_x);
				if ($thumbHeight > $height)
				{
					$thumbHeight = $height;
					$thumbWidth = intval($old_x * $thumbHeight / $old_y);
				}
				$width = $thumbWidth;
				$height = $thumbHeight;

				$new_img = imageCreateTrueColor($width, $height);
				imagealphablending($new_img, false);
				$colorTransparent = imagecolorallocatealpha($new_img, 0, 0, 0, 127);
				imagefill($new_img, 0, 0, $colorTransparent);
				imagesavealpha($new_img, true);
				imagecopyresampled($new_img, $img, 0, 0, 0, 0, $width, $height, $old_x, $old_y);
				imagepng($new_img, $targetfile, $quality);
				imagedestroy($new_img);
				imagedestroy($img);
			}
			*/
		}
		$img = plgJEventsjevfiles::canonicalize(JEVP_MEDIA_BASEURL . "/" . $folder) . "/" . $dimensions . "/" . basename($imgfile);

		return $img;
	}

	public static function canonicalize($address)
	{
		$address = explode('/', $address);
		$keys = array_keys($address, '..');

		foreach ($keys AS $keypos => $key)
		{
			array_splice($address, $key - ($keypos * 2 + 1), 2);
		}

		$address = implode('/', $address);
		$address = str_replace('./', '', $address);
		return $address;
	}


	function imageSpecificParameter($parameter, $default, $imageNameOrNumber)
	{
		return plgJEventsjevfiles::imageSpecificParameterStatic($this->params, $parameter, $default, $imageNameOrNumber);
	}

	static function imageSpecificParameterStatic($params, $parameter, $default , $imageNameOrNumber )
	{
		if ($params->get("globalscaling", 1))
		{
			return $params->get($parameter, $default);
		}
		else
		{
			$imageNumber = preg_replace("/[^0-9]/", "", $imageNameOrNumber);
            if ('something stupid' === $params->get($parameter . $imageNumber, 'something stupid'))
            {
                $default = $params->get($parameter, $default);
            }
            return $params->get($parameter . $imageNumber, $default);
		}
	}

}
