<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
JLoader::register('jevFilterProcessing',JPATH_SITE."/components/com_jevents/libraries/filters.php");
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");

class plgJEventsJevgroupevent extends JPlugin
{
	var $_dbvalid = 0;
	public $params = null;
	private $jomsocial = false;
	private $cb = false;
	private $groupjive = false;

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$lang 		= JFactory::getLanguage();
		$lang->load("plg_jevents_jevgroupevent", JPATH_ADMINISTRATOR);
		$lang->load("plg_jevents_jevgroupevent", JPATH_SITE);

		// get plugin params
		$plugin = JPluginHelper::getPlugin('jevents', 'jevgroupevent');
		$this->params = new JRegistry($plugin->params);

		$jomsocial = JComponentHelper::getComponent("com_community");
		if (isset($jomsocial) && isset($jomsocial->id)){
			$this->jomsocial = true;
		}

		$cb = JComponentHelper::getComponent("com_comprofiler");
		if (isset($cb) && isset($cb->id)){
			$this->cb = true;
			if (file_exists(JPATH_SITE."/components/com_comprofiler/plugin/user/plug_cbgroupjive/cbgroupjive.php")){
				$this->groupjive = true;
			}
		}


	}

	function onListIcalEvents( & $extrafields, & $extratables, & $extrawhere, & $extrajoin, & $needsgroupdby=false)
	{

		if(JFactory::getApplication()->isAdmin()) {
			return;
		}

		// show all so strip all private events	the user is not authorised to see
		$filters = jevFilterProcessing::getInstance(array("activegroup","groupeventsearch"),dirname(__FILE__)."/filters/");

		$filters->setWhereJoin($extrawhere,$extrajoin);
		if (!$needsgroupdby) $needsgroupdby=$filters->needsGroupBy();

		return true;
	}

	function onListEventsById( & $extrafields, & $extratables, & $extrawhere, & $extrajoin)
	{
		if(JFactory::getApplication()->isAdmin()) {
			return;
		}

		$pluginsDir = JPATH_ROOT.'/plugins/jevents';

		// use computed path so that joomla doesn't choke on soft links!
		$filters = jevFilterProcessing::getInstance(array("activegroup","groupeventsearch"),dirname(__FILE__)."/filters/");

		$filters->setWhereJoin($extrawhere,$extrajoin);

		return true;
	}

	function onEditCustom( &$row, &$customfields )
	{

		$db = JFactory::getDbo();
		$charset = ($db->hasUTFSupport()) ? 'DEFAULT CHARACTER SET `utf8`' : '';

		$sql = <<<SQL
CREATE TABLE IF NOT EXISTS #__jev_groupeventsmap(
	user_id int(12) NOT NULL  default 0,
	evdet_id int(12) NOT NULL  default 0,
	groupid int(12) NOT NULL default 0,

	PRIMARY KEY (user_id,evdet_id, groupid),
	INDEX  (evdet_id),
	INDEX  (user_id)
) $charset;
SQL;
		$db->setQuery($sql);
		if (!$db->execute()){
			echo $db->getErrorMsg();
		}

		$html = "";

		// get the data from database and attach to row
		$detailid = intval($row->evdet_id());
		$user = JFactory::getUser();
		if ($user->id==0) return true;

		$groupuser = $row->created_by();
		if ($groupuser==0){
			$groupuser=$user->id;
		}
		if ($this->jomsocial){

			if ($this->params->get("onlymember",0)) {
				$db->setQuery("select * from #__community_groups as a LEFT JOIN #__community_groups_members as b ON a.id=b.groupid where b.approved=1 AND b.memberid=".$groupuser."  group by a.id ORDER BY a.name");
			}
			else {
				$db->setQuery("select * from #__community_groups as a LEFT JOIN #__community_groups_members as b ON a.id=b.groupid where (a.published=1 OR (b.approved=1 AND b.memberid=".$groupuser.")) group by a.id ORDER BY a.name");
			}
			$jsgroups = $db->loadObjectList();
			if ($jsgroups && count($jsgroups)>0){
				$this->jomsocialgroups = true;

			}
			else $this->jomsocialgroups = false;

		}

		// These must be last!!
		if ($this->jomsocial && $this->jomsocialgroups){
			$html .= "<div id='jsgroupevents' style='display:block'>";

			$sql = "SELECT jum.groupid FROM #__jev_groupeventsmap as jum WHERE evdet_id=".$detailid;
			$db->setQuery($sql);
			$privategroups = $db->loadColumn();

			$html .= "<select name='custom_jevgroupevent[]' id='custom_jevgroupevent_jsgroupselection' multiple='multiple' size='4'>";

            // Add Default value as gslselect sets index of -1 to first option
            $html .= "<option value='4g-1'>" . JText::_('JEV_SELECT_GROUP') . "</option>";

			foreach ($jsgroups as $group) {
				$html .= "<option value='4g$group->id' ".(in_array($group->id,$privategroups)?" selected='true'":"").">$group->name</option>";
			}
			$html .= "</select>";
			$html .= "</div>";

		}

		if ($html=="") return true;
		$label = JText::_("JEV_SELECT_GROUP");

		$customfield = array("label"=>$label,"input"=>$html);
		$customfields["jevgroupevent"]=$customfield;

		return true;
	}

	/**
	 * Clean out custom fields for event details not matching global event detail
	 *
	 * @param unknown_type $idlist
	 */
	function onCleanCustomDetails($idlist){
		// TODO
		return true;
	}


	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	function onStoreCustomDetails($evdetail){

		$detailid = intval($evdetail->evdet_id);
		$groupevent = array_key_exists("jevgroupevent",$evdetail->_customFields)?$evdetail->_customFields["jevgroupevent"]:"0";

		$db = JFactory::getDbo();
		$user = JFactory::getUser();

		// Who is marked as the creator - no need for double security here since the event would unviewable if it is abused
		$created_by = JRequest::getInt("jev_creatorid", $user->id);

		// first of all remove all the old mappings
		$sql = "DELETE FROM #__jev_groupeventsmap WHERE evdet_id=".$detailid;
		$db->setQuery($sql);
		$success = $db->execute();

		// These are groups
		if (is_array($groupevent)){
			foreach ($groupevent as $group) {
				// Jomsocial groups have a leading value of 4g and a group type = 1
				if (strpos($group,"4g")===0){
					$value = intval(str_replace("4g","",$group));
					$sql = "INSERT INTO #__jev_groupeventsmap SET user_id=".intval($created_by).",  evdet_id=".$detailid.",groupid=".intval($value);
					$db->setQuery($sql);
					$success =  $db->execute();
				}

			}
		}
		return $success;

	}


	function onDisplayCustomFields(&$row){


		$summary = "";
		$detailid = intval($row->evdet_id());

		$sql = "SELECT g.name, g.id, g.avatar, g.thumb FROM #__jev_groupeventsmap as gem LEFT JOIN #__community_groups as g ON g.id=gem.groupid WHERE gem.evdet_id=".$detailid;
		$db = JFactory::getDbo();
		$db->setQuery($sql);
		$eventgroups = $db->loadObjectList();

		$groupnames = array();
		$groupavatars = array();
		$groupthumbs = array();
		$groupurls = array();

		if (!class_exists('CFactory'))
		{
			require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
			require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'template.php');
			require_once( COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'apps.php' );
		}

		foreach ($eventgroups as $eventgroup)
		{
			$groupnames[] = $eventgroup->name;
			$groupavatars[] = $eventgroup->avatar;
			$groupthumbs[] = $eventgroup->thumb;
			$groupurls[] = CRoute::_('index.php?option=com_community&view=groups&task=viewgroup&groupid=' . $eventgroup->id);
		}


		if (count($groupnames)>0){
			$summary = JText::_("JEV_GROUP_EVENT");
			$summary .= implode (", ",$groupnames);
			$row->groupeventgroups= $eventgroups;
			$row->groupeventsummary = $summary;
			$row->groupeventavatars = implode (", ",$groupavatars);
			$row->groupeventthumbs = implode (", ",$groupthumbs);
			$row->groupeventurls = implode (", ",$groupurls);
		}
		return $summary;
	}

	static function fieldNameArray($layout='detail'){
		// only offer in detail view
		if ($layout != "detail" && $layout != "edit") return array();

		if ($layout == "edit")
		{
			$return = array();
			$labels = array();
			$values = array();

			$return['group'] = JText::_("JEV_GROUP_EVENT", true);

			$labels[] =  JText::_("JEV_GROUP_EVENT");
			$values[] = "jevgroupevent";

			$return['values'] = $values;
			$return['labels'] = $labels;

			return $return;
		}

		$return  = array();
		$return['group'] = JText::_("JEV_GROUP_EVENT",true);

		$labels = array();
		$values = array();

		$labels[] = JText::_("JEV_GROUP_EVENT",true);
		$values[] = "JEV_GROUPEVENT_SUMMARY";

		$labels[] =  JText::_("JEV_GROUP_AVATAR");
		$values[] = "GROUPAVATAR";

		$labels[] =  JText::_("JEV_GROUP_AVATAR_THUMB");
		$values[] = "GROUPTHUMB";

		$labels[] =  JText::_("JEV_GROUP_URL");
		$values[] = "GROUPURL";


		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;
	}

	static function substitutefield($row, $code){
		if (isset($row->hidedetail) && $row->hidedetail){
			return "";
		}

		if ($code == "JEV_GROUPEVENT_SUMMARY"){
			if (isset($row->groupeventsummary))return $row->groupeventsummary;
		}

		if ($code == "GROUPAVATAR"){
			if (isset($row->groupeventavatars))return $row->groupeventavatars;
		}

		if ($code == "GROUPURL"){
			if (isset($row->groupeventurls))return $row->groupeventurls;
		}

		if ($code == "GROUPTHUMB"){
			if (isset($row->groupeventthumb))return $row->groupeventthumb;
		}

		return "";
	}


}