<?php

// no direct access
defined('_JEXEC') or die('Restricted access');
use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\Utilities\ArrayHelper;

jimport('joomla.plugin.plugin');
JLoader::register('JevJoomlaVersion', JPATH_ADMINISTRATOR . "/components/com_jevents/libraries/version.php");

class plgJEventsJevhiddendetail extends CMSPlugin {

    private $whitelist;
    
    public function __construct(&$subject, $config = array()) {
        parent::__construct($subject, $config);
        if (!isset($this->whitelist)) {
			$this->whitelist = $this->params->get("whitelist", "");
            if (is_string($this->whitelist)) {
                $this->whitelist = explode(",", $this->whitelist);
            }
            ArrayHelper::toInteger($this->whitelist);
        }
    }

    public function onDisplayCustomFields(&$row) {

        $rows = array($row);
        $this->onDisplayCustomFieldsMultiRow($rows);
        $row = $rows[0];
    }

	public function onJEventsFinderResult (& $result, & $query)
	{
		// ALWAYS apply the hidden plugin to events just in case they were indexed before the plugin was updated
		include_once(JPATH_SITE . "/components/com_jevents/jevents.defines.php");

		static $dataModel;

		if (!isset($dataModel))
		{
			$dataModel  = new JEventsDataModel();

		}
		$event = $dataModel->queryModel->listEventsById( $result->getElement('rp_id'), 0,"icaldb");

		if (!$event || $event->rp_id()!= $result->getElement('rp_id'))
		{
			$result->title = "No such event";
			$result->description = "No such event detail";
			return;
		}

		$rows = array($event);
		$this->onDisplayCustomFieldsMultiRow($rows);
		$event = $rows[0];

		$result->title = $event->title();
		$result->description = $event->content();
		$result->setElement('body', '');
		$result->setElement('summary', $event->content());
	}

	public function onJevFinderIndexing(&$rows) {

		if ($this->params->get("finderaction",1) == 1)
		{
			return;
		}

		JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

		// set hiddendetailuser to zero to simulate a visit by Joe Public
		$registry = JevRegistry::getinstance("jevents");
		$registry->set("jevents.hiddendetailuser", 0);

		$this->onDisplayCustomFieldsMultiRow($rows);

	}

	public function onDisplayCustomFieldsMultiRow(&$rows) {

    	$app    = Factory::getApplication();
	    $jinput = $app->input;

	    // Do not run on send notifications!
	    if($jinput->get('file', '') === 'sendnotifications') {
	    	return;
	    }

        $user = Factory::getUser();
	    JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

        $registry = JevRegistry::getinstance("jevents");
        $hiddenDetailUser = $registry->get("jevents.hiddendetailuser", -1);

        if ($hiddenDetailUser !== -1)
        {
            $user = Factory::getUser($hiddenDetailUser);
        }

        $title = $this->params->get("hiddentitle", "This event is only visible to logged in users");
        $content = $this->params->get("hiddendesc", "This content is only visible to logged in users");

        $transtitle = Text::_($title);
        $transcontent = Text::_($content);

        if ($transtitle != $title)
        {
            $title = $transtitle;
        }

        if ($transcontent != $content)
        {
            $content = $transcontent;
        }

        $advancedpermissions = $this->params->get("advancedpermissions", 0);

        if (!$advancedpermissions) {

            $blockaccess = false;
            $accesslevel = $this->params->get("accesslevel", -1);

            if ($accesslevel > 0) {
                $accesslevels = $user->getAuthorisedViewLevels();
                $blockaccess = !in_array($accesslevel, $accesslevels);
            }

            if ($blockaccess) {
                $pastfuture = $this->getFuturePast();
                $rows_cnt = count($rows);

                for ($r = 0; $r < $rows_cnt; $r++) {
                    if (count($this->whitelist) > 0 && in_array($rows[$r]->catid(), $this->whitelist)) {
                        continue;
                    }

                    if (count($this->whitelist) > 0 && $rows[$r]->catids() && count($rows[$r]->catids()) > 0 && array_intersect($rows[$r]->catids(), $this->whitelist)) {
                        continue;
                    }

                    // Always allow creator to see
                    if ($user->id > 0 && $rows[$r]->ev_id() > 0 && $rows[$r]->created_by() == $user->id) {
                        continue;
                    }

	                // Are we an invitee to an invitee only event - let RSVP Pro take care of this?
	                if (isset($rows[$r]->rsvpdata) && $rows[$r]->rsvpdata->hidenoninvitees)
	                {
		                continue;
	                }

	                $blockbydate = true;
                    if ($pastfuture["past"] && $rows[$r]->publish_up() >= $pastfuture["past"]) {
                        $blockbydate = false;
                    }
                    if ($pastfuture["future"] && $rows[$r]->publish_up() <= $pastfuture["future"]) {
                        $blockbydate = false;
                    }

                    // for sites that want to hide specific custom fields after event has started - use code like the following
                    /*
                      $now = new JevDate("+0 seconds");
                      $now = $now->toFormat("%Y-%m-%d %H:%M:%S");
                      if ($rows[$r]->publish_up() <=$now){
                      unset($rows[$r]->customfields["reglink1"]);
                      unset($rows[$r]->customfields["reglink2"]);
                      }
                     */

                    if (!$blockbydate) {
                        continue;
                    }

                    $params = ComponentHelper::getParams(JEV_COM_COMPONENT);
                    $icalkey = $params->get("icalkey", "secret phrase");
                    if (Factory::getApplication()->input->getCmd("accesscode", "") == md5($rows[$r]->rp_id . $icalkey)) {
                        continue;
                    }

                    if ($jinput->get('task', '') === 'icalrepeat.detail' && strlen($this->params->get('hiddenurl', '')) > 0)
                    {
                    	// We are in the event details and we have a redirect url lets go!
	                    $app->redirect($this->params->get('hiddenurl'), 302);
                    }

	                // Do we need to fix the link to login?
                    if (strpos($content, "{link}")!==false){
                        $Itemid = $jinput->getInt("Itemid");
                        list($year, $month, $day) = JEVHelper::getYMD();
                        $link = $rows[$r]->viewDetailLink($year, $month, $day, true, $Itemid);
                        if (strpos($link, "?") > 0) {
                            $link .= "&login=1";
                        } else {
                            $link .= "?login=1";
                        }
                        $content = str_replace("{link}", $link, $content);            
                    }

                    if ($this->params->get('hidetitle', 0) == 1) {
	                    $rows[$r]->_summary = $rows[$r]->_title = $title;
                    }
                    $rows[$r]->content($content);
	                $rows[$r]->_description = $content;
                    $rows[$r]->_contact_info = "";
                    $rows[$r]->_contact = "";
                    $rows[$r]->_extra_info = "";
	                if ($this->params->get('hidecustomfields', 1) == 1)
	                {
		                $rows[$r]->customfields       = null;
		                $rows[$r]->customfieldsummary = "";
	                }
                    $rows[$r]->hidedetail = true;
                    $rows[$r]->location(0);
                }
            }
        } 
        else {
            $subform = $this->params->get("advancedacl", array());
            if ($subform && !is_array($subform)) {
                $subform = (array) $subform;
            }
            $advancedacl = array();
            foreach ($subform as $rule) {
                foreach ($rule->category as $cat) {
                    $advancedacl[$cat] = $rule->usergroups;
                }
            }

            if (count($advancedacl)) {
                $pastfuture = $this->getFuturePast();
                $rows_cnt = count($rows);

                $usergroups = $user->getAuthorisedGroups();
                $pastfuture = $this->getFuturePast();                
                
                for ($r = 0; $r < $rows_cnt; $r++) {
                    
                    if (count($this->whitelist) > 0 && in_array($rows[$r]->catid(), $this->whitelist)) {
                        continue;
                    }

                    if (count($this->whitelist) > 0 && $rows[$r]->catids() && count($rows[$r]->catids()) > 0 && array_intersect($rows[$r]->catids(), $this->whitelist)) {
                        continue;
                    }
                    
                    // Always allow creator to see
                    if ($user->id > 0 && $rows[$r]->ev_id() > 0 && $rows[$r]->created_by() == $user->id) {
                        continue;
                    }

                    // Are we an invitee to an invitee only event - let RSVP Pro take care of this?
	                if (isset($rows[$r]->rsvpdata) && $rows[$r]->rsvpdata->hidenoninvitees)
	                {
	                	continue;
	                }

                    $params = ComponentHelper::getParams(JEV_COM_COMPONENT);
                    $icalkey = $params->get("icalkey", "secret phrase");
                    if (Factory::getApplication()->input->getCmd("accesscode", "") == md5($rows[$r]->rp_id . $icalkey)) {
                        continue;
                    }
                    
                    $catids = array($rows[$r]->catid());
                    if ($rows[$r]->catids() && count($rows[$r]->catids()) > 0){
                        $catids = array_merge($catids,$rows[$r]->catids()); 
                    }
                    $catids = array_unique($catids);
                    
                    $allowedgroups = array();
                    foreach ($catids as $catid) { 
                        if (array_key_exists($catid, $advancedacl)) {
                            $allowedgroups = array_merge($allowedgroups,$advancedacl[$catid]);
                        }
                    }
                    $allowedgroups = array_unique($allowedgroups);
                    
                    if (array_intersect($allowedgroups, $usergroups)) {
                        continue;
                    }
                 
                    $blockbydate = true;
                    if ($pastfuture["past"] && $rows[$r]->publish_up() >= $pastfuture["past"]) {
                        $blockbydate = false;
                    }
                    if ($pastfuture["future"] && $rows[$r]->publish_up() <= $pastfuture["future"]) {
                        $blockbydate = false;
                    }

                    // for sites that want to hide specific custom fields after event has started - use code like the following
                    /*
                      $now = new JevDate("+0 seconds");
                      $now = $now->toFormat("%Y-%m-%d %H:%M:%S");
                      if ($rows[$r]->publish_up() <=$now){
                      unset($rows[$r]->customfields["reglink1"]);
                      unset($rows[$r]->customfields["reglink2"]);
                      }
                     */

                    if (!$blockbydate) {
                        continue;
                    }

	                if ($jinput->get('task', '') === 'icalrepeat.detail' && strlen($this->params->get('hiddenurl', '')) > 0)
	                {
		                // We are in the event details and we have a redirect url lets go!
		                $app->redirect($this->params->get('hiddenurl'), 302);
	                }

                    // Do we need to fix the link to login?
                    if (strpos($content, "{link}")!==false){
                        $Itemid = Factory::getApplication()->input->getInt("Itemid");
                        list($year, $month, $day) = JEVHelper::getYMD();
                        $link = $rows[$r]->viewDetailLink($year, $month, $day, true, $Itemid);
                        if (strpos($link, "?") > 0) {
                            $link .= "&login=1";
                        } else {
                            $link .= "?login=1";
                        }
                        $content = str_replace("{link}", $link, $content);            
                    }
                    
                    if ($this->params->get('hidetitle', 0) == 1) {
                        $rows[$r]->_title = $title;
                    }
                    $rows[$r]->content($content);
                    $rows[$r]->_contact_info = "";
                    $rows[$r]->_contact = "";
                    $rows[$r]->_extra_info = "";
                    if ($this->params->get('hidecustomfields', 1) == 1)
                    {
	                    $rows[$r]->customfields       = null;
	                    $rows[$r]->customfieldsummary = "";
                    }
                    $rows[$r]->hidedetail = true;
                    $rows[$r]->location(0);
                    
                }
                
                
            }
            
            
        }
    }

    private function getFuturePast() {
        static $pastdate;
        static $futuredate;
        if (!isset($pastdate)) {
            $pastdate = false;
            $futuredate = false;

            if (!is_numeric($this->params->get("past", -1))) {
                $past = $this->params->get("past", "");
                $future = $this->params->get("future", "");
                if ($past != "" && $future != "") {
                    $pastdate = new JevDate($past);
                    $pastdate = $pastdate->toFormat("%Y-%m-%d 00:00:00");
                    $futuredate = new JevDate($future);
                    $futuredate = $futuredate->toFormat("%Y-%m-%d 23:59:59");
                } else if ($past != "") {
                    $pastdate = new JevDate($past);
                    $pastdate = $pastdate->toFormat("%Y-%m-%d 00:00:00");
                } else if ($future != "") {
                    $futuredate = new JevDate($future);
                    $futuredate = $futuredate->toFormat("%Y-%m-%d 23:59:59");
                }
            } else {
                $past = (int) $this->params->get("past", -1);
                $future = (int) $this->params->get("future", -1);
                if ($past >= 0 && $future >= 0) {
                    $pastdate = new JevDate("-$past days");
                    $pastdate = $pastdate->toFormat("%Y-%m-%d 00:00:00");
                    $futuredate = new JevDate("$future days");
                    $futuredate = $futuredate->toFormat("%Y-%m-%d 23:59:59");
                } else if ($past >= 0) {
                    $pastdate = new JevDate("-$past days");
                    $pastdate = $pastdate->toFormat("%Y-%m-%d 00:00:00");
                } else if ($future >= 0) {
                    $futuredate = new JevDate("$future days");
                    $futuredate = $futuredate->toFormat("%Y-%m-%d 23:59:59");
                }
            }
        }
        return array("past" => $pastdate, "future" => $futuredate);
    }

    public static function fieldNameArray($layout = 'detail') {
        $return = array();
        $return['group'] = Text::_("JEV_HIDDEN_DETAIL", true);

        $labels = array();
        $values = array();

        $labels[] = Text::_("JEV_HIDDEN_ACCESS_CODE");
        $values[] = "ACCESSCODE";

        $labels[] = Text::_("JEV_HIDDEN_DETAILS_HIDDEN");
        $values[] = "DETAILSHIDDEN";
	
        $return['values'] = $values;
        $return['labels'] = $labels;

        return $return;
    }

    public static function substitutefield($row, $code) {

        if ($code == "DETAILSHIDDEN") {
            if (isset($row->hidedetail) && $row->hidedetail) {
                return "hidden";
            }
	    return "";
        }

	if ($code == "ACCESSCODE") {
            if ($row->created_by() == Factory::getUser()->id || JEVHelper::isAdminUser()) {
                $params = ComponentHelper::getParams(JEV_COM_COMPONENT);
                $icalkey = $params->get("icalkey", "secret phrase");
                $link = Route::_($row->viewDetailLink($row->yup(), $row->mup(), $row->dup(), false, Factory::getApplication()->input->getInt("Itemid", 0)) . "&accesscode=" . md5($row->rp_id . $icalkey));
                return "<a href='$link' >" . Text::_("JEV_ACCESS_LINK") . "</a>";
            }
        }
        return "";
    }

}
