<?php
/**
 * copyright (C) 2010 GWE Systems Ltd - All rights reserved
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
if (!defined('DS'))
	define('DS', DIRECTORY_SEPARATOR);
JLoader::register('JevJoomlaVersion', JPATH_ADMINISTRATOR . "/components/com_jevents/libraries/version.php");

class plgJEventsJevjsstream extends JPlugin
{

	private $jomsocial = false;
	private $wallid = false;
	private $jsversion = 0;

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);

		jimport('joomla.html.parameter');
		JFactory::getLanguage()->load('plg_jevents_jevjsstream', JPATH_ADMINISTRATOR);

		$jomsocial = JComponentHelper::getComponent("com_community");
		if (isset($jomsocial) && isset($jomsocial->id))
		{
			$this->jomsocial = true;
		}

		$user = JFactory::getUser();

// if logged in and wrapping is enbled then persist group and user
		if ($user->id > 0 && $this->params->get("enablejswrap", 0))
		{

			// JomSocial 2.2
			$xml = JPATH_ADMINISTRATOR . "/components/com_community/community.xml";
			$parser = JFactory::getXML($xml);
			$document = & $parser->document;
			$element = $parser->xpath('//extension//version');
			if (count($element) > 0)
			{
				$this->jsversion = (string) $element[0];
			}
			else
			{
				$this->jsversion = "2.8";
			}

// ONLY DO THIS FOR THE JOMSOCIAL JEVENTS MENU ITEM
			$Itemid = JRequest::getInt("Itemid");
			$plugin = JPluginHelper::getPlugin('community', 'jevents');
			if (!$plugin)
				return;
			$pluginparams = new JRegistry($plugin->params);
			if (!$this->params->get("wrapall", 0) && intval($pluginparams->get("target_itemid", 0)) > 0 && $pluginparams->get("target_itemid", 0) != $Itemid)
			{
				return;
			}

			$mainframe = JFactory::getApplication('site');
			$activeuser = $mainframe->getUserStateFromRequest('jevu_fv_ses', 'jevu_fv', "");
			$activegroup = $mainframe->getUserStateFromRequest('jevge_fv_ses', 'jevge_fv', "");

			if ($activeuser)
			{
				JRequest::setVar("jevu_fv", $activeuser);
			}
			if ($activegroup)
			{
				JRequest::setVar("jevge_fv", $activegroup);
			}
		}
	}

	function onJEventsHeader($view)
	{
		$user = JFactory::getUser();

// if logged in then offer JomSocial bar and panels
		if ($user->id > 0 && $this->params->get("enablejswrap", 0))
		{

			$pop = JRequest::getInt('pop', 0);

// ONLY DO THIS FOR THE JOMSOCIAL JEVENTS MENU ITEM
			$Itemid = JRequest::getInt("Itemid");
			$plugin = JPluginHelper::getPlugin('community', 'jevents');
			if (!$plugin)
				return;
			$pluginparams = new JRegistry($plugin->params);

			// only do this for jomsocial or jev js streams  target menu items
			if (!$this->params->get("wrapall", 0) && $pluginparams->get("target_itemid", 0) != $Itemid && $this->params->get("target_itemid", 0) != $Itemid)
			{
				return;
			}

			// make sure view itemid is set!
			if (!isset($view->itemid) || intval($view->itemid) == 0)
			{
				$view->itemid = JEVHelper::getItemid();
			}

			$mainframe = JFactory::getApplication('site');
			$activeuser = $mainframe->getUserStateFromRequest('jevu_fv_ses', 'jevu_fv', "");
			$activegroup = $mainframe->getUserStateFromRequest('jevge_fv_ses', 'jevge_fv', "");

			$lang = JFactory::getLanguage();
			$lang->load("com_community");

			if (!class_exists('CFactory'))
			{
				require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
				require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'template.php');
				require_once( COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'apps.php' );
			}

			$appsLib = CAppPlugins::getInstance();
			$appsLib->loadApplications();

// Only trigger applications and set active URI when needed
			if (JRequest::getString("tmpl", "") != 'component')
			{
				$args = array();
				$appsLib->triggerEvent('onSystemStart', $args);
// Set active URI - this can end up adding Joomfish language to current URI which means it won't match up!
				CFactory::setCurrentURI();
			}

			if (version_compare($this->jsversion, "4.0", ">="))
			{
				$env = CTemplate::getTemplateEnvironment();

				$svgFile = CFactory::getPath('template://assets/icon/joms-icon.svg');

				// non ajax-prefixed tasks that should avoid svg
				$excludeSvgList = array(
					'changeAvatar',
					'multiUpload',
					'uploadvideo'
				);

				// exclude svg file from ajax response
				if ($svgFile)
				{
					include_once $svgFile;
				}
				$viewName = "Jevents";
				$html = '<div id="community-wrap" class="jomsocial-wrapper on-' . $env->joomlaTemplate . ' ' . JFactory::getDocument()->direction . ' c' . ucfirst($viewName) . '">';
				$html .= '<div class="jomsocial">';

				$config = CFactory::getConfig();
				$my = CFactory::getUser();

				$cuser = CFactory::getUser(intval($activeuser));

				CFactory::load('libraries', 'template');
				CTemplate::addStyleSheet('style');

				$templateParams = CTemplate::getTemplateParams();
				CTemplate::addStylesheet('style.' . $templateParams->get('colorTheme', 'green'));

				// FOr iPhone, we need to add the stylesheet AFTER the main stylesheet has been loaded
				if (JRequest::getVar('format') == 'iphone')
				{
					JHTML::stylesheet('components/com_community/templates/default/css/style.iphone.css');
				}

				// This need to be loaded in main messaging library
				CFactory::load('libraries', 'window');
				CWindow::load();

				$template = new CTemplateHelper;
				$styleIE7 = $template->getTemplateAsset('styleIE7', 'css');
				$styleIE6 = $template->getTemplateAsset('styleIE6', 'css');

				$css = '<!-- JomSocial -->
						<!--[if IE 7.0]>
						<link rel="stylesheet" href="' . $styleIE7->url . '" type="text/css" />
						<![endif]-->
						<!--[if lte IE 6]>
						<link rel="stylesheet" href="' . $styleIE6->url . '" type="text/css" />
						<![endif]-->';

				JFactory::getDocument()->addCustomTag($css);


				// Build the component menu module
				ob_start();

				$tmpl = new CTemplate();
				$tmpl->renderModules('js_top');
				$moduleHTML = ob_get_contents();
				ob_end_clean();
				$html .= $moduleHTML;

				$toolbar_lib = CToolbarLibrary::getInstance();
				$html .= $toolbar_lib->getHTML($user->id);

				echo $html;
			}
			else
			{
				echo '<div id="community-wrap">';

				// Build the component menu module
				//CTemplate::renderModules('js_top');

				$config = CFactory::getConfig();
				$my = CFactory::getUser();

				$cuser = CFactory::getUser(intval($activeuser));

				$js = '/assets/window-1.0';
				$js .= ( $config->getBool('usepackedjavascript') ) ? '.pack.js' : '.js';
				CAssets::attach($js, 'js');

				$js = '/assets/script-1.2';
				$js .= ( $config->getBool('usepackedjavascript') ) ? '.pack.js' : '.js';
				CAssets::attach($js, 'js');

				$js = '/*<![CDATA[*/';
				$js .= 'var js_viewerId = ' . $my->id . '; ';
				$js .= 'var js_profileId = ' . $cuser->id . ';';
				$js .= '/*]]>*/';
				$doc = JFactory::getDocument();
				$doc->addScriptDeclaration($js);

				CFactory::load('libraries', 'template');
				CTemplate::addStyleSheet('style');

				$templateParams = CTemplate::getTemplateParams();
				CTemplate::addStylesheet('style.' . $templateParams->get('colorTheme'));

				// FOr iPhone, we need to add the stylesheet AFTER the main stylesheet has been loaded
				if (JRequest::getVar('format') == 'iphone')
				{
					JHTML::stylesheet('components/com_community/templates/default/css/style.iphone.css');
				}

				// This need to be loaded in main messaging library
				CFactory::load('libraries', 'window');
				CWindow::load();

				// add alternate CSS file
				$overrideExists = JFolder::exists(JPATH_ROOT . DS . 'templates' . DS . $mainframe->getTemplate() . DS . 'html' . DS . 'com_community');

				$styleIE7Path = JPATH_ROOT . DS . 'templates' . DS . $mainframe->getTemplate() . DS . 'html' . DS . 'com_community' . DS . 'css' . DS . 'styleIE7.css';
				$tmplIE7Path = JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'templates' . DS . $config->get('template') . DS . 'css' . DS . 'styleIE7.css';

				if (JFile::exists($styleIE7Path))
				{
					$styleIE7File = '/templates/' . $mainframe->getTemplate() . '/html/com_community/css/styleIE7.css';
				}
				else if (JFile::exists($tmplIE7Path) && !$overrideExists)
				{
					$styleIE7File = '/components/com_community/templates/' . $config->get('template') . '/css/styleIE7.css';
				}
				else
				{
					$styleIE7File = '/components/com_community/templates/default/css/styleIE7.css';
				}

				$styleIE6Path = JPATH_ROOT . DS . 'templates' . DS . $mainframe->getTemplate() . DS . 'html' . DS . 'com_community' . DS . 'css' . DS . 'styleIE6.css';
				$tmplIE6Path = JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'templates' . DS . $config->get('template') . DS . 'css' . DS . 'styleIE6.css';

				if (JFile::exists($styleIE6Path))
				{
					$styleIE6File = '/templates/' . $mainframe->getTemplate() . '/html/com_community/css/styleIE6.css';
				}
				else if (JFile::exists($tmplIE6Path) && !$overrideExists)
				{
					$styleIE6File = '/components/com_community/templates/' . $config->get('template') . '/css/styleIE6.css';
				}
				else
				{
					$styleIE6File = '/components/com_community/templates/default/css/styleIE6.css';
				}

				$css = '
	<!-- Jom Social -->
	<!--[if IE 7.0]>
	<link rel="stylesheet" href="' . rtrim(JURI::root(), '/') . $styleIE7File . '" type="text/css" />
	<![endif]-->
	<!--[if lte IE 6]>
	<link rel="stylesheet" href="' . rtrim(JURI::root(), '/') . $styleIE6File . '" type="text/css" />
	<![endif]-->';

				$doc = JFactory::getDocument();
				if (is_callable(array($doc, "addCustomTag")))
				{
					$doc->addCustomTag($css);
				}
			}

			$logoutLink = CRoute::_('index.php?option=com_community&view=frontpage', false);
			$logoutLink = base64_encode($logoutLink);

			$app = JFactory::getApplication();
			$router = $app->getRouter();
			$vars = $router->getVars();

			$this->isDetailPage = false;
			if (JRequest::getString("jevtask") == "icalrepeat.detail" || JRequest::getString("jevtask") == "icalevent.detail")
			{
				$this->isDetailPage = true;
				$vars["task"] = "month.calendar";
			}

			$this->showside = false;
			if (JEVHelper::isEventCreator())
				$this->showside = true;

			$filter = JFilterInput::getInstance();
			foreach ($vars as $k => &$v)
			{
				$v = $filter->clean($v);
			}
			unset($v);

			if (!isset($vars["Itemid"]) || intval($vars["Itemid"]) == 0)
			{
				$vars["Itemid"] = JEVHelper::getItemid();
			}
			$myvars = $vars;
			$myvars["jevu_fv"] = intval($my->id);
			$myvars["jevge_fv"] = "";
			$mylink = JRoute::_("index.php?" . http_build_query($myvars));

			$groupvars = $vars;
			$groupvars["jevge_fv"] = intval($activegroup);
			$grouplink = JRoute::_("index.php?" . http_build_query($groupvars));

			$vars["jevu_fv"] = "";
			$vars["jevge_fv"] = "";
			$alllink = JRoute::_("index.php?" . http_build_query($vars));

// fix some style conflicts
			$style = <<< STYLE
#community-wrap .cLayout table#jevents_body .cSidebar {
padding:5px 12px 0px 0px;
}

table#jevents_body label {
display:inline;
}
STYLE;
			$document = JFactory::getDocument();
			$document->addStyleDeclaration($style);

			if (!$pop)
			{
				?>
				<div class="joms-subnav--desktop">

					<ul>
						<li>
							<a <?php echo $activeuser == $my->id ? "class='active'" : ""; ?> href="<?php echo $mylink; ?>"><?php echo JText::_('JEV_MY_EVENTS'); ?></a>
						</li>
						<?php
						if ($activeuser > 0 && $activeuser != $my->id)
						{
							$uservars = $vars;
							$uservars["jevu_fv"] = intval($activeuser);
							$userlink = JRoute::_("index.php?" . http_build_query($uservars));
							?>
							<li>
								<a class='active' href="<?php echo $userlink; ?>"><?php echo JText::sprintf("JEV_USER_EVENTS_S", $cuser->name); ?></a>
							</li>
						<?php } ?>
						<?php
						if ($activegroup > 0)
						{
							$db = JFactory::getDbo();
							$db->setQuery("SELECT * from #__community_groups where id=" . intval($activegroup));
							$group = $db->loadObject();
							if (!$group)
							{
								$groupname = "";
							}
							else
							{
								$groupname = $group->name;
							}
							?>
							<li>
								<a class='active' href="<?php echo $grouplink; ?>"><?php echo JText::sprintf("JEV_GROUP_EVENTS_S", $groupname); ?></a>
							</li>
						<?php } ?>
						<li>
							<a <?php echo ($activeuser == 0 && $activegroup == 0) ? "class='active'" : ""; ?> href="<?php echo $alllink; ?>"><?php echo JText::_('JEV_JOMSOCIAL_ALL_EVENTS'); ?></a>
						</li>
						<?php
						if ($my->id > 0 && JEVHelper::isEventCreator())
						{
							$editLink = JRoute::_('index.php?option=' . JEV_COM_COMPONENT
								. '&task=icalevent.edit' . '&year=' . $view->year . '&month=' . $view->month . '&day=' . $view->day
								. '&Itemid=' . $view->Itemid, true);
							$popup = false;
							$params = JComponentHelper::getParams(JEV_COM_COMPONENT);
							if ($params->get("editpopup", 0))
							{
								JHTML::_('behavior.modal');
								JHtml::script('components/' . JEV_COM_COMPONENT . '/assets/js/editpopup.js');
								$popup = true;
								$popupw = $params->get("popupw", 800);
								$popuph = $params->get("popuph", 600);
							}
							$eventlinkadd = $popup ? "javascript:jevEditPopup('" . $editLink . "',$popupw, $popuph);" : $editLink;
							?>
							<li class='action actions' >
								<a href="<?php echo $eventlinkadd; ?>" title="<?php echo JText::_('JEV_ADDEVENT'); ?>">
									<strong>
										<?php
										echo JHTML::_('image', 'media/system/images/new.png', JText::_('JEV_ADDEVENT'), array('title' => JText::_('JEV_ADDEVENT'), "style" => "height:13px;"), false);
										?>
									</strong>
								</a>
							</li>
							<?php
						}
						$cfg = JEVConfig::getInstance();
						$version = JEventsVersion::getInstance();
						$jevtype = JRequest::getVar('jevtype');
						$evid = JRequest::getInt('evid');
						$pop = JRequest::getInt('pop', 0);
						$params = JComponentHelper::getParams(JEV_COM_COMPONENT);
						$task = JRequest::getString("jevtask");

						$print_link = 'index.php?option=' . JEV_COM_COMPONENT
							. '&task=' . $task
							. ($evid ? '&evid=' . $evid : '')
							. ($jevtype ? '&jevtype=' . $jevtype : '')
							. ($view->year ? '&year=' . $view->year : '')
							. ($view->month ? '&month=' . $view->month : '')
							. ($view->day ? '&day=' . $view->day : '')
							. $view->datamodel->getItemidLink()
							. $view->datamodel->getCatidsOutLink()
							. '&pop=1'
							. '&tmpl=component';
						$print_link = JRoute::_($print_link);

						$task = JRequest::getString("jevtask");
						$link = 'index.php?option=' . JEV_COM_COMPONENT
							. '&task=' . $task
							. ($evid ? '&evid=' . $evid : '')
							. ($jevtype ? '&jevtype=' . $jevtype : '')
							. ($view->year ? '&year=' . $view->year : '')
							. ($view->month ? '&month=' . $view->month : '')
							. ($view->day ? '&day=' . $view->day : '')
							. $view->datamodel->getItemidLink()
							. $view->datamodel->getCatidsOutLink()
						;
						$link = JRoute::_($link);
						if (strpos($link, "/") === 0)
							$link = substr($link, 1);
						$link = JURI::root() . $link;

						$url = JRoute::_('index.php?option=com_mailto&tmpl=component&link=' . base64_encode($link));

						$today_date = new JEventDate();
						$today_date->setDate($view->year, $view->month, $view->day);

						$cat = $view->datamodel->getCatidsOutLink();
						$searchlink = JRoute::_('index.php?option=' . JEV_COM_COMPONENT . $cat . '&task=search.form&' . $today_date->toDateURL() . '&Itemid=' . $view->Itemid);
						?>
						<li class="action actions">
							<strong>
								<a href="javascript:void(0);" onclick="window.open('<?php echo $print_link; ?>', 'win2', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=600,height=600,directories=no,location=no');" title="<?php echo JText::_('JEV_CMN_PRINT'); ?>">
									<?php
									echo JHTML::_('image', 'media/system/images/printButton.png', JText::_('JEV_CMN_PRINT'), array('title' => JText::_('JEV_CMN_PRINT'), "style" => "height:13px;"), false);
									?>
								</a>
							</strong>
						</li>
						<li class="action actions">
							<strong>
								<a href="javascript:void(0);" onclick="javascript:window.open('<? echo $url; ?>', 'emailwin', 'width=400,height=350,menubar=yes,resizable=yes'); return false;" title="<?php echo JText::_('EMAIL'); ?>">
									<?php
									echo JHTML::_('image', 'media/system/images/emailButton.png', JText::_('EMAIL'), array('title' => JText::_('EMAIL'), "style" => "height:13px;"), false);
									?>
								</a>
							</strong>
						</li>
						<li class="action actions">
							<strong>
								<a href="<?php echo $searchlink; ?>" title="<?php echo JText::_('JEV_SEARCH_TITLE'); ?>">
									<?php echo JHTML::_('image', 'components/com_jevents/views/ext/assets/images/icon-search.gif', JText::_('JEV_SEARCH_TITLE'), array('title' => JText::_('JEV_SEARCH_TITLE'), "style" => "height:13px;"), false) . " " . JText::_('JEV_SEARCH_TITLE'); ?>
								</a>
							</strong>
						</li>
					</ul>
				</div>
				<?php
			}
			echo '<div class="cLayout clrfix clearfix">';
		}
	}

	function onJEventsFooter()
	{
		$user = JFactory::getUser();
// if logged in then close the JomSocial stuff
		if ($user->id > 0 && $this->params->get("enablejswrap", 0))
		{

// ONLY DO THIS FOR THE JOMSOCIAL JEVENTS MENU ITEM
			$Itemid = JRequest::getInt("Itemid");
			$plugin = JPluginHelper::getPlugin('community', 'jevents');
			if (!$plugin)
				return;

			if ($this->wallid)
			{

// Load joms.ajax
				CTemplate::addScript('joms.ajax');

// Get the Wall
				CFactory::load('libraries', 'wall');
				$isAdmin = false;
				$wallContent = CWallLibrary::getWallContents('jevents', $this->wallid, $isAdmin, 10, 0, 'wall.content', 'jevents,jevents');
				$wallCount = CWallLibrary::getWallCount('jevents', $this->wallid);
				$viewAllLink = false;

				if (JRequest::getVar('task', '', 'REQUEST') != 'app')
				{
					$viewAllLink = CRoute::_('index.php?option=com_community&view=events&task=app&eventid=' . $this->wallid . '&app=walls');
				}
				$wallContent .= CWallLibrary::getViewAllLinkHTML($viewAllLink, $wallCount);

				echo $wallContent;

				$wallForm = '';
// if( !$config->get('lockeventwalls')
// || ($config->get('lockeventwalls') && ($isEventGuest) && !($waitingApproval) && $hasResponded)
// || $isCommunityAdmin )
// {
				$wallForm = CWallLibrary::getWallInputForm($this->wallid, 'jevents,ajaxSaveWall', 'jevents,ajaxRemoveWall');
// }

				echo $wallForm;
			}

			$pluginparams = new JRegistry($plugin->params);

			if (!$this->params->get("wrapall", 0) && $pluginparams->get("target_itemid", 0) != $Itemid && $this->params->get("target_itemid", 0) != $Itemid)
			{
				return;
			}

			echo " </div>"; // cLayout
			if (version_compare($this->jsversion, "4.0", ">="))
			{
				echo "</div>"; // jomsocial
			}
			echo "</div>"; // community-wrap
		}
	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	function onStoreCustomDetails($evdetail)
	{
		return true;
	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	function onStoreCustomEvent($event)
	{
		return true;
	}

	function onAfterSaveEvent($event)
	{
		if ($event->ev_id > 0 && JRequest::getInt("evid", 0) == $event->ev_id)
		{
			$cmd = "modified";
		}
		else
			$cmd = "created";

		$datamodel = new JEventsDataModel();
		$row = $datamodel->queryModel->getEventById($event->ev_id, 0, "icaldb");

		if ($this->params->get("preserveowners", 0) && isset($event->data["X-CREATEDBY"]) && intval($event->data["X-CREATEDBY"]) > 0 && (!isset($row) || $row->created_by() != $event->data["X-CREATEDBY"] ))
		{
			$db = JFactory::getDbo();
			$db->setQuery("Update #__jevents_vevent set created_by=" . intval($event->data["X-CREATEDBY"]) . " where ev_id=" . $event->ev_id);
			$db->execute();
		}
		// no stream data for private events
		if (JRequest::getInt("custom_jevuser", 0) == 1 || JRequest::getInt("custom_jevuser", 0) == 2)
		{
			return true;
		}
		$this->recordActivity($cmd, $row);

		return true;
	}

	function onDeleteEventDetails($idlist)
	{
		return true;
	}

	function onDeleteCustomEvent($idlist)
	{
		$ids = explode(",", $idlist);
		JArrayHelper::toInteger($ids);

		foreach ($ids as $id)
		{
			$this->removeActivity($id);
		}
	}

	function onDisplayCustomFields(&$row)
	{

// redirect?
		if ($this->params->get("redirectimport", 0) && strpos($row->content(), "JSE:") !== false && JRequest::getCmd("task") != 'icals.reload' && JRequest::getCmd("task") != 'icals.export' && !JFactory::getApplication()->isAdmin())
		{
			$link = $row->content();
			if (strpos($link, "JSE:<a href=") !== false)
			{
				$link = preg_replace('#JSE:<a href="(.*?)">.*#', '$1', $link);
				JFactory::getApplication()->redirect($link);
			}
			else if (strpos($link, "JSE:") !== false)
			{
				$matches = array();
				preg_match('#JSE:(.*)#', $link, $matches);
				if (count($matches) == 2)
				{
					$link = $matches[1];
					JFactory::getApplication()->redirect($link);
				}
			}
		}

// $this->wallid = $row->rp_id();

		$contact = $row->_contact;
		if (strpos($contact, "js:") === 0)
		{
			$contact = str_replace("js:", "", $contact);
			if (is_numeric($contact) || is_string($contact))
			{
				require_once ( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'defines.community.php');
				require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'error.php');
//require_once (COMMUNITY_COM_PATH.DS.'controllers'.DS.'controller.php');
				require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'apps.php' );
				require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'core.php');
				$cuser = CFactory::getUser($contact);
				if ($cuser && $cuser->id > 0)
				{
					$link = CRoute::_('index.php?option=com_community&view=profile&userid=' . $cuser->id);
					$row->_contact = "<a href='$link'>" . $cuser->name . "</a>";
				}
			}
		}
	}

	private function removeActivity($id)
	{
		if (!$this->jomsocial)
			return;
		$user = JFactory::getUser();
		if ($user->id == 0)
			return;

		require_once ( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'defines.community.php');

// Require the base controller
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'error.php');
		require_once (COMMUNITY_COM_PATH . DS . 'controllers' . DS . 'controller.php');
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'apps.php' );
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'core.php');
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'template.php');
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'userpoints.php');
		require_once (COMMUNITY_COM_PATH . DS . 'views' . DS . 'views.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'url.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'ajax.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'time.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'owner.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'azrul.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'string.php');

		//CuserPoints::assignPoint('event.delete');

		if (!$this->params->get("enablestreams", 1))
			return;
		CFactory::load('libraries', 'activities');

		CActivityStream::remove('jevents', $id);
	}

	private function recordActivity($cmd, $event)
	{

		if (!$this->jomsocial)
			return;
		$user = JFactory::getUser();
		if ($user->id == 0)
			return;
		if (!$event)
		{
			return;
		}

		require_once ( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'defines.community.php');

// Require the base controller
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'error.php');
		require_once (COMMUNITY_COM_PATH . DS . 'controllers' . DS . 'controller.php');
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'apps.php' );
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'core.php');
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'template.php');
		require_once (COMMUNITY_COM_PATH . DS . 'libraries' . DS . 'userpoints.php');
		require_once (COMMUNITY_COM_PATH . DS . 'views' . DS . 'views.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'url.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'ajax.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'time.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'owner.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'azrul.php');
		require_once (COMMUNITY_COM_PATH . DS . 'helpers' . DS . 'string.php');

		if ($cmd == "created")
		{
			CuserPoints::assignPoint('event.create');
		}

		if (!$this->params->get("enablestreams", 1))
			return;

		CFactory::load('libraries', 'activities');

		list($year, $month, $day) = JEVHelper::getYMD();

		$mainframe = JFactory::getApplication('site');
		if ($mainframe->isAdmin())
		{
// force the check on menu items
			$menuid = $this->params->get("target_itemid", JEVHelper::getItemid($event));
			$link = $event->viewDetailLink($year, $month, $day, false, $menuid);
			$link = JURI::root() . $link;
		}
		else
		{
			$link = JRoute::_($event->viewDetailLink($year, $month, $day, false));
			if (strpos($link, "/") !== 0)
			{
				$link = "/" . $link;
			}
			$uri = JURI::getInstance(JURI::base());
			$root = $uri->toString(array('scheme', 'host', 'port'));

			$link = $root . $link;
		}


		if ($cmd == "created")
		{
			$title = JText::sprintf("JSSTREAM_EVENT_CREATED", $link, $event->title());
		}
		else
		{
			$title = JText::sprintf("JSSTREAM_EVENT_UPDATED", $link, $event->title());
		}
		$act = new stdClass();
		$act->cmd = $cmd;

// Do we really want to do this? What if editors are changing an event
		$creatorid = JRequest::getInt("jev_creatorid", 0);
		if ($creatorid > 0)
		{
			$user = JEVHelper::getUser($creatorid);
		}
		$act->actor = $user->id;
		$act->target = 0;
		$act->title = $title;
		$act->content = "";
		$act->app = "jevents";
		$act->cid = $event->ev_id();

// set access
// 0-10 everyone
// 20 logged in users
// 30 actor and friends
// 40 actor only
		if ($event->access() > 0)
		{
			$act->access = 20;
		}

		$privateevent = JRequest::getInt("custom_jevuser", 0);
		switch ($privateevent)
		{
			case 0:
// public event
				break;
			case 1:
// private event
				$act->access = 40;
				break;
			case 2:
// Jom social friends
				$act->access = 30;
				break;
			case 3:
// details private
				break;
			case 4:
// JomSocial Groups
// No specific rule available for this
				$act->access = 30;
				break;
			case 5:
			case 6:
// Group Jive or CB Connections
				break;
		}

		CActivityStream::add($act);
	}

	static function fieldNameArray($layout = 'detail')
	{
		// only offer in detail view ?
		//if ($layout != "detail")	return array();

		$return = array();
		$return['group'] = JText::_("JEV_JOMSOCIAL", true);

		$labels = array();
		$values = array();
		$labels[] = JText::_("JEV_CREATOR_AVATAR", true);
		$values[] = "JOMSOCIAL_AVATAR";
		$labels[] = JText::_("JEV_CREATOR_MESSAGE", true);
		$values[] = "JOMSOCIAL_PM";
		$labels[] = JText::_("JEV_CREATOR_FULLAVATAR", true);
		$values[] = "JOMSOCIAL_FULLAVATAR";
		$labels[] = JText::_("JEV_CREATOR_AVATAR_LINK", true);
		$values[] = "JOMSOCIAL_AVLINK";
		$labels[] = JText::_("JEV_CREATOR_LINK", true);
		$values[] = "JOMSOCIAL_LINK";
		$labels[] = JText::_("JEV_CREATOR_NAME", true);
		$values[] = "JOMSOCIAL_NAME";

		$labels[] = JText::_("JEV_JOMSOCIAL_FIELD", true);
		$values[] = "JOMSOCIAL_FIELD;FIELD_GENDER";

		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;
	}

	static function substitutefield($row, $code)
	{
		if (isset($row->hidedetail) && $row->hidedetail)
		{
			return "";
		}

		if ($code == "JOMSOCIAL_AVATAR")
		{
			if ($row->created_by() > 0)
			{
				require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
				$jsuser = CFactory::getUser($row->created_by());
				$avatarImgPath = $jsuser->getThumbAvatar();
				return "<img src='$avatarImgPath' alt='avatar' />";
			}
		}
		else if ($code == "JOMSOCIAL_FULLAVATAR")
		{
			if ($row->created_by() > 0)
			{
				require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
				$jsuser = CFactory::getUser($row->created_by());
				$avatarImgPath = $jsuser->getAvatar();
				return "<img src='$avatarImgPath' alt='avatar' />";
			}
		}
		else if ($code == "JOMSOCIAL_NAME")
		{
			if ($row->created_by() > 0)
			{
				require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
				$jsuser = CFactory::getUser($row->created_by());
				$name = $jsuser->getDisplayName();
				return $name;
			}
		}
		else if ($code == "JOMSOCIAL_AVLINK")
		{
			if ($row->created_by() > 0)
			{
				require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
				$jsuser = CFactory::getUser($row->created_by());
				$avatarImgPath = $jsuser->getThumbAvatar();
				$Itemid = JRequest::getInt("Itemid");
				$jslink = CRoute::_('index.php?option=com_community&view=profile&userid=' . $jsuser->id);
				return "<a href='" . $jslink . "'><img src='$avatarImgPath' alt='avatar' /></a>";
			}
		}
		else if ($code == "JOMSOCIAL_LINK")
		{
			if ($row->created_by() > 0)
			{
				require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
				$jsuser = JEVHelper::getUser($row->created_by());
				$Itemid = JRequest::getInt("Itemid");
				$jslink = CRoute::_('index.php?option=com_community&view=profile&userid=' . $jsuser->id);
				return "<a href='" . $jslink . "'>" . $jsuser->name . "</a>";
			}
		}
		else if (strpos($code, "JOMSOCIAL_FIELD;") === 0)
		{
			list($code, $field) = explode(";", $code);
			require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
			$jsuser = CFactory::getUser($row->created_by());
			$info = $jsuser->getInfo($field);
			// does it need translation?
			if (is_string($info) && JText::_($info) !== $info)
			{
				return JText::_($info);
			}
			return $info;
		}
		else if ($code == "JOMSOCIAL_PM")
		{
			if ($row->created_by() > 0)
			{
				require_once( JPATH_SITE . '/components/com_community/libraries/core.php');
				$jsuser = CFactory::getUser($row->created_by());


				CAssets::getInstance();

				return '<a href="javascript:" class="joms-button--neutral joms-button--small" onclick="joms.api.pmSend(\'' . $jsuser->id . '\');">'
					. JText::_("JEV_CREATOR_MESSAGE") . "</a>";

			}
		}



		return "";
	}

	/*
	  static function fieldNameArray($layout='detail'){
	  // only offer in detail view
	  if ($layout != "detail") return array();

	  $return = array();
	  $return['group'] = JText::_("JEV_JOMSOCIAL",true);

	  $labels = array();
	  $values = array();
	  $labels[] = JText::_("JEV_TAG_SUMMARY",true);
	  $values[] = "JEV_TAG";

	  $labels[] = JText::_("JEV_TAG_NOLABEL",true);
	  $values[] = "JEV_TAG_NOLABEL";

	  $return['values'] = $values;
	  $return['labels'] = $labels;

	  return $return;
	  }

	  static function substitutefield($row, $code){
	  if ($code == "JEV_TAG"){
	  if (isset($row->_jevtagstext)) return $row->_jevtagstext;
	  }
	  if ($code == "JEV_TAG_NOLABEL"){
	  if (isset($row->_jevtagsraw)) return $row->_jevtagsraw;
	  }


	  return "";
	  }
	 */
	private function getActiveLink()
	{
		$url = 'index.php?';
		$segments = & $_GET;

		$i = 1;
		foreach ($segments as $key => $value)
		{
			// Do not check against Itemid, format and userid as they may be different.
			if ($key == 'option' || $key == 'view')
			{
				$url .= $i > 1 ? '&' : '';
				$url .= $key . '=' . $value;
				$i++;
			}
		}

		return $url;
	}

}
