<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Version;

jimport('joomla.plugin.plugin');
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

class plgJEventsJevmatchingevents extends CMSPlugin
{

	public function onDisplayCustomFields(&$row)
	{

		if (!$row->ev_id())
		{
			return;
		}

		$row->_jevmatches        = $this->getMatchingEvents($row, $this->params->get("matchby", array("id")));
		$row->_jevmatch_criteria = $this->params->get("matchby", array("id"));
		if (!is_array($row->_jevmatch_criteria))
		{
			$row->_jevmatch_criteria = array($row->_jevmatch_criteria);
		}

		return $row->_jevmatches;

	}


	public function onDisplayCustomFieldsMultiRow(&$rows)
	{
		if (!$this->params->set("inlists", 0))
		{
			return;
		}
		static $processed = array();
		$rows_count = count($rows);

		for ($i = 0; $i < $rows_count; $i++)
		{

			$row = $rows[$i];
			// must avoid recursion
			if (isset($processed[$row->ev_id()]))
			{
				if (!isset($row->_jevmatches) && $processed[$row->ev_id()] !== 1)
				{
					$row->_jevmatches = $processed[$row->ev_id()];
				}
				continue;
			}
			// avoid recursion before we get the results even!
			$processed[$row->ev_id()] = 1;
			$this->onDisplayCustomFields($row);
			$processed[$row->ev_id()] = isset($row->_jevmatches) ? $row->_jevmatches : 1;
		}
	}


	public function getMatchingEvents(&$row, $criterias, $fieldnames = "")
	{


		if (!is_array($criterias))
		{
			$criterias = array($criterias);
		}
		require_once(JPATH_SITE . "/modules/mod_jevents_latest/helper.php");

		$jevhelper = new modJeventsLatestHelper();
		$theme     = JEV_CommonFunctions::getJEventsViewName();

		$extras = array();
		PluginHelper::importPlugin("jevents");

		if (!$criterias)
			return "";

		if (!is_array($criterias))
		{
			$criteriaArray[] = $criterias;
			unset($criterias);
			$criterias = $criteriaArray;
			unset($criteriaArray);
		}

		foreach ($criterias as $criteria)
		{
			$extra = new stdClass();
			if ($criteria == "tags")
			{
				if (!isset($row->matchedtaglist))
				{
					$user = Factory::getUser();
					$db   = Factory::getDbo();
					$sql  = "SELECT tg.tag_id, tg.title FROM #__jev_tageventsmap as tem
			LEFT JOIN #__jev_tags as tg ON tem.tag_id = tg.tag_id
			WHERE ev_id=" . $row->ev_id() . " AND tg.published=1 AND tg.access" . (version_compare(JVERSION, '1.6.0', '>=') ? ' IN (' . JEVHelper::getAid($user) . ')' : ' <=  ' . JEVHelper::getAid($user));
					$db->setQuery($sql);
					$row->matchedtaglist = $db->loadObjectList('tag_id');
				}

				if (count($row->matchedtaglist) > 0)
				{

					$tags = array();
					foreach ($row->matchedtaglist as $tag)
					{
						$tags[] = $tag->tag_id;
					}
					$extra->criteria = "jevmetag";
					$extra->tags     = $tags;
					$extras[]        = $extra;
				}
			}
			else if ($criteria == "id")
			{
				if ($row->hasRepetition())
				{
					$extra->criteria = "jevmeid";
					$extra->match    = $row->ev_id();
					$extras[]        = $extra;
				}
			}
			else if ($criteria == "title")
			{
				$extra->criteria = "jevmetit";
				$extra->id       = $row->ev_id();
				$extra->title    = $row->title();
				$extras[]        = $extra;
			}
			else if ($criteria == "custom" && $fieldnames !== "")
			{
				// Are we matching specific fieldname?
				$fieldnamesarray = !empty($fieldnames) ? explode(",", $fieldnames) : array();

				static $cfversion;
				if (!isset($cfversion))
				{
					$db    = Factory::getDbo();
					$query = $db->getQuery(true)
						->select('manifest_cache')
						->from('#__extensions')
						->where('type =' . $db->quote('plugin'))
						->where('folder =' . $db->quote('jevents'))
						->where('element =' . $db->quote('jevcustomfields'));
					$db->setQuery($query);
					$manifestcache = $db->loadResult();

					if (!$manifestcache)
					{
						\Joomla\CMS\Factory::getApplication()->enqueueMessage( 'You are attempting to match events based on custom fields values but have not installed the custom fields addon!', "warning");
						$cfversion = false;
					}
					else
					{
						$manifestcache = json_decode($manifestcache, true);
						$cfversion     = $manifestcache["version"];
					}
				}

				if (!isset($row->matchedcflist))
				{
					static $matchfields;
					static $firstmatchfield;
					if (!isset($matchfields))
					{
						$matchfields     = array();
						$firstmatchfield = array();
					}
					if (!isset($matchfields[$fieldnames]))
					{
						$matchfields = array();
						static $pluginparams;
						if (!isset($pluginparams))
						{
							$cfplugin = PluginHelper::getPlugin("jevents", "jevcustomfields");
							if (!$cfplugin) return "";
							$cfpluginparams = new Registry($cfplugin->params);
						}

						$template     = $cfpluginparams->get("template", "");
						$customfields = array();
						if ($template != "")
						{
							$xmlfile = JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/templates/" . $template;
							if (file_exists($xmlfile))
							{
								$db              = Factory::getDbo();

								JLoader::register('JevCfForm', dirname(__FILE__) . "/customfields/jevcfform.php");

								$cfparams = JevCfForm::getInstance("com_jevent.customfields", $xmlfile, array('control' => 'jform', 'load_data' => true), true, "/form");
								$cfparams->setEvent(null);

								$customfields = array();
								$groups       = $cfparams->getFieldsets();
								foreach ($groups as $group => $fieldset)
								{
									$count = $cfparams->getFieldCountByFieldSet($group);
									if (!$count) continue;
									$groupparams = $cfparams->getFieldset($group);
									foreach ($groupparams as $p => $node)
									{
										if (!$node->attribute('matchevents'))
										{
											continue;
										}
										if (count($fieldnamesarray) > 0 && !in_array($node->attribute("name"), $fieldnamesarray))
										{
											continue;
										}
										$matchfields[$fieldnames][]   = "cf.name=" . $db->Quote($node->attribute("name"));
										$firstmatchfield[$fieldnames] = $node->attribute("name");
									}
								}

							}
						}
					}

					$db  = Factory::getDbo();
					$sql = "SELECT cf.id, cf.value, cf.name FROM #__jev_customfields as cf
			WHERE evdet_id=" . $row->_detail_id;
					if (isset($matchfields[$fieldnames]) && count($matchfields[$fieldnames]) > 0)
					{
						// match all fields or just anys of them
						$sql .= " AND (" . implode(" OR ", $matchfields[$fieldnames]) . ")";

						$db->setQuery($sql);
						$row->matchedcflist = $db->loadObjectList('id');
					}
					else
					{
						$row->matchedcflist = array();
					}
				}

				if (count($row->matchedcflist) == 0)
				{
					// if no custom field values then we should be matching no events!
					if (isset($firstmatchfield[$fieldnames]) && count($fieldnamesarray) > 0)
					{
						$dummyCustomField        = new stdClass();
						$dummyCustomField->ev_id = $row->ev_id();
						$dummyCustomField->name  = $fieldnamesarray[0];
						$dummyCustomField->value = 'somknolivunwk34ufhsudnv08374nb.kljsndf0v7n3p4ot';

						if ($this->params->get("skipblank", 1) && isset($dummyCustomField))
						{
							$extra->criteria     = "jevmecf";
							$extra->customfields = array($dummyCustomField);
							$extras[]            = $extra;
						}
					}
				}

				$customfields = array();
				foreach ($row->matchedcflist as $cf)
				{
					$customField = new stdClass();
					// some sites will want to NOT match blank values


					if ($this->params->get("skipblank", 1) && trim($cf->value) == "")
					{
						$dummyCustomField        = new stdClass();
						$dummyCustomField->ev_id = $row->ev_id();
						$dummyCustomField->name  = $cf->name;
						$dummyCustomField->value = 'somknolivunwk34ufhsudnv08374nb.kljsndf0v7n3p4ot';
						continue;
					}

					$customField->ev_id = $row->ev_id();
					$customField->name  = $cf->name;
					$customField->value = $cf->value;
					$customfields[]     = $customField;
				}

				if (count($customfields) > 0)
				{
					$extra->criteria     = "jevmecf";
					$extra->customfields = $customfields;
					$extras[]            = $extra;
				}

				if ($this->params->get("skipblank", 1) && isset($dummyCustomField))
				{
					$extra->criteria     = "jevmecf";
					$extra->customfields = array($dummyCustomField);
					$extras[]            = $extra;
				}

			}
			else if ($criteria == "category")
			{
				// lock the categories!
				$this->params->set("lockcategory", 1);
				$extra->criteria = "jevmecat";
				$extras[]        = $extra;
			}
			else if ($criteria == "location")
			{
				$extra->criteria = "jevmeloc";
				if (!$row->_jevlocation)
				{
					$extra->match = $row->_location;
				}
				else
				{
					$extra->match = $row->_jevlocation->loc_id;
				}
				$extras[] = $extra;
			}
			else if ($criteria == "creator")
			{
				$extra->criteria = "jevmecreator";
				$extra->match    = $row->_created_by;
				$extras[]        = $extra;
			}
		}

		if (empty($extras))
		{
			return "";
		}

		$criteriaParam = new stdClass();

		$criteriaParam->ev_id   = $row->ev_id();
		$criteriaParam->rp_id   = $row->_rp_id;
		$criteriaParam->matches = $extras;

		$this->params->set("jevmecriteria", json_encode($criteriaParam));

		if ($this->params->get("lockcategory", 0))
		{
			$params = ComponentHelper::getParams("com_jevents");
			if ($params->get("multicategory", 0))
			{
				$this->params->set("catids", implode(",", $row->catids()));
			}
			else
			{
				$this->params->set("catid", $row->catid());
			}
		}

		$input  = Factory::getApplication()->input;
		$Itemid = $input->getInt("Itemid");
		$option = $input->getCmd("option");
		if ($option == "com_jevents")
		{
			$this->params->set("target_itemid", $Itemid);
		}

		$reg       = Factory::getConfig();
		$modparams = $reg->set("jev.modparams", $this->params);

		$registry      = JevRegistry::getInstance("jevents");
		$activeprocess = $registry->set("jevents.activeprocess", "mod_jevents_latest");
		$moduleparams  = $registry->set("jevents.moduleparams", $modparams);

		$theme = $this->params->get('com_calViewName');
		if ($theme == "" || $theme == "global")
		{
			$theme = JEV_CommonFunctions::getJEventsViewName();;
		}
		$viewclass = $jevhelper->getViewClass($theme, 'mod_jevents_latest', $theme . "/latest", $this->params);
		$modview   = new $viewclass($this->params, 0);
		$matches   = $modview->displayLatestEvents();

		if ($this->params->get("hideempty", 0))
		{
			if (trim(strip_tags($matches)) == trim(Text::_('JEV_NO_EVENTS')))
			{
				$matches = "";
			}
		}

		$reg->set("jev.modparams", false);

		return $matches;
	}

	public function onListIcalEvents(&$extrafields, &$extratables, &$extrawhere, &$extrajoin, &$needsgroupdby = false)
	{
		if (Factory::getApplication()->isClient('administrator'))
		{
			return;
		}

		// Find what is running - used by the filters
		$registry      = JevRegistry::getInstance("jevents");
		$activeprocess = $registry->get("jevents.activeprocess", "");
		$moduleid      = $registry->get("jevents.moduleid", 0);
		$moduleparams  = $registry->get("jevents.moduleparams", false);

		// default is to only show all events
		$extraval = "";
		if ($activeprocess == "mod_jevents_latest")
		{
			$extraval = $moduleparams->get("jevmecriteria", "");
		}

		if (!$extraval)
			return "";

		$criteriaParam = json_decode($extraval);
		$ev_id         = $criteriaParam->ev_id;
		$rp_id         = $criteriaParam->rp_id;
		$criterias     = $criteriaParam->matches;
		$extrawhere1   = array();
		$evidWhere     = false;
		$meExtraWhere  = "";
		$db            = Factory::getDbo();

		foreach ($criterias as $criteria)
		{
			if (!isset($criteria->criteria))
				continue;
			switch ($criteria->criteria)
			{
				case "jevmeid":
					$ev_id         = $criteria->match;
					$extrawhere1[] = " ev.ev_id = " . $ev_id;
					$needsgroupdby = true;
					break;
				case "jevmecreator":
					$ev_creator_id = $criteria->match;
					$extrawhere1[] = " ev.created_by = " . $ev_creator_id;
					$needsgroupdby = true;
					break;
				case "jevmeloc":
					$idLocation    = $criteria->match;
					$extrawhere1[] = " det.location = " . $db->Quote($idLocation);
					$needsgroupdby = true;
					break;
				case "jevmetit":
					$evtit = $criteria->title;

					$extrawhere1[] = " det.summary = " . $db->Quote($evtit);
					$needsgroupdby = true;
					break;
				case "jevmetag":
					$idTags = $criteria->tags;
					if ($this->params->get('tagsmatch', 0))
					{
						foreach ($idTags as $tagIndex => $idTag)
						{
							$extrajoin[] = "#__jev_tageventsmap AS jevmetagmap" . $tagIndex . " ON ev.ev_id = jevmetagmap" . $tagIndex . ".ev_id";
							$tagsWhere[] = "(jevmetagmap" . $tagIndex . ".tag_id = " . $idTag . ")";
						}
						$extrawhere1[] = '( ' . implode(' AND ', $tagsWhere) . ' ) ';

					}
					else
					{
						$extrawhere1[] = "jevmetagmap.tag_id IN (" . implode(",", $idTags) . ")";
						$extrajoin[]   = " #__jev_tageventsmap as jevmetagmap ON jevmetagmap.ev_id = ev.ev_id ";
					}

					$needsgroupdby = true;
					break;
				case "jevmecf":
					$db   = Factory::getDbo();
					$evcf = $criteria->customfields;
					if (empty($evcf))
						break;

					if (count($evcf) > 0)
					{
						$db      = Factory::getDbo();
						$cfWhere = array();
						if ($this->params->get('custommatch', 0))
						{
							$cfIndex = 0;
							foreach ($evcf as $k => $customField)
							{
								$extrajoin[]   = "#__jev_customfields AS jevmecf" . $cfIndex . " ON det.evdet_id=jevmecf" . $cfIndex . ".evdet_id";
								$extrawhere1[] = "(jevmecf" . $cfIndex . ".name = " . $db->Quote($customField->name) . " AND jevmecf" . $cfIndex . ".value = " . $db->Quote($customField->value) . " AND jevmecf" . $cfIndex . ".evdet_id IS NOT NULL)";
								$cfIndex++;
							}
						}
						else
						{
							$extrajoin[] = "#__jev_customfields AS jevmecf ON det.evdet_id=jevmecf.evdet_id";

							foreach ($evcf as $k => $customField)
							{
								$cfWhere[] = "(jevmecf.name = " . $db->Quote($customField->name) . " AND jevmecf.value = " . $db->Quote($customField->value) . ")";
							}
							$extrawhere1[] = '( ' . implode(' OR ', $cfWhere) . ' ) ';
						}


						$needsgroupdby = true;
					}
					break;

			}
		}

		if (!$moduleparams->get("showownrepeat", 0))
		{
			$evidWhere = " rpt.rp_id <> " . $rp_id;
		}

		if ($moduleparams->get("lockcategory", 0))
		{
			$params = ComponentHelper::getParams("com_jevents");
			if ($params->get("multicategory", 0))
			{
				$extrawhereCategory = " catmap.catid IN (" . $moduleparams->get("catids", 0) . ")";
			}
			else
			{
				$extrawhereCategory = " ev.catid = " . $moduleparams->get("catid", 0);
			}
		}

		if (!empty($extrawhere1))
		{
			if ($moduleparams->get('jevmultimatch', 0))
			{
				$meExtraWhere = "(" . implode(" AND ", $extrawhere1);
				if ($evidWhere)
				{
					$meExtraWhere .= " AND " . $evidWhere . ")";
				}
				else
				{
					$meExtraWhere .= ")";
				}

			}
			else
			{
				$meExtraWhere = "(" . implode(" OR ", $extrawhere1);
				if ($evidWhere)
				{
					$meExtraWhere .= " AND " . $evidWhere . ")";
				}
				else
				{
					$meExtraWhere .= ")";
				}
			}
		}

		if (isset($extrawhereCategory))
		{
			if (!empty($meExtraWhere))
			{
				$meExtraWhere .= " AND ";
			}
			$meExtraWhere .= $extrawhereCategory;
		}

		if (!empty($meExtraWhere))
		{
			$extrawhere[] = $meExtraWhere;
		}

		return true;

	}

	public static function fieldNameArray($layout = 'detail')
	{
		//Call the params again as we are a static function we cannot use $this.
		$plugin = PluginHelper::getPlugin('jevents', 'jevmatchingevents');
		$params = new Registry($plugin->params);

		// only offer in detail view
		if ($layout != "detail" && !$params->get("inlists", 0))
			return array();

		$labels   = array();
		$values   = array();
		$labels[] = Text::_("JEV_MATCHING_EVENTS", true);
		$values[] = "JEV_MATCHING";

		$labels[] = Text::_("JEV_MATCHING_ID", true);
		$values[] = "JEV_MATCHING_ID";

		$labels[] = Text::_("JEV_MATCHING_TITLE", true);
		$values[] = "JEV_MATCHING_TITLE";

		$labels[] = Text::_("JEV_MATCHING_CUSTOMFIELDS", true);
		$values[] = "JEV_MATCHING_CF";

		$labels[] = Text::_("JEV_MATCHING_SPECIFIC_CUSTOMFIELD", true);
		$values[] = "JEV_MATCHING_CF;fieldname";

		$labels[] = Text::_("JEV_MATCHING_TAGS", true);
		$values[] = "JEV_MATCHING_TAGS";

		$labels[] = Text::_("JEV_MATCHING_CATEGORY", true);
		$values[] = "JEV_MATCHING_CATEGORY";

		$labels[] = Text::_("JEV_MATCHING_LOCATION", true);
		$values[] = "JEV_MATCHING_LOCATION";

		$labels[] = Text::_("JEV_MATCHING_CREATOR", true);
		$values[] = "JEV_MATCHING_CREATOR";

		$return           = array();
		$return['group']  = Text::_("JEV_MATCHING_EVENTS", true);
		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;

	}

	public static function substitutefield($row, $code)
	{
		if (isset($row->hidedetail) && $row->hidedetail)
		{
			return "";
		}
		$rawcode = $code;

		$criteria = $row->_jevmatch_criteria;

		if ($code == "JEV_MATCHING")
		{
			if (isset($row->_jevmatches) && $row->_jevmatches != "")
			{
				return $row->_jevmatches;
			}
			else
			{
				return "";
			}
		}
		else
		{
			$code = str_replace("JEV_MATCHING_", "", $code);

			// specific custom field match
			if (strpos($code, ";") > 0)
			{
				list($code, $fieldnames) = explode(";", $code);
			}
			else
			{
				$fieldnames = "";
			}

			$codes = explode("_", $code);

			if (count($codes) == count($criteria) && !empty($fieldnames))
			{
				$allMatch = true;
				foreach ($codes as $code)
				{
					if (!in_array($code, $criteria))
					{
						$allMatch = false;
						break;
					}
				}
				if ($allMatch)
				{
					if (isset($row->_jevmatches) && $row->_jevmatches != "")
					{
						return $row->_jevmatches;
					}
				}
			}

			$criteria = array();
			foreach ($codes as $code)
			{
				if ($code == "ID")
				{
					$criteria[] = "id";
				}
				else if ($code == "TITLE")
				{
					$criteria[] = "title";
				}
				else if ($code == "TAGS")
				{
					$criteria[] = "tags";
				}
				else if ($code == "CF")
				{
					$criteria[] = "custom";
				}
				else if ($code == "CATEGORY")
				{
					$criteria[] = "category";
				}
				else if ($code == "LOCATION")
				{
					$criteria[] = "location";
				}
				else if ($code == "CREATOR")
				{
					$criteria[] = "creator";
				}
			}

			if (!empty($criteria))
			{

				$plugin     = PluginHelper::getPlugin('jevents', 'jevmatchingevents');

				$jversion = new Version;
				if ($jversion->isCompatible('4.0'))
				{
					$app        = Factory::getApplication();
					$component  = $app->bootComponent('com_jevents');
					$dispatcher = $component->getDispatcher($app);
				}
				else
				{
					$dispatcher = JEventDispatcher::getInstance();
				}

				$plugin     = new plgJEventsJevmatchingevents($dispatcher, array("params" => $plugin->params));

				$oldmatchedtaglist = $row->matchedtaglist;
				$oldmatchedcflist  = $row->matchedcflist;
				unset($row->matchedtaglist);
				unset($row->matchedcflist);

				$results = $plugin->getMatchingEvents($row, $criteria, $fieldnames);

				$row->matchedtaglist = $oldmatchedtaglist;
				$row->matchedcflist  = $oldmatchedcflist;

				return $results;
			}
		}

		return "";
	}

}

