<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod.defines.php 1400 2009-03-30 08:45:17Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgJEventsJevmissingevent extends JPlugin
{

	function onMissingEvent(& $row, $rpid, $jevtype, $year, $month, $day, $uid)
	{
		//Load jinput
		$jinput = JFactory::getApplication()->input;

		// ALREADY FOUND THE EVENT so this exercise is redundance
		if ($row)
		{
			return true;
		}

		// already redirected
		if ( $jinput->getInt("rde", 0) )
		{
			return true;
		}

		// Not in the backend !!!
		if (JFactory::getApplication()->isAdmin())
		{
			return true;
		}

		// MUST AVOID RECURSION - and also store the active menu item in case we don't have any success
		static $menuitem;
		if (isset($menuitem))
		{
			return true;
		}
		$Itemid = $jinput->getInt("Itemid");
		$menuitem = $Itemid;

		$menu =  JFactory::getApplication()->getMenu();

		$jevitems = $menu->getItems("component", JEV_COM_COMPONENT);
		// TODO second level Check on enclosing categories and other constraints
		if (count($jevitems) > 0)
		{
			$user =  JFactory::getUser();
			foreach ($jevitems as $jevitem)
			{
				// no need to check current menu item
				if ($Itemid == $jevitem->id)
				{
					continue;
				}

				// can we access this menu item?
				if (version_compare(JVERSION, '1.6.0', '>=') ? in_array($jevitem->access, JEVHelper::getAid($user, 'array')) : JEVHelper::getAid($user) >= $jevitem->access)
				{
					//if ($user->aid>=$jevitem->access){
					// pretend we are on a different menu item.
					$Itemid = $jevitem->id;

					// set active menu item too
					$menu->setActive($jevitem->id);

					// must also set the component parameters to match this menu item
					$pmenu = JFactory::getApplication()->getMenu()->getActive();
					if (!$pmenu || !isset($pmenu->params))
					{
						continue;
					}
					$component =  JComponentHelper::getComponent(JEV_COM_COMPONENT);
					$component->params = $pmenu->params;

					$dataModel = new JEventsDataModel();
					$this->setupComponentCatids($dataModel, $jevitem->id);

					$registry = JRegistry::getInstance("jevents");
					$activeprocess = $registry->set("jevents.activeprocess", "missingevent");
					$moduleid = $registry->set("jevents.moduleid", "missingevent" . $Itemid);
					 $registry->set("getnewfilters",1);

					// can we get this item from here
					$testevent = $dataModel->getEventData($rpid, $jevtype, $year, $month, $day);

					if ($testevent && isset($testevent["row"]))
					{
						$rawlink = $testevent["row"]->viewDetailLink($year, $month, $day, false, $jevitem->id);
						// support RSVP Pro
						if ($em = $jinput->getString("em", ""))
						{
							$rawlink .= "&em=" . $em;
						}
						if ($em2 = $jinput->getString("em2", ""))
						{
							$rawlink .= "&em2=" . $em2;
						}
						// stop multiple redirects
						$rawlink .= "&rde=1";
						$link = JRoute::_($rawlink);
						JFactory::getApplication()->redirect($link, false);
					}
				}
			}
		}
                // failure
                if ($this->params->get("missing404",0)){
                    throw new Exception(JText::_("Event not found"), 404);
                }
	}

	// Custom version to ensure static values are ignored!
	private function setupComponentCatids(&$datamodel, $itemid)
	{
		$datamodel->myItemid = $itemid;

		$menu =  JFactory::getApplication()->getMenu();
		$active = $menu->getActive();
		$params = $menu->getParams($itemid);

		$datamodel->catids = array();
		$datamodel->catidList = "";

		// New system
		$newcats = $params->get("catidnew", false);
		if ($newcats && is_array($newcats))
		{
			foreach ($newcats as $newcat)
			{
				if (!in_array($newcat, $datamodel->catids))
				{
					$datamodel->catids[] = $newcat;
				}
			}
		}
		// hardening!
		$datamodel->catidList = JEVHelper::forceIntegerArray($datamodel->catids, true);

		// some functions e.g. JEventCal::viewDetailLink don't have access to a datamodel so set a global value
		// as a backup
		global $catidsOut;
		$catidsOut = $datamodel->catidsOut;

	}

}
