<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * Based on custom fields jevtemplate field type
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.html.html');
jimport('joomla.form.formfield');

class JFormFieldjevsetup extends JFormField
{

    // the no shipping category name
    private $catname = 'Event Tokens';
    private $catdesc = 'Tokens to purchase that allow user to create events';
    // the product type name
    private $productname = 'Event Creation';
    private $product_s_desc = 'Event Token - To allow event creation.';
    private $product_desc = '<p>This product type controls the number of events that can be submitted or the time window in which events can be submitted.</p>';
    private $psku = 'event-creation';
    private $pslug = 'event-creation';
    private $pid = 0;
    private $catid = 0;

    protected function getInput()
    {
        return "";

    }

    protected function getLabel()
    {
        JFactory::getLanguage()->load('plg_jevents_jevpaidsubs', JPATH_ADMINISTRATOR);
        $this->setupPlugin();
        return "";

    }

    private function setupPlugin()
    {
        $db = JFactory::getDBO();

        // get the VM configuration
        $query = ' SELECT `config` FROM `#__virtuemart_configs` WHERE `virtuemart_config_id` = "1";';
        $db->setQuery($query);
        $configraw = $db->loadResult();
        $pair = array();
        $config = explode('|', $configraw);
        foreach ($config as $item) {
            $item = explode('=', $item);
            if (!empty($item[1])) {
                if ($item[0] !== 'offline_message' && $item[0] !== 'dateformat') {
                    $pair[$item[0]] = unserialize($item[1]);
                } else {
                    if (strpos($item[1], ":") === false) {
                        $pair[$item[0]] = unserialize(base64_decode($item[1]));
                    } else {
                        $pair[$item[0]] = unserialize($item[1]);
                    }
                }
            } else {
                $pair[$item[0]] = '';
            }
        }
        $this->vmconfig = $pair;


        // get the VM language info
        $this->vmlang_selector = $this->vmconfig["vmlang_js"];
        $this->vmlang = $this->vmconfig["active_languages"][$this->vmlang_selector];
        if (isset($this->vmconfig["active_languages"])) {
            $this->vmlangs = $this->vmconfig["active_languages"];
        } else {
            $this->vmlangs = array($this->vmlang);
        }

        $this->vmlang = str_replace("-", "_", strtolower($this->vmlang));

        $user = JFactory::getUser();

        $timestamp = new JDate();
        $timestamp = $timestamp->toSql();

        // get the plugin parameters (even if plugin is not enabled!!)
        $db->setQuery("select params from #__extensions where type='plugin' and element='jevpaidsubs' and folder='jevents' ");
        $params = $db->loadResult();
        $this->pluginParams = new JRegistry($params);

        $this->catid = $this->pluginParams->get("paidsubscat", 0);
        $cat = false;
        if ($this->catid) {
            $db->setQuery("SELECT * FROM #__virtuemart_categories WHERE virtuemart_category_id = '$this->catid'");
            $cat = $db->loadObject();
        }

        if (!$cat)
        {
            // we have no 'no shipping' category so create one
            $vmcat = new JTableVMCategory($db);
            $vmcat->virtuemart_category_id = 0;
            $vmcat->virtuemart_vendor_id = 1;
            //$vmcat->category_name = $this->catname;
            //$vmcat->slug = $this->catslug;
            //$vmcat->category_description = $this->catdesc;
            $vmcat->category_template = "";
            $vmcat->category_layout = "";
            $vmcat->category_product_layout = "";
            $vmcat->products_per_row = 4;
            $vmcat->ordering = 9999;
            $vmcat->published = 1;
            $vmcat->created_on = $timestamp;
            $vmcat->modified_on = $timestamp;
            $success = $vmcat->store();
            if (!$success)
                return;
            $cat_slug = strtolower(str_replace(' ', '-', $this->catname));
            $this->insertVmLanguageValues("#__virtuemart_categories", array("virtuemart_category_id", "category_name", "category_description", "metadesc", "metakey", "customtitle", "slug"), array($vmcat->virtuemart_category_id, $this->catname, $this->catdesc, '', '', '', $cat_slug));
            $catid = $vmcat->virtuemart_category_id;
            $this->pluginParams->set("paidsubscat", $catid);
            $db->setQuery("update #__extensions set params = " . $db->quote((string) $this->pluginParams) . " where type='plugin' and element='jevpaidsubs' and folder='jevents' ");
            //TODO Update to J3.4 compatibility
            $db->query();
            if (!$db->getErrorMsg())
            {
                $uri = JURI::getInstance();
                JFactory::getApplication()->redirect((string) $uri);
            }
        }
        else
        {
            $vmcat = new JTableVMCategory($db);
            $vmcat->load($cat->virtuemart_category_id);
            $catid = $vmcat->virtuemart_category_id;
        }

        $db = JFactory::getDBO();

        // map the category
        // Now create the product type and parameters
        $db->setQuery("SELECT * FROM #__virtuemart_category_categories WHERE category_child_id = '$catid'");
        $catcat = $db->loadObject();

        if (!$catcat) {
            $sql = <<<SQL
				INSERT  INTO #__virtuemart_category_categories(category_parent_id, category_child_id, ordering)
				VALUES (0 , $catid, 0);
SQL;
            $db->setQuery($sql);
            $db->query();
        }

        // Now create the product type and parameters
        $db->setQuery("SELECT * FROM #__virtuemart_products as prod
				LEFT JOIN #__virtuemart_product_categories as cat on cat.virtuemart_product_id=prod.virtuemart_product_id
				WHERE cat.virtuemart_category_id = '$catid'");
        $pname = $db->loadObject();

        if ($pname) {
            $this->pid = $pname->virtuemart_product_id;
            $pname = new JTableVMProducts($db);
            $pname->load($this->pid);
        } else {
            $pname = new JTableVMProducts($db);
            $pname->virtuemart_product_id = 0;
            $pname->virtuemart_vendor_id = 1;
            $pname->product_parent_id = 0;
            $pname->product_sku = $this->psku;
            //$pname->product_name = $this->productname;
            //$pname->slug = $this->pslug;
            //$pname->product_s_desc = 'Event Token - To allow event creation.';
            //$pname->product_desc = 'This product type controls the number of events that can be submitted or the time window in which events can be submitted.';
            $pname->product_weight = 0.0000;
            $pname->product_weight_uom = 'KG';
            $pname->product_length = 0.0000;
            $pname->product_width = 0.0000;
            $pname->product_height = 0.0000;
            $pname->product_lwh_uom = 'M';
            $pname->product_url = '';
            $pname->product_in_stock = 99999999;
            $pname->product_ordered = 0;
            $pname->product_available_date = $timestamp;
            $pname->product_availability = "";
            $pname->product_special = 0;
            $pname->product_sales = 0;
            $pname->product_unit = "KG";
            $pname->product_params = 'min_order_level=s:1:"0";|max_order_level=s:1:"0";|min_order_level=s:1:"0";|max_order_level=s:1:"0";|min_order_level=s:1:"0";|max_order_level=s:1:"0";|min_order_level=s:1:"0";|max_order_level=s:1:"0";|min_order_level=s:1:"0";|max_order_level=s:1:"0";|min_order_level=s:1:"0";|max_order_level=s:1:"0";|min_order_level=s:1:"1";|max_order_level=s:3:"100";|min_order_level=s:1:"1";|max_order_level=s:3:"100";|min_order_level=s:1:"1";|max_order_level=s:3:"100";|min_order_level=s:1:"1";|max_order_level=s:3:"100";|';
            $pname->intnotes = "";
            $pname->metarobot = "";
            $pname->metaauthor = "";
            $pname->layout = 0;
            $pname->published = 1;
            $pname->created_on = $timestamp;
            $pname->created_by = 635;
            $success = $pname->store();
            echo $db->getErrorMsg();

            if (!$success)
                return;

            $this->insertVmLanguageValues("#__virtuemart_products", array("virtuemart_product_id", "product_name", "product_s_desc", "product_desc", "slug"), array($pname->virtuemart_product_id, $this->productname, $this->product_s_desc, $this->product_desc, $this->pslug));
        }

        $pid = $pname->virtuemart_product_id;

        $db->setQuery("SELECT * FROM #__virtuemart_shoppergroups as sg WHERE sg.default=1 and sg.published=1");
        $defgroup = $db->loadObject();

        $db->setQuery("SELECT * FROM #__virtuemart_product_prices WHERE virtuemart_product_id = '$pid'");
        $pprice = $db->loadObject();
        if (!$pprice) {
            $pprice = new JTableVMProductPrices($db);
            $pprice->virtuemart_product_price_id = 0;
            $pprice->virtuemart_product_id = $pid;
            $pprice->virtuemart_shoppergroup_id = $defgroup->virtuemart_shoppergroup_id;
            $pprice->product_price = 10;
            $pprice->override = 0;
            $pprice->product_override_price = 0;
            // TODO find the currency
            $pprice->product_currency = 52;
            $pprice->created_on = $timestamp;
            $pprice->price_quantity_start = 0;
            $pprice->price_quantity_end = 0;
            $pprice->store();
            echo $db->getErrorMsg();
        }

        $db->setQuery("SELECT * FROM #__virtuemart_product_categories WHERE virtuemart_product_id = '$pid'");
        $pcat = $db->loadObject();
        if (!$pcat) {
            //Insert the product category field
            $sql = <<<SQL
            INSERT INTO #__virtuemart_product_categories (id, virtuemart_product_id, virtuemart_category_id, ordering)
            VALUES (0, $pid, $catid, 0);
SQL;
            $db->setQuery($sql);
            $db->query();
        }

        /* custom fields */
        $db->setQuery("SELECT * FROM #__virtuemart_customs WHERE custom_title = '" . JText::_("JEV_PAIDSUBS_NUMBER_OF_EVENTS") . "'");
        $customs = $db->loadObject();
        if (!$customs) {
            $customfield = new JTableVMCustoms($db);
            $customfield->virtuemart_custom_id = 0;
            $customfield->custom_parent_id = 0;
            $customfield->custom_title = JText::_("JEV_PAIDSUBS_NUMBER_OF_EVENTS");
            $customfield->custom_tip = JText::_("JEV_PAIDSUBS_NUMBER_OF_EVENTS_TIP");
            $customfield->custom_desc = JText::_("JEV_PAIDSUBS_THE_NUMBER_OF_EVENTS_INCLUDED_IN_PRODUCT");
            $customfield->custom_value = 10;
            $customfield->field_type = "S"; // Stupid Virtuemart, removed I = Integer custom field, resolved with S but must make sure all calls to the custom field are intval();
            $customfield->published = 1;
            $customfield->admin_only = 1;
            $customfield->store();
            echo $db->getErrorMsg();
        } else {
            $customfield = new JTableVMCustoms($db);
            $customfield->load($customs->virtuemart_custom_id);
        }


        $db->setQuery("SELECT * FROM #__virtuemart_product_customfields WHERE virtuemart_product_id=" . $pid . " AND virtuemart_custom_id=" . $customfield->virtuemart_custom_id);
        $productcustom = $db->loadObject();

        if (!$productcustom) {
            $prodcust = new JTableVMProductCustom($db);
            $prodcust->virtuemart_customfield_id;
            $prodcust->virtuemart_product_id = $pid;
            $prodcust->virtuemart_custom_id = $customfield->virtuemart_custom_id;
            $prodcust->customfield_value = 10;
            $prodcust->store();
            echo $db->getErrorMsg();
        }

        $this->customfieldid = $this->pluginParams->get("paidsubscustomfield", 0);
        if (!$this->customfieldid) {
            $this->pluginParams->set("paidsubscustomfield", $customfield->virtuemart_custom_id);
            $db->setQuery("update #__extensions set params = " . $db->quote((string)$this->pluginParams) . " where type='plugin' and element='jevpaidsubs' and folder='jevents' ");
            $db->query();
            if (!$db->getErrorMsg()) {
                $uri = JURI::getInstance();
                JFactory::getApplication()->redirect((string)$uri);
            }
        }

        $charset = ($db->hasUTF()) ? 'DEFAULT CHARACTER SET `utf8`' : '';
        $sql = <<<SQL
CREATE TABLE IF NOT EXISTS #__jev_subevents(
	id int(11) NOT NULL auto_increment,
	ev_id int(11) NOT NULL default 0,
	user_id int(11) NOT NULL default 0,
	PRIMARY KEY  (id),
	INDEX (ev_id),
	INDEX (user_id)
)  $charset;
SQL;
        $db->setQuery($sql);
        if (!$db->query()) {
            echo $db->getErrorMsg();
        }

    }

    private function insertVmLanguageValues($table, $fields, $values)
    {
        $db = JFactory::getDbo();
        $values = array_map(array($db, "quote"), $values);
        foreach ($this->vmlangs as $vmlang)
        {
            $vmlang = str_replace("-", "_", strtolower($vmlang));
            $db->setQuery("replace into " . $table . "_" . $vmlang . " (" . implode(",", $fields) . ") values (" . implode(",", $values) . ")");
            $db->query();
            echo $db->getErrorMsg();
        }

    }

}

class JTableVMCategory extends JTable
{

    public function __construct(&$db)
    {
        parent::__construct('#__virtuemart_categories', 'virtuemart_category_id', $db);

    }

}

class JTableVMCategoryCategories extends JTable
{

    public function __construct(&$db)
    {
        parent::__construct('#__virtuemart_category_categories', 'id', $db);

    }

}

class JTableVMProducts extends JTable
{

    public function __construct(&$db)
    {
        parent::__construct('#__virtuemart_products', 'virtuemart_product_id', $db);

    }

}

class JTableVMProductPrices extends JTable
{

    public function __construct(&$db)
    {
        parent::__construct('#__virtuemart_product_prices', 'virtuemart_product_price_id', $db);

    }

}

class JTableVMCustoms extends JTable
{

    public function __construct(&$db)
    {
        parent::__construct('#__virtuemart_customs', 'virtuemart_custom_id', $db);

    }

}

class JTableVMProductCustom extends JTable
{

    public function __construct(&$db)
    {
        parent::__construct('#__virtuemart_product_customfields', 'virtuemart_customfield_id', $db);

    }

}
