<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Factory;

jimport( 'joomla.plugin.plugin' );

class plgJEventsJevrsvp extends CMSPlugin
{
	var $_dbvalid = 0;

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);

		Factory::getLanguage()->load( 'plg_jevents_jevrsvp',JPATH_ADMINISTRATOR );

		$db = Factory::getDbo();
		$sql = <<<SQL
CREATE TABLE IF NOT EXISTS #__jev_attendance(
	id int(11) NOT NULL auto_increment,
	ev_id int(11) NOT NULL default 0,
	allowregistration tinyint(1) unsigned NOT NULL default 0,
	allowcancellation tinyint(1) unsigned NOT NULL default 0,
	allrepeats tinyint(1) unsigned NOT NULL default 1,	
	PRIMARY KEY  (id)
) ENGINE =MyISAM;	
SQL;
		$db->setQuery($sql);
		if (!$db->execute()){
			// echo $db->getErrorMsg();
		}

		$db = Factory::getDbo();
		$sql = <<<SQL
CREATE TABLE IF NOT EXISTS #__jev_attendees(
	id int(11) NOT NULL auto_increment,
	at_id int(11) NOT NULL default 0,
	user_id int(11) NOT NULL default 0,
	rp_id int(11) NOT NULL default 0,
	PRIMARY KEY  (id),
	INDEX (at_id,user_id),
	INDEX (at_id,user_id,rp_id)
) ENGINE =MyISAM;	
SQL;
		$db->setQuery($sql);
		if (!$db->execute()){
			// echo $db->getErrorMsg();
		}
	}

	function onEditCustom( &$row, &$customfields )
	{

		// Only setup when editing an event (not a repeat)
		if (Factory::getApplication()->input->getString("jevtask","")!="icalevent.edit") return;

		$db = Factory::getDbo();

		JHTML::script( 'plugins/jevents/jevrsvp/rsvp.js');

		$jevuser = JEVHelper::getAuthorisedUser();

		$eventid = intval($row->ev_id());
		if ($eventid>0){
			$rsvpmapping = 0;

			$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=".$eventid;
			$db->setQuery($sql);
			$rsvpdata = $db->loadObject();
			if ($rsvpdata){
				$rsvpmapping = intval($rsvpdata->id);
			}
			else {
				$rsvpmapping = 0;
				$rsvpdata=new stdClass();
				$rsvpdata->id=0;
				$rsvpdata->allowregistration=$this->params->get("defaultallow",0);
				$rsvpdata->allowcancellation=$this->params->get("defaultcancel",0);
				$rsvpdata->allrepeats=1;
			}

		}
		else {
			$rsvpmapping = 0;
			$rsvpdata=new stdClass();
			$rsvpdata->id=0;
			$rsvpdata->allowregistration=$this->params->get("defaultallow",0);
			$rsvpdata->allowcancellation=$this->params->get("defaultcancel",0);
			$rsvpdata->allrepeats=1;
		}

		$script = "JevRsvpLanguage.strings['JEV_HIDE_REGISTRATION_RSVP']='".Text::_("JEV_HIDE_REGISTRATION_RSVP",true)."';";
		$document = Factory::getDocument();
		$document->addScriptDeclaration($script);

		$allowregistration = Text::_("");
		$allowcancellation = Text::_("JEV_ALLOW_CANCELLATION");
		$yes = Text::_("JEV_YES");
		$no = Text::_("JEV_NO");

		ob_start();
		?>
<input type="hidden" name="custom_rsvp_evid" value="<?php echo $row->ev_id();?>" />
<div id="jevsimplereg">
	<fieldset>
		<legend><?php echo  Text::_("JEV_ATTENDANCE");?></legend>
		<div class="rsvp_allowregistration " style="margin-bottom:10px;">
			<span style="margin-right:10px;"><?php echo  Text::_("JEV_ALLOW_REGISTRATION");?></span>
			<div class="radio btn-group">
				<label for="custom_rsvp_allowregistration1" class="btn radio">
					<?php echo Text::_("JEV_YES");?>
					<input type="radio" name="custom_rsvp_allowregistration" id="custom_rsvp_allowregistration1" value="1" <?php echo $rsvpdata->allowregistration?"checked='checked'":"";?>/>
				</label>
				<label for="custom_rsvp_allowregistration0" class="btn radio">
					<?php echo Text::_("JEV_NO");?>
					<input type="radio" name="custom_rsvp_allowregistration" id="custom_rsvp_allowregistration0" value="0" <?php echo $rsvpdata->allowregistration?"":"checked='checked'";?>/>
				</label>
			</div>
		</div>
		<div class="rsvp_allowcancellation"  style="margin-bottom:10px;">
			<span style="margin-right:10px;"><?php echo  Text::_("JEV_ALLOW_CANCELLATION");?></span>
			<div class="radio btn-group">
				<label for="custom_rsvp_allowcancellation1" class="btn radio">
					<?php echo Text::_("JEV_YES");?>
					<input type="radio" name="custom_rsvp_allowcancellation" id="custom_rsvp_allowcancellation1" value="1"  <?php echo $rsvpdata->allowcancellation?"checked='checked'":"";?>/>
				</label>
				<label for="custom_rsvp_allowcancellation0" class="btn radio">
					<?php echo Text::_("JEV_NO");?>
					<input type="radio" name="custom_rsvp_allowcancellation" id="custom_rsvp_allowcancellation0" value="0" <?php echo $rsvpdata->allowcancellation?"":"checked='checked'";?>/>
				</label>
			</div>
		</div>
		<div  class="rsvp_allrepeats " style="margin-bottom:10px;">
			<span style="margin-right:10px;"><?php echo  Text::_("JEV_REGISTER_TRACK_ATTENDANCE");?></span>
			<div class="radio btn-group">
				<label for="custom_rsvp_allrepeats1" class="btn radio">
					<?php echo Text::_("JEV_ALL_REPEATS");?>
					<input type="radio" name="custom_rsvp_allrepeats" id="custom_rsvp_allrepeats1" value="1" <?php echo $rsvpdata->allrepeats?"checked='checked'":"";?>/>
				</label>
				<label for="custom_rsvp_allrepeats0" class="btn radio">
					<?php echo Text::_("JEV_SPECIFIC_REPEATS");?>
					<input type="radio" name="custom_rsvp_allrepeats" id="custom_rsvp_allrepeats0" value="0" <?php echo $rsvpdata->allrepeats?"":"checked='checked'";?>/>
				</label>
			</div>
		</div>
	</fieldset>
</div>
		<?php
		$input = ob_get_clean();

		$label = Text::_("JEV_ATTENDANCE");
		$customfield = array("label"=>$label,"input"=>$input);
		//$customfields["rsvp"]=$customfield;

		// for layout editor
		$customfields["JEV_ATTENDANCE_SUMMARY"]=$customfield;

		return true;
	}

	/**
	 * Clean out custom fields for event details not matching global event detail
	 *
	 * @param unknown_type $idlist
	 */
	function onCleanCustomDetails($idlist){
		// TODO
		return true;
	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	function onStoreCustomDetails($evdetail){
	}

	/**
	 * Store custom fields
	 *
	 * @param iCalEventDetail $evdetail
	 */
	// TODO update reminder timestamps when event times have changed
	function onStoreCustomEvent($event){
		$evdetail = $event->_detail;

		if (!array_key_exists("rsvp_allowregistration",$evdetail->_customFields)) return;

		$db = Factory::getDbo();

		$eventid = intval($evdetail->_customFields["rsvp_evid"]);
		if ($eventid ==0){
			$eventid = $event->ev_id;
		}

		$success = $this->setupAttendance($eventid, $evdetail->_customFields["rsvp_allowregistration"], $evdetail->_customFields["rsvp_allowcancellation"], $evdetail->_customFields["rsvp_allrepeats"]);
		return $success;
	}

	function setupAttendance($eventid, $allowregistration, $allowcancellation, $allrepeats)
	{
		$db = Factory::getDbo();
		$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=".$eventid;
		$db->setQuery($sql);
		$rsvpdata = $db->loadObject();
		if ($rsvpdata && $rsvpdata->id>0){
			$basesql = "UPDATE #__jev_attendance "
				." SET allowregistration=" . intval($allowregistration)
				.",  allowcancellation=" . intval($allowcancellation)
				.",  allrepeats=" . intval($allrepeats)
				.", ev_id=".intval($eventid);
			$conditionSql = " WHERE id=".intval($rsvpdata->id);
		}
		else {
			$basesql = "INSERT INTO #__jev_attendance "
				." SET allowregistration=" . intval($allowregistration)
				.",  allowcancellation=" . intval($allowcancellation)
				.",  allrepeats=" . intval($allrepeats)
				.", ev_id=".intval($eventid);
			$conditionSql = "";
		}
		$sql = $basesql . $conditionSql;
		$db->setQuery($sql);
		try
		{
			$db->execute();
		}
		catch (Exception $e)
		{
			// If using Joomla 4 and have demoted the installation from RSVP Pro to RSVP then there will be extra columns with no default values!
			if (version_compare(JVERSION, '4.0.0', 'gt'))
			{
				$sql = "SHOW COLUMNS FROM `#__jev_attendance`";
				$db->setQuery($sql);
				$cols = @$db->loadObjectList("Field");

				$missingColumns = array('message', 'remindermessage', 'attendintro', 'params');
				foreach ($missingColumns as $missingColumn)
				{
					if (array_key_exists($missingColumn, $cols))
					{
						$basesql .= ", $missingColumn=''";
					}
				}
				$sql = $basesql . $conditionSql;
				$db->setQuery($sql);
				try
				{
					$success = $db->execute();
				}
				catch (Exception $e)
				{
					Factory::getApplication()->enqueueMessage('Unable to save event with Simple RSVP Pro', 'error');
					Factory::getApplication()->enqueueMessage($e->getMessage(), 'error');
				}
			}
		}
		if (!$rsvpdata || $rsvpdata->id == 0)
		{
			$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $eventid;
			$db->setQuery($sql);
			$rsvpdata = $db->loadObject();
		}

		return $rsvpdata;
	}

	/**
	 * Clean out custom details for deleted event details
	 *
	 * @param comma separated list of event detail ids $idlist
	 */
	function onDeleteEventDetails($idlist){
		return true;
	}

	function onListIcalEvents( & $extrafields, & $extratables, & $extrawhere, & $extrajoin, & $needsgroupdby=false)
	{

	}

	function onListEventsById( & $extrafields, & $extratables, & $extrawhere, & $extrajoin)
	{
		return true;
	}

	function onGetEventData(&$row){

		return true;
	}

	function onDisplayCustomFields(&$row){

		$db = Factory::getDbo();
		$html ='';
		$eventid = intval($row->ev_id());
		if ($eventid>0){
			$rsvpmapping = 0;

			$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=".$eventid;
			$db->setQuery($sql);
			$rsvpdata = $db->loadObject();

			// if enabled by default then create the missing attendance record
			if (!$rsvpdata){
				$rsvpdata = $this->setupAttendance($eventid, $this->params->get("defaultallow",0), $this->params->get("defaultcancel",0), 1);
				if (!$rsvpdata){
					return false;
				}
			}

			if ($rsvpdata->allowregistration){

				$user=Factory::getUser();
				if ($user->id==0 && ($rsvpdata->allowregistration || $rsvpdata->allowreminders)){
					if ($rsvpdata->allowregistration){
						$row->attendancedata = Text::_("JEV_LOGIN_TO_CONFIRM_ATTENDANCE");
					}
					else {
						$row->attendancedata = Text::_("JEV_LOGIN_TO_REQUEST_REMINDER");
					}
					return $row->attendancedata;
				}

				// Are we saving an attendance update
				$jevattend_hidden = Factory::getApplication()->input->getInt("jevattend_hidden",0);
				if ($jevattend_hidden){
					$jevattend = Factory::getApplication()->input->getInt("jevattend",0);
					if (!$jevattend && $rsvpdata->allowcancellation) {
						$sql = "DELETE FROM #__jev_attendees WHERE at_id=".$rsvpdata->id." and user_id=".$user->id;
						if (!$rsvpdata->allrepeats){
							$sql .= " AND (rp_id=".$row->rp_id(). " OR rp_id=0)";
						}
						$db->setQuery($sql);
						$db->execute();

						$Itemid = Factory::getApplication()->input->getInt("Itemid",0);
						list($year,$month,$day) = JEVHelper::getYMD();
						$link = $row->viewDetailLink($year,$month,$day,true, $Itemid);

						Factory::getApplication()->enqueueMessage( Text::_('JEV_ATTENDANCE_CANCELLED'), 'info');
						Factory::getApplication()->redirect($link);
					}
					else if ($jevattend) {
						$sql = "SELECT * FROM #__jev_attendees WHERE at_id=".$rsvpdata->id." and user_id=".$user->id;
						if (!$rsvpdata->allrepeats){
							$sql .= " AND rp_id=".$row->rp_id();
						}
						$db->setQuery($sql);
						$attendee = $db->loadObject();
						if (!$attendee){

							$sql = "INSERT INTO #__jev_attendees SET at_id=".$rsvpdata->id.", user_id=".$user->id;
							if (!$rsvpdata->allrepeats){
								$sql .= ", rp_id=".$row->rp_id();
							}
							$db->setQuery($sql);
							try
							{
								$db->execute();
								Factory::getApplication()->enqueueMessage( Text::_('JEV_ATTENDANCE_RECORDED'));
							}
							catch (Exception $e)
							{
								// If using Joomla 4 and have demoted the installation from RSVP Pro to RSVP then there will be extra columns with no default values!
								if (version_compare(JVERSION, '4.0.0', 'gt'))
								{
									$colssql = "SHOW COLUMNS FROM `#__jev_attendees`";
									$db->setQuery($colssql);
									$cols = @$db->loadObjectList("Field");

									$missingColumns = array('params', 'attendnotes', 'notes', 'guestattend');
									foreach ($missingColumns as $missingColumn)
									{
										if (array_key_exists($missingColumn, $cols))
										{
											$sql .= ", $missingColumn=''";
										}
									}

									$db->setQuery($sql);
									try
									{
										$success = $db->execute();
										Factory::getApplication()->enqueueMessage( Text::_('JEV_ATTENDANCE_RECORDED'));
									}
									catch (Exception $e)
									{
										Factory::getApplication()->enqueueMessage( Text::_('JEV_ATTENDANCE_RECORD_FAILED'), 'error');
										Factory::getApplication()->enqueueMessage($e->getMessage(), 'error');
										return;
									}
								}
								else
								{
									Factory::getApplication()->enqueueMessage(Text::_('JEV_ATTENDANCE_RECORD_FAILED'), 'warning');
								}
							}
						}
					}
				}

				$sql = "SELECT * FROM #__jev_attendees WHERE at_id=".$rsvpdata->id." and user_id=".$user->id;
				if (!$rsvpdata->allrepeats){
					$sql .= " AND rp_id=".$row->rp_id();
				}
				$db->setQuery($sql);
				$attendee = $db->loadObject();
				if ($attendee){
					$attending = true;
				}
				else {
					$attending = false;
				}
				if (!$rsvpdata->allowregistration) return;

				$Itemid = Factory::getApplication()->input->getInt("Itemid",0);
				list($year,$month,$day) = JEVHelper::getYMD();
				$link = $row->viewDetailLink($year,$month,$day,true, $Itemid);
				// do we track attendance for the event/all repeats
				if (!$rsvpdata->allowcancellation && $attending){
					$html = Text::_("JEV_YOU_ARE_ATTENDING");
				}
				else {
					if ($rsvpdata->allrepeats){
						$html ='
<form action="'.$link.'"  method="post" >
	<label for="jevattend">'. ($row->hasrepetition()?Text::_("JEV_ATTEND_ALL_REPEATS"):Text::_("JEV_ATTEND_THIS_EVENT")).'</label>
    <input type="checkbox" name="jevattend" value="1" onclick="form.submit();" '.($attending?"checked='checked'":"").'/>
    <input type="hidden" name="jevattend_hidden" value="1" />    
    <noscript><input type="submit" name="submit" value="'.Text::_("JEV_CONFIRM").'" /></noscript>
</form>';
					}
					// or just this repeat
					else if ($row->hasrepetition()){
						$html ='
<form action="'.$link.'"  method="post" >
	<label for="jevattend">'. Text::_("JEV_ATTEND_THIS_REPEAT").'</label>
    <input type="checkbox" name="jevattend" value="1"  onclick="form.submit();" '.($attending?"checked='checked'":"").'/>
    <input type="hidden" name="jevattend_hidden" value="1" />
    <noscript><input type="submit" name="submit" value="'.Text::_("JEV_CONFIRM").'" /></noscript>
</form>';

					}
				}
				
				$sql = "SELECT u.name, u.username FROM #__jev_attendees as a LEFT JOIN #__users as u on u.id=a.user_id WHERE a.at_id=".$rsvpdata->id;
				if (!$rsvpdata->allrepeats){
					$sql .= " and rp_id=".$row->rp_id();
				}

				$db->setQuery($sql);
				$attendees = $db->loadObjectList();
				$html .=" <h3>".Text::_("JEV_Attendees")."</h3>";
				$html .=" <div>".Text::_("Total_Attendees")." ".count($attendees)."</div>";
				if ($this->params->get("jevrsvpname",0) == 1) {
					foreach ($attendees as $attendee) {
						$html .="<div class='jevattendee'>".$attendee->username."</div>";
					}
				} else if ($this->params->get("jevrsvpname",0) == 0){
					foreach ($attendees as $attendee) {
						$html .="<div class='jevattendee'>".$attendee->name."</div>";
					}
				} else if ($this->params->get("jevrsvpname",0) == 2)
					foreach ($attendees as $attendee) {
						$html .="<div class='jevattendee'>".$attendee->usernamename." - ".$attendee->name."</div>";
					}
			}
		}

		$row->attendancedata = $html;

		return $html;

	}


	static function fieldNameArray(){
		$return  = array();
		$return['group'] = Text::_("JEV_ATTENDANCE_FIELDS",true);

		$labels = array();
		$labels[] = Text::_("JEV_ATTENDANCE_SUMMARY",true);
		$values = array();
		$values[] = "JEV_ATTENDANCE_SUMMARY";

		$return['values'] = $values;
		$return['labels'] = $labels;

		return $return;
	}

	static function substitutefield($row, $code){
                if (isset($row->hidedetail) && $row->hidedetail){
                    return "";
                }
            
		if ($code == "JEV_ATTENDANCE_SUMMARY"){
			if (isset($row->attendancedata)) return $row->attendancedata;
		}
		return "";
	}
}
