<?php
/**
 * copyright (C) 2009 GWE Systems Ltd - All rights reserved
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Factory;
use Joomla\Utilities\ArrayHelper;
JLoader::register('jevFilterProcessing',JPATH_SITE."/components/com_jevents/libraries/filters.php");

jimport( 'joomla.plugin.plugin' );

class plgJEventsJevweekdays extends CMSPlugin
{


	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);

		Factory::getLanguage()->load( 'plg_jevents_jevweekdays',JPATH_ADMINISTRATOR );
		Factory::getLanguage()->load( 'com_jevents',JPATH_SITE);

	}

	/**
	 * When editing a JEvents menu item can add additional menu constraints dynamically
	 *
	 */
	function onEditMenuItem(&$menudata, $value,$control_name,$name, $id, $param)
	{
		// already done this param
		if (isset($menudata[$id])) return;

		static $matchingextra = null;
		// find the parameter that matches jevwd: (if any)
		if (!isset($matchingextra)){
			if (version_compare(JVERSION, '1.6.0', '>=') ){
				$params = $param->getGroup('params');
				foreach ($params as $key => $element){
					$val = $element->value;
					if (strpos($key,"jform_params_extras")===0 ){
						if (strpos($val,"jevwd:")===0){
							$matchingextra = $key;
							break;
						}
					}
				}
			}
			else {
				$keyvals = $param->toArray();
				foreach ($keyvals as $key=>$val) {
					if (strpos($key,"extras")===0 && strpos($val,"jevwd:")===0){
						$matchingextra = str_replace("extras","",$key);
						break;
					}
				}
			}
			if (!isset($matchingextra)){
				$matchingextra = false;
			}
		}

		// either we found matching extra and this is the correct id or we didn't find matching extra and the value is blank
		if (strpos($value,"jevwd:")===0 || (($value==""||$value=="0") && $matchingextra===false)){
			$matchingextra = true;
			$invalue = str_replace(" ","",$value);
			if ($invalue =="") $invalue =  'jevwd:-1';

			$options = array();
			$options[] = JHTML::_('select.option', 'jevwd:-1', Text::_('JEVF_ALL_DAYS'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:0', Text::_('JEV_MONDAY'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:1', Text::_('JEV_TUESDAY'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:2', Text::_('JEV_WEDNESDAY'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:3', Text::_('JEV_THURSDAY'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:4', Text::_('JEV_FRIDAY'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:5', Text::_('JEV_SATURDAY'), 'id', 'title');
			$options[] = JHTML::_('select.option', 'jevwd:6', Text::_('JEV_SUNDAY'), 'id', 'title');

			$invalue = explode(",",$invalue);
			$input = JHTML::_('select.genericlist',  $options, 'jevweekdaysselect', 'multiple="multiple" size="4" onchange="jupdateJevWeekdays()"', 'id', 'title', $invalue, 'jevweekdaysselect' );
			if (version_compare(JVERSION, '1.6.0', '>=') ){
				$input .= '<input type="hidden"  name="'.$name.'"  id="jevweekdays" value="'.$value.'" />';
				// for CB plugins !!!
				$input .= '<input type="hidden"  name="'.$control_name.'['.$name.']"   id="compat_jevweekdays"  value="'.$value.'" />';
				$input .= '<div style="clear:left"></div>';
			}
			else {
				$input .= '<input type="hidden"  name="'.$control_name.'['.$name.']"  id="jevweekdays" value="'.$value.'" />';
			}

			$script = '
			function jupdateJevWeekdays(){
				jupdateJevWeekdaysByField("jevweekdays");
				jupdateJevWeekdaysByField("compat_jevweekdays");
			}
			function jupdateJevWeekdaysByField(fieldid){
				var select = document.querySelector("select#jevweekdaysselect");
				var input = document.getElementById(fieldid);
				if (!input) return;
				input.value="";
				select.querySelectorAll("option").forEach(
					function(item,index){
						if (item.selected) {
							// if select none - reset everything else
							if (item.value=="jevwd:-1") {
								select.selectedIndex=0;
								return;
							}
							if (input.value!="") input.value+=",";
							input.value+=item.value;
						}
					}
				);
			}
			';
			$document = Factory::getDocument();
			$document->addScriptDeclaration($script);

			$data = new stdClass();
			$data->name = "jevuser";
			$data->html = $input;
			$data->label = "JEVF_WEEKDAYS";
			$data->description = "JEVF_WEEKDAYS_DESC";
			$data->options = array();
			$menudata[$id] = $data;
		}
	}

	function onListIcalEvents( & $extrafields, & $extratables, & $extrawhere, & $extrajoin, & $needsgroupdby=false)
	{

		if(Factory::getApplication()->isClient('administrator')) {
			return;
		}

		// Have we specified specific people for the menu item
		$compparams = ComponentHelper::getParams(Factory::getApplication()->input->getCmd("option","com_jevents"));

		// If loading from a module then get the modules params from the registry
		$reg = Factory::getConfig();
		$modparams = $reg->get("jev.modparams",false);
		if ($modparams){
			$compparams = $modparams;
		}

		for ($extra = 0;$extra<20;$extra++){
			$extraval = $compparams->get("extras".$extra, false);
			if (strpos($extraval,"jevwd:")===0){
				break;
			}
		}
		if (!$extraval) return true;

		JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

		$invalue = str_replace("jevwd:","",$extraval);
		$invalue = str_replace(" ","",$invalue);
		if (strlen($invalue)>0){
			$invalue = explode(",",$invalue);
			ArrayHelper::toInteger($invalue);
		}
		else {
			return true;
		}
		//  any events
		if (in_array(-1,$invalue)) return;


		// find what is running - used by the filters
		$registry = JevRegistry::getinstance("jevents");
		$activeprocess = $registry->get("jevents.activeprocess", "");
		$moduleid = $registry->get("jevents.moduleid", 0);
		$moduleparams = $registry->get("jevents.moduleparams", false);

		Factory::getApplication()->input->set("jevwd_fv", implode(",",$invalue));
		
		$filters = jevFilterProcessing::getInstance(array("Weekdays"), JPATH_SITE."/plugins/jevents/filters/", false, $moduleid);
		$filters->setWhereJoin($extrawhere, $extrajoin);

		Factory::getApplication()->input->set("jevwd_fv", null);

	}


}
