<?php
/**
 * JEvents Calendar Plus Module
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 * @author		Carlos M'Cámara and Geraint Edwards
 */

//no direct access
defined('_JEXEC') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\File;

$document = Factory::getDocument();

JLoader::register('JEventsHelper', JPATH_ADMINISTRATOR . "/components/com_jevents/helpers/jevents.php");
JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

require_once (dirname(__FILE__).'/'.'helper.php');

$jevhelper = new modJeventsCalendarPlusHelper();

PluginHelper::importPlugin("jevents");
JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

// record what is running - used by the filters
$registry	= JevRegistry::getInstance("jevents");
$registry->set("jevents.activeprocess","mod_jevents_cal");
$registry->set("jevents.moduleid", $module->id);
$registry->set("jevents.moduleparams", $params);

//We check if popup plugin
$popupPlugin = PluginHelper::getPlugin('jevents', 'jevpopupdetail');
if ( $popupPlugin )
{
	$popupPluginParams = new Registry($popupPlugin->params);

	$detailInPopup = $popupPluginParams->get("detailinpopup",0);
}
else if ( ($params->get('jevcalplus_newwindow', 1) == 2) )
{
	$detailInPopup = 1;
}
else{
	$detailInPopup = 0;
}

$params->set('detailInPopup', $detailInPopup);

// See http://www.php.net/manual/en/timezones.php
$compparams = ComponentHelper::getParams(JEV_COM_COMPONENT);
$tz=$compparams->get("icaltimezonelive","");
if ($tz!="" && is_callable("date_default_timezone_set")){
	$timezone= date_default_timezone_get();
	//echo "timezone is ".$timezone."<br/>";
	date_default_timezone_set($tz);
	$registry->set("jevents.timezone",$timezone);
}


$theme = JEV_CommonFunctions::getJEventsViewName();
$modtheme = $params->get("com_calViewName", $theme);
if ($modtheme == "global" || $modtheme == ""){
	$modtheme=$theme;
}

$theme=$modtheme;

if ($theme == "map")
{
	// display the correct layout
	$theme = $compparams->get("fallbackview", "geraint");
}

if ($theme == "ruthin")
{
	$theme = $theme."_".$colorscheme = $compparams->get("iccolourscheme","red");
}

if($theme == "flatplus")
{
	$theme = "flat";
}

HTMLHelper::stylesheet( 'modules/mod_jevents_calendarplus/assets/css/jevcalendarplus.css');

if (!File::exists(JPATH_SITE . '/modules/mod_jevents_calendarplus/assets/css/'.strtolower($theme).'.css'))
{
	$theme="default";
}

HTMLHelper::stylesheet( 'modules/mod_jevents_calendarplus/assets/css/'.strtolower($theme).'.css');

if (File::exists(JPATH_SITE . "/components/com_jevents/assets/css/jevcustom.css"))
{
	JEVHelper::stylesheet('jevcustom.css', 'components/' . JEV_COM_COMPONENT . '/assets/css/');
}

if($params->get('jevcalplus_loadbootstrap', 1))
{
	HTMLHelper::_('bootstrap.tooltip');
}

if($params->get('detailInPopup', 0))
{
	HTMLHelper::script(Uri::base().'components/com_jevents/assets/js/editpopupJQ.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => false), array('defer' => true));
}

HTMLHelper::script('mod_jevents_calendarplus/underscore.min.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => true), array('defer' => true));
// Load moment locaels for languages
HTMLHelper::script('mod_jevents_calendarplus/moment-with-locales.min.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => true), array('defer' => true));
HTMLHelper::script('mod_jevents_calendarplus/clndr.min.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => true), array('defer' => true));
HTMLHelper::script('mod_jevents_calendarplus/jevcalplus.min.js', array('version' => JEventsHelper::JEvents_Version(false), 'relative' => true), array('defer' => true));
HTMLHelper::script('mod_jevents_calendarplus/underscore.min.js', false, true, false, true);

$viewclass = $jevhelper->getViewClass('default', 'mod_jevents_calendarplus','default/'."calendar", $params);
$modview = new $viewclass($params, $module->id);
//$modview->jevlayout = $theme;
echo $modview->getCal();

// Must reset the timezone back!!
if ($tz && is_callable("date_default_timezone_set")){
	date_default_timezone_set($timezone);
}
