<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: mod_jevents_categories.php 1746 2011-03-09 12:13:31Z geraintedwards $
 * @package     JEvents
 * @subpackage  Module JEvents Calendar
 * @copyright   Copyright (C) 2006-2017 JEvents Project Group
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://joomlacode.org/gf/project/jevents
 */


defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\Registry\Registry;
use Joomla\CMS\Helper\ModuleHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\File;

JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

if (File::exists(JPATH_SITE . "/components/com_jevents/assets/css/jevcustom.css"))
{
	$document = Factory::getDocument();
	JEVHelper::stylesheet('jevcustom.css', 'components/' . JEV_COM_COMPONENT . '/assets/css/');
}

$jinput = Factory::getApplication()->input;

// Check if should in event details or not? Default = 1 since it has always been shown previously.
if ($jinput->getCmd('task') === "icalrepeat.detail" && $params->get('showindetails', 1) == 0){
	return;
}
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");
// record what is running - used by the filters
$registry	= JevRegistry::getinstance("jevents");
$registry->set("jevents.activeprocess","mod_jevents_categories");
$registry->set("jevents.moduleid", $module->id);
$registry->set("jevents.moduleparams", $params);

$reg =  Factory::getConfig();
$modparams = $reg->set("jev.modparams", $params);

require_once(dirname(__FILE__) . '/helper.php');

$jevhelper = new modJeventsCategoriesHelper($params);

require_once(ModuleHelper::getLayoutPath('mod_jevents_categories', "default"));

$viewclass = "ModCategoriesView";
$modview = new $viewclass($params, $module->id, $jevhelper);
echo $modview->displayCalendarCategories();
