<?php

/**
 *
 * @version     $Id: mod_remoteloader.php 1746 2011-03-09 12:13:31Z geraintedwards $
 * @package     JEvents
 * @subpackage  Load Remote Joomla Module
 * @copyright   Copyright (C) 2014 - 2021GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Http\HttpFactory;
use Joomla\CMS\Factory;

$rawData = "";
$url = trim($params->get("remoteurl"));
if (strrpos($url, "/")!= strlen($url)-1){
    $url .= "/";
}
if (strpos($url, "secretmodule.php")>0){
    $url = str_replace("/modules/mod_remoteloader/remotemodule/secretmodule.php", "/", $url);
    $url = str_replace("/secretmodule.php", "/", $url);
}
$url .= "index.php?option=com_jevents&typeaheadtask=gwejson&json={}&file=secretmodule&path=module&folder=mod_remoteloader%2Fremotemodule";

//$url .= "&XDEBUG_SESSION_START=netbeans-xdebug";

// Attach configured module id or position
$remotemodid = $params->get("remotemodid", 0);
$remoteposition = $params->get("remoteposition", false);
$remoteitemid = $params->get("remoteitemid", 0);
if (!$remotemodid && !$remoteposition  && !$remoteitemid){
	echo "No remote module id, menu item or position specified";
	exit();
}
if ($remotemodid){
	$url .= "&modid=".$remotemodid;
}
else if ($remoteposition) {
	$url .= "&position=".$remoteposition;
}

// attach language code
$remotelangcode = $params->get("remotelangcode", false);
if ($remotelangcode) {
	$url .= "&lang=".$remotelangcode;
}

// Attach javascript and css
$loadjs = $params->get("loadjs", 0);
if ($loadjs) {
	$url .= "&loadjs=".$loadjs;
}
$loadcss = $params->get("loadcss", 0);
if ($loadcss) {
	$url .= "&loadcss=".$loadcss;
}

$remoteitemid = $params->get("remoteitemid", 0);
if ($remoteitemid) {
	$url .= "&Itemid=".$remoteitemid;
}

// tell remote module 
//if ($loadjs || $loadcss) {
// Always want the data as JSON for remote module module
	$url .= "&asJSON=1";
//}

//$url .= "&XDEBUG_SESSION_START=PHPSTORM&";

$rawData = false;

// Use HttpFactory that allows using CURL and Sockets as alternative method when available
// Adding a valid user agent string etc.
$goptions = new \joomla\Registry\Registry;

$goptions->set('userAgent', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:41.0) Gecko/20100101 Firefox/41.0');

$http = HttpFactory::getHTTP($goptions);
$headers = array();
//$headers["json"] = $args;
$webpage = $http->get($url, $headers);

if (strpos($webpage->body, "{") === 0) {
    $rawData = $webpage->body;
}
else if (ini_get("allow_url_fopen")){
	$rawData = file_get_contents($url);
}
else if (is_callable("curl_exec"))
{
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$rawData = curl_exec($ch);
	curl_close($ch);
}

if (!$rawData){
	echo "Failed to load remote module data";// from $url";
        return;//exit();
}
//echo $rawData;exit();
// rawData will be json_encoded !
$keepdata = $rawData;
$rawData = json_decode($rawData);
if (!$rawData || !isset($rawData->host)){
	echo "Failed to decode data from source site<Br/>";
        //echo "Source Url = $url<br/>";
        //echo $rawData;
	return;
}

// replace relative URLs with absolute URLs
$host = $rawData->host;

// replace relative URLs with absolute URLs
if (strrpos($host, "/") == strlen($host)-1){
	$host = substr($host, 0, strlen($host)-1);
}

// Process stylesheets
if (isset($rawData->head)){
	if (isset($rawData->head->stylesheets) && count($rawData->head->stylesheets)>0){
		foreach ($rawData->head->stylesheets as $stylesheet){
			if (strpos($stylesheet->strSrc, "/") === 0) {
				JHTML::stylesheet($host.$stylesheet->strSrc, get_object_vars($stylesheet->strAttr));			
			}
			else
			{
				JHTML::stylesheet($host."/".$stylesheet->strSrc, get_object_vars($stylesheet->strAttr));
			}
		}
	}
	if (isset($rawData->head->styles) && count($rawData->head->styles)>0){
		foreach ($rawData->head->styles as $style){
			Factory::getDocument()->addStyleDeclaration($style->content, $style->type);
		}
	}

	if (isset($rawData->head->scriptfiles) && count($rawData->head->scriptfiles)>0){
		foreach ($rawData->head->scriptfiles as $scriptfile){
			if (strpos($scriptfile->strSrc, "/") === 0) {
				JHTML::script($host.$scriptfile->strSrc, get_object_vars($scriptfile->strAttr));				
			}
			else  {
				JHTML::script($host."/".$scriptfile->strSrc, get_object_vars($scriptfile->strAttr));
			}
		}
	}
	if (isset($rawData->head->scripts) && count($rawData->head->scripts)>0){
		foreach ($rawData->head->scripts as $script){
			Factory::getDocument()->addScriptDeclaration($script->content, $script->type);
		}
	}
}

$rawData = $rawData->data;

// convert hrefs
$rawData = str_replace("href='/","href='$host/",$rawData);
$rawData = str_replace('href="/','href="'.$host.'/',$rawData);

$rawData = str_replace("href='index.php","href='$host/index.php",$rawData);
$rawData = str_replace('href="index.php','href="'.$host.'/index.php',$rawData);

// convert images
$rawData = str_replace("src='/","src='$host/",$rawData);
$rawData = str_replace('src="/','src="'.$host.'/',$rawData);

$rawData = str_replace("src='index.php","src='$host/index.php",$rawData);
$rawData = str_replace('src="index.php','src="'.$host.'/index.php',$rawData);

// generic links e.g. in mouse events etc.
$rawData = str_replace("'index.php","'$host/index.php", $rawData);
$rawData = str_replace('"index.php','"'.$host."/index.php", $rawData);

echo $rawData;
