<?php
/**
 * copyright (C) 2008-2017 GWE Systems Ltd - All rights reserved
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;

/**
 * HTML View class for the module  frontend
 *
 * @static
 */
include_once(JPATH_SITE."/modules/mod_jevents_latest/tmpl/default/latest.php");
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

class FloatModLatestViewOld extends DefaultModLatestView
{

	public function displayLatestEvents(){

		JLoader::register('JevIsotope', JPATH_LIBRARIES . "/jevents/jevisotope/jevisotope.php");
		JEVHelper::componentStylesheet($this);

		$cfg = JEVConfig::getInstance();

		//$isoParams = array('microdata' => 1);
		$isoParams = array("layoutMode" => "packery", "layoutOpts" => "percentPosition: true, packery: { gutter: '.jeviso_gutter' }, ", "itemSelector" => ".jeviso_item", "", "jevlayout" => "float");
		//Load the Isotope Library
		JevIsotope::isotopep(array(), $isoParams, $filters = null);

		$this->getLatestEventsData();

		$content = "<div class='mod_events_latest_data isotope'  id='mod_events_latest_".$this->_modid."_data'>"; // latest isotope line 33

		if(isset($this->eventsByRelDay) && count($this->eventsByRelDay))
		{

			$content .= "<div class='isotope jevisotope'>"; // open isotope jevisotope
			if (method_exists($this, 'getNavigationIcons'))
			{
				$content .= $this->getNavigationIcons();
			}

			$templateTop = $this->modparams->get("modlatest_templatetop") ? $this->modparams->get("modlatest_templatetop") : '';
			if (true || strpos($templateTop, 'jeviso_container') === false)
			{
				$content .= "<div id='jeviso_main' class='jeviso_day'>"; // open jeviso_main jeviso_day
				$content .= "<div class='jeviso_container' itemscope itemtype='http://schema.org/Event'>"; // open jeviso_container
			}
			else
			{
				$content .= $templateTop;
			}
			$content .= "<div class='jeviso_gutter'></div>";

			// Now to display these events, we just start at the smallest index of the $this->eventsByRelDay array
			// and work our way up.

			// initialize name of com_jevents module and task defined to view
			// event detail.  Note that these could change in future com_event
			// component revisions!!  Note that the '$this->itemId' can be left out in
			// the link parameters for event details below since the event.php
			// component handler will fetch its own id from the db menu table
			// anyways as far as I understand it.

			$task_events = 'icalrepeat.detail';

			$this->processFormatString();

			foreach($this->eventsByRelDay as $relDay => $daysEvents){

				reset($daysEvents);

				// get all of the events for this day
				foreach($daysEvents as $dayEvent)
				{

					$eventcontent = "";

					// generate output according custom string
					foreach ($this->splitCustomFormat as $condtoken)
					{

						if (isset($condtoken['cond']))
						{
							if ($condtoken['cond'] == 'a' && !$dayEvent->alldayevent()) continue;
							else if ($condtoken['cond'] == '!a' && $dayEvent->alldayevent()) continue;
							else if ($condtoken['cond'] == 'e' && !($dayEvent->noendtime() || $dayEvent->alldayevent())) continue;
							else if ($condtoken['cond'] == '!e' && ($dayEvent->noendtime() || $dayEvent->alldayevent())) continue;
							else if ($condtoken['cond'] == '!m' && $dayEvent->getUnixStartDate() != $dayEvent->getUnixEndDate()) continue;
							else if ($condtoken['cond'] == 'm' && $dayEvent->getUnixStartDate() == $dayEvent->getUnixEndDate()) continue;
						}
						foreach ($condtoken['data'] as $token)
						{
							unset($match);
							unset($dateParm);
							$dateParm = "";
							$match    = '';
							if (is_array($token))
							{
								$match    = $token['keyword'];
								$dateParm = isset($token['dateParm']) ? trim($token['dateParm']) : "";
							}
							else if (strpos($token, '${') !== false)
							{
								$match = $token;
							}
							else
							{
								$eventcontent .= $token;
								continue;
							}
							$this->processMatch($eventcontent, $match, $dayEvent, $dateParm, $relDay);

						} // end of foreach
					} // end of foreach

					$item_bodycore = file_get_contents(JEV_PATH . "views/float/defaults/icalevent.list_block" . $cfg->get('float_style', 1) . ".html");

					$templaterow = $this->modparams->get("modlatest_templaterow") ? $this->modparams->get("modlatest_templaterow") : '%s';
					if ($cfg->get("floatmoduleuseformatstring", 0)  || !$this->modparams->get("uselayouteditor", 0))
					{
						$item_bodycore = $eventcontent;
					}

					$item_bodycore = str_replace("%s", $item_bodycore, $templaterow);

					if (strpos($item_bodycore, 'jeviso_item w') === false)
					{
						$item_body = '<div  id="jeviso_item' . $dayEvent->rp_id() . '" class="jeviso_item w' . $cfg->get('float_columns', 4) . ' ' . $dayEvent->catname() . ' style' . $cfg->get('float_style', 1) . '">';
					}
					$item_body .= $item_bodycore;
					if (strpos($item_bodycore, 'jeviso_item w') === false)
					{
						$item_body .= '</div>';
					}
					$content   .= JevIsotope::itembody($dayEvent, $isoParams, '', $item_body);

					$firstTime=false;
				} // end of foreach
			} // end of foreach
			$templateBottom = $this->modparams->get("modlatest_templatebottom") ? $this->modparams->get("modlatest_templatebottom") : "";

			if (true || strpos($templateTop, 'jeviso_container') === false)
			{
				$content .= "</div>"; // close jeviso_container
				$content .= "</div>"; // close jeviso_main jeviso_day
			}
			else
			{
				$content .= $templateBottom;
			}
			$content .= "</div>"; // close isotope jevisotope


		}
		else if ($this->modparams->get("modlatest_NoEvents", 1)){
			$content .= $this->modparams->get("modlatest_templatetop") ? $this->modparams->get("modlatest_templatetop") : '<table class="mod_events_latest_table jevbootstrap" width="100%" border="0" cellspacing="0" cellpadding="0" align="center">';
			$templaterow = $this->modparams->get("modlatest_templaterow") ? $this->modparams->get("modlatest_templaterow")  : '<tr><td class="mod_events_latest_noevents">%s</td></tr>' . "\n";
			$content .= str_replace("%s", Text::_('JEV_NO_EVENTS') , $templaterow);
			$content .=$this->modparams->get("modlatest_templatebottom") ? $this->modparams->get("modlatest_templatebottom") : "</table>\n";
		}

		$callink_HTML = '<div class="mod_events_latest_callink">'
			.$this->getCalendarLink()
			. '</div>';

		if ($this->linkToCal == 1) $content = $callink_HTML . $content;
		if ($this->linkToCal == 2) $content .= $callink_HTML;

		if ($this->displayRSS){
			if (version_compare(JVERSION, "1.6.0", 'ge')) {
				$rssimg = JURI::root() . "media/system/images/livemarks.png";
			}
			else {
				$rssimg = JURI::root() . "images/M_images/livemarks.png";
			}

			$callink_HTML = '<div class="mod_events_latest_rsslink">'
				.'<a href="'.$this->rsslink.'" title="'.Text::_("RSS_FEED").'" target="_blank">'
				.'<img src="'.$rssimg.'" alt="'.Text::_("RSS_FEED").'" />'
				.Text::_("SUBSCRIBE_TO_RSS_FEED")
				. '</a>'
				. '</div>';
			$content .= $callink_HTML;
		}
		$content .= "</div>";  // close latest isotope line 33

		$width = $cfg->get('float_columns', 4);
		$script = <<< SCRIPT
		function jeviso_listmodule(id) {			
			var container = jQuery('#mod_events_latest_' + id + '_data div.jeviso_container');
			container.trigger('jevisolist');
			
			container.find('.jeviso_item').removeClass('w$width');
			container.find('.jeviso_item').addClass('w1 listv');
			/* Reset layout for the changes to take effect */
			container.isotope('layout');
		}

		function jeviso_gridmodule(id) {
			var container = jQuery('#mod_events_latest_' + id + '_data div.jeviso_container');
			container.trigger('jevisogrid');
			
			container.find('.jeviso_item').addClass('w$width');
			container.find('.jeviso_item').removeClass('w1');
			container.find('.jeviso_item').removeClass('listv');
			/* Reset layout for the changes to take effect */
			container.isotope('layout');
		}
SCRIPT;
		Factory::getDocument()->addScriptDeclaration($script);

		// if called from gwe_fetchlatestevents.php
		if (Factory::getApplication()->input->getString('file', '') !== 'fetchlatestevents')
		{
			// Navigation
			static $scriptloaded = false;
			if (!$scriptloaded ){
				$root = JURI::root();
				$token= Session::getFormToken();
				$script = <<<SCRIPT
function fetchMoreFloatEvents(modid, direction)
{        
        jQuery.ajax({
                    type : 'POST',
                    dataType : 'json',
                    url : "{$root}index.php?option=com_jevents&ttoption=com_jevents&typeaheadtask=gwejson&file=fetchlatestevents&path=module&folder=mod_jevents_latest&token={$token}",
                    data : {'json':JSON.stringify({'modid':modid, 'direction':direction})},
                    contentType: "application/x-www-form-urlencoded; charset=utf-8",
                    scriptCharset: "utf-8"
            })                        
                .done(function( data ){                    
					jQuery("#mod_events_latest_" + modid + "_data").replaceWith(data.html);
					jQuery('#mod_events_latest_' + modid + '_data .jeviso_container').isotope({
			            /* Options */
			            layoutMode: 'packery',
			            packery: { gutter: '.jeviso_gutter' }, 
			            itemSelector: '.jeviso_item',
			        })
                    
                    try {
                        document.getElementById("mod_events_latest_"+modid+"_data").parentNode.scrollIntoView({block: "start", behavior: "smooth"});
                    }
                    catch (e) {
                    }
                })
                .fail(function(x) {
        alert('fail '+x);
                });
}
SCRIPT;
				Factory::getDocument()->addScriptDeclaration($script);
			}

		}
		return $content;
	} // end of function

	protected function getNavigationIcons() {
		$cfg = JEVConfig::getInstance();

		$registry = JevRegistry::getInstance("jevents");
		$params = $registry->get("jevents.moduleparams", new Registry);
		$content = "";
		$prev = "";
		$next = "";
		if ($params->get("showNavigation",0))
		{
			$page = (int) Factory::getApplication()->getUserState("jevents.moduleid" . $this->_modid . ".page", 0);
			if ($page > 0 || $params->get("modlatest_Mode", 0) != 2)
			{
				$prev = '<div class="jeviso_prev"><button class="btn btn-default" onclick="fetchMoreFloatEvents(' . $this->_modid . ',-1);return false;"> &lt; </button></div>';
			}
			$next = '<div class="jeviso_next"><button class="btn btn-default" onclick="fetchMoreFloatEvents(' . $this->_modid . ',1);return false;"> &gt; </button></div>';
		}

		$viewswitch = "";
		if ($cfg->get('float_dyn_switch', 1) == 1)
		{
			$lang = Factory::getLanguage();
			$lang->load("files_jeventsfloatlayout");

			$list =  Text::_('JEV_FLOAT_LIST_VIEW');
			$grid =  Text::_('JEV_FLOAT_GRID_VIEW');
			$viewswitch = <<< VIEWSWITCH
<div class="jeviso_view_switch">
	<button class="btn btn-default" onclick="jeviso_listmodule($this->_modid);">$list</button>
	<button class="btn btn-default" onclick="jeviso_gridmodule($this->_modid);">$grid</button>
</div>
VIEWSWITCH;
		}

		if (!empty($viewswitch) || !empty($next))
		{
			$content .= <<< LINKS
			<div class="jeviso_display_header">
				$viewswitch
				<div class="date nv_links">
					$prev
					$next
				</div>
			</div>
LINKS;
		}
		return $content;
	}


} // end of class
