<?php
/**
 * copyright (C) 2008-2015 GWE Systems Ltd - All rights reserved
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * HTML View class for the module  frontend
 *
 * @static
 */
include_once(JPATH_SITE."/modules/mod_jevents_latest/tmpl/default/latest.php");

class MapModLatestView extends DefaultModLatestView  
{
	function displayLatestEvents(){

		$jevparams  = ComponentHelper::getParams("com_jevents");
		$h = $jevparams->get("modheight","250px");
		$w = $jevparams->get("modwidth","250px");

		$this->getLatestEventsData();

		$content = "";
		if ($this->customFormatStr!="MAP"){
			// load global view version first
			$jevhelper = new modJeventsLatestHelper();
			$jevparams = ComponentHelper::getParams(JEV_COM_COMPONENT);
			$fallbackview = $jevparams->get("fallbackview", "geraint");
			$viewclass = $jevhelper->getViewClass($fallbackview, 'mod_jevents_latest',$fallbackview.'/'."latest", $this->modparams);
			
			$modview = new $viewclass($this->modparams, $this->_modid);
			$modview->jevlayout = $fallbackview;
			$content .= $modview->displayLatestEvents();			
		}
		
		$events = array();	
		if(isset($this->eventsByRelDay) && count($this->eventsByRelDay)){

			foreach($this->eventsByRelDay as $relDay => $dayEvents){

				foreach ($dayEvents as $dayEvent){
					if (!isset($dayEvent->_loc_id) || intval($dayEvent->_loc_id)==0) continue;
					$events[] = $dayEvent;
				}
			}
		}
		$modid = $this->_modid;
		if (count ($events)==0) return $content;
		
		$compparams = ComponentHelper::getParams("com_jevlocations");
		JLoader::register('JevLocationsHelper',JPATH_ADMINISTRATOR."/components/com_jevlocations/libraries/helper.php");
		JevLocationsHelper::loadApiScript();
		HTMLHelper::script('com_jevents/jevmaps/locationdetail.js', array('relative' => true));

		$zoom = 10;
		$document = Factory::getDocument();
		$document->addStyleDeclaration("div.modlocmap {clear:left;} div.modlocmap div.gmapMulti{margin:5px auto} div.modlocmap .gmapMulti img { max-width: inherit;}");
		$maptype = JevLocationsHelper::getParameter('googlemaps-lookandfeel', "maptype", "ROADMAP");
		$disableautopan = $compparams->get("autopan", 1)  ? "false":"true";
		$redirecttodirections = $compparams->get("redirecttodirections", 0);
		$googleDirections = $compparams->get('googledirections', 'https://maps.google.com');
		$maplinknewwindow = $compparams->get('maplinktonewwindow', '0');
		$root = JURI::root();
		$Itemid = $this->myItemid;
		$mapsprovider = $compparams->get("mapsprovider", "googlemaps");
		$urlroot = JURI::root() . 'media/com_jevlocations/images/';

		ob_start();
?>
<div class='modlocmap'>
	<?php
	$script = '';

	$minlon = 0;
	$minlat = 0;
	$maxlon = 0;
	$maxlat = 0;
	$first = true;
	foreach ($events as $event)
	{
		if ($event->_loc_zoom == 0)
			continue;
		if ($first)
		{
			$minlon = floatval($event->_loc_lon);
			$minlat = floatval($event->_loc_lat);
			$maxlon = floatval($event->_loc_lon);
			$maxlat = floatval($event->_loc_lat);
			$first = false;
		}
		$minlon = floatval($event->_loc_lon) > $minlon ? $minlon : floatval($event->_loc_lon);
		$minlat = floatval($event->_loc_lat) > $minlat ? $minlat : floatval($event->_loc_lat);
		$maxlon = floatval($event->_loc_lon) < $maxlon ? $maxlon : floatval($event->_loc_lon);
		$maxlat = floatval($event->_loc_lat) < $maxlat ? $maxlat : floatval($event->_loc_lat);
	}
	if ($minlon == $maxlon)
	{
		$minlon-=0.002;
		$maxlon+=0.002;
	}
	if ($minlat == $maxlat)
	{
		$minlat-=0.002;
		$maxlat+=0.002;
	}
	$midlon = ($minlon + $maxlon) / 2.0;
	$midlat = ($minlat + $maxlat) / 2.0;
	
	$locparams = ComponentHelper::getParams("com_jevlocations");
	$maptype =  $locparams->get("maptype", "ROADMAP") ;
	$script.=<<<SCRIPT
document.addEventListener('DOMContentLoaded', function (){window.setTimeout("myMaploadMulti($midlat, $midlon, $minlat, $minlon, $maxlat, $maxlon, '$maptype',$modid, '$mapsprovider')",1000);});
function addPointsmyMapMulti$modid() {
SCRIPT;

	foreach ($events as $event) {
	if ($event->_loc_id==0) continue;

	// On mouse over date formats
	$event->start_date	= JEventsHTML::getDateFormat( $event->yup(), $event->mup(), $event->dup(), 0 );
	$event->start_time = $event->startTime()	;

	$event->stop_date	= JEventsHTML::getDateFormat(  $event->ydn(), $event->mdn(), $event->ddn(), 0 );
	$event->stop_time = $event->endTime()	;

	$event->stop_time_midnightFix = $event->stop_time ;
	$event->stop_date_midnightFix = $event->stop_date ;
	if ($event->sdn() == 59 && $event->mindn()==59){
		$event->stop_time_midnightFix = JEVHelper::getTime($event->getUnixEndTime()+1,0,0);
		$event->stop_date_midnightFix = JEventsHTML::getDateFormat(  $event->ydn(), $event->mdn(), $event->ddn()+1, 0 );
	}
	
	if (isset($event->_loc_mapicon) && $event->_loc_mapicon!=""){
		$icon = $event->_loc_mapicon;
	}
	else {
		$icon = "blue-dot.png";
	}
	$url = $event->viewDetailLink($event->yup(), $event->mup(), $event->dup(), true, $Itemid);

	$script.="	addPoint($event->_loc_lat,$event->_loc_lon,".$event->rp_id().",$event->_loc_id, '".addslashes($event->_location."<br/>".$event->repeatSummary())."', '".addslashes($event->title())."', '$url', '$icon', null, $modid, '$mapsprovider', '$urlroot', $disableautopan, $maplinknewwindow);\n";
}
$script.=<<<SCRIPT
};
SCRIPT;
	$document = Factory::getDocument();
	$document->addScriptDeclaration($script);
	JHTML::_('bootstrap.modal');
	?>
	<div id="gmapMulti<?php echo $modid;?>" style="width:<?php echo $w;?>; height:<?php echo $h;?>;" class="gmap" ></div>
</div>
<?php
		$mapcontent = ob_get_clean();

		if ($jevparams->get("mapplacement", 1) == 0)
		{
			// map before module
			return $mapcontent . $content;
		
		}
		else if ($jevparams->get("mapplacement", 1) == 1)
		{
			// module before map
			return $content . $mapcontent;
		}	
		else {
			// just map
			return $mapcontent;
		}
		
		return $content;
	} // end of function
} // end of class
