<?php

use Joomla\Registry\Registry;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Date\Date;
use Joomla\CMS\User\User;
use Joomla\CMS\Factory;


/**
 * @copyright	Copyright (C) 2009 GWE Systems Ltd. All rights reserved.
 */
//ini_set("display_errors",1);
// Set flag that this is a parent file
define('_JEXEC', 1);
$x = realpath(dirname(__FILE__) . "/../../");
if (!file_exists($x . DS . "plugins"))
{
	$x = realpath(dirname(__FILE__) . "/../../../");
}
define('JPATH_BASE', $x);

// create the mainframe object
$_REQUEST['tmpl'] = 'component';

require_once JPATH_BASE . '/includes/defines.php';
require_once JPATH_BASE . '/includes/framework.php';

if (version_compare(JVERSION, "1.6.0", 'ge'))
{
	// force lifetime for session to be very short as a precaution - this means that this session CANNOT continue
	//Factory::getConfig()->set("lifetime", 0.0001);
	jimport('joomla.event.dispatcher');
	jimport('joomla.environment.response');
	jimport('joomla.log.log');
	JLoader::register('JevJoomlaVersion',JPATH_ADMINISTRATOR."/components/com_jevents/libraries/version.php");

	$session = Factory::getSession();

	// remove the cookie
	if (isset($_COOKIE[session_name()])) {
		$config = Factory::getConfig();
		$cookie_domain = $config->get('cookie_domain', '');
		$cookie_path = $config->get('cookie_path', '/');
		setcookie(session_name(), '', time()-42000, $cookie_path, $cookie_domain);
	}	
}

global $mainframe;
$mainframe =  Factory::getApplication('site');
$mainframe->initialise();

// User must be able to access all the events we need to
$params = ComponentHelper::getParams("com_jevents");
$adminuser = $params->get("jevadmin");

// joomla 1.5 access level
if (!version_compare(JVERSION, "1.6.0", 'ge'))
{
	// it doesn't work with Joomla 1.6
	$user =  Factory::getUser();
	$user = User::getInstance($adminuser);
	$user->aid = 2;
}
else
{
	$resetsession = false;
	$user = Factory::getUser();
	if ($user->id ==0){
		// delete the session from the database straight away so that it can't be resused at all!  
		// BELTS AND BRACES
		$db = Factory::getDbo();
		$db->setQuery(
		'DELETE  FROM `#__session`' .
				' WHERE `session_id` = '.$db->quote($session->getId()));			
		$exists = $db->execute();
				
		// DANGEROUS - it logs in this user but we set the session time to be short in the up top!
		$adminuser = User::getInstance($adminuser);
		// put spoof data into the user profile so that its meaningless
		//$adminuser->name = "silly";
		$adminuser->username = "silly";
		//$adminuser->email = "silly@silly.com";
		//$adminuser->id  = 1;
		$adminuser->password  = 'something secret';
		$adminuser->password_clear  = '';
		$session->set('user', $adminuser);
		$user = Factory::getUser();
		$resetsession = true;
	}
}
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

if ($params->get("icaltimezonelive", "") != "" && is_callable("date_default_timezone_set"))
{
	$timezone = date_default_timezone_get();
	$tz = $params->get("icaltimezonelive", "");
	date_default_timezone_set($tz);
	$registry = JevRegistry::getinstance("jevents");
	$registry->set("jevents.timezone", $timezone);
}

$plugin = PluginHelper::getPlugin("jevents", "jevnotify");
if (!$plugin)
{
	echo "Sorry, this plugin has been disabled. Please re-enable it. ";
	return;
}

jimport("joomla.html.parameter");
$params = new Registry($plugin->params);

include_once(JPATH_SITE . "/components/com_jevents/jevents.defines.php");

// Select the next 20 emails to send
$db = Factory::getDbo();
jimport("joomla.utilities.date");
if (class_exists("JevDate")){
	$now = new JevDate("+0 seconds");
}
else {
	$now = new Date("+0 seconds");
}
$now = $now->toSql();
$lag = intval($params->get("lag", 0));
$lagtime = new Date("-$lag seconds");
$lagtime = $lagtime->toSql();

$limit = 500;
$db->setQuery("Select n.*, u.name, u.email , u.username from #__jev_notifications as n LEFT JOIN #__users as u on u.id = n.user_id order by n.id desc limit $limit");

$notifications = $db->loadObjectList();

$datamodel =  new JEventsDataModel();
?>
<table>
<?php
// prepare the messages
$sent = 0;
foreach ($notifications as $notification)
{

	list ($y, $m, $d) = JEVHelper::getYMD();

	// just incase we don't have jevents plugins registered yet
	PluginHelper::importPlugin("jevents");
	$event = $datamodel->getEventData($notification->rp_id, 'icaldb', $y, $m, $d);

	if (!$event) {
		echo "<tr><td colspan='2'>Can't find event ".$notification->rp_id."</td>";
		if ($notification->messagetype == 0)
		{
			echo "<td>new event</td>";
		}
		else if ($notification->messagetype == 2)
		{
			echo "<td>deleted event</td>";
		}
		else
		{
			echo "<td>changed event</td>";
		}
		echo "</tr>";
		continue;
	}
	$event = $event['row'];
	?>
	<tr>
	<?php
	if ($notification->messagetype == 0)
	{
		echo "<td>new event</td>";
	}
	else if ($notification->messagetype == 2)
	{
		echo "<td>deleted event</td>";
	}
	else
	{
		echo "<td>changed event</td>";
	}
	echo "<td>". $event->title()." </td><td> ". ($notification->email ? $notification->email : $notification->email_address). "</td><td> ".($notification->sentmessage?$notification->whensent:""). "</td>";
	?>
	<tr>
	<?php


}


if (version_compare(JVERSION, "1.6.0", 'ge') && $resetsession)
{
	// reset the session user
	$session->set('user', 0);
	// delete the session  BELTS AND BRACES
	$session->destroy();
}

?>
</table>
