<?php
/**
* @copyright	Copyright (C) 2009 GWE Systems Ltd. All rights reserved.
*/
ini_set("display_errors",1);

// Set flag that this is a parent file
define( '_JEXEC', 1 );
define( 'DS', DIRECTORY_SEPARATOR );
$x = realpath(dirname(__FILE__)) ;
define( 'JPATH_BASE', $x );

// create the mainframe object
$_REQUEST['tmpl'] = 'component';

require_once JPATH_BASE.DS.'includes'.DS.'defines.php';
require_once JPATH_BASE.DS.'includes'.DS.'framework.php';

global $mainframe;
$mainframe =& JFactory::getApplication('site');
$mainframe->initialise();

// User must be able to access all the events we need to
$params = JComponentHelper::getParams("com_jevents");
$adminuser = $params->get("jevadmin");
$user =& JFactory::getUser();
$user = JUser::getInstance($adminuser);
$user->aid = 2;

// Config Analysis
/*
?>
<h2>JEvents Config Options</h2>
<table border="1" cellpadding="3">
	<tr>
		<th>Setting</th>
		<th>Current State</th>
		<th>Recommended State</th>
		<th>Comments</th>
	</tr>
<?php
$settings = array();
$setting = new stdClass();
$config = &JFactory::getConfig();

$setting->setting="Joomla Cache";
$setting->current=$config->getValue("config.caching",0)?"On":"Off";
$setting->recommended="On";
$setting->comment="Setting the Joomla cache on reduces load time for all non-registered site visitors";
$settings[]=$setting;

$setting->setting="Joomla Cache";
$setting->current=$params->get('com_blockRobots',0);
switch ($setting->current) {
	case 0:
		$setting->current="No";
		break;
	case 1:
		$setting->current="Yes";
		break;
	case 2:
		$setting->current="Conditional on calendar date";
		break;
	case 3:
		$setting->current="Allow robots to index event detail pages";
		break;
}
$setting->recommended=array("No","Conditional on calendar date")
$setting->comment="Setting the Joomla cache on reduces load time for all non-registered site visitors";
$settings[]=$setting;

$setting->setting="Joomla Cache";
$setting->current=$config->getValue("config.caching",0)?"On":"Off";
$setting->recommended="On";
$setting->comment="Setting the Joomla cache on reduces load time for all non-registered site visitors";
$settings[]=$setting;



foreach ($settings as $setting) {
	$setting->problem=0;
	if ($setting->recommended!=$setting->current){
		$setting->problem=1;
	}
	?>
	<tr <?php echo $setting->problem?"style='color:red;font-weight:bold'":"";?> >
		<td><?php echo $setting->setting;?></td>
		<td><?php echo $setting->current;?></td>
		<td><?php echo $setting->recommended;?></td>
		<td><?php echo $setting->comment;?></td>
	</tr>
	<?php
}
?>
</table>
<?php

*/

$db = JFactory::getDBO();
jimport ("joomla.utilities.date");

$until = mktime(0,0,0,12,11,$params->get("com_latestyear",2020));
list ($d,$m,$y) = explode(":",strftime("%d:%m:%Y",$until));
$untilMidnight = strftime("%Y-%m-%d %H:%M:%S",$until);

$sql =<<<QUERY
SELECT count(rpt.rp_id) as cnt,rul.*, rpt.rp_id, det.* FROM #__jevents_repetition as rpt
LEFT JOIN  #__jevents_rrule as rul ON rul.eventid = rpt.eventid
LEFT JOIN #__jevents_vevdetail as det ON rpt.eventdetail_id = det.evdet_id 
WHERE rul.freq <>'NONE' 
GROUP BY rpt.eventid
HAVING count(rpt.rp_id)>100 
QUERY;
$db->setQuery( $sql );
$rows = $db->loadObjectList();
echo $db->getErrorMsg();
?>
<h2>Potential Performance Problem Causing Events</h2>
<table border="1" cellpadding="3">
	<tr>
		<th>Frequency</th>
		<th>Input Count</th>
		<th>Actual Count</th>
		<th>Input Until</th>
		<th>Last Repeat Start</th>
		<th>Event Id</th>
		<th>Title/Link</th>
	</tr>
<?php

foreach ($rows  as $row) {
	// Find last repeat
	$sql =<<<QUERY
SELECT rpt.startrepeat FROM #__jevents_repetition as rpt 
WHERE rpt.eventid = $row->eventid
ORDER BY rpt.startrepeat DESC
LIMIT 1
QUERY;
	$db->setQuery( $sql );
	$lastrepeat = $db->loadResult();
	$link = "index.php?option=com_jevents&task=icalrepeat.detail&evid=".$row->rp_id;
	if ($row->until=="" || $row->until==0){
		 $row->until = " ";
	}
	else {
		$row->until=strftime("%Y-%m-%d",$row->until);
		if ($row->count==999){
			$row->count = "";
		}
	}
	?><tr><?php
	echo "<td>".$row->freq."</td><td>" .$row->count."</td><td>".$row->cnt."</td><td>".$row->until."</td><td>".substr($lastrepeat,0,10)."</td><td>".$row->eventid."</td><td><a href='$link'>".$row->summary. "</a></td>";
	?><tr><?php
}
?>
</table>
<h2>Overlapping Repeat Events</h2>
<p>These events have repeats that overlap - i.e. one repeat starts before another finishes.  This is usually a sign of a badly entered event.</p>
<table border="1" cellpadding="3">
	<tr>
		<th>Frequency</th>
		<th>Input Count</th>
		<th>Input Until</th>
		<th>Last Repeat Start</th>
		<th>Event Id</th>
		<th>Title/Link</th>
	</tr>
<?php
$sql =<<<QUERY
SELECT rul.*, rpt.rp_id, det.* FROM #__jevents_repetition as rpt
LEFT JOIN  #__jevents_repetition  as rpt2 ON rpt2.eventid = rpt.eventid
LEFT JOIN  #__jevents_rrule as rul ON rul.eventid = rpt.eventid
LEFT JOIN #__jevents_vevent as evt ON evt.ev_id = rpt.eventid
LEFT JOIN #__jevents_vevdetail as det ON rpt.eventdetail_id = det.evdet_id
WHERE rul.freq <>'NONE'
AND rpt2.startrepeat>rpt.startrepeat AND rpt2.startrepeat<rpt.endrepeat
GROUP BY rpt.eventid
QUERY;
$db->setQuery( $sql );
$rows = $db->loadObjectList();
echo $db->getErrorMsg();

foreach ($rows  as $row) {
	// Find last repeat
	$sql =<<<QUERY
SELECT rpt.startrepeat FROM #__jevents_repetition as rpt
WHERE rpt.eventid = $row->eventid
ORDER BY rpt.startrepeat DESC
LIMIT 1
QUERY;
	$db->setQuery( $sql );
	$lastrepeat = $db->loadResult();
	$link = "index.php?option=com_jevents&task=icalrepeat.detail&evid=".$row->rp_id;
	if ($row->until=="" || $row->until==0){
		 $row->until = " ";
	}
	else {
		$row->until=strftime("%Y-%m-%d",$row->until);
		if ($row->count==999){
			$row->count = "";
		}
	}
	?><tr><?php
	echo "<td>".$row->freq."</td><td>" .$row->count."</td><td>".$row->until."</td><td>".substr($lastrepeat,0,10)."</td><td>".$row->eventid."</td><td><a href='$link'>".$row->summary. "</a></td>";
	?><tr><?php
}
?>
</table>