<?php

/**
 *
 * @version     $Id: secretmodule.php geraintedwards $
 * @package     JEvents
 * @subpackage  Present Joomla Module To Remote Server
 * @copyright   Copyright (C) 2014-2021 GWE Systems Ltd
 * @license     GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
 * @link        http://www.jevents.net
 */
use \Joomla\CMS\Factory;
use \Joomla\CMS\Language\Text;
use \Joomla\CMS\Language\LanguageHelper;
use \Joomla\CMS\Language\Language;
use \Joomla\CMS\Uri\Uri;
use \Joomla\Registry\Registry;
use \Joomla\CMS\Router\Router;
use \Joomla\CMS\User\User;
use \Joomla\Utilities\ArrayHelper;

function gwejson_skiptoken()
{
	return true;

}

function ProcessJsonRequest(&$requestObject, $returnData)
{

	// Config Section - pick these up from paramters set somewher!
	// set cache lifetime in seconds - set to zero for no cache
	$CACHE_EXPIRY = 0;

	// Default menu item id
	$DEFAULT_ITEMID = 0;

	// Default Module Position
	$DEFAULT_POSITION = "";

	// Default Module Id
	$DEFAULT_MODULE_ID = 0;

	// End of Config Section

	ini_set("display_errors", 0);

	$input = Factory::getApplication()->input;

	$itemid = $input->get("Itemid", $DEFAULT_ITEMID, "int");
        if (!$itemid) {
            $itemid = $input->get("itemid", $DEFAULT_ITEMID, "int");
        }

	$position = $input->get("position", $DEFAULT_POSITION, "string");
	$modid = $input->get("modid", $DEFAULT_MODULE_ID, "int");

	// Should we check the cache?
	if ($CACHE_EXPIRY > 0)
	{
		$cacheExpiry = time() - $CACHE_EXPIRY;
		$cacheDir = dirname(__FILE__) . "/cache";
		if (!file_exists($cacheDir))
		{
			mkdir($cacheDir);
		}
		$cacheFile = md5($position . "_" . $itemid . "_" . $modid . "This is the extra bit of the file name");
		if (file_exists($cacheDir . "/" . $cacheFile) && @filemtime($cacheDir . "/" . $cacheFile) > $cacheExpiry)
		{
			header('Content-Type: text/html; charset=utf-8');
			return json_decode(file_get_contents($cacheDir . "/" . $cacheFile));
		}
	}

	// Find the correct base path
	$x = realpath("./");
	$strippath = "";
	if (strpos($x, "modules") && strpos($x, "mod_remoteloader") > 0)
	{
		$x = realpath("../../../");
		$strippath = "/modules/mod_remoteloader/remoteloader/";
	}
	// if this file is a soft link then use the SCRIPT_FILENAME server data to get the valid Joomla root folder
	if (!file_exists($x . "/plugins") && !file_exists($x . "/modules") && isset($_SERVER["SCRIPT_FILENAME"]))
	{
		$x = dirname($_SERVER["SCRIPT_FILENAME"]);
		if (strpos($x, "modules") && strpos($x, "mod_remoteloader") > 0)
		{
			$strippath = "/modules/mod_remoteloader/remoteloader/";
		}
		if (strpos($x, "modules") && strpos($x, "mod_remotemodule") > 0)
		{
			$strippath = "/modules/mod_remotemodule/remotemodule/";
		}
	}

	$app = Factory::getApplication('site');

// do we need to do this??
	if ($app->input->getCmd("lang", false))
	{
		$seflanguages = LanguageHelper::getLanguages('sef');
		if (isset($seflanguages[$app->input->getCmd("lang", false)]))
		{
			$lang = new Language($seflanguages[$app->input->getCmd("lang", false)]->lang_code);
			Factory::$language = $lang;
		}
	}
        else {
            $lang = Factory::getLanguage();
        }

	ini_set("display_errors", 0);
        
	$menu = Factory::getApplication('site')->getMenu();
	if ($modid <= 0 && $itemid <= 0 && $position == "")
	{		
                echo "invalid input";
		exit();
	}

	if ($itemid > 0)
	{
		$rau = $input->getInt("rau",0);
		if ($rau) {
			$db = Factory::getDBO();

			$query = 'SELECT id,  params  FROM #__modules where module="mod_remoteloader"';
			$db->setQuery($query);
			$remoteloader = $db->loadObject();
			if($remoteloader)
			{
				// Get module parameters
				$params = new Registry;
				$params->loadString($remoteloader->params);

				$remoteaccessuser = (int) $params->get("remoteaccessuser", 0);
				if ($remoteaccessuser){
					$remoteaccessuser_validation = $params->get("remoteaccessuser_validation", "");
					$remoteaccessuser_test = $input->get("remoteaccessuser_validation", "");
					if ($remoteaccessuser_validation == $remoteaccessuser_test)
					{
						JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");
						$registry = JevRegistry::getinstance("jevents");
						$puser = User::getInstance($remoteaccessuser);
						$registry->set("jevents.icaluser", $puser);
					}					
				}
			}	
				
		}
		$data = ComponentServices::component($itemid);
	}
	else
	{
		$data = ModuleServices::modules($position, $modid);
	}

	// Process the head code
	$head = "";

    $host = Uri::root();
	if ($strippath!=""){
		$host = str_replace($strippath, "", $host);
	}

	if ($app->input->getInt("loadcss", 0) || $app->input->getInt("loadjs", 0))
	{
		$document = Factory::getDocument();
		$renderer = $document->loadRenderer('head');

		// Do we want to return the output in JSON format to be processed by mod_remoteloader.php ?
		if ($app->input->getInt("asJSON", 0))
		{
			$headData = array();
			if ($app->input->getInt("loadcss", 0))
			{
				// Generate stylesheet links
				foreach ($document->_styleSheets as $strSrc => $strAttr)
				{
					$strSrc = str_replace($strippath, "", $strSrc);
					if (!isset($headData["stylesheets"]))
					{
						$headData["stylesheets"] = array();
					}
					$headData["stylesheets"][] = array("strSrc" => $strSrc, "strAttr" => $strAttr);
				}

				// Generate stylesheet declarations
				foreach ($document->_style as $type => $content)
				{
					if (!isset($headData["styles"]))
					{
						$headData["styles"] = array();
					}
					$headData["styles"][] = array("type" => $type, "content" => $content);
				}
			}

			if ($app->input->getInt("loadjs", 0))
			{
				// Generate script file links
				foreach ($document->_scripts as $strSrc => $strAttr)
				{
					$strSrc = str_replace($strippath, "", $strSrc);
					if (!isset($headData["scriptfiles"]))
					{
						$headData["scriptfiles"] = array();
					}
					$headData["scriptfiles"][] = array("strSrc" => $strSrc, "strAttr" => $strAttr);
				}

				// Generate script declarations
				foreach ($document->_script as $type => $content)
				{
					if (!isset($headData["scripts"]))
					{
						$headData["scripts"] = array();
					}
					$headData["scripts"][] = array("type" => $type, "content" => $content);
				}

				// Generate script language declarations.
				if (count(Text::script()))
				{
					$lnEnd = $document->_getLineEnd();
					$tab = $document->_getTab();
					$langscript = $tab . $tab . '(function() {' . $lnEnd;
					$langscript .= $tab . $tab . $tab . 'var strings = ' . json_encode(Text::script()) . ';' . $lnEnd;
					$langscript .= $tab . $tab . $tab . 'if (typeof Joomla == \'undefined\') {' . $lnEnd;
					$langscript .= $tab . $tab . $tab . $tab . 'Joomla = {};' . $lnEnd;
					$langscript .= $tab . $tab . $tab . $tab . 'Joomla.Text = strings;' . $lnEnd;
					$langscript .= $tab . $tab . $tab . '}' . $lnEnd;
					$langscript .= $tab . $tab . $tab . 'else {' . $lnEnd;
					$langscript .= $tab . $tab . $tab . $tab . 'Joomla.Text.load(strings);' . $lnEnd;
					$langscript .= $tab . $tab . $tab . '}' . $lnEnd;
					$langscript .= $tab . $tab . '})();' . $lnEnd;

					if (!isset($headData["scripts"]))
					{
						$headData["scripts"] = array();
					}
					$headData["scripts"][] = array("type" => "text/javascript", "content" => $langscript);
				}
			}

			$head = $headData;
		}
		else
		{
			//$head = $renderer->render(null);
			// do it long hand to get more control!
			// Get line endings
			$lnEnd = $document->_getLineEnd();
			$tab = $document->_getTab();
			$tagEnd = ' />';

			// Generate base tag (need to happen first)
			$base = $document->getBase();
			if (!empty($base))
			{
				$head .= '<base href="' . $document->getBase() . '" />' . $lnEnd;
			}

			$head .= $tab . '<title>' . htmlspecialchars($document->getTitle(), ENT_COMPAT, 'UTF-8') . '</title>' . $lnEnd;

			if ($app->input->getInt("loadcss", 0))
			{
				// Generate stylesheet links
				foreach ($document->_styleSheets as $strSrc => $strAttr)
				{
					$strSrc = $host . "/" . str_replace($strippath, "", $strSrc);

					$head .= $tab . '<link rel="stylesheet" href="' . $strSrc . '" type="' . $strAttr['mime'] . '"';
					if (!is_null($strAttr['media']))
					{
						$head .= ' media="' . $strAttr['media'] . '" ';
					}

					if ($temp = ArrayHelper::toString($strAttr['attribs']))
					{
						$head .= ' ' . $temp;
					}
					$head .= $tagEnd . $lnEnd;
				}

				// Generate stylesheet declarations
				foreach ($document->_style as $type => $content)
				{
					$head .= $tab . '<style type="' . $type . '">' . $lnEnd;

					// This is for full XHTML support.
					if ($document->_mime != 'text/html')
					{
						$head .= $tab . $tab . '<![CDATA[' . $lnEnd;
					}

					$head .= $content . $lnEnd;

					// See above note
					if ($document->_mime != 'text/html')
					{
						$head .= $tab . $tab . ']]>' . $lnEnd;
					}
					$head .= $tab . '</style>' . $lnEnd;
				}
			}

			if ($app->input->getInt("loadjs", 0))
			{
				// Generate script file links
				foreach ($document->_scripts as $strSrc => $strAttr)
				{
					$strSrc = $host . "/" . str_replace($strippath, "", $strSrc);

					$head .= $tab . '<script src="' . $strSrc . '"';
					if (!is_null($strAttr['mime']))
					{
						$head .= ' type="' . $strAttr['mime'] . '"';
					}
					if ($strAttr['defer'])
					{
						$head .= ' defer="defer"';
					}
					if ($strAttr['async'])
					{
						$head .= ' async="async"';
					}
					$head .= '></script>' . $lnEnd;
				}

				// Generate script declarations
				foreach ($document->_script as $type => $content)
				{
					$head .= $tab . '<script type="' . $type . '">' . $lnEnd;

					// This is for full XHTML support.
					if ($document->_mime != 'text/html')
					{
						$head .= $tab . $tab . '<![CDATA[' . $lnEnd;
					}

					$head .= $content . $lnEnd;

					// See above note
					if ($document->_mime != 'text/html')
					{
						$head .= $tab . $tab . ']]>' . $lnEnd;
					}
					$head .= $tab . '</script>' . $lnEnd;
				}

				// Generate script language declarations.
				if (count(Text::script()))
				{
					$head .= $tab . '<script type="text/javascript">' . $lnEnd;
					$head .= $tab . $tab . '(function() {' . $lnEnd;
					$head .= $tab . $tab . $tab . 'var strings = ' . json_encode(Text::script()) . ';' . $lnEnd;
					$head .= $tab . $tab . $tab . 'if (typeof Joomla == \'undefined\') {' . $lnEnd;
					$head .= $tab . $tab . $tab . $tab . 'Joomla = {};' . $lnEnd;
					$head .= $tab . $tab . $tab . $tab . 'Joomla.Text = strings;' . $lnEnd;
					$head .= $tab . $tab . $tab . '}' . $lnEnd;
					$head .= $tab . $tab . $tab . 'else {' . $lnEnd;
					$head .= $tab . $tab . $tab . $tab . 'Joomla.Text.load(strings);' . $lnEnd;
					$head .= $tab . $tab . $tab . '}' . $lnEnd;
					$head .= $tab . $tab . '})();' . $lnEnd;
					$head .= $tab . '</script>' . $lnEnd;
				}
			}
		}
	}

	// Start the output
	ob_clean();

	// force all links to open in top window
	$data = str_replace('<a ', '<a target="_blank" ', $data);

	// May have relative paths to scripts etc. in element events!
	//$data =str_replace($strippath, $host . "/"  , $data);
	// Some may have be absolute URLs with module path in them so need to remove duplicate $host
	//$data =str_replace($host.$host, $host  , $data);
	// May have relative paths to scripts etc. in element events!
	if (strlen($strippath)>0){
		$data = str_replace($strippath, "/", $data);
	}

	// Replace src links.
	$regex = '#\s+(src|href|poster)\s*=\s*"(/)#m';
	$data = preg_replace($regex, " $1=\"$host\$2", $data);
	$regex = "#\s+(src|href|poster)\s*=\s*'(/)#m";
	$data = preg_replace($regex, " $1='$host\$2", $data);
	if (strrpos($host, "/") == strlen($host)-1) {
		$data   = str_replace($host."/", $host, $data);
	}

	if ($app->input->getInt("asJSON", 0))
	{
		$storeddata = array();
		$output = array("head" => $head, "data" => $data, "host" => $host, "storeddata"=>$storeddata);

		//$output = array_map("utf8_encode", $output);
		//$output = array_map("htmlentities", $output);


		// json_encoding is done by gwejson plugin!
		//$data = json_encode($output);
		// so we use this instead
		$data = $output;
	}
	else
	{
		$document = Factory::getDocument();
		header('Content-Type: text/html; charset=utf-8');
		ob_start();
		?>
		<html>
			<head>
				<?php
				echo $head;
				?>
			</head>
			<body>
				<?php
				echo $data;
				?>
			</body>
		</html>
		<?php
		$data = ob_get_clean();
	}
	// Should we cache the results
	if ($CACHE_EXPIRY > 0)
	{
		$cacheFile = md5($position . "_" . $itemid . "_" . $modid . "This is the extra bit of the file name");
		$cacheDir = dirname(__FILE__) . "/cache";
		file_put_contents($cacheDir . "/" . $cacheFile, json_encode($data));
	}
	ob_clean();

	return $data;

}

class ModuleServices
{

	public static function modules($position = "", $modid = 0)
	{

		$services = new ModuleServices();

		$services->setupRouter();

		$modules = $services->getModules($position, $modid);
		$contents = "";

		foreach ($modules as $module)
		{

			$modcontent = $services->renderModule($module);
			$content = "";

			if (!empty($modcontent))
			{
				if (isset($module->title) && count($modules) > 1)
				{
					$content .= "<div class='remoteloadertitle'>$module->title</div>\n";
				}
				$content .= "<div class='remoteloadercontent'>\n";
				$content .= $modcontent;
				$content .= "</div>";
			}

			$contents .= $content;
		}

		$contents = str_replace("xmlrpc/", "", $contents);

		//$data = str_split($contents, 128);

		return $contents;

	}

	function getModules($position = "", $modid = 0)
	{

		$db = Factory::getDBO();

		$query = 'SELECT id, title, module, position, content, showtitle,  params'
				. ' FROM #__modules AS m'
				. ' LEFT JOIN #__modules_menu AS mm ON mm.moduleid = m.id'
				. ' WHERE m.published = 1'
				. ' AND m.access <= 1 '
				. ' AND m.client_id = 0'
				. ($position != "" ? ' AND position="' . $position . '"' : "")
				. ($modid > 0 ? ' AND m.id=' . $modid : "")
				. ' GROUP BY m.id'
				. ' ORDER BY position, ordering';

		$db->setQuery($query);

		if (null === ($modules = $db->loadObjectList()))
		{
			// echo $db->getErrorMsg();
			return false;
		}

		$total = count($modules);
		for ($i = 0; $i < $total; $i ++)
		{
			//determine if this is a custom module
			$file = $modules [$i]->module;
			$custom = substr($file, 0, 4) == 'mod_' ? 0 : 1;
			$modules [$i]->user = $custom;
			// CHECK: custom module name is given by the title field, otherwise it's just 'om' ??
			$modules [$i]->name = $custom ? $modules [$i]->title : substr($file, 4);
			$modules [$i]->style = null;
			$modules [$i]->position = strtolower($modules [$i]->position);
		}

		return $modules;

	}

	function renderModule($module)
	{
		jimport("joomla.application.module.helper");
		jimport("joomla.plugin.helper");
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');

		$document = Factory::getDocument();
		$renderer = $document->loadRenderer('module');

		// Get module parameters
		$params = new Registry();
		$params->loadString($module->params);

		$result = null;
		$content = $renderer->render($module, array(), $result);

		return $content;

	}

	public
			function setupRouter()
	{
		// TODO report the need for a router to Joomla Core Team

		jimport("joomla.application.router");
		$config = Factory::getConfig();

		$options['mode'] = $config->get('sef', $config->get('config.sef'));

		$router = Router::getInstance('site', $options);

        // Setup the language in the router for the language filter plugin to do its stuff!
        // Get the full request URI.
        $uri = clone Uri::getInstance();
        $result = $router->parse($uri);
                
		$config->set('config.live_site', "https://" . $_SERVER['HTTP_HOST']);

	}

	function getLayoutPath($module, $layout = 'default')
	{

		static $template;
		if (!isset($template))
		{

			// Build the template and base path for the layout
			$db = Factory::getDBO();
			$query = 'SELECT template'
					. ' FROM #__templates_menu'
					. ' WHERE client_id = 0 AND menuid = 0 '
					. ' ORDER BY menuid DESC'
			;
			$db->setQuery($query, 0, 1);
			$template = $db->loadResult();
		}

		$tPath = JPATH_SITE . "/" . 'templates' . "/" . $template . "/" . 'html' . "/" . $module . "/" . $layout . '.php';
		$bPath = JPATH_SITE . "/" . 'modules' . "/" . $module . "/" . 'tmpl' . "/" . $layout . '.php';

		// If the template has a layout override use it
		if (file_exists($tPath))
		{
			return $tPath;
		}
		else
		{
			return $bPath;
		}

	}

}


class ComponentServices
{
	public static function component($itemid = 0)
	{
		$menu = Factory::getApplication('site')->getMenu();
		$menuitem  = $menu->getItem($itemid);

		if (!$menuitem ){
			return "Invalid menu";
		}
		$menu->setActive($itemid);
                foreach ($menuitem->query as $key => $value){
                    Factory::getApplication('site')->input->def($key, $value);
                }
                // just in case passing in lower case in URL
                Factory::getApplication('site')->input->def("Itemid", $itemid);
                                
		Factory::getApplication('site')->dispatch();

		$document = Factory::getDocument();

		$data = $document->getBuffer("component");
		return $data;
	}
}
