<?php
/**
 * @copyright	Copyright (C) 2010-2016 GWE Systems Ltd - All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgAcymailingTagjevents_jevents extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$lang = JFactory::getLanguage();
		$lang->load('plg_acymailing_tagjevents_jevents');
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'tagjevents');
			$this->params = new JRegistry( $plugin->params );
		}
	}
	function acymailing_getPluginType() {
		$onePlugin = new stdClass();
		$onePlugin->name = JText::_('JEvents');
		$onePlugin->function = 'acymailingjevents_show';
		$onePlugin->help = 'plugin-tagjevents';
		return $onePlugin;
	}
	function acymailingjevents_show(){
		define("JEV_COM_COMPONENT","com_jevents");
		require_once (JPATH_SITE."/components/com_jevents/libraries/jeventshtml.php");
		$text = '<table class="adminlist" cellpadding="1">';
		$text .= '<tr style="cursor:pointer" class="row0" onclick="updateEventTag(\'jevents\');" ><td>'.JText::_('PLG_ACYMAILING_TAGJEVENTS_JEVENTS_LATEST_EVENTS').'</td><td>'.JText::_('PLG_ACYMAILING_TAGJEVENTS_JEVENTS_LATEST_EVENTS_SUMMARY').'</td></tr>';
		
		$categories = JEventsHTML::buildCategorySelect( 0, 'multiple="multiple" onchange="updateEventTag(\'jevents\');"',null,false,false,0,'jevcatid' );
		$text .='<tr style="cursor:pointer" class="row0" ><td>' . JText::_('PLG_ACYMAILING_TAGJEVENTS_JEVENTS_CHOOSE_CATEGORY') . '</td><td>' . $categories . '</td></tr>';

		$text .= '</table>';

		$script = <<<SCRIPT
		<!--
			var selectedContents = new Array();

			function updateEventTag(tag)
			{

				var otherinfo = '';
				var already = 0;
				var catids = [];
				
				jQuery('#jevcatid :selected').each(function(i, selected){
					catids[i] = jQuery(selected).val();
				});

				console.log(catids);

				if(catids.length>0)
				{
					otherinfo = '|catids=' + catids.join();
				}

				if(otherinfo.length>0)
				{
					tag = '{' + tag + otherinfo + '}';
				}
				else
				{
					tag = '{' + tag + '}';
				}

				setTag(tag);
			}
		//-->
SCRIPT;

		$text .= '<script language="javascript" type="text/javascript">' . $script . '</script>';

		echo $text;
	}
	/*
	function acymailing_replaceusertagspreview(&$email,&$user){
	return $this->acymailing_replacejeventstags($email,$user);
	}
	function acymailing_replacejeventstags(&$email,&$user){
	*/

	function acymailing_replacetags(&$email){
		return $this->acymailing_replacejeventstags($email);
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();
		$result = $this->acymailing_replacejeventstags($email);

		if(!$result)
		{
			$return->message = JText::_('PLG_ACYMAILING_TAGJEVENTS_JEVENTS_NO_EVENTS');
			$return->status = false;
			return $return;
		}

		return $return;

	}

	function acymailing_replacejeventstags(&$email){
		$match = '#{jevents(|.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			if(empty($results[$var][0])) unset($results[$var]);
		}
		if(!$found) return true;
		$tags = array();
		$eventsFound = false;
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($tags[$oneTag])) continue;
				$eventsData = $this->replaceSubTag($allresults,$i);
				if(!empty($eventsData))
				{
					$eventsFound = true;
					$tags[$oneTag] = $eventsData;
				}
				else
				{
					$tags[$oneTag] = "<br style='clear:both'/>";
				}
			}
		}
		
		foreach(array_keys($results) as $var){
			$email->$var = str_replace(array_keys($tags),$tags,$email->$var);
		}

		if(!$eventsFound)
		{
			return false;
		}

		return true;
	}

	function replaceSubTag($allresults,$i) {
		$catids=false;
		if (count($allresults)==2 &&  strpos($allresults[1][$i],"|catids=")===0){
			$catids= str_replace("|catids=","",$allresults[1][$i]);
			$catids = explode(",",$catids);
			$catids = Joomla\Utilities\ArrayHelper::toInteger($catids);
		}

		$result = $this->getLatestEvents($catids);

		return $result;
	}


	//function _getLatestEvents($userName, $userId){
	private function getLatestEvents($catids){

		$return = "";
		//JRequest::setVar("jevu_fv",$userId);
		require_once (JPATH_SITE."/modules/mod_jevents_latest/helper.php");

		$jevhelper = new modJeventsLatestHelper();
		$theme = $this->params->get("com_calViewName", JEV_CommonFunctions::getJEventsViewName());

		JPluginHelper::importPlugin("jevents");

		$viewclass = $jevhelper->getViewClass($theme, 'mod_jevents_latest',$theme . "/latest", $this->params);

		// create temporary clone of the params for tinkering with
		$this->tempparams = clone $this->params;

		// Set categories in params
		if ($catids && count($catids)>0){
			for ($c=0; $c < 999; $c++) {
				$nextCID = "catid$c";
				//  stop looking for more catids when you reach the last one!
				if (!$nextCatId = $this->tempparams->get( $nextCID, null)) {
					break;
				}
			}
			// now add in the constraints
			foreach($catids as $catid){
				$nextCID = "catid$c";
				$this->tempparams->set( $nextCID, $catid);
				$c++;
			}

		}

		// record what is running - used by the filters
		$registry	= JRegistry::getInstance("jevents");
		$registry->set("jevents.activeprocess","mod_jevents_latest");
		$registry->set("jevents.moduleid", "cb");
		$registry->set("jevents.moduleparams", $this->tempparams);

		$modview = new $viewclass($this->tempparams, 0);
		$return .= $modview->displayLatestEvents();

		// replace seffed URLs generated from the backend of the site
		$return = str_replace('/administrator/', '/', $return);
		
		/*
		$menuitem = intval($this->tempparams->get("target_itemid",0));
		//$link = JRoute::_("index.php?option=com_jevents&jevu_fv=".$userId."&Itemid=".$menuitem);
		$link = JRoute::_("index.php?option=com_jevents&Itemid=".$menuitem);

		if (intval($this->tempparams->get("modlatest_LinkToCal",0))) {
			$return .="<strong>".JText::sprintf("JEV_CLICK_TOCOMPONENT",$link)."<strong>";
		}
		 */
		return $return;
	}


}//endclass