<?php

/**
 * copyright (C) 2008 GWE Systems Ltd - All rights reserved
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;

JEVHelper::stylesheet("catbar.css", 'modules/mod_jevents_dynamiclegend/tmpl/');

list($subcatlist, $topcatlist, $task, $Itemid, $year, $month, $day) = $jevLegendHelper->PrepareViewCatbar();

?>
	<nav class="uk-navbar-container" id="jevcatbar" uk-navbar>
	<div class="uk-navbar-left">
		<ul class="uk-navbar-nav">
			<?php
			if ($jevLegendHelper->params->get("positionall", 0) == 1)
			{
				?>
				<li>
					<?php
					$all = Text::_("JEV_DYNAMIC_ALL");
					if ($all == "JEV_DYNAMIC_ALL")
					{
						$all = "All";
					}
					$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=0&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
					?>
					<a href='<?php echo $link; ?>' title='All'>
						<span style='border-width:0px;border-color:transparent'>
							<?php echo $all; ?>
						</span>
					</a>
				</li>
				<?php
			}

			$zindex = count($topcatlist) + 7;
			foreach ($topcatlist as $cat)
			{
				$zindex--;
				$jevLegendHelper->DefaultViewCatbarGetColour($cat);
				?>
				<li class=" <?php echo $cat->isActive ? 'active' : ($cat->isSubActive ? 'subactive' : ''); ?>" style="z-index:<?php echo $zindex; ?>">
					<?php
					$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $cat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
					// should we convert this link into a span
					$disableparent = false;
					if ($jevLegendHelper->params->get("disableparent", 0))
					{
						foreach ($subcatlist as $subcat)
						{
							if ($subcat->parent_id == $cat->id)
							{
								$disableparent = true;
								break;
							}
						}
					}
					if (!$disableparent)
					{
						?>
						<a class='<?php echo $cat->isActive ? 'active' : ($cat->isSubActive ? 'subactive' : ''); ?>' href='$link' title='<?php echo htmlspecialchars($cat->title) ?>'>
							<span style='border-color:<?php echo $cat->color ?>'>
								<?php echo $cat->title; ?>
							</span>
						</a>
						<?php
					}
					else
					{
						// the next line disables the top level selections
						?>
						<span class='spanfolder  <?php echo $cat->isActive ? 'active' : ($cat->isSubActive ? 'subactive' : ''); ?>' href='$link' title='<?php echo htmlspecialchars($cat->title) ?>'>
							<span style='border-color:<?php echo $cat->color ?>'>
								<?php echo $cat->title ?>
							</span>
						</span>
						<?php
						$tempcat            = clone $cat;
						$tempcat->parent_id = $tempcat->id;
						$tempcat->skipkids  = true;
						array_unshift($subcatlist, $tempcat);
					}

					$opensubcat = false;
					foreach ($subcatlist as $subcat)
					{
					if ($subcat->parent_id == $cat->id)
					{
					$jevLegendHelper->DefaultViewCatbarGetColour($subcat);

					if (!$opensubcat)
					{
					?>
					<div class="uk-navbar-dropdown">
						<ul class="uk-nav uk-navbar-dropdown-nav">
							<?php
							$opensubcat = true;
							}
							?>
							<li class='  <?php echo($subcat->isActive ? 'active' : ($subcat->isSubActive ? 'subactive' : '')) ?>'>
								<?php
								$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
								// should we convert this link into a span
								$disableparent = false;
								if ($jevLegendHelper->params->get("disableparent", 0))
								{
									foreach ($subcatlist as $subsubcat)
									{
										if ($subsubcat->parent_id == $subcat->id && !isset($subcat->skipkids))
										{
											$disableparent = true;
											break;
										}
									}
								}
								if (!$disableparent)
								{
									?>
									<a class='  <?php echo($subcat->isActive ? 'active' : ($subcat->isSubActive ? 'subactive' : '')) ?>' href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subcat->title) ?>'>
										<span style='border-color:<?php echo $subcat->color ?>'><?php echo $subcat->title ?></span>
									</a>
									<?php
								}
								else
								{
									// the next line disables the top level selections
									?>
									<span class='spanfolder   <?php echo($subcat->isActive ? 'active' : ($subcat->isSubActive ? 'subactive' : '')) ?>' href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subcat->title) ?>'>
										<span style='border-color:<?php echo $subcat->color ?>'>
											<?php echo $subcat->title ?>
										</span>
									</span>
									<?php
									$tempcat            = clone $subcat;
									$tempcat->parent_id = $tempcat->id;
									$tempcat->skipkids  = true;
									array_unshift($subcatlist, $tempcat);
								}

								$opensubsubcat = false;
								foreach ($subcatlist as $subsubcat)
								{
								// if this is a dummy entry to replace the parent's link then skips its kids here
								if (isset($subcat->skipkids))
								{
									continue;
								}
								if ($subsubcat->parent_id == $subcat->id)
								{
								$jevLegendHelper->DefaultViewCatbarGetColour($subsubcat);

								if (!$opensubsubcat)
								{
								?>
								<div class="uk-navbar-dropdown">
									<ul class="uk-nav uk-navbar-dropdown-nav">
										<?php
										$opensubsubcat = true;
										}
										?>
										<li class=' <?php echo($subsubcat->isActive ? 'active' : ($subsubcat->isSubActive ? 'subactive' : '')) ?>'>
											<?php
											$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
											// should we convert this link into a span
											$disableparent = false;
											if ($jevLegendHelper->params->get("disableparent", 0))
											{
												foreach ($subcatlist as $subsubsubcat)
												{
													if ($subsubsubcat->parent_id == $subsubcat->id && !isset($subsubcat->skipkids))
													{
														$disableparent = true;
														break;
													}
												}
											}
											if (!$disableparent)
											{
												?>
												<a class=' <?php echo($subsubcat->isActive ? 'active' : ($subsubcat->isSubActive ? 'subactive' : '')) ?>'
												   href='<?php echo $link;?>'
												   title='<?php echo htmlspecialchars($subsubcat->title) ?>'>
													<span style='border-color:<?php echo $subsubcat->color ?>'>
														<?php echo $subsubcat->title ?>
													</span>
												</a>
												<?php
											}
											else
											{
												// the next line disables the top level selections
												?>
												<span class='spanfolder  <?php echo($subsubcat->isActive ? 'active' : ($subsubcat->isSubActive ? 'subactive' : '')) ?>'
												      href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subsubcat->title) ?>'>
													<span style='border-color:<?php echo $subsubcat->color ?>'>
														<?php echo $subsubcat->title ?>
													</span>
												</span>
												<?php
												$tempcat            = clone $subsubcat;
												$tempcat->parent_id = $tempcat->id;
												$tempcat->skipkids  = true;
												array_unshift($subcatlist, $tempcat);
											}

											$opensubsubsubcat = false;
											foreach ($subcatlist as $subsubsubcat)
											{
											// if this is a dummy entry to replace the parent's link then skips its kids here
											if (isset($subsubcat->skipkids))
											{
												continue;
											}

											if ($subsubsubcat->parent_id == $subsubcat->id)
											{
											$jevLegendHelper->DefaultViewCatbarGetColour($subsubsubcat);

											if (!$opensubsubsubcat)
											{
											?>
											<div class="uk-navbar-dropdown">
												<ul class="uk-nav uk-navbar-dropdown-nav">
													<?php
													$opensubsubsubcat = true;
													}
													?>
													<li class=' <?php echo($subsubsubcat->isActive ? 'active' : ($subsubsubcat->isSubActive ? 'subactive' : '')) ?>'>
														<?php
														$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
														// should we convert this link into a span
														$disableparent = false;
														if ($jevLegendHelper->params->get("disableparent", 0))
														{
															foreach ($subcatlist as $subsubsubsubcat)
															{
																if ($subsubsubsubcat->parent_id == $subsubsubcat->id && !isset($subsubsubcat->skipkids))
																{
																	$disableparent = true;
																	break;
																}
															}
														}
														if (!$disableparent)
														{
															?>
															<a class=' <?php echo($subsubsubcat->isActive ? 'active' : ($subsubsubcat->isSubActive ? 'subactive' : '')) ?>'
															   href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subsubsubcat->title) ?>'>
																<span style='border-color:<?php echo $subsubsubcat->color ?>'>
																	<?php echo $subsubsubcat->title ?>
																</span>
															</a>
															<?php
														}
														else
														{
															// the next line disables the top level selections
															?>
															<span class='spanfolder  <?php echo($subsubsubcat->isActive ? 'active' : ($subsubsubcat->isSubActive ? 'subactive' : '')) ?>'
															      href='<?php echo $link;?>'  title='<?php echo htmlspecialchars($subsubsubcat->title) ?>'>
																<span style='border-color:<?php echo $subsubsubcat->color ?>'>
																	<?php echo $subsubsubcat->title ?>
																</span>
															</span>
															<?php
															$tempcat            = clone $subsubsubcat;
															$tempcat->parent_id = $tempcat->id;
															$tempcat->skipkids  = true;
															array_unshift($subcatlist, $tempcat);
														}

														$opensubsubsubsubcat = false;
														foreach ($subcatlist as $subsubsubsubcat)
														{
														// if this is a dummy entry to replace the parent's link then skips its kids here
														if (isset($subsubsubcat->skipkids))
														{
															continue;
														}

														if ($subsubsubsubcat->parent_id == $subsubsubcat->id)
														{
														$jevLegendHelper->DefaultViewCatbarGetColour($subsubsubsubcat);

														if (!$opensubsubsubsubcat)
														{
														?>
														<div class="uk-navbar-dropdown">
															<ul class="uk-nav uk-navbar-dropdown-nav">
																<?php
																$opensubsubsubsubcat = true;
																}
																?>
																<li class=' <?php echo($subsubsubsubcat->isActive ? 'active' : ($subsubsubsubcat->isSubActive ? 'subactive' : '')) ?>'>
																	<?php
																	$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubsubsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
																	// should we convert this link into a span
																	$disableparent = false;
																	if ($jevLegendHelper->params->get("disableparent", 0))
																	{
																		foreach ($subcatlist as $subsubsubsubsubcat)
																		{
																			if ($subsubsubsubsubcat->parent_id == $subsubsubsubcat->id && !isset($subsubsubsubcat->skipkids))
																			{
																				$disableparent = true;
																				break;
																			}
																		}
																	}
																	if (!$disableparent)
																	{
																		?>
																		<a class='<?php echo($subsubsubsubcat->isActive ? 'active' : ($subsubsubsubcat->isSubActive ? 'subactive' : '')) ?>'
																		   href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subsubsubsubcat->title) ?>'>
																			<span style='border-color:<?php echo $subsubsubsubcat->color ?>'>
																				<?php echo $subsubsubsubcat->title ?>
																			</span>
																		</a>
																		<?php
																	}
																	else
																	{
																		// the next line disables the top level selections
																		?>
																		<span class='spanfolder <?php echo($subsubsubsubcat->isActive ? 'active' : ($subsubsubsubcat->isSubActive ? 'subactive' : '')) ?>'
																		      href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subsubsubsubcat->title) ?>'>
																			<span style='border-color:<?php echo $subsubsubsubcat->color ?>'>
																				<?php echo $subsubsubsubcat->title ?>
																			</span>
																		</span>
																		<?php
																		$tempcat            = clone $subsubsubsubcat;
																		$tempcat->parent_id = $tempcat->id;
																		$tempcat->skipkids  = true;
																		array_unshift($subcatlist, $tempcat);
																	}

																	$opensubsubsubsubsubcat = false;
																	foreach ($subcatlist as $subsubsubsubsubcat)
																	{
																	// if this is a dummy entry to replace the parent's link then skips its kids here
																	if (isset($subsubsubsubcat->skipkids))
																	{
																		continue;
																	}
																	if ($subsubsubsubsubcat->parent_id == $subsubsubsubcat->id)
																	{
																	$jevLegendHelper->DefaultViewCatbarGetColour($subsubsubsubsubcat);

																	if (!$opensubsubsubsubsubcat)
																	{
																	?>
																	<div class="uk-navbar-dropdown">
																		<ul class="uk-nav uk-navbar-dropdown-nav">
																			<?php
																			$opensubsubsubsubsubcat = true;
																			}
																			?>
																			<li class=' <?php echo($subsubsubsubsubcat->isActive ? 'active' : ($subsubsubsubsubcat->isSubActive ? 'subactive' : '')) ?>'>
																				<?php
																				$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subsubsubsubsubcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
																				?>
																				<a class='<?php echo($subsubsubsubsubcat->isActive ? 'active' : ($subsubsubsubsubcat->isSubActive ? 'subactive' : '')) ?>'
																				   href='<?php echo $link;?>' title='<?php echo htmlspecialchars($subsubsubsubsubcat->title) ?>'>
																					<span style='border-color:<?php echo $subsubsubsubsubcat->color ?>'>
																						<?php echo $subsubsubsubsubcat->title ?>
																					</span>
																				</a>
																			</li>
																			<?php
																			}
																			}
																			if ($opensubsubsubsubsubcat)
																			{
																			?>
																		</ul>
																	</div>
																<?
																}

																?>
																</li>
																<?php
																}
																}
																if ($opensubsubsubsubcat)
																{
																?>
															</ul>
														</div>
													<?

													}

													?>
													</li>
													<?php
													}
													}
													if ($opensubsubsubcat)
													{
													?>
												</ul>
											</div>
										<?

										}

										?>
										</li>
										<?php
										}
										}
										if ($opensubsubcat)
										{
										?>
									</ul>
								</div>
							<?

							}
							?>
							</li>
							<?php
							}
							}
							if ($opensubcat)
							{
							?>
						</ul>
					</div>
				<?

				}
				?>
				</li>
				<?php
			}
			if ($jevLegendHelper->params->get("positionall", 0) == 0)
			{
				?>
				<li>
					<?php
					$all = Text::_("JEV_DYNAMIC_ALL");
					if ($all == "JEV_DYNAMIC_ALL")
					{
						$all = "All";
					}
					$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=0&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
					?>
					<a href='<?php echo $link;?>' title='All'>
						<span style='border-width:0px;border-color:transparent'>
							<?php echo $all ?>
						</span>
					</a>
				</li>
				<?php
			}
			?>
		</ul>
	</div>
<?php
// remove all the cloned items from the subcatlist and re-index!
$newsubcatlist = array();
foreach ($subcatlist as $subcat)
{
	if (!isset($subcat->skipkids))
	{
		$newsubcatlist[$subcat->id] = $subcat;
	}
}
$subcatlist = $newsubcatlist;

$html = array();
unset($subcat);
foreach ($subcatlist as $subcat)
{
	if (isset($subcat->isActive) && $subcat->isActive)
	{
		if ($jevLegendHelper->params->get("breadcrumblinks", 1) == 1)
		{
			$link    = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
			$html [] = "<a  href='$link' title='" . htmlspecialchars($subcat->title) . "'>" . $subcat->title . "</a>";
		}
		else
		{
			$html [] = $subcat->title;
		}

		while (array_key_exists($subcat->parent_id, $subcatlist))
		{
			$subcat = $subcatlist[$subcat->parent_id];
			if ($jevLegendHelper->params->get("breadcrumblinks", 1) == 1)
			{
				$link    = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
				$html [] = "<a  href='$link' title='" . htmlspecialchars($subcat->title) . "'>" . $subcat->title . "</a>";
			}
			else
			{
				$html [] = $subcat->title;
			}
		}
		while (array_key_exists($subcat->parent_id, $topcatlist))
		{
			$subcat = $topcatlist[$subcat->parent_id];
			if ($jevLegendHelper->params->get("breadcrumblinks", 1) == 1)
			{
				$link    = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $subcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
				$html [] = "<a  href='$link' title='" . htmlspecialchars($subcat->title) . "'>" . $subcat->title . "</a>";
			}
			else
			{
				$html [] = $subcat->title;
			}
		}

		break;
	}
}

if (count($html) == 0)
{
	foreach ($topcatlist as $topcat)
	{
		if (isset($topcat->isActive) && $topcat->isActive)
		{
			if ($jevLegendHelper->params->get("breadcrumblinks", 1) == 1)
			{
				$link    = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=" . $topcat->id . "&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
				$html [] = "<a  href='$link' title='" . htmlspecialchars($topcat->title) . "'>" . $topcat->title . "</a>";
			}
			else
			{
				$html [] = $topcat->title;
			}
		}
	}
}

$html = implode(" -> ", array_reverse($html));
if ($html != "" && count($jevLegendHelper->catids) == 1 && $jevLegendHelper->catids[0] != 0)
{
	if ($jevLegendHelper->params->get("breadcrumblinks", 1) == 1)
	{
		$all = Text::_("JEV_DYNAMIC_ALL");
		if ($all == "JEV_DYNAMIC_ALL")
		{
			$all = "All";
		}
		$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "&task=" . $task . "&catids=0&year=$year&month=$month&day=$day&Itemid=" . $Itemid);
		$html = "<a  href='$link' title='All'>" . $all . "</a> -> " . $html;
	}
	else
	{
		$html = Text::_("ALL") . " -> " . $html;
	}

	$eventsInCat = Text::sprintf("JEV_DYNAMICLEG_EVENTS_IN_CATEGORY", $html);
	if ($eventsInCat == "JEV_DYNAMICLEG_EVENTS_IN_CATEGORY")
	{
		$eventsInCat = "Events in the Category : " . $html;
	}
	if ($jevLegendHelper->params->get("show_breadcrumbs", 1) == 1)
	{
		?>
		<div class='dynamicleg_breadcrumb' style='margin:5px 0px;color:gray'>
			<?php echo $eventsInCat; ?>
		</div>
		<?php
	}
	else
	{
		?>
		<br style='clear:left'/>
		</nav>
		<?php
	}
}
else
{
	?>
	<br style='clear:left'/>
	</nav>
	<?php
}
$jevLegendHelper->CloseViewCatbar();