<?php

/**
 * copyright (C) 2011 - 2017 GWE Systems Ltd - All rights reserved
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\Utilities\ArrayHelper;

class ModCategoriesView
{

	var $_modid = null;
	var $_params = null;
	var $inccss = false;
	var $disable = true;
	var $myItemid = 0;
	var $myTask = null;
	var $helper = null;

	function __construct(&$params, $modid, $helper)
	{

		$this->_modid = $modid;

		$this->_params = & $params;
		$this->datamodel = new JEventsdatamodel();
		$this->inccss = $params->get('modlatest_inccss', 1);
		$this->disable = false;
		$this->helper = $helper;

		$this->jevlayout = JEV_CommonFunctions::getJEventsViewName();
		if ($this->inccss)
		{
			//JEVHelper::componentStylesheet($this);
			JEVHelper::componentStylesheet($this, "modstyle.css");
		}

		include_once(JEV_LIBS . "/modfunctions.php");
		$this->myItemid = $params->get("target_itemid","");

		$this->corder = $params->get('cordering', 'c.title');

		if ($this->myItemid==""){
			$this->myItemid = $this->datamodel->setupModuleCatids($this->_params);
		}

		$menu =  Factory::getApplication()->getMenu('site');
		$menuItem = $menu->getItem($this->myItemid);
		if ($menuItem->component == JEV_COM_COMPONENT)
		{
			if (isset($menuItem->query["task"]))
			{
				$this->myTask = $menuItem->query["task"];
			}
			else
			{
				$this->myTask = $menuItem->query["view"] . "." . $menuItem->query["layout"];
			}
		}
		else
		{
			$this->myTask = "month.calendar";
		}

		static $css;

		if (!isset($css) && $params->get("hideinactivekids", 1))
		{
			$document = Factory::getDocument();
			$document->addStyleDeclaration(".childcat {display:none;}");
			$css = 1;
		}
		else {
			$document = Factory::getDocument();
			$document->addStyleDeclaration(".childcat {margin-left:10px;}");
			$css = 1;
		}

	}

	function getViewName()
	{
		return "default";

	}

	function displayCalendarCategories($style="list")
	{

		JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

		// since this is meant to be a comprehensive legend look for catids from menu first:
		global $mainframe;
		$cfg = JEVConfig::getInstance();
		$Itemid = isset($this->myItemid) ? $this->myItemid : JEVHelper::getItemid();

		$user =  Factory::getUser();

		$db = Factory::getDbo();
		// Parameters - This module should only be displayed alongside a com_jevents calendar component!!!
		$cfg = JEVConfig::getInstance();

		JEVHelper::loadCustomCSS();

		global $option; // NB $option must be global $option here!!!
		if ($this->disable && $option != JEV_COM_COMPONENT)
			return;

		$catidList = "";

		$menu =  Factory::getApplication()->getMenu();
		$active = $menu->getActive();
		if ((!is_null($active) && $active->component == JEV_COM_COMPONENT) || !isset($Itemid))
		{
			$params = ComponentHelper::getParams(JEV_COM_COMPONENT);
		}
		else
		{
			// If accessing this function from outside the component then I must load suitable parameters
			$params = $menu->getParams($Itemid);
		}
		$params = ComponentHelper::getParams(JEV_COM_COMPONENT);

		// constraints menu item
		$catids = array();
		// New system
		$newcats = $params->get("catidnew", false);
		if ($newcats && is_array($newcats))
		{
			foreach ($newcats as $newcat)
			{
				if (!in_array($newcat, $catids))
				{
					$catids[] = $newcat;
				}
			}
		}
		else
		{
			$c = 0;
			while ($nextCatId = $params->get("catid$c", null))
			{
				if (!in_array($nextCatId, $catids))
				{
					$catids[] = $nextCatId;
					$catidList .= (strlen($catidList) > 0 ? "," : "") . $nextCatId;
				}
				$c++;
			}
		}
		$this->menucatids = $catids;

		// module constraints on cats to show
		$modcatids = array();
		// New system
		$newcats = $this->_params->get("catidnew", false);
		if ($newcats && is_array($newcats))
		{
			foreach ($newcats as $newcat)
			{
				if (!in_array($newcat, $modcatids))
				{
					$modcatids[] = $newcat;
				}
			}
		}
		else if (version_compare(JVERSION, "1.6.0", 'ge')){
			// in this case we select ALL the categories
			$this->helper->getAllCats($this->_params, $modcatids, $modcatidList);
		}
		else
		{
			$c = 0;
			while ($nextCatId =  $this->_params->get("catid$c", null))
			{
				if (!in_array($nextCatId, $modcatids))
				{
					$modcatids[] = $nextCatId;
					$catidList .= (strlen($catidList) > 0 ? "," : "") . $nextCatId;
				}
				$c++;
			}
		}
		if (count($modcatids) == 0)
		{
			$this->helper->getAllCats($this->_params, $modcatids, $modcatidList);
		}
		
		if (!$this->_params->get("usemenuitemcats",0)){
			$catidList = implode(",",$modcatids);
		}
		else {
			$catidList = implode(",",$catids);
		}
				
		$separator = $params->get("catseparator", "|");

		// I should only show legend for items that **can** be shown in calendar so must filter based on GET/POST
		$catidsIn = Factory::getApplication()->input->getString('catids', "NONE");
		if ($catidsIn != "NONE")
			$catidsGP = explode("|", $catidsIn);
		else {
			if (!$this->_params->get("usemenuitemcats",0)) {
				// in this case use the menu item constraints to pre-select the checkboxes
				$catidsGP = $catids;
			}
			else {
				$catidsGP = array();
			}
		}
		$catidsGP = ArrayHelper::toInteger($catidsGP);
		$catidsGPList = implode(",", $catidsGP);
		$catidsGPList = "";
		
		// This produces a full tree of categories
		$allrows = $this->getCategoryHierarchy($catidList, $catidsGPList, $this->corder);

		$catcounts = $this->helper->countEventsByCat($allrows);

		// This is the full set of top level catids
		$availableCatsIds = "";
		foreach ($allrows as $row)
		{
			$availableCatsIds.=(strlen($availableCatsIds) > 0 ? $separator : "") . $row->cid;
		}

		$allcats = new catLegend("0", Text::_('JEV_LEGEND_ALL_CATEGORIES'), "#d3d3d3", Text::_('JEV_LEGEND_ALL_CATEGORIES_DESC'));
		$allcats->activeBranch = true;

		// All categories count
		$allcount = 0;
		foreach ($catcounts as $catcount)
		{
			$allcount += $catcount['evcount'];
		}
		$catcounts[0] = array('evcount' => $allcount, 'catid' => 0);

		array_push($allrows, $allcats);
		if (count($allrows) == 0)
			return "";
		else
		{

			if ($Itemid < 999999)
				$itm = "&Itemid=$Itemid";
			$task = Factory::getApplication()->input->getCmd('jevcmd', $cfg->get('com_startview'));

			list($year, $month, $day) = JEVHelper::getYMD();
			$tsk = "";
			if ($task == "month.calendar" || $task == "year.listeventsevents" || $task == "week.listevents" || $task == "year.listevents" || $task == "day.listevents" || $task == "cat.listevents")
			{
				$tsk = "&task=$task&year=$year&month=$month&day=$day";
			}
			else
			{
				$tsk = "&task=$this->myTask&year=$year&month=$month&day=$day";
			}
			$content = '<div class="event_categories_container" id="multicat_container"><ul>';
			foreach ($allrows as $row)
			{

				if (isset($row->activeBranch))
				{
					$content .= $this->listKids($row, $itm, $tsk, $availableCatsIds, $catcounts);
				}
			}
			$content .= "</ul></div>";

			if ($this->_params->get("multiselect", 0))
			{

				$catidsIn = Factory::getApplication()->input->getString('catids', "NONE");
				if ($catidsIn != "NONE")
					$catidsGP = explode("|", $catidsIn);
				else {
					if (!$this->_params->get("usemenuitemcats",0)) {
						// in this case use the menu item constraints to pre-select the checkboxes
						$catidsGP = $catids;
					}
					else {
						$catidsGP = array();
					}
				}
				$catidsGP = ArrayHelper::toInteger($catidsGP);

				$content .= '<input type="hidden" name="catids" id="multicatcatids" value="' . implode("|", $catidsGP) . '" />';
				if ($this->_params->get("combinedcategorylinks"))
				{
					$content .= '<input type="hidden" name="catidcombo" id="catidcombo" value="1" />';					
				}
				$content .= '<input type="button" value="'.Text::_("JEV_CAT_MOD_FILTER").'" onclick="multicatdo();" id="submitmf" />';
				$content .= '<input type="button" value="'.Text::_("JEV_CAT_MOD_RESET").'" onclick="multicatclear();" id="resetmf" />';
				// stop floating legend items
				$content .= '<br style="clear:both" />' ;
				$content .= "\n".'<script type="text/javascript">';

				$cat = "&catids=XXXXXX";
				$link = Route::_("index.php?option=" . JEV_COM_COMPONENT . "$cat$itm$tsk", false);
				$autosubmit = $this->_params->get("autosubmit",0);
				
				$content .= "function setmulticat(rowid){
				var row = jQuery('#mlcat'+rowid);
				var inputs = jQuery('#multicat_container input[type=checkbox]');
				if(rowid==0 && row.prop('checked')){
					jQuery('#multicatcatids').val('');
					inputs.prop('checked', true);
                                        jQuery('#mlcat0').prop('checked', false);
					if ($autosubmit){
						multicatdo();
					}
				}
				else if (rowid>0){
					jQuery('#multicatcatids').val('');
                                        jQuery('#mlcat0').prop('checked', false);
					inputs.each(function(idx, element){
                                                // element is native javascript
						if (element.id=='mlcat0') return;
						if (element.checked ==false) return;
						if (jQuery('#multicatcatids').val()!='') 
                                                    jQuery('#multicatcatids').val( jQuery('#multicatcatids').val() + '|');
						jQuery('#multicatcatids').val(jQuery('#multicatcatids').val() + element.value);
					});
					if ($autosubmit){
						multicatdo();
					}
					//multicatall();
				}
			}
			function multicatall(){
				var inputs = jQuery('#multicat_container input[type=checkbox]');
				jQuery('#mlcat0').prop('checked',false);
				jQuery('#multicatcatids').val('');
				inputs.each(function(idx, element){
                                        // element is native javascript
					if (element.id=='mlcat0') return; 
					if (element.checked==false) return;
					if (jQuery('#multicatcatids').val()!='') 
                                            jQuery('#multicatcatids').val(jQuery('#multicatcatids').val() +'|');
					jQuery('#multicatcatids').val(jQuery('#multicatcatids').val() +element.value);
				});
				if (jQuery('#multicatcatids').val('')) 
                                    jQuery('#mlcat0').prop('checked', true);
                                setmulticat(0);
			}
			function multicatclear(){
				var inputs = jQuery('#multicat_container input[type=checkbox]');
                                inputs.prop('checked', false);
                                jQuery('#mlcat0').prop('checked',true);
        			jQuery('#multicatcatids').val('');
				if ($autosubmit){
					inputs.each(function(idx, element){
                                                // element is native javascript
						if (element.id=='mlcat0') return; 
						if (element.checked==false) return;
						if (jQuery('#multicatcatids').val()!='') 
                                                    jQuery('#multicatcatids').val(jQuery('#multicatcatids').val() + '|');
						jQuery('#multicatcatids').val(jQuery('#multicatcatids').val() +element.value);
					});				
					multicatdo();
				}
			}
			function multicatdo(){
				url = '$link';
				if (jQuery('#multicatcatids').val()=='') 
                                    jQuery('#multicatcatids').val(0);
				url = url.replace('XXXXXX',jQuery('#multicatcatids').val());
				document.location.replace(url);
			}";

				$content .= '</script>';
			}


			// only if called from module
			if (isset($this->_params))
			{
				if ($this->_params->get('show_admin', 0) && isset($year) && isset($month) && isset($day) && isset($Itemid))
				{

					// This is only displayed when JEvents is the component so I can get the component view
					$component =  ComponentHelper::getComponent(JEV_COM_COMPONENT);

					$registry = JevRegistry::getinstance("jevents");
					$controller =  $registry->getValue("jevents.controller", null);
					$view = $controller->view;

					//include_once(JPATH_SITE."/components/$option/events.html.php");
					ob_start();
					if (method_exists($view, "_viewNavAdminPanel"))
					{
						echo $view->_viewNavAdminPanel();
					}
					$content .= ob_get_contents();
					ob_end_clean();
				}
			}

			return $content;
		}

	}

	protected function getCategoryHierarchy($catidList, $catidsGPList, $order)
	{


		$db = Factory::getDbo();
		$aid = $this->datamodel->aid;
		$sectionname = JEV_COM_COMPONENT;

		$query = "SELECT c.id as cid,  c.* FROM #__categories AS c "
				. "\n WHERE c.access  IN ($aid)"
				. "\n AND c.published = 1"
				. "\n AND c.extension = '" . $sectionname . "'"
				. "\n ORDER BY $order"
		;

		$db->setQuery($query);
		$catlist = $db->loadObjectList('cid');

		// any plugin based resitrictions

		// remember NOT to reindex the list
		Factory::getApplication()->triggerEvent('onGetAccessibleCategories', array(& $catlist, false));

		// Copy the array
		$clonedCatList = unserialize(serialize($catlist));

		$validcats = array();
		 if (strlen($catidsGPList) > 0) $validcats = array_merge($validcats, explode(",", $catidsGPList));		
		
		// convert to a tree
		$cattree = $this->mapTree($catlist, $validcats);

		// constrain tree by component or module paramaters
		if (strlen($catidList) > 0)
		{
			$validcats = array();
			$validcats = array_merge($validcats, explode(",", $catidList));
			if (count($validcats) > 0)
			{
				$cattree2 = $this->mapTree($clonedCatList, $validcats);
				$combinedCatTree = $this->constrainTree($cattree, $cattree2);
			}
		}


		return $cattree;

	}

	function constrainTree(&$cattree, &$constrainTree)
	{
		foreach (array_keys($cattree) as $id)
		{
			if (array_key_exists($id, $constrainTree))
			{
				if (( isset($constrainTree[$id]->activeBranch)) ||
						($cattree[$id]->parent_id > 1 && isset($constrainTree[$cattree[$id]->parent_id]->activeBranch)))
				{
					if (isset($cattree[$id]->subcats) && isset($constrainTree[$id]->subcats))
					{
						$this->constrainTree($cattree[$id]->subcats, $constrainTree[$id]->subcats);
					}
				}
				else
				{
					unset($cattree[$id]);
				}
			}
			else
			{
				unset($cattree[$id]);
			}
		}

	}

	// build the tree
	function mapTree($dataset, $validcats)
	{
		$tree = array();
		foreach ($dataset as $id => &$node)
		{
			if (in_array($node->cid, $validcats))
			{
				$this->markParentsActive($node, $dataset, $validcats);
			}
			if (count($validcats) == 0 && $node->parent_id == 1)
			{
				$this->markParentsActive($node, $dataset, $validcats);
			}
			if ($node->parent_id == 1)
			{ // root node
				$tree[$id] = &$node;
			}
			else
			{ // sub node
				// If this node's parent is not in the dataset because of plugin restrictions perhaps then ignore it
				if (!array_key_exists($node->parent_id, $dataset))
					continue;
				if (array_key_exists($node->parent_id, $dataset) && !isset($dataset[$node->parent_id]->subcats))
					$dataset[$node->parent_id]->subcats = array();
				$dataset[$node->parent_id]->subcats[$id] = &$node;
			}
		}

		return $tree;

	}

	function markParentsActive(&$node, $dataset, $validcats)
	{
		$node->activeBranch = true;

		// if we have selected one node then mark is as active so we can show its children
		if (count($validcats) == 1)
		{
			$node->activeNode = true;
		}

		if ($node->parent_id > 0 && array_key_exists($node->parent_id, $dataset))
			$this->markParentsActive($dataset[$node->parent_id], $dataset, $validcats);

	}

	function listKids($row, $itm, $tsk, $availableCatsIds, $catcounts, $activeParent = false, $activeSubCat=0)
	{
		$catclass = "";
		if ($row->parent_id > 1)
			$catclass = "childcat";
		if ($row->parent_id > 1 && isset($row->activeBranch))
			$catclass = "activechildcat";
		if ($row->parent_id > 1 && $activeParent)
			$catclass = "activechildcat";
		if ($row->parent_id > 1 && $activeSubCat > 0 && $row->cid != $activeSubCat && !isset($row->activeNode))
			$catclass = "childcat";

		$count = 0;
		$id = isset($row->cid) ? $row->cid : $row->id;
		if (array_key_exists($id, $catcounts))
		{
			$count = $catcounts[$id]['evcount'];
		}
		
		$catclass .= " catclass".$id;
		
                $newcats = $this->_params->get("catidnew", false);
		$cat = $id > 0 ? "&catids=$id" : ($newcats ? "&catids=$availableCatsIds" :"");
		$name = isset($row->title) ? $row->title : $row->name;
		if (!isset($row->color) && isset($row->params) && strpos($row->params,"catcolour")){
			$row->params = json_decode($row->params);
			$row->color = $row->params->catcolour;
		}
		if (!isset($row->color)) {
			$row->color = "transparent";
		}
		//Should we show empty categories?
		if ($this->_params->get('showempty_cats', 1) == 0 && $count == 0) return;

		$content = "<li class='" . $catclass . "'  style='border-left:solid 3px " . $row->color . ";padding-left:5px'>\n";

		if ($this->_params->get("multiselect", 0))
		{
			// I should only show legend for items that **can** be shown in calendar so must filter based on GET/POST
			$catidsIn = Factory::getApplication()->input->getString('catids', "NONE");
			if ($catidsIn != "NONE")
				$catidsGP = explode("|", $catidsIn);
			else{
				if ($this->_params->get("usemenuitemcats",0)) {
			
					// in this case use the menu item constraints to pre-select the checkboxes
					$catidsGP = $this->menucatids ;
				}
				else {
					$catidsGP = array();
				}
			}
			$catidsGP = ArrayHelper::toInteger($catidsGP);

			$checked = "";
			if (in_array($id, $catidsGP))
			{
				$checked = 'checked= "checked"';
			}
			if ($this->_params->get("showcount", 1)){
				$count =  " (" . $count . ")";
			}
			else {
				$count = "";
			}
			$content .= '<label for="mlcat' . $id . '">' . JEventsHTML::special($name).$count ;
			$content .= '<input type="checkbox" class="mlcat" id="mlcat' . $id . '" onclick="setmulticat(' . $id . ');" ' . $checked . ' value="' . $id . '"/>';
			$content .= '</label>';
		}
		else
		{
			if ($this->_params->get("showcount", 1)){
				$count =  " (" . $count . ")";
			}
			else {
				$count = "";
			}			
			$content .= "<a style='text-decoration:none' href='" . Route::_("index.php?option=" . JEV_COM_COMPONENT . "$cat$itm$tsk") . "' title='" . JEventsHTML::special($name) . "'>"
					. JEventsHTML::special($name) .  $count . "</a>\n";
		}

		if (isset($row->activeBranch) && isset($row->subcats))
		{
			$activeSubCat = 0;
			foreach ($row->subcats as $subcatid => $subcat)
			{
				if (isset($subcat->activeBranch))
				{
					$activeSubCat = $subcatid;
				}
			}
			//$content .= "<ul>\n";
			foreach ($row->subcats as $subcatid => $subcat)
			{
				$content .= $this->listKids($subcat, $itm, $tsk, $availableCatsIds, $catcounts, isset($row->activeNode), $activeSubCat);
			}
			//$content .= "</ul>\n";
		}
		$content .= "</li>\n";
		return $content;

	}

}
