<?php
/**
 * copyright (C) 2008 GWE Systems Ltd - All rights reserved
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Response\JsonResponse;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * HTML View class for the component frontend
 *
 * @static
 */
class DefaultModCalendarPlusView
{
	var $_modid = null;

	/* parameters form module or component */
	var $displayLastMonth		= null;
	var $disp_lastMonthDays		= null;
	var $disp_lastMonth			= null;

	var $displayNextMonth		= null;
	var $disp_nextMonthDays		= null;
	var $disp_nextMonth			= null;

	var $linkCloaking			= null;

	/* component only parameter */
	var $com_starday			= null;

	/* module only parameters */
	var $minical_showlink		= null;
	var $minical_prevyear		= null;
	var $minical_prevmonth		= null;
	var $minical_actmonth		= null;
	var $minical_actyear		= null;
	var $minical_nextmonth		= null;
	var $minical_nextyear		= null;

	/* class variables */
	var $catidsOut				= null;
	var $modcatids				= null;
	var $catidList				= "";
	var $lang					= null;
	var $myItemid				= 0;
	var $cat 					= "";

	/* modules parameter object */
	var $modparams				= null;

	// data model for module
	var $datamodel				= null;

	function __construct($params, $modid){

		$this->_modid = $modid;

		$user = Factory::getUser();

		$cfg = JEVConfig::getInstance();
		$jev_component_name  = JEV_COM_COMPONENT;
		$db	= Factory::getDbo();

		$this->datamodel = new JEventsDataModel();

		// component config object
		$jevents_config		= JEVConfig::getInstance();

		$this->modparams	= & $params;
		$tmplang			= Factory::getLanguage();

		// get params exclusive to module
		$this->minical_showlink		= $this->modparams->get('minical_showlink', 1);;
		$this->minical_prevyear		= $this->modparams->get('minical_prevyear', 1);;
		$this->minical_prevmonth	= $this->modparams->get('minical_prevmonth', 1);;
		$this->minical_actmonth		= $this->modparams->get('minical_actmonth', 1);;
		$this->minical_actmonth		= $this->modparams->get('minical_actmonth', 1);;
		$this->minical_actyear		= $this->modparams->get('minical_actyear', 1);;
		$this->minical_nextmonth	= $this->modparams->get('minical_nextmonth', 1);;
		$this->minical_nextyear		= $this->modparams->get('minical_nextyear', 1);;

		// get params exclusive to component
		$this->com_starday	= intval($jevents_config->get('com_starday',0));

		// make config object (module or component) current
		if (intval($this->modparams->get('modcal_useLocalParam',  0)) == 1) {
			$myparam	= & $this->modparams;
		} else {
			$myparam	= & $jevents_config;
		}

		// get com_event config parameters for this module
		$this->displayLastMonth		= $myparam->get('modcal_DispLastMonth', 'NO');
		$this->disp_lastMonthDays	= $myparam->get('modcal_DispLastMonthDays', 0);
		$this->linkCloaking			= $myparam->get('modcal_LinkCloaking', 0);

		$t_datenow = JEVHelper::getNow();
		$this->timeWithOffset = $t_datenow->toUnix(true);

		switch($this->displayLastMonth) {
			case 'YES_stop':
				$this->disp_lastMonth = 1;
				break;
			case 'YES_stop_events':
				$this->disp_lastMonth = 2;
				break;
			case 'ALWAYS':
				$this->disp_lastMonthDays = 0;
				$this->disp_lastMonth = 1;
				break;
			case 'ALWAYS_events':
				$this->disp_lastMonthDays = 0;
				$this->disp_lastMonth = 2;
				break;
			case 'NO':
			default:
				$this->disp_lastMonthDays = 0;
				$this->disp_lastMonth = 0;
				break;
		}

		$this->displayNextMonth		= $myparam->get('modcal_DispNextMonth', 'NO');
		$this->disp_nextMonthDays	= $myparam->get('modcal_DispNextMonthDays', 0);

		switch($this->displayNextMonth) {
			case 'YES_stop':
				$this->disp_nextMonth = 1;
				break;
			case 'YES_stop_events':
				$this->disp_nextMonth = 2;
				break;
			case 'ALWAYS':
				$this->disp_nextMonthDays = 0;
				$this->disp_nextMonth = 1;
				break;
			case 'ALWAYS_events':
				$this->disp_nextMonthDays = 0;
				$this->disp_nextMonth = 2;
				break;
			case 'NO':
			default:
				$this->disp_nextMonthDays = 0;
				$this->disp_nextMonth = 0;
				break;
		}

		// find appropriate Itemid and setup catids for datamodel
		$this->myItemid = $this->datamodel->setupModuleCatids($this->modparams);

		$this->cat = $this->datamodel->getCatidsOutLink(true);

		$this->linkpref = 'index.php?option='.$jev_component_name.'&Itemid='.$this->myItemid.$this->cat.'&task=';

	}

	function getAjaxCal($modid=0, $month, $year){
		// capture module id so that we can use it for ajax type navigation
		if ($modid!=0) {
			$this->_modid=$modid;
		}
		$document = Factory::getDocument();
		$user = Factory::getUser();

		$db	= Factory::getDbo();

		$cfg = JEVConfig::getInstance();

		$year = Factory::getApplication()->input->getInt( 'jev_current_year', 0 );
		$month = Factory::getApplication()->input->getInt( 'jev_current_month', 0 );

		$reg = Factory::getConfig();
		$reg->set("jev.modparams",$this->modparams);

		$data = $this->datamodel->getCalendarData($year,$month,1,false, 0);

		$events = $this->getEventsArray($data);

		$result = new JsonResponse($events);

		echo $result;

	} // function getSpecificCal

	function getTheme(){
		$theme = JEV_CommonFunctions::getJEventsViewName();
		return $theme;

	}

	function getEventsArray($data)
	{
		$events = array();
		foreach ($data['dates'] as $day_index)
		{
			foreach($day_index['events'] as $event)
			{
				$eventArray['date'] = $day_index['year'] ."-".$day_index['month']."-".$day_index['d0']. " " .date("H:i",$event->getUnixStartTime());

				$title = str_replace("'", "&#39;", $event->title());
				$eventArray['title'] = str_replace('"', "&#34;", $title);
				$eventArray['safeTitle'] = addslashes($event->title());
				$link = $event->viewDetailLink($day_index['year'], $day_index['month'], $day_index['d0'], false, $this->myItemid) . $this->datamodel->getCatidsOutLink();
				$eventArray['link'] = Route::_($link );
				$eventArray['linkInPopup'] = Route::_($link . "&tmpl=component");
				//$eventArray['link'] = $link;
				$events[] = $eventArray;
			}
		}

		return $events;
	}

	function getEventListFormatJS($detailInPopup=0)
	{

		//Get the time format

		if ($this->modparams->get('modcalplus_12_24_hr', 1) == 1) {
			$time_format = 'HH:mm';
		} else {
			$time_format = 'h:mm a';
		}

		if(!$detailInPopup)
		{
			if( $this->modparams->get('jevcalplus_newwindow', true) )
			{
				$string = 'moment(event.date).format("'.$time_format.'")+" - " + "<a href=\'"+event.link+"\' title=\'"+event.safeTitle+"\' target=\'_blank\'>"+event.title+"</a>"';
			}
			else
			{
				$string = 'moment(event.date).format("'.$time_format.'")+" - " + "<a href=\'"+event.link+"\' title=\'"+event.safeTitle+"\' target=\'_top\'>"+event.title+"</a>"';
			}
		}
		else
		{
			$string = 'moment(event.date).format("'.$time_format.'")+" - " + "<a href=\'#\' title=\'"+event.safeTitle+"\' onClick=\'showPopup(\""+event.safeTitle+"\",\""+event.linkInPopup+"\")\' >"+event.title+"</a>"';
		}


		return $string;
	}

	function getCal($modid=0) {

		if ($modid!=0) {
			$this->_modid=$modid;
		}

		$detailInPopup = $this->modparams->get('detailInPopup', 0);

		$cfg = JEVConfig::getInstance();

		$document = Factory::getDocument();
		$time = $this->timeWithOffset;
		$cal_year=date("Y",$time);
		$cal_month=date("m",$time);

		$reg = Factory::getConfig();
		$reg->set("jev.modparams",$this->modparams);

		$data = $this->datamodel->getCalendarData($cal_year,$cal_month,1,false, $this->modparams->get("noeventcheck",0));

		$events = $this->getEventsArray($data);

		// Make sure jQuery is loaded
		HTMLHelper::_('jquery.framework');

		$eventsJSON = "var eventArray = ".json_encode(array_values($events));
		$document->addScriptDeclaration($eventsJSON);
		$this->modparams->get('jevcalplus_usebrowserlanguage');
		if(!$this->modparams->get('jevcalplus_usebrowserlanguage', false))
		{
			$calendarLanguage = $this->getLanguage();
			$document->addScriptDeclaration($calendarLanguage);
		}

		$showYearControls = $this->modparams->get('jevcalplus_dispyearcontrols', false);
		$showScroll = $this->modparams->get('jevcalplus_scroll', false);

		$formatJS = $this->getEventListFormatJS($detailInPopup);
		$modid = $this->_modid;
		if($showScroll)
		{
			$showScrollScript = 'container.toggleClass("scroll",true);';
		}
		else
		{
			$showScrollScript = 'var mainCalendar = jQuery(".clndr");
			        var height = jQuery("#jevcalendarplus-list-container").height() + 20;
					mainCalendar.css("height",height);';
		}
		$JEV_EVENTSFORTHE = Text::_("JEV_EVENTSFORTHE");
		$base = Juri::base();
$script = <<< SCRIPT
var calendars = {};
var checkedMonths = ["$cal_year-$cal_month"];
document.addEventListener("DOMContentLoaded", function() {
		calendars.clndr1 = jQuery(".jevcalendarplus_calendar").clndr({
			template: jQuery("#template-calendar").html(),
			events: eventArray,
			clickEvents: {
				click: function(target) {
					  if(target.events.length) {
							var listTitle="$JEV_EVENTSFORTHE" + moment(target.events[0].date).format("D") + " " + moment(target.events[0].date).format("MMM");
						    listContainer = jQuery("#jevcalendarplus-list-container");
							jQuery(".jevcalendarplus-row").remove();
							jQuery.each(target.events, function(index,event){
								  var eventdiv = "<div class=\"jevcalendarplus-row\">" + $formatJS + "</div>";
								  listContainer.append(eventdiv);
							});
							var container = jQuery("#jevcalendarplus-container");
							container.toggleClass("jevcalendarplus-eventslist",true);
							$showScrollScript
							jQuery("#jev-close-list").click( function() {
								var mainCalendar = jQuery(".clndr");
								container.toggleClass("jevcalendarplus-eventslist", false);
								container.toggleClass("scroll", false);
								mainCalendar.css("height","");
							});
						    jQuery("#jevcalendarplus-list-header-title").html(listTitle);
						}
					},
				onMonthChange: function(month){
						var monthToShow = month.format("MM");
						var yearToShow =  month.format("YYYY");
						var index = yearToShow + "-" + monthToShow;
						var container = jQuery("#jevcalendarplus-container");
						var mainCalendar = jQuery(".clndr");
						container.toggleClass("jevcalendarplus-eventslist", false);
						container.toggleClass("scroll", false);
						mainCalendar.css("height","");
	
						if(checkedMonths.indexOf(index) == -1)
						{
							var parameters = {
								jev_current_month: monthToShow,
								jev_current_year: yearToShow
							};
	
							var post = jQuery.post("$base" + "index.php?option=com_jevents&task=getjson.monthevents&modid=$modid&format=json",parameters,
								function(r){
									var eventArrayNext = r.data;
									eventArray = eventArray.concat(eventArrayNext);
									calendars.clndr1.setEvents(eventArray);
									checkedMonths.push(yearToShow + "-" + monthToShow);
									},"json")
								.fail(function(e){
	                                errorAlert(e);
								    //alert("Error in the response");
							});
						}
					}
			  },
			showAdjacentMonths: false,
			adjacentDaysChangeMonth: true,
			targets:{
				nextButton:	"jevcalendarplus-next-button",
				previousButton: "jevcalendarplus-previous-button",
				nextYearButton:	"jevcalendarplus-nextyear-button",
				previousYearButton: "jevcalendarplus-previousyear-button"
			}
		});
});

function errorAlert(e) {
    alert("Error in the response");
}
SCRIPT;


$document->addScriptDeclaration($script);

		$calendarTemplate = '
<div class="jevcalendarplus_container">
    <div class="jevcalendarplus_calendar">
    </div>
	<script type="text/template" id="template-calendar">
        <div class="jevcalendarplus_calendar_controls">';
		$yearCSSClass = "";
		if($showYearControls)
		{
			$calendarTemplate .= '<div class="jevcalendarplus-previousyear-button">&lsaquo;&lsaquo;</div>';
			$yearCSSClass = "withyears";
		}
			$calendarTemplate .= '<div class="jevcalendarplus-previous-button">&lsaquo;</div>
          <div class="month '.$yearCSSClass.'"><%= month %> <%= year %></div>';
		if($showYearControls)
		{
			$calendarTemplate .= '<div class="jevcalendarplus-nextyear-button">&rsaquo;&rsaquo;</div>';
		}
			$calendarTemplate .= '<div class="jevcalendarplus-next-button">&rsaquo;</div>
        </div>
        <div id="jevcalendarplus-container" class="jevcalendarplus-grid">
          <div class="jevcalendarplus-days-of-the-week">
            <% _.each(daysOfTheWeek, function(day) { %>
              <div class="jevcalendarplus-header-day"><%= day %></div>
            <% }); %>
            <div class="jevcalendarplus-days">
              <% _.each(days, function(day) { %>
                <div class="<%= day.classes %>"><%= day.day %></div>
              <% }); %>
            </div>
          </div>
		  <div class="jevcalendarplus-list" id="jevcalendarplus-list-container">
			<div id="jevcalendarplus-list-header" class="headers">
				<div id="jev-close-list"><i class="icon-undo"></i></div>
				<div id="jevcalendarplus-list-header-title">Events For the day</div>
			</div>
		  </div>
        </div>

	</script>
	</div>';

		return $calendarTemplate;
	} // function getCal

	function getLanguage()
	{
		$lang = Factory::getLanguage();

		$script = '
		document.addEventListener("DOMContentLoaded", function() {
			moment.locale("'.$lang->getTag().'", {
						months : "'.Text::_("JEV_JANUARY").'_'.Text::_("JEV_FEBRUARY").'_'.Text::_("JEV_MARCH").'_'.Text::_("JEV_APRIL").'_'.Text::_("JEV_MAY").'_'.Text::_("JEV_JUNE").'_'.Text::_("JEV_JULY").'_'.Text::_("JEV_AUGUST").'_'.Text::_("JEV_SEPTEMBER").'_'.Text::_("JEV_OCTOBER").'_'.Text::_("JEV_NOVEMBER").'_'.Text::_("JEV_DECEMBER").'".split("_"),
						monthsShort : "'.Text::_("JEV_JAN_SHORT").'_'.Text::_("JEV_FEB_SHORT").'_'.Text::_("JEV_MAR_SHORT").'_'.Text::_("JEV_APR_SHORT").'_'.Text::_("JEV_MAY_SHORT").'_'.Text::_("JEV_JUN_SHORT").'_'.Text::_("JEV_JUL_SHORT").'_'.Text::_("JEV_AUG_SHORT").'_'.Text::_("JEV_SEP_SHORT").'_'.Text::_("JEV_OCT_SHORT").'_'.Text::_("JEV_NOV_SHORT").'_'.Text::_("JEV_DEC_SHORT").'".split("_"),
						weekdays : "'.Text::_("JEV_SUNDAY").'_'.Text::_("JEV_MONDAY").'_'.Text::_("JEV_TUESDAY").'_'.Text::_("JEV_WEDNESDAY").'_'.Text::_("JEV_THURSDAY").'_'.Text::_("JEV_FRIDAY").'_'.Text::_("JEV_SATURDAY").'".split("_"),
						weekdaysShort : "'.Text::_("JEV_SUN").'_'.Text::_("JEV_MON").'_'.Text::_("JEV_TUES").'_'.Text::_("JEV_WED").'_'.Text::_("JEV_THU").'_'.Text::_("JEV_FRI").'_'.Text::_("JEV_SAT").'".split("_"),
						weekdaysMin : "'.Text::_("JEV_SUNDAY_CHR").'_'.Text::_("JEV_MONDAY_CHR").'_'.Text::_("JEV_TUESDAY_CHR").'_'.Text::_("JEV_WEDNESDAY_CHR").'_'.Text::_("JEV_THURSDAY_CHR").'_'.Text::_("JEV_FRIDAY_CHR").'_'.Text::_("JEV_SATURDAY_CHR").'".split("_"),
						week : {
							dow : '.$this->com_starday.', // Monday is the first day of the week.
						}
			});
		});';
		/*
		 * THIS SHOULD BE IN THE SCRIPT VARIABLE
		 * longDateFormat : {
							LT : "HH:mm",
							L : "DD/MM/YYYY",
							LL : "D MMMM YYYY",
							LLL : "D MMMM YYYY LT",
							LLLL : "dddd D MMMM YYYY LT"
						},
						calendar : {
							sameDay: "[Aujourd\'hui à] LT",
							nextDay: "[Demain à] LT",
							nextWeek: "dddd [à] LT",
							lastDay: "[Hier à] LT",
							lastWeek: "dddd [dernier à] LT",
							sameElse: "L"
						},
						relativeTime : {
							future : "dans %s",
							past : "il y a %s",
							s : "quelques secondes",
							m : "une minute",
							mm : "%d minutes",
							h : "une heure",
							hh : "%d heures",
							d : "un jour",
							dd : "%d jours",
							M : "un mois",
							MM : "%d mois",
							y : "une année",
							yy : "%d années"
						},
					    ordinal : function (number) {
							return number + (number === 1 ? "er" : "ème");
						}*/
		return $script;
	}
}
