<?php
/**
 * JEvents Component for Joomla!
 *
 * @version     $Id: mod_jevents_slideshow.php 3309 2012-03-01 10:07:50Z geraintedwards $
 * @package     JEvents
 * @subpackage  Module Slideshow JEvents
 * @copyright   Copyright (C) 2006-2014 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * HTML View class for the module  frontend
 *
 * @static
 */
include_once(JPATH_SITE . "/modules/mod_jevents_latest/tmpl/default/latest.php");

class DefaultModSlideshowView extends DefaultModLatestView
{

	public function displaySlideshowEvents()
	{
		$cfg = JEVConfig::getInstance();
		$compname = JEV_COM_COMPONENT;


		$datenow = JEVHelper::getNow();

		$this->getLatestEventsData();

		$content = "";
		$hasEventsWithImages = false;

		$moduleclass_sfx = htmlspecialchars($this->modparams->get('moduleclass_sfx'), ENT_COMPAT, 'UTF-8');

		$content .= $this->getModuleHeader('');

		if (isset($this->eventsByRelDay) && count($this->eventsByRelDay))
		{
			//$this->customFormatStr = '<div class="item active">${imageimg1}<div class="carousel-caption">${title}</div></div>';
			// only the first should be active!!

			if (version_compare(JVERSION, '4', ">"))
			{
				$this->customFormatStr = $this->modparams->get('modlatest_CustFmtStr', '<div class="carousel-item ISACTIVE"><a href="${eventDetailLink}" target="_self">${imageimg1}</a><div class="carousel-caption">${title}<span class="jevcstart"><a href="${eventDetailLink}" target="_self">${startDate(%e %b %Y)}</a></span></div></div>');
				$this->customFormatStr = str_replace(array('item ISACTIVE', ' item ISACTIVE'), 'carousel-item ISACTIVE', $this->customFormatStr);
			}
			else
			{
				$this->customFormatStr = $this->modparams->get('modlatest_CustFmtStr', '<div class="item ISACTIVE"><a href="${eventDetailLink}" target="_self">${imageimg1}</a><div class="carousel-caption">${title}<span class="jevcstart"><a href="${eventDetailLink}" target="_self">${startDate(%e %b %Y)}</a></span></div></div>');
			}

			$this->processFormatString();

			HTMLHelper::_('bootstrap.carousel', 'jevlatestcarousel', array('interval' => $this->modparams->get('sldelay', 500), 'pause' => 'hover'));
			JHTML::stylesheet("modules/mod_jevents_slideshow/css/mod_jevents_slideshow.css");

			ob_start();
			?>
			<div class="jevcarousel<?php echo version_compare(JVERSION, '4', ">") ? "_j4" : ""?> <?php echo $moduleclass_sfx; ?>">
				<div id="jevlatestcarousel" class="carousel slide jevlatest jevlatestcarousel" data-ride="carousel" data-bs-ride="carousel">
					<!-- Indicators -->
					<ol class="carousel-indicators">
						<?php
						$count = 0;

						foreach ($this->eventsByRelDay as $relDay => $daysEvents)
						{
							// get all of the events for this day
							foreach ($daysEvents as $dayEvent) {
								if (!isset($dayEvent->_imageurl1) || $dayEvent->_imageurl1==""){
									continue;
								}
								$hasEventsWithImages = true;
								?>
								<li
										data-target="#jevlatestcarousel" data-slide-to="<?php echo $count; ?>" <?php echo ($count == 0) ? 'class="active"' : ''; ?>
										data-bs-target="#jevlatestcarousel" data-bs-slide-to="<?php echo $count; ?>" <?php echo ($count == 0) ? 'class="active"' : ''; ?>
								></li>
								<?php
								$count++;
							}
						}
						?>
					</ol>
					<div class="carousel-inner">
						<?php
						$first = true;
						foreach ($this->eventsByRelDay as $relDay => $daysEvents)
						{

							reset($daysEvents);

							// get all of the events for this day
							foreach ($daysEvents as $dayEvent)
							{
								if (!isset($dayEvent->_imageurl1) || $dayEvent->_imageurl1==""){
									continue;
								}

								if ($this->processTemplate($content, $dayEvent))
								{
									continue;
								}

								$html = "";
								// generate output according custom string
								foreach ($this->splitCustomFormat as $condtoken)
								{

									if (isset($condtoken['cond']))
									{
										if ($condtoken['cond'] == 'a' && !$dayEvent->alldayevent())
											continue;
										else if ($condtoken['cond'] == '!a' && $dayEvent->alldayevent())
											continue;
										else if ($condtoken['cond'] == 'e' && !($dayEvent->noendtime() || $dayEvent->alldayevent()))
											continue;
										else if ($condtoken['cond'] == '!e' && ($dayEvent->noendtime() || $dayEvent->alldayevent()))
											continue;
										else if ($condtoken['cond'] == '!m' && $dayEvent->getUnixStartDate() != $dayEvent->getUnixEndDate())
											continue;
										else if ($condtoken['cond'] == 'm' && $dayEvent->getUnixStartDate() == $dayEvent->getUnixEndDate())
											continue;
									}
									foreach ($condtoken['data'] as $token)
									{
										if (is_string($token) && strpos($token, "ISACTIVE"))
										{
											if ($first)
											{
												$token = str_replace("ISACTIVE", "active", $token);
												$first = false;
											}
											else
											{
												$token = str_replace("ISACTIVE", "", $token);
											}
										}
										unset($match);
										unset($dateParm);
										$dateParm = "";
										$match = '';
										if (is_array($token))
										{
											$match = $token['keyword'];
											$dateParm = isset($token['dateParm']) ? trim($token['dateParm']) : "";
										}
										else if (strpos($token, '${') !== false)
										{
											$match = $token;
										}
										else
										{
											$html .= $token;
											continue;
										}
										$this->processMatch($html, $match, $dayEvent, $dateParm, $relDay);
									}
								}

								$templaterow = $this->modparams->get("modlatest_templaterow") ? $this->modparams->get("modlatest_templaterow") : "%s";

								echo str_replace("%s", $html, $templaterow);

							}
						}
						?>
					</div>

					<!-- Controls -->
					<?php if($count > 1) {
						if (version_compare(JVERSION, '4.0.0', 'ge'))
						{
							?>
							<button class="carousel-control-prev"  data-bs-slide="prev" data-bs-target="#jevlatestcarousel" >
								<span class="carousel-control-prev-icon" aria-hidden="true"></span>
							</button>
							<button class="carousel-control-next" data-bs-slide="next" data-bs-target="#jevlatestcarousel" >
								<span class="carousel-control-next-icon" aria-hidden="true"></span>
							</button>
							<?php
						}
						else
						{
							?>
							<a class="left carousel-control carousel-control-prev" href="#jevlatestcarousel" data-slide="prev" data-bs-target="#jevlatestcarousel" >
								<span class="carousel-control-prev-icon" aria-hidden="true"></span>
							</a>
							<a class="right carousel-control carousel-control-next" href="#jevlatestcarousel" data-slide="next" data-bs-target="#jevlatestcarousel" >
								<span class="carousel-control-next-icon" aria-hidden="true"></span>
							</a>
							<?php
						}
					} ?>
				</div>
			</div>
			<?php
			if (version_compare(JVERSION, '4', "<"))
			{
				?>
				<script>
                    // Mootools fix - see http://stackoverflow.com/questions/10462747/twitter-bootstrap-carousel-using-joomla-and-its-mootools
                    if (typeof jQuery != 'undefined') {
                        (function($) {
                            $(document).ready(function() {
                                $('.jevcarousel .carousel').each(function(index, element) {
                                    $(this)[index].slide = null;
                                });

                                $("#jevlatestcarousel").carousel('cycle');
                            });
                        })(jQuery);
                    }</script>
				<?php
			}
			?>

			<?php
			$content .= ob_get_clean();
			if (!$hasEventsWithImages) {
				$content = "";
			}
		}
		if ($this->modparams->get('modlatest_NoEvents', 0) == 1 && !$hasEventsWithImages) {
			$content = Text::_('JEV_SLIDE_LATEST_NO_EVENTS');
		}

		$content .= $this->getModuleFooter('');

		return $content;

	}

}
