<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Helper\ModuleHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Session\Session;
/*
HTMLHelper::stylesheet('https://cdn.jsdelivr.net/npm/uikit@3.6.16/dist/css/uikit.min.css');
HTMLHelper::script("https://cdn.jsdelivr.net/npm/uikit@3.6.16/dist/js/uikit.min.js");
HTMLHelper::script("https://cdn.jsdelivr.net/npm/uikit@3.6.16/dist/js/uikit-icons.min.js");
*/
$modid     = $module->id;
$position  = $params->get("position", "left");
$preloaded = $params->get("preload", 1) ? "true" : "false";
$user      = Factory::getUser();
$debug     = "&XDEBUG_SESSION_START=PHPSTORM";
//$debug = "";
$url = Route::_("index.php?option=com_jevents&ttoption=com_jevents&typeaheadtask=gwejson&file=fetchmodule&path=module$debug&folder=mod_tabbedmodules&token=" . Session::getFormToken() . $urlitemid . $ttitemid, false);

$tabtitles   = array();
$tabcontents = array();

foreach (ModuleHelper::getModules($position) as $mod)
{
	if (!is_object($mod))
	{
		$mod = ModuleHelper::getModule($mod, $title);
	}

	if (is_object($mod))
	{

		// Latest Events Title fix!
		modTabbedmodulesHelper::fixLatestEventsModule($mod);

		$document   = Factory::getDocument();
		$renderer   = $document->loadRenderer('module');
		$tempparams = array('style' => -2);
		// always preload the first tab
		if ($params->get("preload", 1) || count($tabtitles) == 0)
		{
			$mod->tabcontent = $renderer->render($mod, $tempparams);
		}
		else
		{
			$mod->tabcontent = "";
		}

		// wrap latest events module
		modTabbedmodulesHelper::wrapLatestEventsModule($mod);

		$tabtitles[] = $mod;
	}
}

// only output if there are any modules to display
if (count($tabtitles) == 0) return "";

modTabbedmodulesHelper::stylesheet("mod_tabbedmodules_gsl.css");

$tabselection = $params->get("tabbedorselect", 0);

if ($tabselection == 1)
{
	$taborselect  = 'form';
	$taborselect1 = 'option';
}
else
{
	$taborselect  = 'ul';
	$taborselect1 = 'li';
}
?>

<ul class="uk-tab" data-uk-tab="connect: #myTabbedModules_<?php echo $modid; ?>_tabs"
    id="myTabbedModules_<?php echo $modid;?>">
	<?php
	$first = true;
	foreach ($tabtitles as $tabtitle)
	{
		if ($first)
		{
			$first = false;
			$class = ' class="active"';
		}
		else
		{
			$class = '';
		}
		//$activeclass .= ($tabtitle->module == "mod_jevents_latest" ? ' events' : '');
		$title       = isset($tabtitle->tabtitle) ? $tabtitle->tabtitle : $tabtitle->title;
		?>
		<li <?php echo $class; ?>><a data-toggle="tab"
		                             href="#<?php echo $tabtitle->module . "_" . $tabtitle->id; ?>"><?php echo $title; ?></a>
		</li>
		<?php
	}
	?>
</ul>
<!-- Tabs themselves //-->
<div class=" uk-margin-remove uk-card-body uk-card-default uk-padding uk-width-expand">
	<ul class="uk-switcher" id="myTabbedModules_<?php echo $modid; ?>_tabs">
		<?php
		foreach ($tabtitles as $tabtitle)
		{
			?>
			<li id="<?php echo $tabtitle->module . "_" . $tabtitle->id;?>">
				<?php
				echo $tabtitle->tabcontent;
				?>
			</li>
			<?php
		}
		?>
	</ul>
</div>
<script>
    document.addEventListener('DOMContentLoaded', function () {
        document.getElementById('myTabbedModules_<?php echo $modid;?>').addEventListener('click', function (e) {
            // activated tab
            var tabid = e.target.hash.replace('#', '');
            var json_tabid = tabid;
            var tabparts = tabid.split("_");
            if (tabparts.length > 0) {
                json_tabid = tabparts[tabparts.length - 1]
            }
            tabid = tabid.replace('title_', '');
            var tabcontent = document.getElementById(tabid);
            // no need to reload the same data
            if (tabcontent.innerHTML.trim() != "") {
                return;
            }

            var requestObject = new Object();
            requestObject.error = false;
            requestObject.modid = json_tabid;

            const xhr = new XMLHttpRequest();
            xhr.open("POST", '<?php echo $url;?>');

            xhr.onload = function () {
                try {
                    if (xhr.status != 200) {
                        alert('error ' + xhr.statusText);
                        return;
                    }

                    let returnData = JSON.parse(xhr.responseText);
                    if (returnData.error) {
                        try {
                            eval(returnData.error);
                        } catch (e) {
                            alert('could not process error handler');
                        }
                        return;
                    }

                    var tabcontent = document.getElementById(tabid);
                    tabcontent.innerHTML = returnData.modvalue;
                } catch (e) {
                    alert('bad response = ' + e + " :: " + xhr.responseText);
                }
            },
                xhr.onerror = function () {
                    alert('error ' + xhr.statusText);

                }

            let fd = new FormData()
            fd.append('json', JSON.stringify(requestObject));

            xhr.send(fd);

        })
    });

</script>


