<?php

/**
 * @copyright Copyright (C) 2008 GWE Systemts Ltd. All rights reserved.
 * @license By negotiation
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgContentTogglecontent extends JPlugin
{

	private $context = false;

	function onPrepareContent(&$article, &$params, $limitstart)
	{

		// only process events - pickup context from Joomla 3.2 so that the plugin works in latest events module even if page is not com_content etc.
		$option = JRequest::getCmd("option");
		if ($this->context) {
		   $option = $this->context;
		}
		$this->context = false;

		if (!isset($option) || !($option == "com_content" || $option == "com_jevents" || $option == "com_frontpage" || $option == "com_phocadownload"  || $option == "com_zoo"))
			return true;

		// simple performance check to determine whether bot should process further
		if (strpos($article->text, '{toggle}') === false)
		{
			return true;
		}

		// define the regular expression for the bot
		$regex = "#{toggle}(.*?){/toggle}#s";

		preg_match_all($regex, $article->text, $matcharray);
		if (!$matcharray || count($matcharray) != 2)
			return true;

		$hides = array();
		$reveals = array();

		static $base = 0;

		for ($i = 0; $i < count($matcharray[1]); $i++)
		{
			$matches = $matcharray[1][$i];
			$regex = $matcharray[0][$i];

			$parts = explode("|", $matches, 3);
			if (count($parts) == 3)
			{
				list($reveal, $hide, $content) = explode("|", $matches, 3);
			}
			else
			{
				$reveal = $this->params->get("enlarge", "");
				$hide = $this->params->get("reduce", "");
				$content = $matches;
			}

			$html = "<div class='toggleDetail' id='togid".($base+$i)."'>";
			$html .= "<a class='toggleEnlarge' href='#' onclick='return false'><div class='togreveal'>$reveal</div><div class='toghide' style='display:none'>$hide</div></a>";
			$html .= "<div class='largeDetail' >";
			$html .= "<div class='largeDetailContent'>";
			$html .= $content;
			$html .= "</div>";
			$html .= "</div>";
			$html .= "</div>";

			$article->text = str_replace($regex, $html, $article->text);

			//$reveal = addslashes($reveal);
			//$hide = addslashes($hide);
			$hides['togid'.($base+$i)] = $hide;
			$reveals['togid'.($base+$i)] = $reveal;
		}

		$base += count($matcharray[1]);


		static $script;
		if (!isset($script))
		{
			$script = "";
			//$script = "var togglereveals = ".json_encode($reveals).";\n";
		//	$script .= "var togglehides = ".json_encode($hides).";\n";
			$script .= <<<SCRIPT
function toggleDetails(el) {
	//var reveal = togglereveals[el.getParent().id];
	//var hide = togglehides[el.getParent().id];
	var node =el.getParent().getElement('.largeDetail');
	var nodeContent =el.getParent().getElement('.largeDetailContent');
	var nodeHeight = (nodeContent.getStyle('height').toInt() || nodeContent.getSize().y)+6;
	if (node.status!='show'){
		closeOtherToggles();
		//el.getElement('div').innerHTML = hide;
		el.getElement('div.toghide').style.display='block';
		el.getElement('div.togreveal').style.display='none';
		var myeffect = new Fx.Morph(node ,{
			onComplete:function(){setToggleStatus(node);},
			duration: 500,
			transition: Fx.Transitions.quadOut
			});
		myeffect.start( {'height': nodeHeight});
	}
	else {
		//el.getElement('div').innerHTML = reveal;
		el.getElement('div.togreveal').style.display='block';
		el.getElement('div.toghide').style.display='none';
		var myeffect = new Fx.Morph(node ,{
			onComplete:function(){setToggleStatus(node);},
			duration: 500,
			transition: Fx.Transitions.quadOut
			});
		myeffect.start( {'height': 0});
	}
	return false;
}
function closeOtherToggles(){
	document.getElements('.largeDetail').each(function(node){
		if (node.status=='show'){
			el = node.getParent().getElement('.toggleEnlarge');
			el.getElement('div.togreveal').style.display='block';
			el.getElement('div.toghide').style.display='none';
			var myeffect = new Fx.Morph(node ,{
				onComplete:function(){setToggleStatus(node);},
				duration: 500,
				transition: Fx.Transitions.quadOut
				});
			myeffect.start( {'height': 0});
		}
	});
}
function setToggleStatus (node) {
	if (node.status!='show'){
		node.status='show';
		node.getParent().getElement('.toggleReduce');
	}
	else {
		node.status='hide';
		node.getParent().getElement('.toggleEnlarge');
	}
}
function setupToggles() {
	$$('.toggleEnlarge').each(
		function(el, index){
			el.addEvent('mousedown',function(evt){toggleDetails(this);return false;});
		}
	);
}
window.addEvent('domready',function(){setupToggles();});
SCRIPT;
			$document = JFactory::getDocument();
			$document->addScriptDeclaration($script);
			JHTML::stylesheet( 'plugins/content/togglecontent/togglecontentstyle/togglecontent.css');

		}
		return true;

	}

	/*
	 * for Joomla 2.5 +
	 */
	public function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		$this->context = $context;
		return $this->onPrepareContent($row, $params, $page);
	}
}

