<?php
// No direct access
defined('_JEXEC') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\Folder;
use Joomla\String\StringHelper;

jimport("joomla.filesystem.file");
HTMLHelper::_('bootstrap.framework');
HTMLHelper::_('bootstrap.loadCss');
$jversion = new Joomla\CMS\Version;
if (!$jversion->isCompatible('4.0'))
{
	HTMLHelper::_('formbehavior.chosen', 'select:not(.notchosen)');
}

$editor = \Joomla\CMS\Editor\Editor::getInstance('none');

$input = Factory::getApplication()->input;

if (!empty($this->sidebar)) {
    $version = JEventsVersion::getInstance();
    ?>
    <div id="j-sidebar-container" class="span2">

        <?php echo $this->sidebar; ?>

        <?php
        //Version Checking etc
        ?>
        <div class="jev_version">
            <?php echo Text::sprintf('JEV_CURRENT_VERSION', StringHelper::substr($version->getShortVersion(), 1)); ?>
        </div>
    </div>
    <?php
}

Text::script("JEVCF_FIELD_EDIT_MISSING_REQUIRED_MESSAGE");

$mainspan = 10;
$fullspan = 12;
?>
<div id="jevents" class="span12">
    <form action="index.php" method="post" name="adminForm" id="adminForm" onsubmit="return jevcfforms.checkRequiredMessages();">
        <div id="j-main-container" class="span<?php echo (!empty($this->sidebar)) ? $mainspan : $fullspan; ?>  ">
            <div class="row-fluid">
                <input type="hidden" name="option" value="com_jevents"/>
                <input type="hidden" name="task" value="plugin.jev_customfields.edit"/>
                <?php echo HTMLHelper::_('form.token'); ?>

                <div class="form-horizontal ">
                    <div class="control-group">
                        <label class="control-label"><?php echo Text::_('JEV_CUSTOMFIELDS_FILENAME'); ?> </label>
                        <div class="controls" >
                            <input class="inputbox" type="text" name="cfname"  size="50" maxlength="100" value="<?php echo $this->file; ?>"/>
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label"><?php echo Text::_('JEV_CUSTOMFIELDS_DESCRIPTION'); ?></label>

                        <div class="controls" >
                            <?php
                            // parameters : areaname, content, hidden field, width, height, rows, cols
                            echo $editor->display('description', htmlspecialchars(trim($this->xml->description), ENT_QUOTES, 'UTF-8'), "80%", 100, '70', '10', false);
                            ?>
                        </div>
                    </div>
                    <div class="addfield span6">
                        <h3><?php echo Text::_('JEVCF_Add_field'); ?></h3>
                        <div id="jevtemplate_fields">
                            <?php
                            jimport("joomla.filesystem.folder");
                            $fieldfiles = Folder::files(JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/", ".php");

                            $options = array();
                            $value = false;
                            foreach ($fieldfiles as $fieldfile) {
                                $type = str_replace(".php", "", $fieldfile);
                                if (strpos($type, "jevcf") !== 0 || strpos($type, ".zip") !== false || strpos($type, ".gz") !== false || strpos($type, "jevcfparameter") !== false) {
                                    continue;
                                }
                                if ($type == 'jevcfjoomla')
                                {

                                }
                                if (!$value)
                                    $value = $type;
                                try {
                                    include_once( JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/" . $fieldfile);

                                    if (method_exists("JFormField" . ucfirst($type), "isEnabled")) {
                                        if (!call_user_func(array("JFormField" . ucfirst($type), "isEnabled"))) {
                                            continue;
                                        }
                                    }

                                    $label = Text::_('CUSTOM_FIELD_TYPE_' . $type);
                                    if ($label == 'CUSTOM_FIELD_TYPE_' . $type && method_exists("JFormField" . ucfirst($type), "fieldName")) {
                                        $label = call_user_func(array("JFormField" . ucfirst($type), "fieldName"));
                                    }
                                    if (method_exists("JFormField" . ucfirst($type), "loadScript")) {
                                        call_user_func(array("JFormField" . ucfirst($type), "loadScript"));
                                        $options[] = HTMLHelper::_('select.option', $type, $label);
                                    }
                                }
                                catch (Exception $e){
                                    echo $e->getMessage()."<br/>";
                                    continue;
                                }
                            }
                            CustomFieldsHelper::getFieldScript();
                            ?>
							<div class="dropdown gsl-button-group" id="fieldsdropdown">
							  <button class="gsl-button gsl-button-small gsl-button-default" type="button" id="dropdowncustomfields" data-toggle="dropdown" aria-expanded="false">
							    <?php echo Text::_("JEVCF_SELECT_NEW_FIELD_TYPE");?>
							    <span class="caret"></span>
							  </button>
							  <ul class="gsl-dropdown gsl-list gsl-list-none gsl-margin-large-bottom  gsl-padding-large-bottom"  data-gsl-dropdown role="menu" aria-labelledby="dropdowncustomfields" id="dropdownUL_customfields" role="menu">
							      <?php
							      foreach ($options as $option){
							          ?>
							      <li role="presentation"><a role="menuitem" class="dropdownpopover" href="#" data-title="<?php echo addslashes($option->text);?>" data-content="<?php echo Text::_("JEVCF_".strtoupper($option->value)."_DESCRIPTION", true);?>" data-value="<?php echo $option->value;?>" ><?php echo $option->text;?></a></li>
							          <?php
							      }
							      ?>
							    </ul>
							</div>
							<?php
                            //echo HTMLHelper::_('select.genericlist', $options, 'templatetype', 'class="jevcftemplatetype" size="1" ', 'value', 'text', $value, "templatetype");
                            ?>

                        </div>
                        <!-- <input id="newFieldButton" class="gsl-button gsl-button-small gsl-button-default" type="button" value="<?php echo Text::_("JEVCF_CREATE_FIELD"); ?>"/> //-->
                        <input id="deleteFieldButton" type="button" value="<?php echo Text::_("JEVCF_DELETE_FIELD"); ?>" style='display:none' class="gsl-button gsl-button-small gsl-button-danger deleteFieldButton"/>
                        <input id="closeFieldButton" type="button" value="<?php echo Text::_("JEVCF_CLOSE_FIELD"); ?>" style='display:none' class="gsl-button gsl-button-small gsl-button-warning closeFieldButton"/>
                    </div>
                    <div class="addfieldgroup span6">
                        <h3><?php echo Text::_('JEVCF_Add_field_GROUP'); ?></h3>
                        <input id="newFieldGroupButton" class="gsl-button gsl-button-small gsl-button-default" type="button" value="<?php echo Text::_("JEVCF_CREATE_FIELD_GROUP"); ?>"/>
                    </div>
                    <div id="jevcffields" class="jevcffieldscontainer" >
                        <?php
                        $cfparams = JevCfForm::getInstance("com_jevent.customfields", $this->xml->asXML(), array('control' => 'jform', 'load_data' => true), true, "/form");
                        $cfparams->setEvent(null);
                        $fieldsets = $cfparams->getFieldsets();
                        // Put the default fieldset first
                        $groups = array();
                        if (isset($fieldsets["default"])) {
                            $groups["default"] = $fieldsets["default"];
                        }
                        foreach ($fieldsets as $group => $element) {
                            if ($group != "default") {
                                $groups[$group] = $element;
                            }
                        }

                        foreach ($groups as $group => $element) {
                            $description = (isset($element->description) ? $element->description : "");
                            $descriptionElement= $this->xml->xpath('//fieldset[@name="' . (string) $group . '"]/description');
                            if (count($descriptionElement)>0){
                                $description = trim( (string) $descriptionElement[0]) ;
                            }
                            ?>
                            <fieldset class="jevcffieldset <?php echo ($group == "default")?"jevcfdefaultfieldset":""?>" >
                            <?php
                            if ($group == "default") {
                                ?>
                                    <legend class="fieldsetlabel">
                                        <!-- Default HAS TO COME FIRST!! //-->
                                        <span class="sortable-handler gsl-icon" data-gsl-icon="menu" ></span>
                                <?php
                                echo Text::sprintf("JEVCF_FIELD_GROUP", ucwords($group));
                                echo "<input type='text' name='jevcffieldset[]' size='40' value='" . htmlspecialchars($group) . "' />";
                                echo "<div class='fieldsetdescription' ><textarea name='jevcffieldsetdescription[]' cols='60' rows='3'></textarea></div>";
                                ?>
                                    </legend>
                                    <?php
                                } else {
                                    ?>
                                    <legend class="fieldsetlabel">
                                        <span class="sortable-handler gsl-icon" data-gsl-icon="menu" ></span>
                                        <?php
                                        echo Text::sprintf("JEVCF_FIELD_GROUP", "<span class='fieldsetname' >" . ucwords($group) . "</span>");
                                        echo HTMLHelper::image('com_jevents/icons-32/edit.png', Text::_("JEV_E_EDIT"), array("class"=>"editimg"), true);
                                        echo HTMLHelper::image('com_jevents/icons-32/discard.png', Text::_("JEV_E_DELETE"), array("class"=>"deleteimg", "style" => "display:none"), true);
                                        echo "<input type='text' name='jevcffieldset[]' size='40' value='" . ucwords(htmlspecialchars($group)) . "' />";
                                        echo HTMLHelper::image('com_jevents/icons-32/accept.png', Text::_("JEV_E_SAVE"), array("class"=>"saveimg", "style" => "display:none"), true);
                                        echo "<div class='fieldsetdescription' >" . Text::sprintf("JEVCF_FIELD_GROUP_DESCRIPTION", "<textarea name='jevcffieldsetdescription[]' cols='60' rows='3'>" . $description . "</textarea>") . "</div>";
                                        ?>
                                    </legend>
                                    <?php
                                }
                                $count = $cfparams->getFieldCountByFieldSet($group);
                                $groupparams = $cfparams->getFieldset($group);
                                foreach ($groupparams as $p => $field) {
                                    if ($field->fieldname == "Field Name" || $field->fieldname == Text::_("CUSTOM_FIELD_NAME")){
                                        $field->fieldname =  uniqid('cf_', false);
                                        $field->addAttribute("name", $field->fieldname) ;
                                    }
                                    $fieldhtml = "<div class='jevcfclear'></div>";
                                    if (method_exists($field, "loadScript")) {
                                        $fieldhtml = $field->html = $field->loadScript($field);
                                    }
                                    ?>
                                    <div class='jevcffield' id='field<?php echo $field->fieldname; ?>'>
                                        <span class="sortable-handler gsl-icon" data-gsl-icon="menu" ></span>
                                        <input id="deleteFieldButtonfield<?php echo $field->fieldname; ?>" type="button" value="<?php echo Text::_("JEVCF_DELETE_FIELD"); ?>" class="gsl-button gsl-button-small gsl-button-danger deleteFieldButton"/>
                                        <input id="closeFieldButtonfield<?php echo $field->fieldname; ?>" type="button" value="<?php echo Text::_("JEVCF_CLOSE_FIELD"); ?>" class="gsl-button gsl-button-small gsl-button-warning closeFieldButton"/>
                                    <?php
                                    echo $fieldhtml;
                                    ?>
                                        <input class="fieldsetmap" type="text" name="fieldsetmap[field<?php echo $field->fieldname; ?>]" value="<?php echo ucwords(htmlspecialchars($group)); ?>">
                                    </div>
                                    <?php
                                }
                                ?>
                            <div class='jevcffield jevcflastfield'></div>
                            </fieldset>
    <?php
}
                        ?>
                        <fieldset class="jevcffieldset jevcflastfieldset" >
                            <legend class="fieldsetlabel">
                                <span class="sortable-handler gsl-icon" data-gsl-icon="menu" ></span>

                                <?php
                                echo Text::sprintf("JEVCF_FIELD_GROUP", "<span class='fieldsetname' >" . Text::sprintf("JEVCF_FIELD_GROUP", "XXXXX" ) . "</span>");
                                echo HTMLHelper::image('com_jevents/icons-32/edit.png', Text::_("JEV_E_EDIT"), array("class"=>"editimg"), true);
                                echo HTMLHelper::image('com_jevents/icons-32/discard.png', Text::_("JEV_E_DELETE"), array("class"=>"deleteimg", "style" => "display:none"), true);
                                echo "<input type='text' name='jevcffieldset[]' size='40' value='" . Text::sprintf("JEVCF_FIELD_GROUP", "XXXXX" ) ."' />";
                                echo HTMLHelper::image('com_jevents/icons-32/accept.png', Text::_("JEV_E_SAVE"), array("class"=>"saveimg", "style" => "display:none"), true);
                                echo "<div class='fieldsetdescription' ><textarea name='jevcffieldsetdescription[]' cols='60' rows='3'></textarea></div>";
                                ?>
                            </legend>
                            <div class='jevcffield jevcflastfield'></div>
                        </fieldset>
                    </div>
                </div>
            </div>
        </div>
    </form>
</div>
                            <?php
// make sure the form isn't too big!'
                            $max_input_vars = (int) @ini_get("max_input_vars");
                            if ($max_input_vars == 0) {
                                $max_input_vars = 999999;
                            }
                            ?>
<script type="text/javascript">
    var inputvars = document.querySelectorAll('#adminForm input');
    var selectvars = document.querySelectorAll('#adminForm select');
    var textareavars = document.querySelectorAll('#adminForm textarea');
    if (inputvars.length + selectvars.length + textareavars.length > <?php echo $max_input_vars; ?>) {
        alert("<?php echo Text::_("JEVCF_FORM_LARGER_THAN_MAXIMUM_SIZE_CHECK_HTACCESS_SETTINGS", true) ?>\n" + (inputvars.length + selectvars.length + textareavars.length) + "  vs " + <?php echo $max_input_vars; ?>);
    } else if (inputvars.length + selectvars.length + textareavars.length > <?php echo $max_input_vars; ?> * 0.90) {
        alert("<?php echo Text::_("JEVCF_FORM_GETTING_CLOSE_TO_MAXIMUM_SIZE_CHECK_HTACCESS_SETTINGS", true) ?>\n" + (inputvars.length + selectvars.length + textareavars.length) + "  vs " + <?php echo $max_input_vars; ?>);
    }
</script>

<script type="text/javascript" >
    window.setTimeout("setupJEVCFTemplateUIkit()", 500);

    function setupJEVCFTemplateUIkit() {
        (function ($) {
            // Turn radios into gsl-button-group
            document.querySelectorAll('.radio.gsl-button-group label').forEach(function(item) {
                item.classList.add('gsl-button');
            });
            document.querySelectorAll('.radio.gsl-button-group input').forEach(function(item) {
                item.classList.add('gsl-hidden');
            });
            //var el = $(".radio.gsl-button-group label:not(.active)");

            // Isis template and others may already have done this so remove these!
            //$(".radio.gsl-button-group label:not(.active)").unbind('click');

            document.querySelectorAll(".radio.gsl-button-group label:not(.active)").forEach(function (item) {
                item.addEventListener('click', function () {
                    var label = this;
                    var input = document.getElementById(label.getAttribute('for'));

                    if (!input.checked && !input.disabled) {
                        label.closest('.gsl-button-group').querySelectorAll("label").forEach(function (itemLabel) {
                            itemLabel.classList.remove('active','gsl-button-success','gsl-button-danger','gsl-button-primary');
                        });
                        if (input.value != 0) {
                            label.classList.add('active','gsl-button-success');
                        } else {
                            label.classList.add('active','gsl-button-danger');
                        }
                        input.checked = true;
	                    input.dispatchEvent(new CustomEvent('change', {
	                        bubbles: true,
	                        cancelable: true
	                    }));
                    }
                });
            });

            // Turn checkboxes into gsl-button-group
            $('.checkbox.gsl-button-group label').addClass('gsl-button');
            $('.checkbox.gsl-button-group input').addClass('gsl-hidden');

            // Isis template and others may already have done this so remove these!
            $(".checkbox.gsl-button-group label").unbind('click');

            $(".checkbox.gsl-button-group label").click(function (event) {
                event || (event = window.event);
                var label = $(this);
                var input = $('#' + label.attr('for'));
                //alert(label.val()+ " checked? "+input.prop('checked')+ " disabled? "+input.prop('disabled')+ " label disabled? "+label.hasClass('disabled'));
                if (input.prop('disabled')) {
                    label.removeClass('active gsl-button-success gsl-button-danger gsl-button-primary');
                    input.prop('checked', false);
                    event.stopImmediatePropagation();
                    input.trigger('change');
                    return false;
                }
                if (!input.prop('checked')) {
                    if (input.prop('value') != 0) {
                        label.addClass('active gsl-button-success');
                    } else {
                        label.addClass('active gsl-button-danger');
                    }
                } else {
                    label.removeClass('active gsl-button-success gsl-button-danger gsl-button-primary');
                }
                input.trigger('change');
                // bootstrap takes care of the checkboxes themselves!
            });

            $(".gsl-button-group input[type=checkbox]").each(function () {
                var input = $(this);
                input.css('display', 'none');
            });
        })(jQuery);

        initialiseJEVCFTemplateBootstrapButtons();
    }

    function initialiseJEVCFTemplateBootstrapButtons() {
        document.querySelectorAll(".gsl-button-group input[type=checkbox]").forEach(function (elem) {
            var label = document.querySelector("label[for='" + elem.id + "']");
            if (elem.disabled) {
                label.classList.add('disabled');
                label.classList.remove('active','gsl-button-success','gsl-button-danger','gsl-button-primary');
                return;
            }
            label.classList.remove('disabled');
            if (!elem.checked) {
                label.classList.remove('active','gsl-button-success','gsl-button-danger','gsl-button-primary');
                return;
            }
            if (elem.value != 0) {
                label.classList.add('active','gsl-button-success');
            } else {
                label.classList.add('active','gsl-button-danger');
            }
        });

    }

</script>
